// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.

// "%code top" blocks.
#line 31 "../preprocessor/src/DynareBison.yy"

class ParsingDriver;

#line 43 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"




#include "DynareBison.hh"


// Unqualified %code blocks.
#line 56 "../preprocessor/src/DynareBison.yy"

/* Little hack: we redefine the macro which computes the locations, because
   we need to access the location from within the parsing driver for error
   and warning messages. */
#define YYLLOC_DEFAULT(Current, Rhs, N)                           \
  do                                                              \
    {                                                             \
      if (N)                                                      \
        {                                                         \
          (Current).begin = YYRHSLOC(Rhs, 1).begin;               \
          (Current).end   = YYRHSLOC(Rhs, N).end;                 \
        }                                                         \
      else                                                        \
        {                                                         \
          (Current).begin = (Current).end = YYRHSLOC(Rhs, 0).end; \
        }                                                         \
      driver.location = (Current);                                \
    }                                                             \
  while (false)

#include "ParsingDriver.hh"

/* this "connects" the bison parser in the driver to the flex scanner class
 * object. it defines the yylex() function call to pull the next token from the
 * current lexer object of the driver context. */
#undef yylex
#define yylex driver.lexer->lex

#include <cctype>

string
str_tolower(string s)
{
  // Converting to unsigned char is needed, see https://en.cppreference.com/w/cpp/string/byte/tolower
  transform(s.begin(), s.end(), s.begin(), [](unsigned char c){ return std::tolower(c); });
  return s;
}

#line 91 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 25 "../preprocessor/src/DynareBison.yy"
namespace Dynare {
#line 184 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"

  /// Build a parser object.
  parser::parser (ParsingDriver &driver_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg)
  {}

  parser::~parser ()
  {}

  parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/

  // basic_symbol.
  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value ()
    , location (that.location)
  {
    switch (this->kind ())
    {
      case symbol_kind::S_pac_target_kind: // pac_target_kind
        value.copy< PacTargetKind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        value.copy< PriorDistributions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        value.copy< SymbolType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        value.copy< expr_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_list: // matched_irfs_list
        value.copy< map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        value.copy< map<string, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tag_pair_list: // tag_pair_list
        value.copy< map<string, string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_mshocks_options_list: // mshocks_options_list
        value.copy< map<string, variant<bool, string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_weights_list: // matched_irfs_weights_list
        value.copy< map<tuple<string, string, string, string, string, string>, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        value.copy< pair<expr_t,expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_elem: // matched_irfs_elem
        value.copy< pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        value.copy< pair<string, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_mshocks_option: // mshocks_option
        value.copy< pair<string, variant<bool, string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_partition_elem: // partition_elem
      case symbol_kind::S_tag_pair: // tag_pair
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_matched_irfs_elem_var_varexo: // matched_irfs_elem_var_varexo
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        value.copy< pair<string,string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_weights_elem: // matched_irfs_weights_elem
        value.copy< pair<tuple<string, string, string, string, string, string>, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_elem_values_weights: // matched_irfs_elem_values_weights
        value.copy< pair<vector<expr_t>, vector<expr_t>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATES: // DATES
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_MFS: // MFS
      case symbol_kind::S_KIND: // KIND
      case symbol_kind::S_LL: // LL
      case symbol_kind::S_DL: // DL
      case symbol_kind::S_DD: // DD
      case symbol_kind::S_ADD: // ADD
      case symbol_kind::S_MULTIPLY: // MULTIPLY
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_str: // date_str
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_symbol: // symbol
        value.copy< string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        value.copy< tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_weights_elem_var_varexo: // matched_irfs_weights_elem_var_varexo
        value.copy< tuple<string, string, string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        value.copy< tuple<string,string,string,string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
        value.copy< vector<expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        value.copy< vector<int> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tag_pair_list_for_selection: // tag_pair_list_for_selection
        value.copy< vector<map<string, string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_period_list: // period_list
        value.copy< vector<pair<int, int>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_symbol_list_with_tex: // symbol_list_with_tex
      case symbol_kind::S_partition_1: // partition_1
      case symbol_kind::S_partition: // partition
        value.copy< vector<pair<string,string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_symbol_list: // symbol_list
      case symbol_kind::S_symbol_list_or_wildcard: // symbol_list_or_wildcard
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_w_inf_1: // vec_value_w_inf_1
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
        value.copy< vector<string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        value.copy< vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_symbol_list_with_tex_and_partition: // symbol_list_with_tex_and_partition
        value.copy< vector<tuple<string, string, vector<pair<string, string>>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vec_of_vec_value_1: // vec_of_vec_value_1
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
        value.copy< vector<vector<string>> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

  }




  template <typename Base>
  parser::symbol_kind_type
  parser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  template <typename Base>
  bool
  parser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    switch (this->kind ())
    {
      case symbol_kind::S_pac_target_kind: // pac_target_kind
        value.move< PacTargetKind > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        value.move< PriorDistributions > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        value.move< SymbolType > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        value.move< expr_t > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_matched_irfs_list: // matched_irfs_list
        value.move< map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        value.move< map<string, expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tag_pair_list: // tag_pair_list
        value.move< map<string, string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_mshocks_options_list: // mshocks_options_list
        value.move< map<string, variant<bool, string>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_matched_irfs_weights_list: // matched_irfs_weights_list
        value.move< map<tuple<string, string, string, string, string, string>, expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        value.move< pair<expr_t,expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_matched_irfs_elem: // matched_irfs_elem
        value.move< pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        value.move< pair<string, expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_mshocks_option: // mshocks_option
        value.move< pair<string, variant<bool, string>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_partition_elem: // partition_elem
      case symbol_kind::S_tag_pair: // tag_pair
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_matched_irfs_elem_var_varexo: // matched_irfs_elem_var_varexo
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        value.move< pair<string,string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_matched_irfs_weights_elem: // matched_irfs_weights_elem
        value.move< pair<tuple<string, string, string, string, string, string>, expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_matched_irfs_elem_values_weights: // matched_irfs_elem_values_weights
        value.move< pair<vector<expr_t>, vector<expr_t>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATES: // DATES
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_MFS: // MFS
      case symbol_kind::S_KIND: // KIND
      case symbol_kind::S_LL: // LL
      case symbol_kind::S_DL: // DL
      case symbol_kind::S_DD: // DD
      case symbol_kind::S_ADD: // ADD
      case symbol_kind::S_MULTIPLY: // MULTIPLY
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_str: // date_str
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_symbol: // symbol
        value.move< string > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        value.move< tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_matched_irfs_weights_elem_var_varexo: // matched_irfs_weights_elem_var_varexo
        value.move< tuple<string, string, string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        value.move< tuple<string,string,string,string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
        value.move< vector<expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        value.move< vector<int> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tag_pair_list_for_selection: // tag_pair_list_for_selection
        value.move< vector<map<string, string>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_period_list: // period_list
        value.move< vector<pair<int, int>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_symbol_list_with_tex: // symbol_list_with_tex
      case symbol_kind::S_partition_1: // partition_1
      case symbol_kind::S_partition: // partition
        value.move< vector<pair<string,string>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_symbol_list: // symbol_list
      case symbol_kind::S_symbol_list_or_wildcard: // symbol_list_or_wildcard
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_w_inf_1: // vec_value_w_inf_1
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
        value.move< vector<string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        value.move< vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_symbol_list_with_tex_and_partition: // symbol_list_with_tex_and_partition
        value.move< vector<tuple<string, string, vector<pair<string, string>>>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_vec_of_vec_value_1: // vec_of_vec_value_1
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
        value.move< vector<vector<string>> > (YY_MOVE (s.value));
        break;

      default:
        break;
    }

    location = YY_MOVE (s.location);
  }

  // by_kind.
  parser::by_kind::by_kind () YY_NOEXCEPT
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  parser::by_kind::by_kind (by_kind&& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  parser::by_kind::by_kind (const by_kind& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {}

  parser::by_kind::by_kind (token_kind_type t) YY_NOEXCEPT
    : kind_ (yytranslate_ (t))
  {}



  void
  parser::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  parser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  parser::symbol_kind_type
  parser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }


  parser::symbol_kind_type
  parser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }



  // by_state.
  parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  parser::symbol_kind_type
  parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  parser::stack_symbol_type::stack_symbol_type ()
  {}

  parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_pac_target_kind: // pac_target_kind
        value.YY_MOVE_OR_COPY< PacTargetKind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        value.YY_MOVE_OR_COPY< PriorDistributions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        value.YY_MOVE_OR_COPY< SymbolType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        value.YY_MOVE_OR_COPY< expr_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_list: // matched_irfs_list
        value.YY_MOVE_OR_COPY< map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        value.YY_MOVE_OR_COPY< map<string, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tag_pair_list: // tag_pair_list
        value.YY_MOVE_OR_COPY< map<string, string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_mshocks_options_list: // mshocks_options_list
        value.YY_MOVE_OR_COPY< map<string, variant<bool, string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_weights_list: // matched_irfs_weights_list
        value.YY_MOVE_OR_COPY< map<tuple<string, string, string, string, string, string>, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        value.YY_MOVE_OR_COPY< pair<expr_t,expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_elem: // matched_irfs_elem
        value.YY_MOVE_OR_COPY< pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        value.YY_MOVE_OR_COPY< pair<string, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_mshocks_option: // mshocks_option
        value.YY_MOVE_OR_COPY< pair<string, variant<bool, string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_partition_elem: // partition_elem
      case symbol_kind::S_tag_pair: // tag_pair
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_matched_irfs_elem_var_varexo: // matched_irfs_elem_var_varexo
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        value.YY_MOVE_OR_COPY< pair<string,string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_weights_elem: // matched_irfs_weights_elem
        value.YY_MOVE_OR_COPY< pair<tuple<string, string, string, string, string, string>, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_elem_values_weights: // matched_irfs_elem_values_weights
        value.YY_MOVE_OR_COPY< pair<vector<expr_t>, vector<expr_t>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATES: // DATES
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_MFS: // MFS
      case symbol_kind::S_KIND: // KIND
      case symbol_kind::S_LL: // LL
      case symbol_kind::S_DL: // DL
      case symbol_kind::S_DD: // DD
      case symbol_kind::S_ADD: // ADD
      case symbol_kind::S_MULTIPLY: // MULTIPLY
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_str: // date_str
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_symbol: // symbol
        value.YY_MOVE_OR_COPY< string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        value.YY_MOVE_OR_COPY< tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_weights_elem_var_varexo: // matched_irfs_weights_elem_var_varexo
        value.YY_MOVE_OR_COPY< tuple<string, string, string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        value.YY_MOVE_OR_COPY< tuple<string,string,string,string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
        value.YY_MOVE_OR_COPY< vector<expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        value.YY_MOVE_OR_COPY< vector<int> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tag_pair_list_for_selection: // tag_pair_list_for_selection
        value.YY_MOVE_OR_COPY< vector<map<string, string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_period_list: // period_list
        value.YY_MOVE_OR_COPY< vector<pair<int, int>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_symbol_list_with_tex: // symbol_list_with_tex
      case symbol_kind::S_partition_1: // partition_1
      case symbol_kind::S_partition: // partition
        value.YY_MOVE_OR_COPY< vector<pair<string,string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_symbol_list: // symbol_list
      case symbol_kind::S_symbol_list_or_wildcard: // symbol_list_or_wildcard
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_w_inf_1: // vec_value_w_inf_1
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
        value.YY_MOVE_OR_COPY< vector<string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        value.YY_MOVE_OR_COPY< vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_symbol_list_with_tex_and_partition: // symbol_list_with_tex_and_partition
        value.YY_MOVE_OR_COPY< vector<tuple<string, string, vector<pair<string, string>>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vec_of_vec_value_1: // vec_of_vec_value_1
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
        value.YY_MOVE_OR_COPY< vector<vector<string>> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_pac_target_kind: // pac_target_kind
        value.move< PacTargetKind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        value.move< PriorDistributions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        value.move< SymbolType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        value.move< expr_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_list: // matched_irfs_list
        value.move< map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        value.move< map<string, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tag_pair_list: // tag_pair_list
        value.move< map<string, string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_mshocks_options_list: // mshocks_options_list
        value.move< map<string, variant<bool, string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_weights_list: // matched_irfs_weights_list
        value.move< map<tuple<string, string, string, string, string, string>, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        value.move< pair<expr_t,expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_elem: // matched_irfs_elem
        value.move< pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        value.move< pair<string, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_mshocks_option: // mshocks_option
        value.move< pair<string, variant<bool, string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_partition_elem: // partition_elem
      case symbol_kind::S_tag_pair: // tag_pair
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_matched_irfs_elem_var_varexo: // matched_irfs_elem_var_varexo
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        value.move< pair<string,string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_weights_elem: // matched_irfs_weights_elem
        value.move< pair<tuple<string, string, string, string, string, string>, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_elem_values_weights: // matched_irfs_elem_values_weights
        value.move< pair<vector<expr_t>, vector<expr_t>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATES: // DATES
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_MFS: // MFS
      case symbol_kind::S_KIND: // KIND
      case symbol_kind::S_LL: // LL
      case symbol_kind::S_DL: // DL
      case symbol_kind::S_DD: // DD
      case symbol_kind::S_ADD: // ADD
      case symbol_kind::S_MULTIPLY: // MULTIPLY
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_str: // date_str
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_symbol: // symbol
        value.move< string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        value.move< tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_weights_elem_var_varexo: // matched_irfs_weights_elem_var_varexo
        value.move< tuple<string, string, string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        value.move< tuple<string,string,string,string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
        value.move< vector<expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        value.move< vector<int> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tag_pair_list_for_selection: // tag_pair_list_for_selection
        value.move< vector<map<string, string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_period_list: // period_list
        value.move< vector<pair<int, int>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_symbol_list_with_tex: // symbol_list_with_tex
      case symbol_kind::S_partition_1: // partition_1
      case symbol_kind::S_partition: // partition
        value.move< vector<pair<string,string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_symbol_list: // symbol_list
      case symbol_kind::S_symbol_list_or_wildcard: // symbol_list_or_wildcard
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_w_inf_1: // vec_value_w_inf_1
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
        value.move< vector<string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        value.move< vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_symbol_list_with_tex_and_partition: // symbol_list_with_tex_and_partition
        value.move< vector<tuple<string, string, vector<pair<string, string>>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vec_of_vec_value_1: // vec_of_vec_value_1
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
        value.move< vector<vector<string>> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_pac_target_kind: // pac_target_kind
        value.copy< PacTargetKind > (that.value);
        break;

      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        value.copy< PriorDistributions > (that.value);
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        value.copy< SymbolType > (that.value);
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        value.copy< expr_t > (that.value);
        break;

      case symbol_kind::S_matched_irfs_list: // matched_irfs_list
        value.copy< map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        value.copy< map<string, expr_t> > (that.value);
        break;

      case symbol_kind::S_tag_pair_list: // tag_pair_list
        value.copy< map<string, string> > (that.value);
        break;

      case symbol_kind::S_mshocks_options_list: // mshocks_options_list
        value.copy< map<string, variant<bool, string>> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_weights_list: // matched_irfs_weights_list
        value.copy< map<tuple<string, string, string, string, string, string>, expr_t> > (that.value);
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        value.copy< pair<expr_t,expr_t> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_elem: // matched_irfs_elem
        value.copy< pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        value.copy< pair<string, expr_t> > (that.value);
        break;

      case symbol_kind::S_mshocks_option: // mshocks_option
        value.copy< pair<string, variant<bool, string>> > (that.value);
        break;

      case symbol_kind::S_partition_elem: // partition_elem
      case symbol_kind::S_tag_pair: // tag_pair
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_matched_irfs_elem_var_varexo: // matched_irfs_elem_var_varexo
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        value.copy< pair<string,string> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_weights_elem: // matched_irfs_weights_elem
        value.copy< pair<tuple<string, string, string, string, string, string>, expr_t> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_elem_values_weights: // matched_irfs_elem_values_weights
        value.copy< pair<vector<expr_t>, vector<expr_t>> > (that.value);
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATES: // DATES
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_MFS: // MFS
      case symbol_kind::S_KIND: // KIND
      case symbol_kind::S_LL: // LL
      case symbol_kind::S_DL: // DL
      case symbol_kind::S_DD: // DD
      case symbol_kind::S_ADD: // ADD
      case symbol_kind::S_MULTIPLY: // MULTIPLY
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_str: // date_str
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_symbol: // symbol
        value.copy< string > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        value.copy< tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_weights_elem_var_varexo: // matched_irfs_weights_elem_var_varexo
        value.copy< tuple<string, string, string> > (that.value);
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        value.copy< tuple<string,string,string,string> > (that.value);
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
        value.copy< vector<expr_t> > (that.value);
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        value.copy< vector<int> > (that.value);
        break;

      case symbol_kind::S_tag_pair_list_for_selection: // tag_pair_list_for_selection
        value.copy< vector<map<string, string>> > (that.value);
        break;

      case symbol_kind::S_period_list: // period_list
        value.copy< vector<pair<int, int>> > (that.value);
        break;

      case symbol_kind::S_symbol_list_with_tex: // symbol_list_with_tex
      case symbol_kind::S_partition_1: // partition_1
      case symbol_kind::S_partition: // partition
        value.copy< vector<pair<string,string>> > (that.value);
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_symbol_list: // symbol_list
      case symbol_kind::S_symbol_list_or_wildcard: // symbol_list_or_wildcard
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_w_inf_1: // vec_value_w_inf_1
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
        value.copy< vector<string> > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        value.copy< vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > (that.value);
        break;

      case symbol_kind::S_symbol_list_with_tex_and_partition: // symbol_list_with_tex_and_partition
        value.copy< vector<tuple<string, string, vector<pair<string, string>>>> > (that.value);
        break;

      case symbol_kind::S_vec_of_vec_value_1: // vec_of_vec_value_1
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
        value.copy< vector<vector<string>> > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_pac_target_kind: // pac_target_kind
        value.move< PacTargetKind > (that.value);
        break;

      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        value.move< PriorDistributions > (that.value);
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        value.move< SymbolType > (that.value);
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        value.move< expr_t > (that.value);
        break;

      case symbol_kind::S_matched_irfs_list: // matched_irfs_list
        value.move< map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        value.move< map<string, expr_t> > (that.value);
        break;

      case symbol_kind::S_tag_pair_list: // tag_pair_list
        value.move< map<string, string> > (that.value);
        break;

      case symbol_kind::S_mshocks_options_list: // mshocks_options_list
        value.move< map<string, variant<bool, string>> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_weights_list: // matched_irfs_weights_list
        value.move< map<tuple<string, string, string, string, string, string>, expr_t> > (that.value);
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        value.move< pair<expr_t,expr_t> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_elem: // matched_irfs_elem
        value.move< pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        value.move< pair<string, expr_t> > (that.value);
        break;

      case symbol_kind::S_mshocks_option: // mshocks_option
        value.move< pair<string, variant<bool, string>> > (that.value);
        break;

      case symbol_kind::S_partition_elem: // partition_elem
      case symbol_kind::S_tag_pair: // tag_pair
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_matched_irfs_elem_var_varexo: // matched_irfs_elem_var_varexo
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        value.move< pair<string,string> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_weights_elem: // matched_irfs_weights_elem
        value.move< pair<tuple<string, string, string, string, string, string>, expr_t> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_elem_values_weights: // matched_irfs_elem_values_weights
        value.move< pair<vector<expr_t>, vector<expr_t>> > (that.value);
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATES: // DATES
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_MFS: // MFS
      case symbol_kind::S_KIND: // KIND
      case symbol_kind::S_LL: // LL
      case symbol_kind::S_DL: // DL
      case symbol_kind::S_DD: // DD
      case symbol_kind::S_ADD: // ADD
      case symbol_kind::S_MULTIPLY: // MULTIPLY
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_str: // date_str
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_symbol: // symbol
        value.move< string > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        value.move< tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_weights_elem_var_varexo: // matched_irfs_weights_elem_var_varexo
        value.move< tuple<string, string, string> > (that.value);
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        value.move< tuple<string,string,string,string> > (that.value);
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
        value.move< vector<expr_t> > (that.value);
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        value.move< vector<int> > (that.value);
        break;

      case symbol_kind::S_tag_pair_list_for_selection: // tag_pair_list_for_selection
        value.move< vector<map<string, string>> > (that.value);
        break;

      case symbol_kind::S_period_list: // period_list
        value.move< vector<pair<int, int>> > (that.value);
        break;

      case symbol_kind::S_symbol_list_with_tex: // symbol_list_with_tex
      case symbol_kind::S_partition_1: // partition_1
      case symbol_kind::S_partition: // partition
        value.move< vector<pair<string,string>> > (that.value);
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_symbol_list: // symbol_list
      case symbol_kind::S_symbol_list_or_wildcard: // symbol_list_or_wildcard
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_w_inf_1: // vec_value_w_inf_1
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
        value.move< vector<string> > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        value.move< vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > (that.value);
        break;

      case symbol_kind::S_symbol_list_with_tex_and_partition: // symbol_list_with_tex_and_partition
        value.move< vector<tuple<string, string, vector<pair<string, string>>>> > (that.value);
        break;

      case symbol_kind::S_vec_of_vec_value_1: // vec_of_vec_value_1
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
        value.move< vector<vector<string>> > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  parser::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  parser::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  parser::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::operator() ()
  {
    return parse ();
  }

  int
  parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    // User initialization code.
#line 51 "../preprocessor/src/DynareBison.yy"
{
  // Initialize the locations' filenames to the filename maintained by the lexer
  yyla.location.begin.filename = yyla.location.end.filename = &(driver.lexer->filename);
}

#line 1770 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location, driver));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_pac_target_kind: // pac_target_kind
        yylhs.value.emplace< PacTargetKind > ();
        break;

      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        yylhs.value.emplace< PriorDistributions > ();
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        yylhs.value.emplace< SymbolType > ();
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        yylhs.value.emplace< expr_t > ();
        break;

      case symbol_kind::S_matched_irfs_list: // matched_irfs_list
        yylhs.value.emplace< map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > ();
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        yylhs.value.emplace< map<string, expr_t> > ();
        break;

      case symbol_kind::S_tag_pair_list: // tag_pair_list
        yylhs.value.emplace< map<string, string> > ();
        break;

      case symbol_kind::S_mshocks_options_list: // mshocks_options_list
        yylhs.value.emplace< map<string, variant<bool, string>> > ();
        break;

      case symbol_kind::S_matched_irfs_weights_list: // matched_irfs_weights_list
        yylhs.value.emplace< map<tuple<string, string, string, string, string, string>, expr_t> > ();
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        yylhs.value.emplace< pair<expr_t,expr_t> > ();
        break;

      case symbol_kind::S_matched_irfs_elem: // matched_irfs_elem
        yylhs.value.emplace< pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > ();
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        yylhs.value.emplace< pair<string, expr_t> > ();
        break;

      case symbol_kind::S_mshocks_option: // mshocks_option
        yylhs.value.emplace< pair<string, variant<bool, string>> > ();
        break;

      case symbol_kind::S_partition_elem: // partition_elem
      case symbol_kind::S_tag_pair: // tag_pair
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_matched_irfs_elem_var_varexo: // matched_irfs_elem_var_varexo
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        yylhs.value.emplace< pair<string,string> > ();
        break;

      case symbol_kind::S_matched_irfs_weights_elem: // matched_irfs_weights_elem
        yylhs.value.emplace< pair<tuple<string, string, string, string, string, string>, expr_t> > ();
        break;

      case symbol_kind::S_matched_irfs_elem_values_weights: // matched_irfs_elem_values_weights
        yylhs.value.emplace< pair<vector<expr_t>, vector<expr_t>> > ();
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATES: // DATES
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_MFS: // MFS
      case symbol_kind::S_KIND: // KIND
      case symbol_kind::S_LL: // LL
      case symbol_kind::S_DL: // DL
      case symbol_kind::S_DD: // DD
      case symbol_kind::S_ADD: // ADD
      case symbol_kind::S_MULTIPLY: // MULTIPLY
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_str: // date_str
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_symbol: // symbol
        yylhs.value.emplace< string > ();
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        yylhs.value.emplace< tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > ();
        break;

      case symbol_kind::S_matched_irfs_weights_elem_var_varexo: // matched_irfs_weights_elem_var_varexo
        yylhs.value.emplace< tuple<string, string, string> > ();
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        yylhs.value.emplace< tuple<string,string,string,string> > ();
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
        yylhs.value.emplace< vector<expr_t> > ();
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        yylhs.value.emplace< vector<int> > ();
        break;

      case symbol_kind::S_tag_pair_list_for_selection: // tag_pair_list_for_selection
        yylhs.value.emplace< vector<map<string, string>> > ();
        break;

      case symbol_kind::S_period_list: // period_list
        yylhs.value.emplace< vector<pair<int, int>> > ();
        break;

      case symbol_kind::S_symbol_list_with_tex: // symbol_list_with_tex
      case symbol_kind::S_partition_1: // partition_1
      case symbol_kind::S_partition: // partition
        yylhs.value.emplace< vector<pair<string,string>> > ();
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_symbol_list: // symbol_list
      case symbol_kind::S_symbol_list_or_wildcard: // symbol_list_or_wildcard
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_w_inf_1: // vec_value_w_inf_1
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
        yylhs.value.emplace< vector<string> > ();
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        yylhs.value.emplace< vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > ();
        break;

      case symbol_kind::S_symbol_list_with_tex_and_partition: // symbol_list_with_tex_and_partition
        yylhs.value.emplace< vector<tuple<string, string, vector<pair<string, string>>>> > ();
        break;

      case symbol_kind::S_vec_of_vec_value_1: // vec_of_vec_value_1
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
        yylhs.value.emplace< vector<vector<string>> > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 133: // dsample: DSAMPLE INT_NUMBER ';'
#line 400 "../preprocessor/src/DynareBison.yy"
          { driver.dsample(yystack_[1].value.as < string > ()); }
#line 2111 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 134: // dsample: DSAMPLE INT_NUMBER INT_NUMBER ';'
#line 402 "../preprocessor/src/DynareBison.yy"
          { driver.dsample(yystack_[2].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 2117 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 135: // symbol_list: symbol_list symbol
#line 406 "../preprocessor/src/DynareBison.yy"
              {
                yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > ();
                yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
              }
#line 2126 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 136: // symbol_list: symbol_list COMMA symbol
#line 411 "../preprocessor/src/DynareBison.yy"
              {
                yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > ();
                yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
              }
#line 2135 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 137: // symbol_list: symbol
#line 416 "../preprocessor/src/DynareBison.yy"
              { yylhs.value.as < vector<string> > () = { yystack_[0].value.as < string > () }; }
#line 2141 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 138: // symbol_list_or_wildcard: symbol_list
#line 419 "../preprocessor/src/DynareBison.yy"
                          { yylhs.value.as < vector<string> > () = yystack_[0].value.as < vector<string> > (); }
#line 2147 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 139: // symbol_list_or_wildcard: ':'
#line 421 "../preprocessor/src/DynareBison.yy"
                          { yylhs.value.as < vector<string> > () = { ":" }; }
#line 2153 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 140: // symbol_list_with_tex: symbol_list_with_tex symbol
#line 425 "../preprocessor/src/DynareBison.yy"
                       {
                         yylhs.value.as < vector<pair<string,string>> > () = yystack_[1].value.as < vector<pair<string,string>> > ();
                         yylhs.value.as < vector<pair<string,string>> > ().emplace_back(yystack_[0].value.as < string > (), "");
                       }
#line 2162 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 141: // symbol_list_with_tex: symbol_list_with_tex COMMA symbol
#line 430 "../preprocessor/src/DynareBison.yy"
                       {
                         yylhs.value.as < vector<pair<string,string>> > () = yystack_[2].value.as < vector<pair<string,string>> > ();
                         yylhs.value.as < vector<pair<string,string>> > ().emplace_back(yystack_[0].value.as < string > (), "");
                       }
#line 2171 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 142: // symbol_list_with_tex: symbol
#line 435 "../preprocessor/src/DynareBison.yy"
                       { yylhs.value.as < vector<pair<string,string>> > () = {{yystack_[0].value.as < string > (), ""}}; }
#line 2177 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 143: // symbol_list_with_tex: symbol_list_with_tex symbol TEX_NAME
#line 437 "../preprocessor/src/DynareBison.yy"
                       {
                         yylhs.value.as < vector<pair<string,string>> > () = yystack_[2].value.as < vector<pair<string,string>> > ();
                         yylhs.value.as < vector<pair<string,string>> > ().emplace_back(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ());
                       }
#line 2186 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 144: // symbol_list_with_tex: symbol_list_with_tex COMMA symbol TEX_NAME
#line 442 "../preprocessor/src/DynareBison.yy"
                       {
                         yylhs.value.as < vector<pair<string,string>> > () = yystack_[3].value.as < vector<pair<string,string>> > ();
                         yylhs.value.as < vector<pair<string,string>> > ().emplace_back(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ());
                       }
#line 2195 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 145: // symbol_list_with_tex: symbol TEX_NAME
#line 447 "../preprocessor/src/DynareBison.yy"
                       { yylhs.value.as < vector<pair<string,string>> > () = {{yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()}}; }
#line 2201 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 146: // partition_elem: symbol EQUAL QUOTED_STRING
#line 451 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < pair<string,string> > () = {yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()}; }
#line 2207 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 147: // partition_1: '(' partition_elem
#line 454 "../preprocessor/src/DynareBison.yy"
              { yylhs.value.as < vector<pair<string,string>> > () = {yystack_[0].value.as < pair<string,string> > ()}; }
#line 2213 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 148: // partition_1: '(' COMMA partition_elem
#line 456 "../preprocessor/src/DynareBison.yy"
              { yylhs.value.as < vector<pair<string,string>> > () = {yystack_[0].value.as < pair<string,string> > ()}; }
#line 2219 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 149: // partition_1: partition_1 partition_elem
#line 458 "../preprocessor/src/DynareBison.yy"
              {
                yylhs.value.as < vector<pair<string,string>> > () = yystack_[1].value.as < vector<pair<string,string>> > ();
                yylhs.value.as < vector<pair<string,string>> > ().push_back(yystack_[0].value.as < pair<string,string> > ());
              }
#line 2228 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 150: // partition_1: partition_1 COMMA partition_elem
#line 463 "../preprocessor/src/DynareBison.yy"
              {
                yylhs.value.as < vector<pair<string,string>> > () = yystack_[2].value.as < vector<pair<string,string>> > ();
                yylhs.value.as < vector<pair<string,string>> > ().push_back(yystack_[0].value.as < pair<string,string> > ());
              }
#line 2237 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 151: // partition: partition_1 ')'
#line 469 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < vector<pair<string,string>> > () = yystack_[1].value.as < vector<pair<string,string>> > (); }
#line 2243 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 152: // partition: partition_1 COMMA ')'
#line 470 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < vector<pair<string,string>> > () = yystack_[2].value.as < vector<pair<string,string>> > (); }
#line 2249 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 153: // symbol_list_with_tex_and_partition: symbol_list_with_tex_and_partition symbol
#line 474 "../preprocessor/src/DynareBison.yy"
                                     {
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ();
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ().emplace_back(yystack_[0].value.as < string > (), "", vector<pair<string,string>>{});
                                     }
#line 2258 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 154: // symbol_list_with_tex_and_partition: symbol_list_with_tex_and_partition COMMA symbol
#line 479 "../preprocessor/src/DynareBison.yy"
                                     {
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = yystack_[2].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ();
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ().emplace_back(yystack_[0].value.as < string > (), "", vector<pair<string,string>>{});
                                     }
#line 2267 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 155: // symbol_list_with_tex_and_partition: symbol
#line 484 "../preprocessor/src/DynareBison.yy"
                                     { yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = {{yystack_[0].value.as < string > (), "", {}}}; }
#line 2273 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 156: // symbol_list_with_tex_and_partition: symbol_list_with_tex_and_partition symbol partition
#line 486 "../preprocessor/src/DynareBison.yy"
                                     {
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = yystack_[2].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ();
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ().emplace_back(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ());
                                     }
#line 2282 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 157: // symbol_list_with_tex_and_partition: symbol_list_with_tex_and_partition COMMA symbol partition
#line 491 "../preprocessor/src/DynareBison.yy"
                                     {
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = yystack_[3].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ();
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ().emplace_back(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ());
                                     }
#line 2291 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 158: // symbol_list_with_tex_and_partition: symbol partition
#line 496 "../preprocessor/src/DynareBison.yy"
                                     { yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = {{yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()}}; }
#line 2297 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 159: // symbol_list_with_tex_and_partition: symbol_list_with_tex_and_partition symbol TEX_NAME
#line 498 "../preprocessor/src/DynareBison.yy"
                                     {
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = yystack_[2].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ();
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ().emplace_back(yystack_[1].value.as < string > (), yystack_[0].value.as < string > (), vector<pair<string,string>>{});
                                     }
#line 2306 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 160: // symbol_list_with_tex_and_partition: symbol_list_with_tex_and_partition COMMA symbol TEX_NAME
#line 503 "../preprocessor/src/DynareBison.yy"
                                     {
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = yystack_[3].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ();
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ().emplace_back(yystack_[1].value.as < string > (), yystack_[0].value.as < string > (), vector<pair<string,string>>{});
                                     }
#line 2315 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 161: // symbol_list_with_tex_and_partition: symbol TEX_NAME
#line 508 "../preprocessor/src/DynareBison.yy"
                                     { yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = {{yystack_[1].value.as < string > (), yystack_[0].value.as < string > (), {}}}; }
#line 2321 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 162: // symbol_list_with_tex_and_partition: symbol_list_with_tex_and_partition symbol TEX_NAME partition
#line 510 "../preprocessor/src/DynareBison.yy"
                                     {
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = yystack_[3].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ();
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ().emplace_back(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ());
                                     }
#line 2330 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 163: // symbol_list_with_tex_and_partition: symbol_list_with_tex_and_partition COMMA symbol TEX_NAME partition
#line 515 "../preprocessor/src/DynareBison.yy"
                                     {
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = yystack_[4].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ();
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ().emplace_back(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ());
                                     }
#line 2339 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 164: // symbol_list_with_tex_and_partition: symbol TEX_NAME partition
#line 520 "../preprocessor/src/DynareBison.yy"
                                     { yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = {{yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()}}; }
#line 2345 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 165: // rplot: RPLOT symbol_list ';'
#line 523 "../preprocessor/src/DynareBison.yy"
                              { driver.rplot(yystack_[1].value.as < vector<string> > ()); }
#line 2351 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 166: // $@1: %empty
#line 525 "../preprocessor/src/DynareBison.yy"
                                              { driver.begin_model(); }
#line 2357 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 167: // trend_var: TREND_VAR '(' GROWTH_FACTOR EQUAL $@1 hand_side ')' symbol_list_with_tex ';'
#line 526 "../preprocessor/src/DynareBison.yy"
            { driver.end_trend_var(false, yystack_[3].value.as < expr_t > (), yystack_[1].value.as < vector<pair<string,string>> > ()); }
#line 2363 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 168: // $@2: %empty
#line 529 "../preprocessor/src/DynareBison.yy"
                                                          { driver.begin_model(); }
#line 2369 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 169: // log_trend_var: LOG_TREND_VAR '(' LOG_GROWTH_FACTOR EQUAL $@2 hand_side ')' symbol_list_with_tex ';'
#line 530 "../preprocessor/src/DynareBison.yy"
                { driver.end_trend_var(true, yystack_[3].value.as < expr_t > (), yystack_[1].value.as < vector<pair<string,string>> > ()); }
#line 2375 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 170: // var: VAR symbol_list_with_tex_and_partition ';'
#line 534 "../preprocessor/src/DynareBison.yy"
      { driver.var(yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > (), false); }
#line 2381 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 171: // var: VAR '(' LOG ')' symbol_list_with_tex_and_partition ';'
#line 536 "../preprocessor/src/DynareBison.yy"
      { driver.var(yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > (), true); }
#line 2387 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 172: // $@3: %empty
#line 537 "../preprocessor/src/DynareBison.yy"
                             { driver.begin_model(); }
#line 2393 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 173: // var: VAR '(' DEFLATOR EQUAL $@3 hand_side ')' symbol_list_with_tex_and_partition ';'
#line 538 "../preprocessor/src/DynareBison.yy"
      { driver.end_nonstationary_var(false, yystack_[3].value.as < expr_t > (), yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > (), false); }
#line 2399 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 174: // $@4: %empty
#line 539 "../preprocessor/src/DynareBison.yy"
                                       { driver.begin_model(); }
#line 2405 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 175: // var: VAR '(' LOG COMMA DEFLATOR EQUAL $@4 hand_side ')' symbol_list_with_tex_and_partition ';'
#line 540 "../preprocessor/src/DynareBison.yy"
      { driver.end_nonstationary_var(false, yystack_[3].value.as < expr_t > (), yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > (), true); }
#line 2411 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 176: // $@5: %empty
#line 541 "../preprocessor/src/DynareBison.yy"
                                 { driver.begin_model(); }
#line 2417 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 177: // var: VAR '(' LOG_DEFLATOR EQUAL $@5 hand_side ')' symbol_list_with_tex_and_partition ';'
#line 542 "../preprocessor/src/DynareBison.yy"
      { driver.end_nonstationary_var(true, yystack_[3].value.as < expr_t > (), yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > (), false); }
#line 2423 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 178: // var_remove: VAR_REMOVE symbol_list ';'
#line 547 "../preprocessor/src/DynareBison.yy"
                                        { driver.var_remove(yystack_[1].value.as < vector<string> > ()); }
#line 2429 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 179: // var_model: VAR_MODEL '(' var_model_options_list ')' ';'
#line 549 "../preprocessor/src/DynareBison.yy"
                                                         { driver.var_model(); }
#line 2435 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 185: // trend_component_model: TREND_COMPONENT_MODEL '(' trend_component_model_options_list ')' ';'
#line 561 "../preprocessor/src/DynareBison.yy"
                                                                                              { driver.trend_component_model(); }
#line 2441 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 191: // $@6: %empty
#line 573 "../preprocessor/src/DynareBison.yy"
                          { driver.begin_pac_model(); }
#line 2447 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 192: // pac_model: PAC_MODEL '(' $@6 pac_model_options_list ')' ';'
#line 573 "../preprocessor/src/DynareBison.yy"
                                                                                       { driver.pac_model(); }
#line 2453 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 201: // var_expectation_model: VAR_EXPECTATION_MODEL '(' var_expectation_model_options_list ')' ';'
#line 588 "../preprocessor/src/DynareBison.yy"
                        { driver.var_expectation_model(); }
#line 2459 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 204: // var_expectation_model_option: VARIABLE EQUAL symbol
#line 597 "../preprocessor/src/DynareBison.yy"
                               { driver.option_str("variable", yystack_[0].value.as < string > ()); }
#line 2465 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 205: // $@7: %empty
#line 598 "../preprocessor/src/DynareBison.yy"
                                                { driver.begin_model(); }
#line 2471 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 206: // var_expectation_model_option: EXPRESSION EQUAL $@7 hand_side
#line 599 "../preprocessor/src/DynareBison.yy"
                               {
                                 driver.var_expectation_model_expression = yystack_[0].value.as < expr_t > ();
                                 driver.reset_data_tree();
                               }
#line 2480 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 207: // var_expectation_model_option: AUXILIARY_MODEL_NAME EQUAL symbol
#line 604 "../preprocessor/src/DynareBison.yy"
                               { driver.option_str("auxiliary_model_name", yystack_[0].value.as < string > ()); }
#line 2486 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 208: // var_expectation_model_option: HORIZON EQUAL INT_NUMBER
#line 606 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("horizon", yystack_[0].value.as < string > ()); }
#line 2492 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 209: // var_expectation_model_option: HORIZON EQUAL integer_range_w_inf
#line 608 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("horizon", "[ " + yystack_[0].value.as < pair<string,string> > ().first + ' ' + yystack_[0].value.as < pair<string,string> > ().second + " ]"); }
#line 2498 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 210: // var_expectation_model_option: MODEL_NAME EQUAL symbol
#line 610 "../preprocessor/src/DynareBison.yy"
                               { driver.option_str("model_name", yystack_[0].value.as < string > ()); }
#line 2504 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 211: // var_expectation_model_option: DISCOUNT EQUAL expression
#line 612 "../preprocessor/src/DynareBison.yy"
                               { driver.var_expectation_model_discount = yystack_[0].value.as < expr_t > (); }
#line 2510 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 212: // var_expectation_model_option: TIME_SHIFT EQUAL signed_integer
#line 614 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("time_shift", yystack_[0].value.as < string > ()); }
#line 2516 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 213: // varexo: VAREXO symbol_list_with_tex_and_partition ';'
#line 618 "../preprocessor/src/DynareBison.yy"
         { driver.varexo(yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ()); }
#line 2522 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 214: // varexo_det: VAREXO_DET symbol_list_with_tex_and_partition ';'
#line 622 "../preprocessor/src/DynareBison.yy"
             { driver.varexo_det(yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ()); }
#line 2528 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 215: // predetermined_variables: PREDETERMINED_VARIABLES symbol_list ';'
#line 626 "../preprocessor/src/DynareBison.yy"
                          { driver.predetermined_variables(yystack_[1].value.as < vector<string> > ()); }
#line 2534 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 216: // parameters: PARAMETERS symbol_list_with_tex_and_partition ';'
#line 630 "../preprocessor/src/DynareBison.yy"
             { driver.parameters(yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ()); }
#line 2540 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 217: // model_local_variable: MODEL_LOCAL_VARIABLE symbol_list_with_tex ';'
#line 634 "../preprocessor/src/DynareBison.yy"
                       { driver.model_local_variable(yystack_[1].value.as < vector<pair<string,string>> > ()); }
#line 2546 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 218: // change_type: CHANGE_TYPE '(' change_type_arg ')' symbol_list ';'
#line 638 "../preprocessor/src/DynareBison.yy"
              { driver.change_type(yystack_[3].value.as < SymbolType > (), yystack_[1].value.as < vector<string> > ()); }
#line 2552 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 219: // change_type_arg: PARAMETERS
#line 642 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < SymbolType > () = SymbolType::parameter; }
#line 2558 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 220: // change_type_arg: VAR
#line 644 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < SymbolType > () = SymbolType::endogenous; }
#line 2564 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 221: // change_type_arg: VAREXO
#line 646 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < SymbolType > () = SymbolType::exogenous; }
#line 2570 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 222: // change_type_arg: VAREXO_DET
#line 648 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < SymbolType > () = SymbolType::exogenousDet; }
#line 2576 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 223: // init_param: symbol EQUAL expression ';'
#line 651 "../preprocessor/src/DynareBison.yy"
                                         { driver.init_param(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2582 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 224: // expression: '(' expression ')'
#line 654 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = yystack_[1].value.as < expr_t > (); }
#line 2588 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 225: // expression: namespace_qualified_symbol
#line 656 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_expression_variable(yystack_[0].value.as < string > ()); }
#line 2594 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 226: // expression: non_negative_number
#line 658 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_non_negative_constant(yystack_[0].value.as < string > ()); }
#line 2600 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 227: // expression: expression PLUS expression
#line 660 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_plus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2606 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 228: // expression: expression MINUS expression
#line 662 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_minus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2612 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 229: // expression: expression DIVIDE expression
#line 664 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_divide(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2618 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 230: // expression: expression TIMES expression
#line 666 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_times(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2624 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 231: // expression: expression POWER expression
#line 668 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_power(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2630 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 232: // expression: expression LESS expression
#line 670 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_less(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2636 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 233: // expression: expression GREATER expression
#line 672 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_greater(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2642 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 234: // expression: expression LESS_EQUAL expression
#line 674 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_less_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2648 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 235: // expression: expression GREATER_EQUAL expression
#line 676 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_greater_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2654 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 236: // expression: expression EQUAL_EQUAL expression
#line 678 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_equal_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2660 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 237: // expression: expression EXCLAMATION_EQUAL expression
#line 680 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_different(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2666 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 238: // expression: MINUS expression
#line 682 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_uminus(yystack_[0].value.as < expr_t > ()); }
#line 2672 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 239: // expression: PLUS expression
#line 684 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = yystack_[0].value.as < expr_t > (); }
#line 2678 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 240: // expression: EXP '(' expression ')'
#line 686 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_exp(yystack_[1].value.as < expr_t > ()); }
#line 2684 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 241: // expression: LOG '(' expression ')'
#line 688 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 2690 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 242: // expression: LN '(' expression ')'
#line 690 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 2696 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 243: // expression: LOG10 '(' expression ')'
#line 692 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_log10(yystack_[1].value.as < expr_t > ()); }
#line 2702 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 244: // expression: SIN '(' expression ')'
#line 694 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_sin(yystack_[1].value.as < expr_t > ()); }
#line 2708 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 245: // expression: COS '(' expression ')'
#line 696 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_cos(yystack_[1].value.as < expr_t > ()); }
#line 2714 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 246: // expression: TAN '(' expression ')'
#line 698 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_tan(yystack_[1].value.as < expr_t > ()); }
#line 2720 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 247: // expression: ASIN '(' expression ')'
#line 700 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_asin(yystack_[1].value.as < expr_t > ()); }
#line 2726 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 248: // expression: ACOS '(' expression ')'
#line 702 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_acos(yystack_[1].value.as < expr_t > ()); }
#line 2732 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 249: // expression: ATAN '(' expression ')'
#line 704 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_atan(yystack_[1].value.as < expr_t > ()); }
#line 2738 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 250: // expression: SINH '(' expression ')'
#line 706 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_sinh(yystack_[1].value.as < expr_t > ()); }
#line 2744 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 251: // expression: COSH '(' expression ')'
#line 708 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_cosh(yystack_[1].value.as < expr_t > ()); }
#line 2750 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 252: // expression: TANH '(' expression ')'
#line 710 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_tanh(yystack_[1].value.as < expr_t > ()); }
#line 2756 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 253: // expression: ASINH '(' expression ')'
#line 712 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_asinh(yystack_[1].value.as < expr_t > ()); }
#line 2762 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 254: // expression: ACOSH '(' expression ')'
#line 714 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_acosh(yystack_[1].value.as < expr_t > ()); }
#line 2768 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 255: // expression: ATANH '(' expression ')'
#line 716 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_atanh(yystack_[1].value.as < expr_t > ()); }
#line 2774 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 256: // expression: SQRT '(' expression ')'
#line 718 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_sqrt(yystack_[1].value.as < expr_t > ()); }
#line 2780 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 257: // expression: CBRT '(' expression ')'
#line 720 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_cbrt(yystack_[1].value.as < expr_t > ()); }
#line 2786 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 258: // expression: ABS '(' expression ')'
#line 722 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_abs(yystack_[1].value.as < expr_t > ()); }
#line 2792 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 259: // expression: SIGN '(' expression ')'
#line 724 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_sign(yystack_[1].value.as < expr_t > ()); }
#line 2798 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 260: // expression: MAX '(' expression COMMA expression ')'
#line 726 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_max(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2804 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 261: // expression: MIN '(' expression COMMA expression ')'
#line 728 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_min(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2810 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 262: // $@8: %empty
#line 729 "../preprocessor/src/DynareBison.yy"
                                        { driver.push_external_function_arg_vector_onto_stack(); }
#line 2816 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 263: // expression: namespace_qualified_symbol $@8 '(' comma_expression ')'
#line 730 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_model_var_or_external_function(yystack_[4].value.as < string > (), false); }
#line 2822 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 264: // expression: NORMCDF '(' expression COMMA expression COMMA expression ')'
#line 732 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2828 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 265: // expression: NORMCDF '(' expression ')'
#line 734 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[1].value.as < expr_t > ()); }
#line 2834 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 266: // expression: NORMPDF '(' expression COMMA expression COMMA expression ')'
#line 736 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2840 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 267: // expression: NORMPDF '(' expression ')'
#line 738 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[1].value.as < expr_t > ()); }
#line 2846 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 268: // expression: ERF '(' expression ')'
#line 740 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_erf(yystack_[1].value.as < expr_t > ()); }
#line 2852 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 269: // expression: ERFC '(' expression ')'
#line 742 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_erfc(yystack_[1].value.as < expr_t > ()); }
#line 2858 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 270: // expression: NAN_CONSTANT
#line 744 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_nan_constant(); }
#line 2864 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 271: // expression: INF_CONSTANT
#line 746 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_inf_constant(); }
#line 2870 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 272: // comma_expression: expression
#line 750 "../preprocessor/src/DynareBison.yy"
                   { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 2876 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 273: // comma_expression: comma_expression COMMA expression
#line 752 "../preprocessor/src/DynareBison.yy"
                   { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 2882 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 274: // expression_or_empty: %empty
#line 756 "../preprocessor/src/DynareBison.yy"
                      { yylhs.value.as < expr_t > () = driver.add_nan_constant(); }
#line 2888 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 275: // expression_or_empty: expression
#line 757 "../preprocessor/src/DynareBison.yy"
                      { yylhs.value.as < expr_t > () = yystack_[0].value.as < expr_t > (); }
#line 2894 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 276: // initval: INITVAL ';' initval_list END ';'
#line 761 "../preprocessor/src/DynareBison.yy"
          { driver.end_initval(false); }
#line 2900 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 277: // initval: INITVAL '(' ALL_VALUES_REQUIRED ')' ';' initval_list END ';'
#line 763 "../preprocessor/src/DynareBison.yy"
          { driver.end_initval(true); }
#line 2906 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 280: // initval_elem: symbol EQUAL expression ';'
#line 770 "../preprocessor/src/DynareBison.yy"
                                           { driver.init_val(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2912 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 281: // histval_file: HISTVAL_FILE '(' h_options_list ')' ';'
#line 773 "../preprocessor/src/DynareBison.yy"
              { driver.histval_file(); }
#line 2918 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 282: // initval_file: INITVAL_FILE '(' h_options_list ')' ';'
#line 776 "../preprocessor/src/DynareBison.yy"
              { driver.initval_file(); }
#line 2924 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 297: // endval: ENDVAL ';' endval_list END ';'
#line 797 "../preprocessor/src/DynareBison.yy"
         { driver.end_endval(false); }
#line 2930 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 298: // endval: ENDVAL '(' ALL_VALUES_REQUIRED ')' ';' endval_list END ';'
#line 799 "../preprocessor/src/DynareBison.yy"
         { driver.end_endval(true); }
#line 2936 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 299: // endval: ENDVAL '(' LEARNT_IN EQUAL INT_NUMBER ')' ';' endval_list END ';'
#line 801 "../preprocessor/src/DynareBison.yy"
         { driver.end_endval_learnt_in(yystack_[5].value.as < string > ()); }
#line 2942 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 302: // endval_elem: symbol EQUAL expression ';'
#line 809 "../preprocessor/src/DynareBison.yy"
              { driver.end_val(EndValLearntInStatement::LearntEndValType::level, yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2948 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 303: // endval_elem: symbol PLUS_EQUAL expression ';'
#line 811 "../preprocessor/src/DynareBison.yy"
              { driver.end_val(EndValLearntInStatement::LearntEndValType::add, yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2954 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 304: // endval_elem: symbol TIMES_EQUAL expression ';'
#line 813 "../preprocessor/src/DynareBison.yy"
              { driver.end_val(EndValLearntInStatement::LearntEndValType::multiply, yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2960 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 305: // histval: HISTVAL ';' histval_list END ';'
#line 817 "../preprocessor/src/DynareBison.yy"
          { driver.end_histval(false); }
#line 2966 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 306: // histval: HISTVAL '(' ALL_VALUES_REQUIRED ')' ';' histval_list END ';'
#line 819 "../preprocessor/src/DynareBison.yy"
          { driver.end_histval(true); }
#line 2972 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 309: // histval_elem: symbol '(' signed_integer ')' EQUAL expression ';'
#line 826 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.hist_val(yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2978 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 310: // $@9: %empty
#line 828 "../preprocessor/src/DynareBison.yy"
                        { driver.begin_epilogue(); }
#line 2984 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 311: // epilogue: EPILOGUE ';' $@9 epilogue_equation_list END ';'
#line 829 "../preprocessor/src/DynareBison.yy"
                                          { driver.end_epilogue(); }
#line 2990 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 314: // $@10: %empty
#line 836 "../preprocessor/src/DynareBison.yy"
                         { driver.add_epilogue_variable(yystack_[0].value.as < string > ()); }
#line 2996 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 315: // epilogue_equation: NAME $@10 EQUAL expression ';'
#line 837 "../preprocessor/src/DynareBison.yy"
                    { driver.add_epilogue_equal(yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3002 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 316: // compilation_setup: COMPILATION_SETUP '(' compilation_setup_options_list ')' ';'
#line 840 "../preprocessor/src/DynareBison.yy"
                                                                                 { }
#line 3008 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 319: // compilation_setup_option: SUBSTITUTE_FLAGS EQUAL QUOTED_STRING
#line 847 "../preprocessor/src/DynareBison.yy"
                           { driver.compilation_setup_substitute_flags(yystack_[0].value.as < string > ()); }
#line 3014 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 320: // compilation_setup_option: ADD_FLAGS EQUAL QUOTED_STRING
#line 849 "../preprocessor/src/DynareBison.yy"
                           { driver.compilation_setup_add_flags(yystack_[0].value.as < string > ()); }
#line 3020 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 321: // compilation_setup_option: SUBSTITUTE_LIBS EQUAL QUOTED_STRING
#line 851 "../preprocessor/src/DynareBison.yy"
                           { driver.compilation_setup_substitute_libs(yystack_[0].value.as < string > ()); }
#line 3026 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 322: // compilation_setup_option: ADD_LIBS EQUAL QUOTED_STRING
#line 853 "../preprocessor/src/DynareBison.yy"
                           { driver.compilation_setup_add_libs(yystack_[0].value.as < string > ()); }
#line 3032 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 323: // compilation_setup_option: COMPILER EQUAL QUOTED_STRING
#line 855 "../preprocessor/src/DynareBison.yy"
                           { driver.compilation_setup_compiler(yystack_[0].value.as < string > ()); }
#line 3038 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 324: // $@11: %empty
#line 858 "../preprocessor/src/DynareBison.yy"
                                      { driver.begin_matched_moments(); }
#line 3044 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 325: // matched_moments: MATCHED_MOMENTS ';' $@11 matched_moments_list END ';'
#line 859 "../preprocessor/src/DynareBison.yy"
                                               { driver.end_matched_moments(yystack_[2].value.as < vector<expr_t> > ()); }
#line 3050 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 326: // matched_moments_list: hand_side ';'
#line 863 "../preprocessor/src/DynareBison.yy"
                       { yylhs.value.as < vector<expr_t> > () = {yystack_[1].value.as < expr_t > ()}; }
#line 3056 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 327: // matched_moments_list: matched_moments_list hand_side ';'
#line 865 "../preprocessor/src/DynareBison.yy"
                       {
                         yylhs.value.as < vector<expr_t> > () = yystack_[2].value.as < vector<expr_t> > ();
                         yylhs.value.as < vector<expr_t> > ().push_back(yystack_[1].value.as < expr_t > ());
                       }
#line 3065 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 328: // $@12: %empty
#line 871 "../preprocessor/src/DynareBison.yy"
                                            { driver.begin_occbin_constraints(); }
#line 3071 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 329: // occbin_constraints: OCCBIN_CONSTRAINTS ';' $@12 occbin_constraints_regimes_list END ';'
#line 872 "../preprocessor/src/DynareBison.yy"
                                                             { driver.end_occbin_constraints(yystack_[2].value.as < vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > ()); }
#line 3077 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 330: // occbin_constraints_regimes_list: occbin_constraints_regime
#line 877 "../preprocessor/src/DynareBison.yy"
                                  { yylhs.value.as < vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > () = {yystack_[0].value.as < tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > ()}; }
#line 3083 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 331: // occbin_constraints_regimes_list: occbin_constraints_regimes_list occbin_constraints_regime
#line 879 "../preprocessor/src/DynareBison.yy"
                                  {
                                    yylhs.value.as < vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > () = yystack_[1].value.as < vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > ();
                                    yylhs.value.as < vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > ().push_back(yystack_[0].value.as < tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > ());
                                  }
#line 3092 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 332: // occbin_constraints_regime: NAME QUOTED_STRING ';' occbin_constraints_regime_options_list
#line 886 "../preprocessor/src/DynareBison.yy"
                            {
                              BinaryOpNode *bind = dynamic_cast<BinaryOpNode *>(yystack_[0].value.as < map<string, expr_t> > ()["bind"]);
                              if (bind && !(bind->op_code == BinaryOpcode::less
                                            || bind->op_code == BinaryOpcode::greater
                                            || bind->op_code == BinaryOpcode::lessEqual
                                            || bind->op_code == BinaryOpcode::greaterEqual))
                                driver.error("The 'bind' expression must be an inequality constraint");
                              BinaryOpNode *relax = dynamic_cast<BinaryOpNode *>(yystack_[0].value.as < map<string, expr_t> > ()["relax"]);
                              if (relax && !(relax->op_code == BinaryOpcode::less
                                             || relax->op_code == BinaryOpcode::greater
                                             || relax->op_code == BinaryOpcode::lessEqual
                                             || relax->op_code == BinaryOpcode::greaterEqual))
                                driver.error("The 'relax' expression must be an inequality constraint");
                              yylhs.value.as < tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > () = {yystack_[2].value.as < string > (), bind, relax, yystack_[0].value.as < map<string, expr_t> > ()["error_bind"], yystack_[0].value.as < map<string, expr_t> > ()["error_relax"]};
                            }
#line 3112 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 333: // occbin_constraints_regime_options_list: occbin_constraints_regime_option
#line 904 "../preprocessor/src/DynareBison.yy"
                                         { yylhs.value.as < map<string, expr_t> > () = {yystack_[0].value.as < pair<string, expr_t> > ()}; }
#line 3118 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 334: // occbin_constraints_regime_options_list: occbin_constraints_regime_options_list occbin_constraints_regime_option
#line 906 "../preprocessor/src/DynareBison.yy"
                                         {
                                           yylhs.value.as < map<string, expr_t> > () = yystack_[1].value.as < map<string, expr_t> > ();
                                           auto [it, success] = yylhs.value.as < map<string, expr_t> > ().insert(yystack_[0].value.as < pair<string, expr_t> > ());
                                           if (!success)
                                             driver.error("The '" + yystack_[0].value.as < pair<string, expr_t> > ().first + "' clause is declared multiple times");
                                         }
#line 3129 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 335: // occbin_constraints_regime_option: BIND hand_side ';'
#line 915 "../preprocessor/src/DynareBison.yy"
                                   { yylhs.value.as < pair<string, expr_t> > () = {"bind", yystack_[1].value.as < expr_t > ()}; }
#line 3135 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 336: // occbin_constraints_regime_option: RELAX hand_side ';'
#line 917 "../preprocessor/src/DynareBison.yy"
                                   { yylhs.value.as < pair<string, expr_t> > () = {"relax", yystack_[1].value.as < expr_t > ()}; }
#line 3141 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 337: // occbin_constraints_regime_option: ERROR_BIND hand_side ';'
#line 919 "../preprocessor/src/DynareBison.yy"
                                   { yylhs.value.as < pair<string, expr_t> > () = {"error_bind", yystack_[1].value.as < expr_t > ()}; }
#line 3147 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 338: // occbin_constraints_regime_option: ERROR_RELAX hand_side ';'
#line 921 "../preprocessor/src/DynareBison.yy"
                                   { yylhs.value.as < pair<string, expr_t> > () = {"error_relax", yystack_[1].value.as < expr_t > ()}; }
#line 3153 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 339: // $@13: %empty
#line 925 "../preprocessor/src/DynareBison.yy"
                  { driver.begin_pac_target_info(yystack_[2].value.as < string > ()); }
#line 3159 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 340: // pac_target_info: PAC_TARGET_INFO '(' symbol ')' ';' $@13 pac_target_info_statement_list END ';'
#line 928 "../preprocessor/src/DynareBison.yy"
                  { driver.end_pac_target_info(); }
#line 3165 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 343: // pac_target_info_statement: TARGET hand_side ';'
#line 936 "../preprocessor/src/DynareBison.yy"
                            { driver.set_pac_target_info_target(yystack_[1].value.as < expr_t > ()); }
#line 3171 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 344: // pac_target_info_statement: AUXNAME_TARGET_NONSTATIONARY symbol ';'
#line 938 "../preprocessor/src/DynareBison.yy"
                            { driver.set_pac_target_info_auxname_target_nonstationary(yystack_[1].value.as < string > ()); }
#line 3177 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 346: // pac_target_info_component: COMPONENT hand_side ';' pac_target_info_component_list
#line 944 "../preprocessor/src/DynareBison.yy"
                            { driver.add_pac_target_info_component(yystack_[2].value.as < expr_t > ()); }
#line 3183 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 349: // pac_target_info_component_elem: GROWTH hand_side ';'
#line 952 "../preprocessor/src/DynareBison.yy"
                                 { driver.set_pac_target_info_component_growth(yystack_[1].value.as < expr_t > ()); }
#line 3189 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 350: // pac_target_info_component_elem: AUXNAME symbol ';'
#line 954 "../preprocessor/src/DynareBison.yy"
                                 { driver.set_pac_target_info_component_auxname(yystack_[1].value.as < string > ()); }
#line 3195 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 351: // pac_target_info_component_elem: KIND pac_target_kind ';'
#line 956 "../preprocessor/src/DynareBison.yy"
                                 { driver.set_pac_target_info_component_kind(yystack_[1].value.as < PacTargetKind > ()); }
#line 3201 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 352: // pac_target_kind: LL
#line 960 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < PacTargetKind > () = PacTargetKind::ll; }
#line 3207 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 353: // pac_target_kind: DL
#line 962 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < PacTargetKind > () = PacTargetKind::dl; }
#line 3213 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 354: // pac_target_kind: DD
#line 964 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < PacTargetKind > () = PacTargetKind::dd; }
#line 3219 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 355: // resid: RESID ';'
#line 968 "../preprocessor/src/DynareBison.yy"
        { driver.resid(); }
#line 3225 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 356: // resid: RESID '(' o_non_zero ')' ';'
#line 970 "../preprocessor/src/DynareBison.yy"
        { driver.resid(); }
#line 3231 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 357: // model_option: BLOCK
#line 976 "../preprocessor/src/DynareBison.yy"
                     { driver.block(); }
#line 3237 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 358: // model_option: CUTOFF EQUAL non_negative_number
#line 977 "../preprocessor/src/DynareBison.yy"
                                                { driver.cutoff(yystack_[0].value.as < string > ()); }
#line 3243 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 359: // model_option: MFS EQUAL INT_NUMBER
#line 978 "../preprocessor/src/DynareBison.yy"
                                    { driver.mfs(yystack_[0].value.as < string > ()); }
#line 3249 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 360: // model_option: STATIC_MFS EQUAL INT_NUMBER
#line 979 "../preprocessor/src/DynareBison.yy"
                                           { driver.static_mfs(yystack_[0].value.as < string > ()); }
#line 3255 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 361: // model_option: BYTECODE
#line 980 "../preprocessor/src/DynareBison.yy"
                        { driver.bytecode(); }
#line 3261 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 362: // model_option: USE_DLL
#line 981 "../preprocessor/src/DynareBison.yy"
                       { driver.use_dll(); }
#line 3267 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 363: // model_option: NO_STATIC
#line 982 "../preprocessor/src/DynareBison.yy"
                         { driver.no_static(); }
#line 3273 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 364: // model_option: DIFFERENTIATE_FORWARD_VARS
#line 983 "../preprocessor/src/DynareBison.yy"
                                          { driver.differentiate_forward_vars_all(); }
#line 3279 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 365: // model_option: DIFFERENTIATE_FORWARD_VARS EQUAL '(' symbol_list ')'
#line 984 "../preprocessor/src/DynareBison.yy"
                                                                    { driver.differentiate_forward_vars_some(yystack_[1].value.as < vector<string> > ()); }
#line 3285 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 366: // model_option: LINEAR
#line 985 "../preprocessor/src/DynareBison.yy"
                      { driver.linear(); }
#line 3291 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 368: // model_option: BALANCED_GROWTH_TEST_TOL EQUAL non_negative_number
#line 987 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.balanced_growth_test_tol(yystack_[0].value.as < string > ()); }
#line 3297 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 371: // $@14: %empty
#line 994 "../preprocessor/src/DynareBison.yy"
                  { driver.begin_model(); }
#line 3303 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 372: // model: MODEL ';' $@14 equation_list END ';'
#line 995 "../preprocessor/src/DynareBison.yy"
                              { driver.end_model(); }
#line 3309 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 373: // $@15: %empty
#line 996 "../preprocessor/src/DynareBison.yy"
                                             { driver.begin_model(); }
#line 3315 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 374: // model: MODEL '(' model_options_list ')' ';' $@15 equation_list END ';'
#line 997 "../preprocessor/src/DynareBison.yy"
                              { driver.end_model(); }
#line 3321 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 379: // equation: hand_side EQUAL hand_side ';'
#line 1007 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < expr_t > () = driver.add_model_equal(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > (), {}); }
#line 3327 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 380: // equation: hand_side ';'
#line 1009 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < expr_t > () = driver.add_model_equal_with_zero_rhs(yystack_[1].value.as < expr_t > (), {}); }
#line 3333 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 381: // equation: '[' tag_pair_list ']' hand_side EQUAL hand_side ';'
#line 1011 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < expr_t > () = driver.add_model_equal(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > (), yystack_[5].value.as < map<string, string> > ()); }
#line 3339 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 382: // equation: '[' tag_pair_list ']' hand_side ';'
#line 1013 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < expr_t > () = driver.add_model_equal_with_zero_rhs(yystack_[1].value.as < expr_t > (), yystack_[3].value.as < map<string, string> > ()); }
#line 3345 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 383: // tag_pair_list: tag_pair_list COMMA tag_pair
#line 1017 "../preprocessor/src/DynareBison.yy"
                {
                  yylhs.value.as < map<string, string> > () = yystack_[2].value.as < map<string, string> > ();
                  auto [it, success] = yylhs.value.as < map<string, string> > ().emplace(yystack_[0].value.as < pair<string,string> > ());
                  if (!success)
                    driver.error("Tag '" + yystack_[0].value.as < pair<string,string> > ().first + "' cannot be used twice for the same equation");
                }
#line 3356 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 384: // tag_pair_list: tag_pair
#line 1024 "../preprocessor/src/DynareBison.yy"
                { yylhs.value.as < map<string, string> > () = {yystack_[0].value.as < pair<string,string> > ()}; }
#line 3362 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 385: // tag_pair: symbol EQUAL QUOTED_STRING
#line 1028 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < pair<string,string> > () = {str_tolower(yystack_[2].value.as < string > ()), yystack_[0].value.as < string > ()}; }
#line 3368 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 386: // tag_pair: symbol
#line 1030 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < pair<string,string> > () = {str_tolower(yystack_[0].value.as < string > ()), ""}; }
#line 3374 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 387: // hand_side: '(' hand_side ')'
#line 1034 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = yystack_[1].value.as < expr_t > (); }
#line 3380 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 388: // hand_side: namespace_qualified_symbol
#line 1036 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_model_variable(yystack_[0].value.as < string > ()); }
#line 3386 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 389: // hand_side: symbol PIPE_E
#line 1038 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.declare_or_change_type(SymbolType::endogenous, yystack_[1].value.as < string > ()); }
#line 3392 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 390: // hand_side: symbol PIPE_X
#line 1040 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.declare_or_change_type(SymbolType::exogenous, yystack_[1].value.as < string > ()); }
#line 3398 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 391: // hand_side: symbol PIPE_P
#line 1042 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.declare_or_change_type(SymbolType::parameter, yystack_[1].value.as < string > ()); }
#line 3404 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 392: // hand_side: non_negative_number
#line 1044 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_non_negative_constant(yystack_[0].value.as < string > ()); }
#line 3410 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 393: // hand_side: hand_side PLUS hand_side
#line 1046 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_plus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3416 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 394: // hand_side: hand_side MINUS hand_side
#line 1048 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_minus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3422 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 395: // hand_side: hand_side DIVIDE hand_side
#line 1050 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_divide(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3428 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 396: // hand_side: hand_side TIMES hand_side
#line 1052 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_times(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3434 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 397: // hand_side: hand_side LESS hand_side
#line 1054 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_less(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3440 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 398: // hand_side: hand_side GREATER hand_side
#line 1056 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_greater(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3446 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 399: // hand_side: hand_side LESS_EQUAL hand_side
#line 1058 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_less_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3452 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 400: // hand_side: hand_side GREATER_EQUAL hand_side
#line 1060 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_greater_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3458 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 401: // hand_side: hand_side EQUAL_EQUAL hand_side
#line 1062 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_equal_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3464 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 402: // hand_side: hand_side EXCLAMATION_EQUAL hand_side
#line 1064 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_different(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3470 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 403: // hand_side: hand_side POWER hand_side
#line 1066 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_power(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3476 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 404: // hand_side: EXPECTATION '(' signed_integer ')' '(' hand_side ')'
#line 1068 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_expectation(yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3482 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 405: // hand_side: VAR_EXPECTATION '(' symbol ')'
#line 1070 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_var_expectation(yystack_[1].value.as < string > ()); }
#line 3488 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 406: // hand_side: PAC_EXPECTATION '(' symbol ')'
#line 1072 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_pac_expectation(yystack_[1].value.as < string > ()); }
#line 3494 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 407: // hand_side: PAC_TARGET_NONSTATIONARY '(' symbol ')'
#line 1074 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_pac_target_nonstationary(yystack_[1].value.as < string > ()); }
#line 3500 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 408: // hand_side: MINUS hand_side
#line 1076 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_uminus(yystack_[0].value.as < expr_t > ()); }
#line 3506 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 409: // hand_side: PLUS hand_side
#line 1078 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = yystack_[0].value.as < expr_t > (); }
#line 3512 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 410: // hand_side: EXP '(' hand_side ')'
#line 1080 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_exp(yystack_[1].value.as < expr_t > ()); }
#line 3518 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 411: // hand_side: DIFF '(' hand_side ')'
#line 1082 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_diff(yystack_[1].value.as < expr_t > ()); }
#line 3524 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 412: // hand_side: ADL '(' hand_side COMMA QUOTED_STRING ')'
#line 1084 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_adl(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < string > (), "1"); }
#line 3530 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 413: // hand_side: ADL '(' hand_side COMMA QUOTED_STRING COMMA INT_NUMBER ')'
#line 1086 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_adl(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 3536 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 414: // hand_side: ADL '(' hand_side COMMA QUOTED_STRING COMMA vec_int ')'
#line 1088 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_adl(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < string > (), yystack_[1].value.as < vector<int> > ()); }
#line 3542 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 415: // hand_side: LOG '(' hand_side ')'
#line 1090 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 3548 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 416: // hand_side: LN '(' hand_side ')'
#line 1092 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 3554 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 417: // hand_side: LOG10 '(' hand_side ')'
#line 1094 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_log10(yystack_[1].value.as < expr_t > ()); }
#line 3560 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 418: // hand_side: SIN '(' hand_side ')'
#line 1096 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_sin(yystack_[1].value.as < expr_t > ()); }
#line 3566 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 419: // hand_side: COS '(' hand_side ')'
#line 1098 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_cos(yystack_[1].value.as < expr_t > ()); }
#line 3572 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 420: // hand_side: TAN '(' hand_side ')'
#line 1100 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_tan(yystack_[1].value.as < expr_t > ()); }
#line 3578 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 421: // hand_side: ASIN '(' hand_side ')'
#line 1102 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_asin(yystack_[1].value.as < expr_t > ()); }
#line 3584 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 422: // hand_side: ACOS '(' hand_side ')'
#line 1104 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_acos(yystack_[1].value.as < expr_t > ()); }
#line 3590 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 423: // hand_side: ATAN '(' hand_side ')'
#line 1106 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_atan(yystack_[1].value.as < expr_t > ()); }
#line 3596 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 424: // hand_side: SINH '(' hand_side ')'
#line 1108 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_sinh(yystack_[1].value.as < expr_t > ()); }
#line 3602 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 425: // hand_side: COSH '(' hand_side ')'
#line 1110 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_cosh(yystack_[1].value.as < expr_t > ()); }
#line 3608 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 426: // hand_side: TANH '(' hand_side ')'
#line 1112 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_tanh(yystack_[1].value.as < expr_t > ()); }
#line 3614 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 427: // hand_side: ASINH '(' hand_side ')'
#line 1114 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_asinh(yystack_[1].value.as < expr_t > ()); }
#line 3620 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 428: // hand_side: ACOSH '(' hand_side ')'
#line 1116 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_acosh(yystack_[1].value.as < expr_t > ()); }
#line 3626 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 429: // hand_side: ATANH '(' hand_side ')'
#line 1118 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_atanh(yystack_[1].value.as < expr_t > ()); }
#line 3632 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 430: // hand_side: SQRT '(' hand_side ')'
#line 1120 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_sqrt(yystack_[1].value.as < expr_t > ()); }
#line 3638 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 431: // hand_side: CBRT '(' hand_side ')'
#line 1122 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_cbrt(yystack_[1].value.as < expr_t > ()); }
#line 3644 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 432: // hand_side: ABS '(' hand_side ')'
#line 1124 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_abs(yystack_[1].value.as < expr_t > ()); }
#line 3650 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 433: // hand_side: SIGN '(' hand_side ')'
#line 1126 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_sign(yystack_[1].value.as < expr_t > ()); }
#line 3656 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 434: // hand_side: MAX '(' hand_side COMMA hand_side ')'
#line 1128 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_max(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3662 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 435: // hand_side: MIN '(' hand_side COMMA hand_side ')'
#line 1130 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_min(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3668 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 436: // $@16: %empty
#line 1131 "../preprocessor/src/DynareBison.yy"
                                       { driver.push_external_function_arg_vector_onto_stack(); }
#line 3674 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 437: // hand_side: namespace_qualified_symbol $@16 '(' comma_hand_side ')'
#line 1132 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_model_var_or_external_function(yystack_[4].value.as < string > (), true); }
#line 3680 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 438: // hand_side: NORMCDF '(' hand_side COMMA hand_side COMMA hand_side ')'
#line 1134 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3686 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 439: // hand_side: NORMCDF '(' hand_side ')'
#line 1136 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[1].value.as < expr_t > ()); }
#line 3692 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 440: // hand_side: NORMPDF '(' hand_side COMMA hand_side COMMA hand_side ')'
#line 1138 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3698 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 441: // hand_side: NORMPDF '(' hand_side ')'
#line 1140 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[1].value.as < expr_t > ()); }
#line 3704 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 442: // hand_side: ERF '(' hand_side ')'
#line 1142 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_erf(yystack_[1].value.as < expr_t > ()); }
#line 3710 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 443: // hand_side: ERFC '(' hand_side ')'
#line 1144 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_erfc(yystack_[1].value.as < expr_t > ()); }
#line 3716 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 444: // hand_side: STEADY_STATE '(' hand_side ')'
#line 1146 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_steady_state(yystack_[1].value.as < expr_t > ()); }
#line 3722 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 445: // comma_hand_side: hand_side
#line 1150 "../preprocessor/src/DynareBison.yy"
                  { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 3728 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 446: // comma_hand_side: comma_hand_side COMMA hand_side
#line 1152 "../preprocessor/src/DynareBison.yy"
                  { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 3734 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 447: // pound_expression: '#' symbol EQUAL hand_side ';'
#line 1156 "../preprocessor/src/DynareBison.yy"
                  { driver.declare_and_init_model_local_variable(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3740 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 448: // model_remove: MODEL_REMOVE '(' tag_pair_list_for_selection ')' ';'
#line 1159 "../preprocessor/src/DynareBison.yy"
               { driver.model_remove(yystack_[2].value.as < vector<map<string, string>> > ()); }
#line 3746 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 449: // $@17: %empty
#line 1162 "../preprocessor/src/DynareBison.yy"
               { driver.begin_model_replace(yystack_[2].value.as < vector<map<string, string>> > ()); }
#line 3752 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 450: // model_replace: MODEL_REPLACE '(' tag_pair_list_for_selection ')' ';' $@17 equation_list END ';'
#line 1164 "../preprocessor/src/DynareBison.yy"
               { driver.end_model(); }
#line 3758 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 452: // tag_pair_list_for_selection: QUOTED_STRING
#line 1169 "../preprocessor/src/DynareBison.yy"
                              { yylhs.value.as < vector<map<string, string>> > () = {{{"name", yystack_[0].value.as < string > ()}}}; }
#line 3764 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 453: // tag_pair_list_for_selection: tag_pair
#line 1171 "../preprocessor/src/DynareBison.yy"
                              { yylhs.value.as < vector<map<string, string>> > () = {{yystack_[0].value.as < pair<string,string> > ()}}; }
#line 3770 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 454: // tag_pair_list_for_selection: '[' tag_pair_list ']'
#line 1173 "../preprocessor/src/DynareBison.yy"
                              { yylhs.value.as < vector<map<string, string>> > () = {yystack_[1].value.as < map<string, string> > ()}; }
#line 3776 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 455: // tag_pair_list_for_selection: tag_pair_list_for_selection COMMA QUOTED_STRING
#line 1175 "../preprocessor/src/DynareBison.yy"
                              {
                                yylhs.value.as < vector<map<string, string>> > () = yystack_[2].value.as < vector<map<string, string>> > ();
                                yylhs.value.as < vector<map<string, string>> > ().push_back({{"name", yystack_[0].value.as < string > ()}});
                              }
#line 3785 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 456: // tag_pair_list_for_selection: tag_pair_list_for_selection COMMA tag_pair
#line 1180 "../preprocessor/src/DynareBison.yy"
                              {
                                yylhs.value.as < vector<map<string, string>> > () = yystack_[2].value.as < vector<map<string, string>> > ();
                                yylhs.value.as < vector<map<string, string>> > ().push_back({yystack_[0].value.as < pair<string,string> > ()});
                              }
#line 3794 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 457: // tag_pair_list_for_selection: tag_pair_list_for_selection COMMA '[' tag_pair_list ']'
#line 1185 "../preprocessor/src/DynareBison.yy"
                              {
                                yylhs.value.as < vector<map<string, string>> > () = yystack_[4].value.as < vector<map<string, string>> > ();
                                yylhs.value.as < vector<map<string, string>> > ().push_back(yystack_[1].value.as < map<string, string> > ());
                              }
#line 3803 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 458: // shocks: SHOCKS ';' shock_list END ';'
#line 1191 "../preprocessor/src/DynareBison.yy"
                                       { driver.end_shocks(false); }
#line 3809 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 459: // shocks: SHOCKS '(' OVERWRITE ')' ';' shock_list END ';'
#line 1192 "../preprocessor/src/DynareBison.yy"
                                                         { driver.end_shocks(true); }
#line 3815 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 460: // shocks: SHOCKS '(' OVERWRITE ')' ';' END ';'
#line 1193 "../preprocessor/src/DynareBison.yy"
                                               { driver.end_shocks(true); }
#line 3821 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 461: // shocks: SHOCKS '(' SURPRISE ')' ';' det_shock_list END ';'
#line 1194 "../preprocessor/src/DynareBison.yy"
                                                            { driver.end_shocks_surprise(false); }
#line 3827 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 462: // shocks: SHOCKS '(' SURPRISE COMMA OVERWRITE ')' ';' det_shock_list END ';'
#line 1195 "../preprocessor/src/DynareBison.yy"
                                                                            { driver.end_shocks_surprise(true); }
#line 3833 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 463: // shocks: SHOCKS '(' OVERWRITE COMMA SURPRISE ')' ';' det_shock_list END ';'
#line 1196 "../preprocessor/src/DynareBison.yy"
                                                                            { driver.end_shocks_surprise(true); }
#line 3839 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 464: // shocks: SHOCKS '(' LEARNT_IN EQUAL INT_NUMBER ')' ';' det_shock_list END ';'
#line 1197 "../preprocessor/src/DynareBison.yy"
                                                                              { driver.end_shocks_learnt_in(yystack_[5].value.as < string > (), false); }
#line 3845 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 465: // shocks: SHOCKS '(' LEARNT_IN EQUAL INT_NUMBER COMMA OVERWRITE ')' ';' det_shock_list END ';'
#line 1198 "../preprocessor/src/DynareBison.yy"
                                                                                              { driver.end_shocks_learnt_in(yystack_[7].value.as < string > (), true); }
#line 3851 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 466: // shocks: SHOCKS '(' OVERWRITE COMMA LEARNT_IN EQUAL INT_NUMBER ')' ';' det_shock_list END ';'
#line 1199 "../preprocessor/src/DynareBison.yy"
                                                                                              { driver.end_shocks_learnt_in(yystack_[5].value.as < string > (), true); }
#line 3857 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 470: // shock_elem: VAR symbol ';' STDERR expression ';'
#line 1208 "../preprocessor/src/DynareBison.yy"
             { driver.add_stderr_shock(yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3863 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 471: // shock_elem: VAR symbol EQUAL expression ';'
#line 1210 "../preprocessor/src/DynareBison.yy"
             { driver.add_var_shock(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3869 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 472: // shock_elem: VAR symbol COMMA symbol EQUAL expression ';'
#line 1212 "../preprocessor/src/DynareBison.yy"
             { driver.add_covar_shock(yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3875 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 473: // shock_elem: CORR symbol COMMA symbol EQUAL expression ';'
#line 1214 "../preprocessor/src/DynareBison.yy"
             { driver.add_correl_shock(yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3881 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 474: // det_shock_elem: VAR symbol ';' PERIODS period_list ';' VALUES value_list ';'
#line 1218 "../preprocessor/src/DynareBison.yy"
                 { driver.add_det_shock(yystack_[7].value.as < string > (), yystack_[4].value.as < vector<pair<int, int>> > (), yystack_[1].value.as < vector<expr_t> > (), ParsingDriver::DetShockType::standard); }
#line 3887 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 475: // det_shock_elem: VAR symbol ';' PERIODS period_list ';' ADD value_list ';'
#line 1220 "../preprocessor/src/DynareBison.yy"
                 { driver.add_det_shock(yystack_[7].value.as < string > (), yystack_[4].value.as < vector<pair<int, int>> > (), yystack_[1].value.as < vector<expr_t> > (), ParsingDriver::DetShockType::add); }
#line 3893 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 476: // det_shock_elem: VAR symbol ';' PERIODS period_list ';' MULTIPLY value_list ';'
#line 1222 "../preprocessor/src/DynareBison.yy"
                 { driver.add_det_shock(yystack_[7].value.as < string > (), yystack_[4].value.as < vector<pair<int, int>> > (), yystack_[1].value.as < vector<expr_t> > (), ParsingDriver::DetShockType::multiply); }
#line 3899 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 479: // heteroskedastic_shocks: HETEROSKEDASTIC_SHOCKS ';' heteroskedastic_shock_list END ';'
#line 1230 "../preprocessor/src/DynareBison.yy"
                         { driver.end_heteroskedastic_shocks(false); }
#line 3905 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 480: // heteroskedastic_shocks: HETEROSKEDASTIC_SHOCKS '(' OVERWRITE ')' ';' heteroskedastic_shock_list END ';'
#line 1232 "../preprocessor/src/DynareBison.yy"
                         { driver.end_heteroskedastic_shocks(true); }
#line 3911 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 481: // heteroskedastic_shocks: HETEROSKEDASTIC_SHOCKS '(' OVERWRITE ')' ';' END ';'
#line 1234 "../preprocessor/src/DynareBison.yy"
                         { driver.end_heteroskedastic_shocks(true); }
#line 3917 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 484: // heteroskedastic_shock_elem: VAR symbol ';' PERIODS period_list ';' VALUES value_list ';'
#line 1242 "../preprocessor/src/DynareBison.yy"
                             { driver.add_heteroskedastic_shock(yystack_[7].value.as < string > (), yystack_[4].value.as < vector<pair<int, int>> > (), yystack_[1].value.as < vector<expr_t> > (), false); }
#line 3923 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 485: // heteroskedastic_shock_elem: VAR symbol ';' PERIODS period_list ';' SCALES value_list ';'
#line 1244 "../preprocessor/src/DynareBison.yy"
                             { driver.add_heteroskedastic_shock(yystack_[7].value.as < string > (), yystack_[4].value.as < vector<pair<int, int>> > (), yystack_[1].value.as < vector<expr_t> > (), true); }
#line 3929 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 486: // $@18: %empty
#line 1247 "../preprocessor/src/DynareBison.yy"
                                          { driver.begin_svar_identification(); }
#line 3935 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 487: // svar_identification: SVAR_IDENTIFICATION $@18 ';' svar_identification_list END ';'
#line 1248 "../preprocessor/src/DynareBison.yy"
                      { driver.end_svar_identification(); }
#line 3941 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 490: // svar_identification_elem: EXCLUSION LAG INT_NUMBER ';' svar_equation_list
#line 1256 "../preprocessor/src/DynareBison.yy"
                           { driver.combine_lag_and_restriction(yystack_[2].value.as < string > ()); }
#line 3947 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 491: // svar_identification_elem: EXCLUSION CONSTANTS ';'
#line 1258 "../preprocessor/src/DynareBison.yy"
                           { driver.add_constants_exclusion(); }
#line 3953 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 492: // $@19: %empty
#line 1260 "../preprocessor/src/DynareBison.yy"
                         { driver.add_restriction_equation_nbr(yystack_[1].value.as < string > ()); }
#line 3959 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 493: // $@20: %empty
#line 1262 "../preprocessor/src/DynareBison.yy"
                                { driver.add_restriction_equal(); }
#line 3965 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 495: // svar_identification_elem: UPPER_CHOLESKY ';'
#line 1265 "../preprocessor/src/DynareBison.yy"
                           { driver.add_upper_cholesky(); }
#line 3971 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 496: // svar_identification_elem: LOWER_CHOLESKY ';'
#line 1267 "../preprocessor/src/DynareBison.yy"
                           { driver.add_lower_cholesky(); }
#line 3977 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 497: // svar_equation_list: svar_equation_list EQUATION INT_NUMBER COMMA symbol_list ';'
#line 1271 "../preprocessor/src/DynareBison.yy"
                     { driver.add_restriction_in_equation(yystack_[3].value.as < string > (), yystack_[1].value.as < vector<string> > ()); }
#line 3983 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 498: // svar_equation_list: EQUATION INT_NUMBER COMMA symbol_list ';'
#line 1273 "../preprocessor/src/DynareBison.yy"
                     { driver.add_restriction_in_equation(yystack_[3].value.as < string > (), yystack_[1].value.as < vector<string> > ()); }
#line 3989 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 499: // restriction_expression: expression
#line 1276 "../preprocessor/src/DynareBison.yy"
                                    { driver.check_restriction_expression_constant(yystack_[0].value.as < expr_t > ()); }
#line 3995 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 503: // restriction_elem_expression: COEFF '(' symbol COMMA INT_NUMBER ')'
#line 1285 "../preprocessor/src/DynareBison.yy"
                                 { driver.add_positive_restriction_element(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 4001 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 504: // restriction_elem_expression: PLUS COEFF '(' symbol COMMA INT_NUMBER ')'
#line 1287 "../preprocessor/src/DynareBison.yy"
                                 { driver.add_positive_restriction_element(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 4007 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 505: // restriction_elem_expression: MINUS COEFF '(' symbol COMMA INT_NUMBER ')'
#line 1289 "../preprocessor/src/DynareBison.yy"
                                 { driver.add_negative_restriction_element(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 4013 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 506: // restriction_elem_expression: expression TIMES COEFF '(' symbol COMMA INT_NUMBER ')'
#line 1291 "../preprocessor/src/DynareBison.yy"
                                 { driver.add_positive_restriction_element(yystack_[7].value.as < expr_t > (), yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 4019 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 507: // svar_global_identification_check: SVAR_GLOBAL_IDENTIFICATION_CHECK ';'
#line 1295 "../preprocessor/src/DynareBison.yy"
                                  { driver.add_svar_global_identification_check(); }
#line 4025 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 508: // markov_switching: MARKOV_SWITCHING '(' ms_options_list ')' ';'
#line 1299 "../preprocessor/src/DynareBison.yy"
                   { driver.markov_switching(); }
#line 4031 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 517: // svar: SVAR '(' svar_options_list ')' ';'
#line 1315 "../preprocessor/src/DynareBison.yy"
       { driver.svar(); }
#line 4037 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 524: // mshocks: MSHOCKS ';' mshock_list END ';'
#line 1329 "../preprocessor/src/DynareBison.yy"
          { driver.end_mshocks(false, false); }
#line 4043 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 525: // mshocks: MSHOCKS '(' mshocks_options_list ')' ';' mshock_list END ';'
#line 1331 "../preprocessor/src/DynareBison.yy"
          {
            /* NB: the following relies of the fact that bool is the first
               alternative in the variant, so that default initialization of the
               variant by the [] operator will give false */
            if (yystack_[5].value.as < map<string, variant<bool, string>> > ().contains("learnt_in"))
              driver.end_mshocks_learnt_in(get<string>(yystack_[5].value.as < map<string, variant<bool, string>> > ().at("learnt_in")),
                                           get<bool>(yystack_[5].value.as < map<string, variant<bool, string>> > ()["overwrite"]),
                                           get<bool>(yystack_[5].value.as < map<string, variant<bool, string>> > ()["relative_to_initval"]));
            else
              driver.end_mshocks(get<bool>(yystack_[5].value.as < map<string, variant<bool, string>> > ()["overwrite"]), get<bool>(yystack_[5].value.as < map<string, variant<bool, string>> > ()["relative_to_initval"]));
          }
#line 4059 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 526: // mshocks_options_list: mshocks_option
#line 1345 "../preprocessor/src/DynareBison.yy"
                       { yylhs.value.as < map<string, variant<bool, string>> > () = {yystack_[0].value.as < pair<string, variant<bool, string>> > ()}; }
#line 4065 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 527: // mshocks_options_list: mshocks_options_list mshocks_option
#line 1347 "../preprocessor/src/DynareBison.yy"
                       {
                         yylhs.value.as < map<string, variant<bool, string>> > () = yystack_[1].value.as < map<string, variant<bool, string>> > ();
                         auto [it, success] = yylhs.value.as < map<string, variant<bool, string>> > ().insert(yystack_[0].value.as < pair<string, variant<bool, string>> > ());
                         if (!success)
                           driver.error("The '" + yystack_[0].value.as < pair<string, variant<bool, string>> > ().first + "' option is declared multiple times");
                       }
#line 4076 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 528: // mshocks_option: OVERWRITE
#line 1356 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < pair<string, variant<bool, string>> > () = {"overwrite", true}; }
#line 4082 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 529: // mshocks_option: LEARNT_IN EQUAL INT_NUMBER
#line 1358 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < pair<string, variant<bool, string>> > () = {"learnt_in", yystack_[0].value.as < string > ()}; }
#line 4088 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 530: // mshocks_option: RELATIVE_TO_INITVAL
#line 1360 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < pair<string, variant<bool, string>> > () = {"relative_to_initval", true}; }
#line 4094 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 533: // period_list: period_list COMMA INT_NUMBER
#line 1368 "../preprocessor/src/DynareBison.yy"
              {
                yylhs.value.as < vector<pair<int, int>> > () = yystack_[2].value.as < vector<pair<int, int>> > ();
                int p = stoi(yystack_[0].value.as < string > ());
                yylhs.value.as < vector<pair<int, int>> > ().emplace_back(p, p);
              }
#line 4104 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 534: // period_list: period_list INT_NUMBER
#line 1374 "../preprocessor/src/DynareBison.yy"
              {
                yylhs.value.as < vector<pair<int, int>> > () = yystack_[1].value.as < vector<pair<int, int>> > ();
                int p = stoi(yystack_[0].value.as < string > ());
                yylhs.value.as < vector<pair<int, int>> > ().emplace_back(p, p);
              }
#line 4114 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 535: // period_list: period_list COMMA INT_NUMBER ':' INT_NUMBER
#line 1380 "../preprocessor/src/DynareBison.yy"
              {
                yylhs.value.as < vector<pair<int, int>> > () = yystack_[4].value.as < vector<pair<int, int>> > ();
                int p1 = stoi(yystack_[2].value.as < string > ()), p2 = stoi(yystack_[0].value.as < string > ());
                if (p1 > p2)
                  driver.error("Can't have first period index greater than second index in range specification");
                yylhs.value.as < vector<pair<int, int>> > ().emplace_back(p1, p2);
              }
#line 4126 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 536: // period_list: period_list INT_NUMBER ':' INT_NUMBER
#line 1388 "../preprocessor/src/DynareBison.yy"
              {
                yylhs.value.as < vector<pair<int, int>> > () = yystack_[3].value.as < vector<pair<int, int>> > ();
                int p1 = stoi(yystack_[2].value.as < string > ()), p2 = stoi(yystack_[0].value.as < string > ());
                if (p1 > p2)
                  driver.error("Can't have first period index greater than second index in range specification");
                yylhs.value.as < vector<pair<int, int>> > ().emplace_back(p1, p2);
              }
#line 4138 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 537: // period_list: INT_NUMBER ':' INT_NUMBER
#line 1396 "../preprocessor/src/DynareBison.yy"
              {
                int p1 = stoi(yystack_[2].value.as < string > ()), p2 = stoi(yystack_[0].value.as < string > ());
                if (p1 > p2)
                  driver.error("Can't have first period index greater than second index in range specification");
                yylhs.value.as < vector<pair<int, int>> > () = {{p1, p2}};
              }
#line 4149 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 538: // period_list: INT_NUMBER
#line 1403 "../preprocessor/src/DynareBison.yy"
              {
                int p = stoi(yystack_[0].value.as < string > ());
                yylhs.value.as < vector<pair<int, int>> > () = {{p, p}};
              }
#line 4158 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 539: // value_list: value_list COMMA '(' expression ')'
#line 1410 "../preprocessor/src/DynareBison.yy"
             {
               yylhs.value.as < vector<expr_t> > () = yystack_[4].value.as < vector<expr_t> > ();
               yylhs.value.as < vector<expr_t> > ().push_back(yystack_[1].value.as < expr_t > ());
             }
#line 4167 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 540: // value_list: value_list '(' expression ')'
#line 1415 "../preprocessor/src/DynareBison.yy"
             {
               yylhs.value.as < vector<expr_t> > () = yystack_[3].value.as < vector<expr_t> > ();
               yylhs.value.as < vector<expr_t> > ().push_back(yystack_[1].value.as < expr_t > ());
             }
#line 4176 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 541: // value_list: '(' expression ')'
#line 1420 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < vector<expr_t> > () = {yystack_[1].value.as < expr_t > ()}; }
#line 4182 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 542: // value_list: value_list COMMA signed_number
#line 1422 "../preprocessor/src/DynareBison.yy"
             {
               yylhs.value.as < vector<expr_t> > () = yystack_[2].value.as < vector<expr_t> > ();
               yylhs.value.as < vector<expr_t> > ().push_back(yystack_[0].value.as < string > ().at(0) == '-'
                            ? driver.add_uminus(driver.add_non_negative_constant(yystack_[0].value.as < string > ().substr(1)))
                            : driver.add_non_negative_constant(yystack_[0].value.as < string > ()));
             }
#line 4193 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 543: // value_list: value_list signed_number
#line 1429 "../preprocessor/src/DynareBison.yy"
             {
               yylhs.value.as < vector<expr_t> > () = yystack_[1].value.as < vector<expr_t> > ();
               yylhs.value.as < vector<expr_t> > ().push_back(yystack_[0].value.as < string > ().at(0) == '-'
                            ? driver.add_uminus(driver.add_non_negative_constant(yystack_[0].value.as < string > ().substr(1)))
                            : driver.add_non_negative_constant(yystack_[0].value.as < string > ()));
             }
#line 4204 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 544: // value_list: signed_number
#line 1436 "../preprocessor/src/DynareBison.yy"
             {
               yylhs.value.as < vector<expr_t> > () = {yystack_[0].value.as < string > ().at(0) == '-'
                     ? driver.add_uminus(driver.add_non_negative_constant(yystack_[0].value.as < string > ().substr(1)))
                     : driver.add_non_negative_constant(yystack_[0].value.as < string > ())};
             }
#line 4214 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 545: // steady: STEADY ';'
#line 1444 "../preprocessor/src/DynareBison.yy"
         { driver.steady(); }
#line 4220 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 546: // steady: STEADY '(' steady_options_list ')' ';'
#line 1446 "../preprocessor/src/DynareBison.yy"
         { driver.steady(); }
#line 4226 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 559: // check: CHECK ';'
#line 1466 "../preprocessor/src/DynareBison.yy"
        { driver.check(); }
#line 4232 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 560: // check: CHECK '(' check_options_list ')' ';'
#line 1468 "../preprocessor/src/DynareBison.yy"
        { driver.check(); }
#line 4238 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 565: // model_info: MODEL_INFO ';'
#line 1480 "../preprocessor/src/DynareBison.yy"
             { driver.model_info(); }
#line 4244 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 566: // model_info: MODEL_INFO '(' model_info_options_list ')' ';'
#line 1482 "../preprocessor/src/DynareBison.yy"
              { driver.model_info(); }
#line 4250 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 572: // perfect_foresight_setup: PERFECT_FORESIGHT_SETUP ';'
#line 1495 "../preprocessor/src/DynareBison.yy"
                          { driver.perfect_foresight_setup(); }
#line 4256 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 573: // perfect_foresight_setup: PERFECT_FORESIGHT_SETUP '(' perfect_foresight_setup_options_list ')' ';'
#line 1497 "../preprocessor/src/DynareBison.yy"
                          { driver.perfect_foresight_setup(); }
#line 4262 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 579: // perfect_foresight_solver: PERFECT_FORESIGHT_SOLVER ';'
#line 1510 "../preprocessor/src/DynareBison.yy"
                          { driver.perfect_foresight_solver(); }
#line 4268 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 580: // perfect_foresight_solver: PERFECT_FORESIGHT_SOLVER '(' perfect_foresight_solver_options_list ')' ';'
#line 1512 "../preprocessor/src/DynareBison.yy"
                          { driver.perfect_foresight_solver(); }
#line 4274 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 609: // perfect_foresight_with_expectation_errors_setup: PERFECT_FORESIGHT_WITH_EXPECTATION_ERRORS_SETUP ';'
#line 1548 "../preprocessor/src/DynareBison.yy"
                                                  { driver.perfect_foresight_with_expectation_errors_setup(); }
#line 4280 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 610: // perfect_foresight_with_expectation_errors_setup: PERFECT_FORESIGHT_WITH_EXPECTATION_ERRORS_SETUP '(' perfect_foresight_with_expectation_errors_setup_options_list ')' ';'
#line 1550 "../preprocessor/src/DynareBison.yy"
                                                  { driver.perfect_foresight_with_expectation_errors_setup(); }
#line 4286 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 615: // perfect_foresight_with_expectation_errors_solver: PERFECT_FORESIGHT_WITH_EXPECTATION_ERRORS_SOLVER ';'
#line 1562 "../preprocessor/src/DynareBison.yy"
                                                  { driver.perfect_foresight_with_expectation_errors_solver(); }
#line 4292 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 616: // perfect_foresight_with_expectation_errors_solver: PERFECT_FORESIGHT_WITH_EXPECTATION_ERRORS_SOLVER '(' perfect_foresight_with_expectation_errors_solver_options_list ')' ';'
#line 1564 "../preprocessor/src/DynareBison.yy"
                                                  { driver.perfect_foresight_with_expectation_errors_solver(); }
#line 4298 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 621: // method_of_moments: METHOD_OF_MOMENTS ';'
#line 1576 "../preprocessor/src/DynareBison.yy"
                    { driver.method_of_moments(); }
#line 4304 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 622: // method_of_moments: METHOD_OF_MOMENTS '(' method_of_moments_options_list ')' ';'
#line 1578 "../preprocessor/src/DynareBison.yy"
                    { driver.method_of_moments(); }
#line 4310 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 714: // prior_function: PRIOR_FUNCTION '(' prior_posterior_function_options_list ')' ';'
#line 1677 "../preprocessor/src/DynareBison.yy"
                 { driver.prior_posterior_function(true); }
#line 4316 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 715: // posterior_function: POSTERIOR_FUNCTION '(' prior_posterior_function_options_list ')' ';'
#line 1681 "../preprocessor/src/DynareBison.yy"
                     { driver.prior_posterior_function(false); }
#line 4322 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 720: // simul: SIMUL ';'
#line 1693 "../preprocessor/src/DynareBison.yy"
        { driver.simul(); }
#line 4328 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 721: // simul: SIMUL '(' simul_options_list ')' ';'
#line 1695 "../preprocessor/src/DynareBison.yy"
        { driver.simul(); }
#line 4334 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 726: // external_function: EXTERNAL_FUNCTION '(' external_function_options_list ')' ';'
#line 1707 "../preprocessor/src/DynareBison.yy"
                    { driver.external_function(); }
#line 4340 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 733: // stoch_simul: STOCH_SIMUL ';'
#line 1721 "../preprocessor/src/DynareBison.yy"
              { driver.stoch_simul({}); }
#line 4346 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 734: // stoch_simul: STOCH_SIMUL '(' stoch_simul_options_list ')' ';'
#line 1723 "../preprocessor/src/DynareBison.yy"
              { driver.stoch_simul({}); }
#line 4352 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 735: // stoch_simul: STOCH_SIMUL symbol_list ';'
#line 1725 "../preprocessor/src/DynareBison.yy"
              { driver.stoch_simul(yystack_[1].value.as < vector<string> > ()); }
#line 4358 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 736: // stoch_simul: STOCH_SIMUL '(' stoch_simul_options_list ')' symbol_list ';'
#line 1727 "../preprocessor/src/DynareBison.yy"
              { driver.stoch_simul(yystack_[1].value.as < vector<string> > ()); }
#line 4364 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 790: // signed_integer: PLUS INT_NUMBER
#line 1790 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4370 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 791: // signed_integer: MINUS INT_NUMBER
#line 1792 "../preprocessor/src/DynareBison.yy"
                 {
                   yylhs.value.as < string > () = yystack_[0].value.as < string > ();
                   yylhs.value.as < string > ().insert(0, "-");
                 }
#line 4379 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 792: // signed_integer: INT_NUMBER
#line 1796 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4385 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 793: // non_negative_number: INT_NUMBER
#line 1799 "../preprocessor/src/DynareBison.yy"
                      { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4391 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 794: // non_negative_number: FLOAT_NUMBER
#line 1800 "../preprocessor/src/DynareBison.yy"
                      { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4397 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 795: // signed_number: PLUS non_negative_number
#line 1804 "../preprocessor/src/DynareBison.yy"
               { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4403 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 796: // signed_number: MINUS non_negative_number
#line 1806 "../preprocessor/src/DynareBison.yy"
               {
                 yylhs.value.as < string > () = yystack_[0].value.as < string > ();
                 yylhs.value.as < string > ().insert(0, "-");
               }
#line 4412 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 797: // signed_number: non_negative_number
#line 1810 "../preprocessor/src/DynareBison.yy"
                { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4418 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 798: // signed_inf: PLUS INF_CONSTANT
#line 1814 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < string > () = "Inf"; }
#line 4424 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 799: // signed_inf: MINUS INF_CONSTANT
#line 1816 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < string > () = "-Inf"; }
#line 4430 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 800: // signed_inf: INF_CONSTANT
#line 1818 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < string > () = "Inf"; }
#line 4436 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 801: // signed_number_w_inf: signed_inf
#line 1821 "../preprocessor/src/DynareBison.yy"
                      { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4442 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 802: // signed_number_w_inf: signed_number
#line 1822 "../preprocessor/src/DynareBison.yy"
                      { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4448 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 803: // boolean: TRUE
#line 1825 "../preprocessor/src/DynareBison.yy"
          { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4454 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 804: // boolean: FALSE
#line 1826 "../preprocessor/src/DynareBison.yy"
          { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4460 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 805: // estimated_params: ESTIMATED_PARAMS ';' estimated_list END ';'
#line 1830 "../preprocessor/src/DynareBison.yy"
                   { driver.estimated_params(false); }
#line 4466 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 806: // estimated_params: ESTIMATED_PARAMS '(' OVERWRITE ')' ';' estimated_list END ';'
#line 1832 "../preprocessor/src/DynareBison.yy"
                   { driver.estimated_params(true); }
#line 4472 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 807: // estimated_list: estimated_list estimated_elem
#line 1836 "../preprocessor/src/DynareBison.yy"
                 { driver.add_estimated_params_element(); }
#line 4478 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 808: // estimated_list: estimated_elem
#line 1838 "../preprocessor/src/DynareBison.yy"
                 { driver.add_estimated_params_element(); }
#line 4484 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 811: // estimated_elem1: STDERR symbol
#line 1845 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.type = 1;
                    driver.estim_params.name = yystack_[0].value.as < string > ();
                  }
#line 4493 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 812: // estimated_elem1: symbol
#line 1850 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.type = 2;
                    driver.estim_params.name = yystack_[0].value.as < string > ();
                  }
#line 4502 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 813: // estimated_elem1: CORR symbol COMMA symbol
#line 1855 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.type = 3;
                    driver.estim_params.name = yystack_[2].value.as < string > ();
                    driver.estim_params.name2 = yystack_[0].value.as < string > ();
                  }
#line 4512 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 814: // estimated_elem1: DSGE_PRIOR_WEIGHT
#line 1861 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.type = 2;
                    driver.estim_params.name = "dsge_prior_weight";
                  }
#line 4521 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 815: // estimated_elem2: prior_pdf COMMA estimated_elem3
#line 1868 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.prior = yystack_[2].value.as < PriorDistributions > ();
                  }
#line 4529 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 816: // estimated_elem2: expression_or_empty COMMA prior_pdf COMMA estimated_elem3
#line 1872 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.init_val = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.prior = yystack_[2].value.as < PriorDistributions > ();
                  }
#line 4538 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 817: // estimated_elem2: expression_or_empty COMMA expression_or_empty COMMA expression_or_empty COMMA prior_pdf COMMA estimated_elem3
#line 1877 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.init_val = yystack_[8].value.as < expr_t > ();
                    driver.estim_params.low_bound = yystack_[6].value.as < expr_t > ();
                    driver.estim_params.up_bound = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.prior = yystack_[2].value.as < PriorDistributions > ();
                  }
#line 4549 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 818: // estimated_elem2: expression
#line 1884 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.init_val = yystack_[0].value.as < expr_t > ();
                  }
#line 4557 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 819: // estimated_elem2: expression_or_empty COMMA expression_or_empty COMMA expression_or_empty
#line 1888 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.init_val = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.low_bound = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.up_bound = yystack_[0].value.as < expr_t > ();
                  }
#line 4567 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 820: // estimated_elem3: expression_or_empty COMMA expression_or_empty
#line 1896 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.mean = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[0].value.as < expr_t > ();
                  }
#line 4576 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 821: // estimated_elem3: expression_or_empty COMMA expression_or_empty COMMA expression_or_empty
#line 1901 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.mean = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.p3 = yystack_[0].value.as < expr_t > ();
                  }
#line 4586 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 822: // estimated_elem3: expression_or_empty COMMA expression_or_empty COMMA expression_or_empty COMMA expression_or_empty
#line 1907 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.mean = yystack_[6].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.p3 = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.p4 = yystack_[0].value.as < expr_t > ();
                  }
#line 4597 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 823: // estimated_elem3: expression_or_empty COMMA expression_or_empty COMMA expression_or_empty COMMA expression_or_empty COMMA expression
#line 1914 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.mean = yystack_[8].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[6].value.as < expr_t > ();
                    driver.estim_params.p3 = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.p4 = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.jscale = yystack_[0].value.as < expr_t > ();
                  }
#line 4609 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 824: // estimated_params_init: ESTIMATED_PARAMS_INIT ';' estimated_init_list END ';'
#line 1924 "../preprocessor/src/DynareBison.yy"
                        { driver.estimated_params_init(); }
#line 4615 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 825: // estimated_params_init: ESTIMATED_PARAMS_INIT '(' USE_CALIBRATION ')' ';' END ';'
#line 1926 "../preprocessor/src/DynareBison.yy"
                        { driver.estimated_params_init(true); }
#line 4621 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 826: // estimated_params_init: ESTIMATED_PARAMS_INIT '(' USE_CALIBRATION ')' ';' estimated_init_list END ';'
#line 1928 "../preprocessor/src/DynareBison.yy"
                        { driver.estimated_params_init(true); }
#line 4627 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 827: // estimated_init_list: estimated_init_list estimated_init_elem
#line 1932 "../preprocessor/src/DynareBison.yy"
                      { driver.add_estimated_params_element(); }
#line 4633 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 828: // estimated_init_list: estimated_init_elem
#line 1934 "../preprocessor/src/DynareBison.yy"
                      { driver.add_estimated_params_element(); }
#line 4639 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 829: // estimated_init_elem: STDERR symbol COMMA expression ';'
#line 1938 "../preprocessor/src/DynareBison.yy"
                      {
                        driver.estim_params.type = 1;
                        driver.estim_params.name = yystack_[3].value.as < string > ();
                        driver.estim_params.init_val = yystack_[1].value.as < expr_t > ();
                      }
#line 4649 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 830: // estimated_init_elem: CORR symbol COMMA symbol COMMA expression ';'
#line 1944 "../preprocessor/src/DynareBison.yy"
                      {
                        driver.estim_params.type = 3;
                        driver.estim_params.name = yystack_[5].value.as < string > ();
                        driver.estim_params.name2 = yystack_[3].value.as < string > ();
                        driver.estim_params.init_val = yystack_[1].value.as < expr_t > ();
                      }
#line 4660 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 831: // estimated_init_elem: symbol COMMA expression ';'
#line 1951 "../preprocessor/src/DynareBison.yy"
                      {
                        driver.estim_params.type = 2;
                        driver.estim_params.name = yystack_[3].value.as < string > ();
                        driver.estim_params.init_val = yystack_[1].value.as < expr_t > ();
                      }
#line 4670 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 832: // estimated_params_bounds: ESTIMATED_PARAMS_BOUNDS ';' estimated_bounds_list END ';'
#line 1959 "../preprocessor/src/DynareBison.yy"
                          { driver.estimated_params_bounds(); }
#line 4676 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 833: // estimated_bounds_list: estimated_bounds_list estimated_bounds_elem
#line 1962 "../preprocessor/src/DynareBison.yy"
                        { driver.add_estimated_params_element(); }
#line 4682 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 834: // estimated_bounds_list: estimated_bounds_elem
#line 1964 "../preprocessor/src/DynareBison.yy"
                        { driver.add_estimated_params_element(); }
#line 4688 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 835: // estimated_bounds_elem: STDERR symbol COMMA expression COMMA expression ';'
#line 1968 "../preprocessor/src/DynareBison.yy"
                        {
                          driver.estim_params.type = 1;
                          driver.estim_params.name = yystack_[5].value.as < string > ();
                          driver.estim_params.low_bound = yystack_[3].value.as < expr_t > ();
                          driver.estim_params.up_bound = yystack_[1].value.as < expr_t > ();
                        }
#line 4699 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 836: // estimated_bounds_elem: CORR symbol COMMA symbol COMMA expression COMMA expression ';'
#line 1975 "../preprocessor/src/DynareBison.yy"
                        {
                          driver.estim_params.type = 3;
                          driver.estim_params.name = yystack_[7].value.as < string > ();
                          driver.estim_params.name2 = yystack_[5].value.as < string > ();
                          driver.estim_params.low_bound = yystack_[3].value.as < expr_t > ();
                          driver.estim_params.up_bound = yystack_[1].value.as < expr_t > ();
                        }
#line 4711 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 837: // estimated_bounds_elem: symbol COMMA expression COMMA expression ';'
#line 1983 "../preprocessor/src/DynareBison.yy"
                        {
                          driver.estim_params.type = 2;
                          driver.estim_params.name = yystack_[5].value.as < string > ();
                          driver.estim_params.low_bound = yystack_[3].value.as < expr_t > ();
                          driver.estim_params.up_bound = yystack_[1].value.as < expr_t > ();
                        }
#line 4722 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 838: // estimated_params_remove: ESTIMATED_PARAMS_REMOVE ';' estimated_remove_list END ';'
#line 1992 "../preprocessor/src/DynareBison.yy"
                          { driver.estimated_params_remove(); }
#line 4728 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 841: // estimated_remove_elem: estimated_elem1 ';'
#line 1999 "../preprocessor/src/DynareBison.yy"
                        { driver.add_estimated_params_element(); }
#line 4734 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 842: // osr_params_bounds: OSR_PARAMS_BOUNDS ';' osr_bounds_list END ';'
#line 2002 "../preprocessor/src/DynareBison.yy"
                    { driver.osr_params_bounds(); }
#line 4740 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 843: // osr_bounds_list: osr_bounds_list osr_bounds_elem
#line 2005 "../preprocessor/src/DynareBison.yy"
                  { driver.add_osr_params_element(); }
#line 4746 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 844: // osr_bounds_list: osr_bounds_elem
#line 2007 "../preprocessor/src/DynareBison.yy"
                  { driver.add_osr_params_element(); }
#line 4752 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 845: // osr_bounds_elem: symbol COMMA expression COMMA expression ';'
#line 2011 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.osr_params.name = yystack_[5].value.as < string > ();
                    driver.osr_params.low_bound = yystack_[3].value.as < expr_t > ();
                    driver.osr_params.up_bound = yystack_[1].value.as < expr_t > ();
                  }
#line 4762 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 846: // prior_distribution: BETA
#line 2019 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::beta; }
#line 4768 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 847: // prior_distribution: GAMMA
#line 2021 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::gamma; }
#line 4774 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 848: // prior_distribution: NORMAL
#line 2023 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::normal; }
#line 4780 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 849: // prior_distribution: INV_GAMMA
#line 2025 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma; }
#line 4786 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 850: // prior_distribution: INV_GAMMA1
#line 2027 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma1; }
#line 4792 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 851: // prior_distribution: UNIFORM
#line 2029 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::uniform; }
#line 4798 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 852: // prior_distribution: INV_GAMMA2
#line 2031 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma2; }
#line 4804 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 853: // prior_distribution: DIRICHLET
#line 2033 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::dirichlet; }
#line 4810 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 854: // prior_distribution: WEIBULL
#line 2035 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::weibull; }
#line 4816 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 855: // prior_pdf: BETA_PDF
#line 2039 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::beta; }
#line 4822 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 856: // prior_pdf: GAMMA_PDF
#line 2041 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::gamma; }
#line 4828 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 857: // prior_pdf: NORMAL_PDF
#line 2043 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::normal; }
#line 4834 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 858: // prior_pdf: INV_GAMMA_PDF
#line 2045 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma; }
#line 4840 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 859: // prior_pdf: INV_GAMMA1_PDF
#line 2047 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma1; }
#line 4846 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 860: // prior_pdf: UNIFORM_PDF
#line 2049 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::uniform; }
#line 4852 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 861: // prior_pdf: INV_GAMMA2_PDF
#line 2051 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma2; }
#line 4858 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 862: // prior_pdf: WEIBULL_PDF
#line 2053 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::weibull; }
#line 4864 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 863: // date_str: DATES
#line 2056 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4870 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 864: // date_expr: date_str
#line 2058 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4876 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 865: // date_expr: date_expr PLUS INT_NUMBER
#line 2060 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < string > () = yystack_[2].value.as < string > () + '+' + yystack_[0].value.as < string > (); }
#line 4882 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 866: // set_time: SET_TIME '(' date_expr ')' ';'
#line 2064 "../preprocessor/src/DynareBison.yy"
           { driver.set_time(yystack_[2].value.as < string > ()); }
#line 4888 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 867: // data: DATA '(' data_options_list ')' ';'
#line 2068 "../preprocessor/src/DynareBison.yy"
       { driver.estimation_data(); }
#line 4894 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 877: // subsamples: subsamples_eq_opt '(' subsamples_name_list ')' ';'
#line 2085 "../preprocessor/src/DynareBison.yy"
             { driver.set_subsamples(yystack_[4].value.as < pair<string,string> > ().first, yystack_[4].value.as < pair<string,string> > ().second); }
#line 4900 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 878: // subsamples_eq: subsamples_eq_opt EQUAL subsamples_eq_opt ';'
#line 2089 "../preprocessor/src/DynareBison.yy"
                { driver.copy_subsamples(yystack_[3].value.as < pair<string,string> > ().first, yystack_[3].value.as < pair<string,string> > ().second, yystack_[1].value.as < pair<string,string> > ().first, yystack_[1].value.as < pair<string,string> > ().second); }
#line 4906 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 879: // subsamples_eq_opt: symbol '.' SUBSAMPLES
#line 2093 "../preprocessor/src/DynareBison.yy"
                    { yylhs.value.as < pair<string,string> > () = {yystack_[2].value.as < string > (), ""}; }
#line 4912 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 880: // subsamples_eq_opt: STD '(' symbol ')' '.' SUBSAMPLES
#line 2095 "../preprocessor/src/DynareBison.yy"
                    { yylhs.value.as < pair<string,string> > () = {yystack_[3].value.as < string > (), ""}; }
#line 4918 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 881: // subsamples_eq_opt: CORR '(' symbol COMMA symbol ')' '.' SUBSAMPLES
#line 2097 "../preprocessor/src/DynareBison.yy"
                    { yylhs.value.as < pair<string,string> > () = {yystack_[5].value.as < string > (), yystack_[3].value.as < string > ()}; }
#line 4924 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 884: // $@21: %empty
#line 2104 "../preprocessor/src/DynareBison.yy"
                         { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4930 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 885: // prior: symbol '.' PRIOR $@21 '(' prior_options_list ')' ';'
#line 2105 "../preprocessor/src/DynareBison.yy"
        { driver.set_prior(yystack_[7].value.as < string > (), ""); }
#line 4936 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 886: // $@22: %empty
#line 2106 "../preprocessor/src/DynareBison.yy"
                                    { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4942 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 887: // prior: symbol '.' symbol '.' PRIOR $@22 '(' prior_options_list ')' ';'
#line 2107 "../preprocessor/src/DynareBison.yy"
        { driver.set_prior(yystack_[9].value.as < string > (), yystack_[7].value.as < string > ()); }
#line 4948 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 888: // $@23: %empty
#line 2108 "../preprocessor/src/DynareBison.yy"
                             { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4954 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 889: // prior: SYMBOL_VEC '.' PRIOR $@23 '(' joint_prior_options_list ')' ';'
#line 2109 "../preprocessor/src/DynareBison.yy"
        { driver.set_joint_prior(yystack_[7].value.as < vector<string> > ()); }
#line 4960 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 890: // $@24: %empty
#line 2110 "../preprocessor/src/DynareBison.yy"
                                     { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4966 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 891: // prior: STD '(' symbol ')' '.' PRIOR $@24 '(' prior_options_list ')' ';'
#line 2111 "../preprocessor/src/DynareBison.yy"
        { driver.set_std_prior(yystack_[8].value.as < string > (), ""); }
#line 4972 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 892: // $@25: %empty
#line 2112 "../preprocessor/src/DynareBison.yy"
                                                { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4978 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 893: // prior: STD '(' symbol ')' '.' symbol '.' PRIOR $@25 '(' prior_options_list ')' ';'
#line 2113 "../preprocessor/src/DynareBison.yy"
        { driver.set_std_prior(yystack_[10].value.as < string > (), yystack_[7].value.as < string > ()); }
#line 4984 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 894: // $@26: %empty
#line 2114 "../preprocessor/src/DynareBison.yy"
                                                   { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4990 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 895: // prior: CORR '(' symbol COMMA symbol ')' '.' PRIOR $@26 '(' prior_options_list ')' ';'
#line 2115 "../preprocessor/src/DynareBison.yy"
        { driver.set_corr_prior(yystack_[10].value.as < string > (), yystack_[8].value.as < string > (), ""); }
#line 4996 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 896: // $@27: %empty
#line 2116 "../preprocessor/src/DynareBison.yy"
                                                              { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 5002 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 897: // prior: CORR '(' symbol COMMA symbol ')' '.' symbol '.' PRIOR $@27 '(' prior_options_list ')' ';'
#line 2117 "../preprocessor/src/DynareBison.yy"
        { driver.set_corr_prior(yystack_[12].value.as < string > (), yystack_[10].value.as < string > (), yystack_[7].value.as < string > ()); }
#line 5008 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 922: // prior_eq: prior_eq_opt EQUAL prior_eq_opt ';'
#line 2153 "../preprocessor/src/DynareBison.yy"
           { driver.copy_prior(get<0>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[3].value.as < tuple<string,string,string,string> > ()),
                               get<0>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[1].value.as < tuple<string,string,string,string> > ())); }
#line 5015 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 923: // prior_eq_opt: symbol '.' PRIOR
#line 2158 "../preprocessor/src/DynareBison.yy"
               { yylhs.value.as < tuple<string,string,string,string> > () = {"par", yystack_[2].value.as < string > (), "", ""}; }
#line 5021 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 924: // prior_eq_opt: symbol '.' symbol '.' PRIOR
#line 2160 "../preprocessor/src/DynareBison.yy"
               { yylhs.value.as < tuple<string,string,string,string> > () = {"par", yystack_[4].value.as < string > (), "", yystack_[2].value.as < string > ()}; }
#line 5027 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 925: // prior_eq_opt: STD '(' symbol ')' '.' PRIOR
#line 2162 "../preprocessor/src/DynareBison.yy"
               { yylhs.value.as < tuple<string,string,string,string> > () = {"std", yystack_[3].value.as < string > (), "", ""}; }
#line 5033 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 926: // prior_eq_opt: STD '(' symbol ')' '.' symbol '.' PRIOR
#line 2164 "../preprocessor/src/DynareBison.yy"
               { yylhs.value.as < tuple<string,string,string,string> > () = {"std", yystack_[5].value.as < string > (), "", yystack_[2].value.as < string > ()}; }
#line 5039 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 927: // prior_eq_opt: CORR '(' symbol COMMA symbol ')' '.' PRIOR
#line 2166 "../preprocessor/src/DynareBison.yy"
               { yylhs.value.as < tuple<string,string,string,string> > () = {"corr", yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), ""}; }
#line 5045 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 928: // prior_eq_opt: CORR '(' symbol COMMA symbol ')' '.' symbol '.' PRIOR
#line 2168 "../preprocessor/src/DynareBison.yy"
               { yylhs.value.as < tuple<string,string,string,string> > () = {"corr", yystack_[7].value.as < string > (), yystack_[5].value.as < string > (), yystack_[2].value.as < string > ()}; }
#line 5051 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 929: // options: symbol '.' OPTIONS '(' options_options_list ')' ';'
#line 2172 "../preprocessor/src/DynareBison.yy"
          { driver.set_options(yystack_[6].value.as < string > (), ""); }
#line 5057 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 930: // options: symbol '.' symbol '.' OPTIONS '(' options_options_list ')' ';'
#line 2174 "../preprocessor/src/DynareBison.yy"
          { driver.set_options(yystack_[8].value.as < string > (), yystack_[6].value.as < string > ()); }
#line 5063 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 931: // options: STD '(' symbol ')' '.' OPTIONS '(' options_options_list ')' ';'
#line 2176 "../preprocessor/src/DynareBison.yy"
          { driver.set_std_options(yystack_[7].value.as < string > (), ""); }
#line 5069 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 932: // options: STD '(' symbol ')' '.' symbol '.' OPTIONS '(' options_options_list ')' ';'
#line 2178 "../preprocessor/src/DynareBison.yy"
          { driver.set_std_options(yystack_[9].value.as < string > (), yystack_[6].value.as < string > ()); }
#line 5075 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 933: // options: CORR '(' symbol COMMA symbol ')' '.' OPTIONS '(' options_options_list ')' ';'
#line 2180 "../preprocessor/src/DynareBison.yy"
          { driver.set_corr_options(yystack_[9].value.as < string > (), yystack_[7].value.as < string > (), ""); }
#line 5081 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 934: // options: CORR '(' symbol COMMA symbol ')' '.' symbol '.' OPTIONS '(' options_options_list ')' ';'
#line 2182 "../preprocessor/src/DynareBison.yy"
          { driver.set_corr_options(yystack_[11].value.as < string > (), yystack_[9].value.as < string > (), yystack_[6].value.as < string > ()); }
#line 5087 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 940: // options_eq: options_eq_opt EQUAL options_eq_opt ';'
#line 2195 "../preprocessor/src/DynareBison.yy"
             { driver.copy_options(get<0>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[3].value.as < tuple<string,string,string,string> > ()),
                                   get<0>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[1].value.as < tuple<string,string,string,string> > ())); }
#line 5094 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 941: // options_eq_opt: symbol '.' OPTIONS
#line 2200 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < tuple<string,string,string,string> > () = {"par", yystack_[2].value.as < string > (), "", ""}; }
#line 5100 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 942: // options_eq_opt: symbol '.' symbol '.' OPTIONS
#line 2202 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < tuple<string,string,string,string> > () = {"par", yystack_[4].value.as < string > (), "", yystack_[2].value.as < string > ()}; }
#line 5106 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 943: // options_eq_opt: STD '(' symbol ')' '.' OPTIONS
#line 2204 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < tuple<string,string,string,string> > () = {"std", yystack_[3].value.as < string > (), "", ""}; }
#line 5112 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 944: // options_eq_opt: STD '(' symbol ')' '.' symbol '.' OPTIONS
#line 2206 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < tuple<string,string,string,string> > () = {"std", yystack_[5].value.as < string > (), "", yystack_[2].value.as < string > ()}; }
#line 5118 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 945: // options_eq_opt: CORR '(' symbol COMMA symbol ')' '.' OPTIONS
#line 2208 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < tuple<string,string,string,string> > () = {"corr", yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), ""}; }
#line 5124 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 946: // options_eq_opt: CORR '(' symbol COMMA symbol ')' '.' symbol '.' OPTIONS
#line 2210 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < tuple<string,string,string,string> > () = {"corr", yystack_[7].value.as < string > (), yystack_[5].value.as < string > (), yystack_[2].value.as < string > ()}; }
#line 5130 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 947: // estimation: ESTIMATION ';'
#line 2214 "../preprocessor/src/DynareBison.yy"
             { driver.run_estimation({}); }
#line 5136 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 948: // estimation: ESTIMATION '(' estimation_options_list ')' ';'
#line 2216 "../preprocessor/src/DynareBison.yy"
             { driver.run_estimation({}); }
#line 5142 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 949: // estimation: ESTIMATION symbol_list ';'
#line 2218 "../preprocessor/src/DynareBison.yy"
             { driver.run_estimation(yystack_[1].value.as < vector<string> > ()); }
#line 5148 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 950: // estimation: ESTIMATION '(' estimation_options_list ')' symbol_list ';'
#line 2220 "../preprocessor/src/DynareBison.yy"
             { driver.run_estimation(yystack_[1].value.as < vector<string> > ()); }
#line 5154 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1084: // name_value_pair: QUOTED_STRING COMMA QUOTED_STRING
#line 2361 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < string > () = "''" + yystack_[2].value.as < string > () + "'',''" + yystack_[0].value.as < string > () + "''"; }
#line 5160 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1085: // name_value_pair: QUOTED_STRING COMMA signed_number
#line 2363 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < string > () = "''" + yystack_[2].value.as < string > () + "''," + yystack_[0].value.as < string > (); }
#line 5166 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1086: // name_value_pair_list: name_value_pair
#line 2366 "../preprocessor/src/DynareBison.yy"
                       { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5172 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1087: // name_value_pair_list: name_value_pair_list COMMA name_value_pair
#line 2368 "../preprocessor/src/DynareBison.yy"
                       { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ',' + yystack_[0].value.as < string > (); }
#line 5178 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1088: // name_value_pair_with_boolean: name_value_pair
#line 2371 "../preprocessor/src/DynareBison.yy"
                               { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5184 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1089: // name_value_pair_with_boolean: QUOTED_STRING COMMA boolean
#line 2373 "../preprocessor/src/DynareBison.yy"
                               { yylhs.value.as < string > () = "''" + yystack_[2].value.as < string > () + "''," + yystack_[0].value.as < string > (); }
#line 5190 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1090: // name_value_pair_with_boolean_list: name_value_pair_with_boolean
#line 2376 "../preprocessor/src/DynareBison.yy"
                                    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5196 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1091: // name_value_pair_with_boolean_list: name_value_pair_with_boolean_list COMMA name_value_pair_with_boolean
#line 2378 "../preprocessor/src/DynareBison.yy"
                                    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ',' + yystack_[0].value.as < string > (); }
#line 5202 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1092: // name_value_pair_with_suboptions: name_value_pair
#line 2382 "../preprocessor/src/DynareBison.yy"
                                  { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5208 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1093: // name_value_pair_with_suboptions: QUOTED_STRING COMMA vec_str
#line 2384 "../preprocessor/src/DynareBison.yy"
                                  {
                                    yylhs.value.as < string > () = "''" + yystack_[2].value.as < string > () + "'',{";
                                    for (auto &it : yystack_[0].value.as < vector<string> > ())
                                      {
                                        if (&it != &(yystack_[0].value.as < vector<string> > ()).front())
                                          yylhs.value.as < string > () += ",";
                                        yylhs.value.as < string > () += "''" + it + "''";
                                      }
                                    yylhs.value.as < string > () += '}';
                                  }
#line 5223 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1094: // name_value_pair_with_suboptions: QUOTED_STRING COMMA '(' name_value_pair_list ')'
#line 2395 "../preprocessor/src/DynareBison.yy"
                                  { yylhs.value.as < string > () = "''" + yystack_[4].value.as < string > () + "'',''(" + yystack_[1].value.as < string > () + ")''"; }
#line 5229 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1095: // name_value_pair_with_suboptions_list: name_value_pair_with_suboptions
#line 2398 "../preprocessor/src/DynareBison.yy"
                                       { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5235 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1096: // name_value_pair_with_suboptions_list: name_value_pair_with_suboptions_list COMMA name_value_pair_with_suboptions
#line 2400 "../preprocessor/src/DynareBison.yy"
                                       { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ',' + yystack_[0].value.as < string > (); }
#line 5241 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1097: // $@28: %empty
#line 2403 "../preprocessor/src/DynareBison.yy"
                { driver.check_varobs(); }
#line 5247 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1099: // varobs_list: varobs_list symbol
#line 2406 "../preprocessor/src/DynareBison.yy"
              { driver.add_varobs(yystack_[0].value.as < string > ()); }
#line 5253 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1100: // varobs_list: varobs_list COMMA symbol
#line 2408 "../preprocessor/src/DynareBison.yy"
              { driver.add_varobs(yystack_[0].value.as < string > ()); }
#line 5259 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1101: // varobs_list: symbol
#line 2410 "../preprocessor/src/DynareBison.yy"
              { driver.add_varobs(yystack_[0].value.as < string > ()); }
#line 5265 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1102: // $@29: %empty
#line 2413 "../preprocessor/src/DynareBison.yy"
                    { driver.check_varexobs(); }
#line 5271 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1104: // varexobs_list: varexobs_list symbol
#line 2416 "../preprocessor/src/DynareBison.yy"
              { driver.add_varexobs(yystack_[0].value.as < string > ()); }
#line 5277 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1105: // varexobs_list: varexobs_list COMMA symbol
#line 2418 "../preprocessor/src/DynareBison.yy"
              { driver.add_varexobs(yystack_[0].value.as < string > ()); }
#line 5283 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1106: // varexobs_list: symbol
#line 2420 "../preprocessor/src/DynareBison.yy"
              { driver.add_varexobs(yystack_[0].value.as < string > ()); }
#line 5289 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1107: // deterministic_trends: DETERMINISTIC_TRENDS ';' trend_list END ';'
#line 2423 "../preprocessor/src/DynareBison.yy"
                                                                   { driver.set_deterministic_trends(); }
#line 5295 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1108: // observation_trends: OBSERVATION_TRENDS ';' trend_list END ';'
#line 2424 "../preprocessor/src/DynareBison.yy"
                                                               { driver.set_trends(); }
#line 5301 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1111: // trend_element: symbol '(' expression ')' ';'
#line 2430 "../preprocessor/src/DynareBison.yy"
                                               { driver.set_trend_element(yystack_[4].value.as < string > (), yystack_[2].value.as < expr_t > ()); }
#line 5307 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1112: // filter_initial_state: FILTER_INITIAL_STATE ';' filter_initial_state_list END ';'
#line 2433 "../preprocessor/src/DynareBison.yy"
                       { driver.set_filter_initial_state(); }
#line 5313 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1115: // filter_initial_state_element: symbol '(' signed_integer ')' EQUAL expression ';'
#line 2441 "../preprocessor/src/DynareBison.yy"
                               { driver.set_filter_initial_state_element(yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 5319 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1116: // unit_root_vars: UNIT_ROOT_VARS symbol_list ';'
#line 2444 "../preprocessor/src/DynareBison.yy"
                                                { driver.set_unit_root_vars(); }
#line 5325 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1117: // optim_weights: OPTIM_WEIGHTS ';' optim_weights_list END ';'
#line 2446 "../preprocessor/src/DynareBison.yy"
                                                             { driver.optim_weights(); }
#line 5331 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1118: // optim_weights_list: optim_weights_list symbol expression ';'
#line 2449 "../preprocessor/src/DynareBison.yy"
                     { driver.set_optim_weights(yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 5337 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1119: // optim_weights_list: optim_weights_list symbol COMMA symbol expression ';'
#line 2451 "../preprocessor/src/DynareBison.yy"
                     { driver.set_optim_weights(yystack_[4].value.as < string > (), yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 5343 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1120: // optim_weights_list: symbol expression ';'
#line 2453 "../preprocessor/src/DynareBison.yy"
                     { driver.set_optim_weights(yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 5349 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1121: // optim_weights_list: symbol COMMA symbol expression ';'
#line 2455 "../preprocessor/src/DynareBison.yy"
                     { driver.set_optim_weights(yystack_[4].value.as < string > (), yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 5355 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1122: // osr_params: OSR_PARAMS symbol_list ';'
#line 2458 "../preprocessor/src/DynareBison.yy"
                                        { driver.set_osr_params(yystack_[1].value.as < vector<string> > ()); }
#line 5361 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1134: // osr: OSR ';'
#line 2477 "../preprocessor/src/DynareBison.yy"
      { driver.run_osr({}); }
#line 5367 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1135: // osr: OSR '(' osr_options_list ')' ';'
#line 2479 "../preprocessor/src/DynareBison.yy"
      { driver.run_osr({}); }
#line 5373 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1136: // osr: OSR symbol_list ';'
#line 2481 "../preprocessor/src/DynareBison.yy"
      { driver.run_osr(yystack_[1].value.as < vector<string> > ()); }
#line 5379 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1137: // osr: OSR '(' osr_options_list ')' symbol_list ';'
#line 2483 "../preprocessor/src/DynareBison.yy"
      { driver.run_osr(yystack_[1].value.as < vector<string> > ()); }
#line 5385 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1138: // dynatype: DYNATYPE '(' filename ')' ';'
#line 2487 "../preprocessor/src/DynareBison.yy"
           { driver.run_dynatype(yystack_[2].value.as < string > (), {}); }
#line 5391 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1139: // dynatype: DYNATYPE '(' filename ')' symbol_list ';'
#line 2489 "../preprocessor/src/DynareBison.yy"
           { driver.run_dynatype(yystack_[3].value.as < string > (), yystack_[1].value.as < vector<string> > ()); }
#line 5397 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1140: // dynasave: DYNASAVE '(' filename ')' ';'
#line 2493 "../preprocessor/src/DynareBison.yy"
           { driver.run_dynasave(yystack_[2].value.as < string > (), {}); }
#line 5403 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1141: // dynasave: DYNASAVE '(' filename ')' symbol_list ';'
#line 2495 "../preprocessor/src/DynareBison.yy"
           { driver.run_dynasave(yystack_[3].value.as < string > (), yystack_[1].value.as < vector<string> > ()); }
#line 5409 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1142: // load_params_and_steady_state: LOAD_PARAMS_AND_STEADY_STATE '(' filename ')' ';'
#line 2499 "../preprocessor/src/DynareBison.yy"
                               { driver.run_load_params_and_steady_state(yystack_[2].value.as < string > ()); }
#line 5415 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1143: // save_params_and_steady_state: SAVE_PARAMS_AND_STEADY_STATE '(' filename ')' ';'
#line 2503 "../preprocessor/src/DynareBison.yy"
                               { driver.run_save_params_and_steady_state(yystack_[2].value.as < string > ()); }
#line 5421 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1144: // identification: IDENTIFICATION ';'
#line 2507 "../preprocessor/src/DynareBison.yy"
                 { driver.run_identification(); }
#line 5427 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1145: // identification: IDENTIFICATION '(' identification_options_list ')' ';'
#line 2509 "../preprocessor/src/DynareBison.yy"
                 { driver.run_identification(); }
#line 5433 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1183: // model_comparison: MODEL_COMPARISON mc_filename_list ';'
#line 2554 "../preprocessor/src/DynareBison.yy"
                   { driver.run_model_comparison(); }
#line 5439 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1184: // model_comparison: MODEL_COMPARISON '(' o_marginal_density ')' mc_filename_list ';'
#line 2556 "../preprocessor/src/DynareBison.yy"
                   { driver.run_model_comparison(); }
#line 5445 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1185: // filename: symbol
#line 2559 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5451 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1186: // filename: QUOTED_STRING
#line 2560 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5457 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1187: // namespace_qualified_symbol: symbol
#line 2563 "../preprocessor/src/DynareBison.yy"
                             { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5463 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1188: // namespace_qualified_symbol: namespace_qualified_symbol '.' symbol
#line 2565 "../preprocessor/src/DynareBison.yy"
                             { yylhs.value.as < string > () = yystack_[2].value.as < string > () + "." + yystack_[0].value.as < string > (); }
#line 5469 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1189: // namespace_qualified_filename: namespace_qualified_symbol
#line 2568 "../preprocessor/src/DynareBison.yy"
                               { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5475 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1190: // namespace_qualified_filename: QUOTED_STRING
#line 2569 "../preprocessor/src/DynareBison.yy"
                               { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5481 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1191: // parallel_local_filename_list: filename
#line 2573 "../preprocessor/src/DynareBison.yy"
                               { driver.add_parallel_local_file(yystack_[0].value.as < string > ()); }
#line 5487 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1192: // parallel_local_filename_list: parallel_local_filename_list COMMA filename
#line 2575 "../preprocessor/src/DynareBison.yy"
                               { driver.add_parallel_local_file(yystack_[0].value.as < string > ()); }
#line 5493 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1193: // mc_filename_list: filename
#line 2579 "../preprocessor/src/DynareBison.yy"
                   { driver.add_mc_filename(yystack_[0].value.as < string > ()); }
#line 5499 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1194: // mc_filename_list: filename '(' non_negative_number ')'
#line 2581 "../preprocessor/src/DynareBison.yy"
                   { driver.add_mc_filename(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 5505 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1195: // mc_filename_list: mc_filename_list filename
#line 2583 "../preprocessor/src/DynareBison.yy"
                   { driver.add_mc_filename(yystack_[0].value.as < string > ()); }
#line 5511 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1196: // mc_filename_list: mc_filename_list filename '(' non_negative_number ')'
#line 2585 "../preprocessor/src/DynareBison.yy"
                   { driver.add_mc_filename(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 5517 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1197: // mc_filename_list: mc_filename_list COMMA filename
#line 2587 "../preprocessor/src/DynareBison.yy"
                   { driver.add_mc_filename(yystack_[0].value.as < string > ()); }
#line 5523 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1198: // mc_filename_list: mc_filename_list COMMA filename '(' non_negative_number ')'
#line 2589 "../preprocessor/src/DynareBison.yy"
                   { driver.add_mc_filename(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 5529 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1199: // $@30: %empty
#line 2592 "../preprocessor/src/DynareBison.yy"
                                      { driver.begin_planner_objective(); }
#line 5535 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1200: // $@31: %empty
#line 2593 "../preprocessor/src/DynareBison.yy"
                              { driver.end_planner_objective(yystack_[0].value.as < expr_t > ()); }
#line 5541 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1202: // ramsey_model: RAMSEY_MODEL ';'
#line 2596 "../preprocessor/src/DynareBison.yy"
                { driver.ramsey_model(); }
#line 5547 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1203: // ramsey_model: RAMSEY_MODEL '(' ramsey_model_options_list ')' ';'
#line 2598 "../preprocessor/src/DynareBison.yy"
                { driver.ramsey_model(); }
#line 5553 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1204: // ramsey_policy: RAMSEY_POLICY ';'
#line 2602 "../preprocessor/src/DynareBison.yy"
                { driver.ramsey_policy({}); }
#line 5559 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1205: // ramsey_policy: RAMSEY_POLICY '(' ramsey_policy_options_list ')' ';'
#line 2604 "../preprocessor/src/DynareBison.yy"
                { driver.ramsey_policy({}); }
#line 5565 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1206: // ramsey_policy: RAMSEY_POLICY symbol_list ';'
#line 2606 "../preprocessor/src/DynareBison.yy"
                { driver.ramsey_policy(yystack_[1].value.as < vector<string> > ()); }
#line 5571 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1207: // ramsey_policy: RAMSEY_POLICY '(' ramsey_policy_options_list ')' symbol_list ';'
#line 2608 "../preprocessor/src/DynareBison.yy"
                { driver.ramsey_policy(yystack_[1].value.as < vector<string> > ()); }
#line 5577 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1208: // ramsey_constraints: RAMSEY_CONSTRAINTS ';' ramsey_constraints_list END ';'
#line 2612 "../preprocessor/src/DynareBison.yy"
                     { driver.add_ramsey_constraints_statement(); }
#line 5583 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1211: // ramsey_constraint: NAME LESS expression ';'
#line 2620 "../preprocessor/src/DynareBison.yy"
                    { driver.ramsey_constraint_add_less(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 5589 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1212: // ramsey_constraint: NAME GREATER expression ';'
#line 2622 "../preprocessor/src/DynareBison.yy"
                    { driver.ramsey_constraint_add_greater(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 5595 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1213: // ramsey_constraint: NAME LESS_EQUAL expression ';'
#line 2624 "../preprocessor/src/DynareBison.yy"
                    { driver.ramsey_constraint_add_less_equal(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 5601 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1214: // ramsey_constraint: NAME GREATER_EQUAL expression ';'
#line 2626 "../preprocessor/src/DynareBison.yy"
                    { driver.ramsey_constraint_add_greater_equal(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 5607 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1215: // evaluate_planner_objective: EVALUATE_PLANNER_OBJECTIVE ';'
#line 2630 "../preprocessor/src/DynareBison.yy"
                             { driver.evaluate_planner_objective(); }
#line 5613 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1216: // evaluate_planner_objective: EVALUATE_PLANNER_OBJECTIVE '(' evaluate_planner_objective_options_list ')' ';'
#line 2632 "../preprocessor/src/DynareBison.yy"
                             { driver.evaluate_planner_objective(); }
#line 5619 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1221: // occbin_setup: OCCBIN_SETUP ';'
#line 2644 "../preprocessor/src/DynareBison.yy"
               { driver.occbin_setup(); }
#line 5625 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1222: // occbin_setup: OCCBIN_SETUP '(' occbin_setup_options_list ')' ';'
#line 2646 "../preprocessor/src/DynareBison.yy"
               { driver.occbin_setup(); }
#line 5631 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1252: // occbin_solver: OCCBIN_SOLVER ';'
#line 2682 "../preprocessor/src/DynareBison.yy"
                { driver.occbin_solver(); }
#line 5637 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1253: // occbin_solver: OCCBIN_SOLVER '(' occbin_solver_options_list ')' ';'
#line 2684 "../preprocessor/src/DynareBison.yy"
                { driver.occbin_solver(); }
#line 5643 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1264: // occbin_write_regimes: OCCBIN_WRITE_REGIMES ';'
#line 2702 "../preprocessor/src/DynareBison.yy"
                       { driver.occbin_write_regimes(); }
#line 5649 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1265: // occbin_write_regimes: OCCBIN_WRITE_REGIMES '(' occbin_write_regimes_options_list ')' ';'
#line 2704 "../preprocessor/src/DynareBison.yy"
                       { driver.occbin_write_regimes(); }
#line 5655 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1272: // occbin_graph: OCCBIN_GRAPH ';'
#line 2717 "../preprocessor/src/DynareBison.yy"
               { driver.occbin_graph({}); }
#line 5661 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1273: // occbin_graph: OCCBIN_GRAPH '(' occbin_graph_options_list ')' ';'
#line 2719 "../preprocessor/src/DynareBison.yy"
               { driver.occbin_graph({}); }
#line 5667 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1274: // occbin_graph: OCCBIN_GRAPH symbol_list ';'
#line 2721 "../preprocessor/src/DynareBison.yy"
               { driver.occbin_graph(yystack_[1].value.as < vector<string> > ()); }
#line 5673 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1275: // occbin_graph: OCCBIN_GRAPH '(' occbin_graph_options_list ')' symbol_list ';'
#line 2723 "../preprocessor/src/DynareBison.yy"
               { driver.occbin_graph(yystack_[1].value.as < vector<string> > ()); }
#line 5679 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1279: // discretionary_policy: DISCRETIONARY_POLICY ';'
#line 2733 "../preprocessor/src/DynareBison.yy"
                       { driver.discretionary_policy({}); }
#line 5685 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1280: // discretionary_policy: DISCRETIONARY_POLICY '(' discretionary_policy_options_list ')' ';'
#line 2735 "../preprocessor/src/DynareBison.yy"
                       { driver.discretionary_policy({}); }
#line 5691 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1281: // discretionary_policy: DISCRETIONARY_POLICY symbol_list ';'
#line 2737 "../preprocessor/src/DynareBison.yy"
                       { driver.discretionary_policy(yystack_[1].value.as < vector<string> > ()); }
#line 5697 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1282: // discretionary_policy: DISCRETIONARY_POLICY '(' discretionary_policy_options_list ')' symbol_list ';'
#line 2739 "../preprocessor/src/DynareBison.yy"
                       { driver.discretionary_policy(yystack_[1].value.as < vector<string> > ()); }
#line 5703 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1298: // write_latex_dynamic_model: WRITE_LATEX_DYNAMIC_MODEL ';'
#line 2770 "../preprocessor/src/DynareBison.yy"
                            { driver.write_latex_dynamic_model(false); }
#line 5709 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1299: // write_latex_dynamic_model: WRITE_LATEX_DYNAMIC_MODEL '(' WRITE_EQUATION_TAGS ')' ';'
#line 2772 "../preprocessor/src/DynareBison.yy"
                            { driver.write_latex_dynamic_model(true); }
#line 5715 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1300: // write_latex_static_model: WRITE_LATEX_STATIC_MODEL ';'
#line 2776 "../preprocessor/src/DynareBison.yy"
                           { driver.write_latex_static_model(false); }
#line 5721 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1301: // write_latex_static_model: WRITE_LATEX_STATIC_MODEL '(' WRITE_EQUATION_TAGS ')' ';'
#line 2778 "../preprocessor/src/DynareBison.yy"
                            { driver.write_latex_static_model(true); }
#line 5727 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1302: // write_latex_original_model: WRITE_LATEX_ORIGINAL_MODEL ';'
#line 2782 "../preprocessor/src/DynareBison.yy"
                           { driver.write_latex_original_model(false); }
#line 5733 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1303: // write_latex_original_model: WRITE_LATEX_ORIGINAL_MODEL '(' WRITE_EQUATION_TAGS ')' ';'
#line 2784 "../preprocessor/src/DynareBison.yy"
                            { driver.write_latex_original_model(true); }
#line 5739 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1304: // write_latex_steady_state_model: WRITE_LATEX_STEADY_STATE_MODEL ';'
#line 2788 "../preprocessor/src/DynareBison.yy"
                                 { driver.write_latex_steady_state_model(); }
#line 5745 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1305: // shock_decomposition: SHOCK_DECOMPOSITION ';'
#line 2792 "../preprocessor/src/DynareBison.yy"
                      { driver.shock_decomposition({}); }
#line 5751 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1306: // shock_decomposition: SHOCK_DECOMPOSITION '(' shock_decomposition_options_list ')' ';'
#line 2794 "../preprocessor/src/DynareBison.yy"
                      { driver.shock_decomposition({}); }
#line 5757 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1307: // shock_decomposition: SHOCK_DECOMPOSITION symbol_list ';'
#line 2796 "../preprocessor/src/DynareBison.yy"
                      { driver.shock_decomposition(yystack_[1].value.as < vector<string> > ()); }
#line 5763 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1308: // shock_decomposition: SHOCK_DECOMPOSITION '(' shock_decomposition_options_list ')' symbol_list ';'
#line 2798 "../preprocessor/src/DynareBison.yy"
                      { driver.shock_decomposition(yystack_[1].value.as < vector<string> > ()); }
#line 5769 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1309: // realtime_shock_decomposition: REALTIME_SHOCK_DECOMPOSITION ';'
#line 2802 "../preprocessor/src/DynareBison.yy"
                               { driver.realtime_shock_decomposition({}); }
#line 5775 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1310: // realtime_shock_decomposition: REALTIME_SHOCK_DECOMPOSITION '(' realtime_shock_decomposition_options_list ')' ';'
#line 2804 "../preprocessor/src/DynareBison.yy"
                               { driver.realtime_shock_decomposition({}); }
#line 5781 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1311: // realtime_shock_decomposition: REALTIME_SHOCK_DECOMPOSITION symbol_list ';'
#line 2806 "../preprocessor/src/DynareBison.yy"
                               { driver.realtime_shock_decomposition(yystack_[1].value.as < vector<string> > ()); }
#line 5787 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1312: // realtime_shock_decomposition: REALTIME_SHOCK_DECOMPOSITION '(' realtime_shock_decomposition_options_list ')' symbol_list ';'
#line 2808 "../preprocessor/src/DynareBison.yy"
                               { driver.realtime_shock_decomposition(yystack_[1].value.as < vector<string> > ()); }
#line 5793 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1313: // plot_shock_decomposition: PLOT_SHOCK_DECOMPOSITION ';'
#line 2812 "../preprocessor/src/DynareBison.yy"
                           { driver.plot_shock_decomposition({}); }
#line 5799 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1314: // plot_shock_decomposition: PLOT_SHOCK_DECOMPOSITION '(' plot_shock_decomposition_options_list ')' ';'
#line 2814 "../preprocessor/src/DynareBison.yy"
                           { driver.plot_shock_decomposition({}); }
#line 5805 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1315: // plot_shock_decomposition: PLOT_SHOCK_DECOMPOSITION symbol_list ';'
#line 2816 "../preprocessor/src/DynareBison.yy"
                           { driver.plot_shock_decomposition(yystack_[1].value.as < vector<string> > ()); }
#line 5811 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1316: // plot_shock_decomposition: PLOT_SHOCK_DECOMPOSITION '(' plot_shock_decomposition_options_list ')' symbol_list ';'
#line 2818 "../preprocessor/src/DynareBison.yy"
                           { driver.plot_shock_decomposition(yystack_[1].value.as < vector<string> > ()); }
#line 5817 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1317: // initial_condition_decomposition: INITIAL_CONDITION_DECOMPOSITION ';'
#line 2822 "../preprocessor/src/DynareBison.yy"
                                  { driver.initial_condition_decomposition({}); }
#line 5823 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1318: // initial_condition_decomposition: INITIAL_CONDITION_DECOMPOSITION '(' initial_condition_decomposition_options_list ')' ';'
#line 2824 "../preprocessor/src/DynareBison.yy"
                                  { driver.initial_condition_decomposition({}); }
#line 5829 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1319: // initial_condition_decomposition: INITIAL_CONDITION_DECOMPOSITION symbol_list ';'
#line 2826 "../preprocessor/src/DynareBison.yy"
                                  { driver.initial_condition_decomposition(yystack_[1].value.as < vector<string> > ()); }
#line 5835 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1320: // initial_condition_decomposition: INITIAL_CONDITION_DECOMPOSITION '(' initial_condition_decomposition_options_list ')' symbol_list ';'
#line 2828 "../preprocessor/src/DynareBison.yy"
                                  { driver.initial_condition_decomposition(yystack_[1].value.as < vector<string> > ()); }
#line 5841 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1321: // squeeze_shock_decomposition: SQUEEZE_SHOCK_DECOMPOSITION ';'
#line 2832 "../preprocessor/src/DynareBison.yy"
                              { driver.squeeze_shock_decomposition({}); }
#line 5847 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1322: // squeeze_shock_decomposition: SQUEEZE_SHOCK_DECOMPOSITION symbol_list ';'
#line 2834 "../preprocessor/src/DynareBison.yy"
                              { driver.squeeze_shock_decomposition(yystack_[1].value.as < vector<string> > ()); }
#line 5853 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1342: // bvar_density: BVAR_DENSITY INT_NUMBER ';'
#line 2863 "../preprocessor/src/DynareBison.yy"
               { driver.bvar_density(yystack_[1].value.as < string > ()); }
#line 5859 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1343: // bvar_density: BVAR_DENSITY '(' bvar_density_options_list ')' INT_NUMBER ';'
#line 2865 "../preprocessor/src/DynareBison.yy"
               { driver.bvar_density(yystack_[1].value.as < string > ()); }
#line 5865 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1350: // bvar_forecast: BVAR_FORECAST INT_NUMBER ';'
#line 2879 "../preprocessor/src/DynareBison.yy"
                { driver.bvar_forecast(yystack_[1].value.as < string > ()); }
#line 5871 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1351: // bvar_forecast: BVAR_FORECAST '(' bvar_forecast_options_list ')' INT_NUMBER ';'
#line 2881 "../preprocessor/src/DynareBison.yy"
                { driver.bvar_forecast(yystack_[1].value.as < string > ()); }
#line 5877 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1352: // bvar_irf: BVAR_IRF '(' INT_NUMBER COMMA QUOTED_STRING ')' ';'
#line 2885 "../preprocessor/src/DynareBison.yy"
                { driver.bvar_irf(yystack_[4].value.as < string > (), yystack_[2].value.as < string > ()); }
#line 5883 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1403: // sbvar: SBVAR ';'
#line 2942 "../preprocessor/src/DynareBison.yy"
        { driver.sbvar(); }
#line 5889 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1404: // sbvar: SBVAR '(' sbvar_options_list ')' ';'
#line 2944 "../preprocessor/src/DynareBison.yy"
        { driver.sbvar(); }
#line 5895 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1421: // ms_variance_decomposition: MS_VARIANCE_DECOMPOSITION ';'
#line 2968 "../preprocessor/src/DynareBison.yy"
                            { driver.ms_variance_decomposition(); }
#line 5901 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1422: // ms_variance_decomposition: MS_VARIANCE_DECOMPOSITION '(' ms_variance_decomposition_options_list ')' ';'
#line 2970 "../preprocessor/src/DynareBison.yy"
                            { driver.ms_variance_decomposition(); }
#line 5907 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1439: // ms_forecast: MS_FORECAST ';'
#line 2994 "../preprocessor/src/DynareBison.yy"
              { driver.ms_forecast(); }
#line 5913 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1440: // ms_forecast: MS_FORECAST '(' ms_forecast_options_list ')' ';'
#line 2996 "../preprocessor/src/DynareBison.yy"
              { driver.ms_forecast(); }
#line 5919 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1457: // ms_irf: MS_IRF ';'
#line 3020 "../preprocessor/src/DynareBison.yy"
         { driver.ms_irf({}); }
#line 5925 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1458: // ms_irf: MS_IRF '(' ms_irf_options_list ')' ';'
#line 3022 "../preprocessor/src/DynareBison.yy"
         { driver.ms_irf({}); }
#line 5931 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1459: // ms_irf: MS_IRF symbol_list ';'
#line 3024 "../preprocessor/src/DynareBison.yy"
         { driver.ms_irf(yystack_[1].value.as < vector<string> > ()); }
#line 5937 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1460: // ms_irf: MS_IRF '(' ms_irf_options_list ')' symbol_list ';'
#line 3026 "../preprocessor/src/DynareBison.yy"
         { driver.ms_irf(yystack_[1].value.as < vector<string> > ()); }
#line 5943 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1467: // ms_compute_probabilities: MS_COMPUTE_PROBABILITIES ';'
#line 3040 "../preprocessor/src/DynareBison.yy"
                           { driver.ms_compute_probabilities(); }
#line 5949 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1468: // ms_compute_probabilities: MS_COMPUTE_PROBABILITIES '(' ms_compute_probabilities_options_list ')' ';'
#line 3042 "../preprocessor/src/DynareBison.yy"
                           { driver.ms_compute_probabilities(); }
#line 5955 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1479: // ms_compute_mdd: MS_COMPUTE_MDD ';'
#line 3060 "../preprocessor/src/DynareBison.yy"
                 { driver.ms_compute_mdd(); }
#line 5961 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1480: // ms_compute_mdd: MS_COMPUTE_MDD '(' ms_compute_mdd_options_list ')' ';'
#line 3062 "../preprocessor/src/DynareBison.yy"
                 { driver.ms_compute_mdd(); }
#line 5967 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1490: // ms_simulation: MS_SIMULATION ';'
#line 3079 "../preprocessor/src/DynareBison.yy"
                { driver.ms_simulation(); }
#line 5973 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1491: // ms_simulation: MS_SIMULATION '(' ms_simulation_options_list ')' ';'
#line 3081 "../preprocessor/src/DynareBison.yy"
                { driver.ms_simulation(); }
#line 5979 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1529: // ms_estimation: MS_ESTIMATION ';'
#line 3126 "../preprocessor/src/DynareBison.yy"
                { driver.ms_estimation(); }
#line 5985 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1530: // ms_estimation: MS_ESTIMATION '(' ms_estimation_options_list ')' ';'
#line 3128 "../preprocessor/src/DynareBison.yy"
                { driver.ms_estimation(); }
#line 5991 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1531: // sensitivity: SENSITIVITY ';'
#line 3132 "../preprocessor/src/DynareBison.yy"
              { driver.sensitivity(); }
#line 5997 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1532: // sensitivity: SENSITIVITY '(' sensitivity_options_list ')' ';'
#line 3134 "../preprocessor/src/DynareBison.yy"
              { driver.sensitivity(); }
#line 6003 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1533: // sensitivity: DYNARE_SENSITIVITY ';'
#line 3136 "../preprocessor/src/DynareBison.yy"
              {
                driver.warning("The 'dynare_sensitivity' command is deprecated. It has been renamed 'sensitivity'.");
                driver.sensitivity();
              }
#line 6012 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1534: // sensitivity: DYNARE_SENSITIVITY '(' sensitivity_options_list ')' ';'
#line 3141 "../preprocessor/src/DynareBison.yy"
              {
                driver.warning("The 'dynare_sensitivity' command is deprecated. It has been renamed 'sensitivity'.");
                driver.sensitivity();
              }
#line 6021 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1659: // homotopy_setup: HOMOTOPY_SETUP ';' homotopy_list END ';'
#line 3292 "../preprocessor/src/DynareBison.yy"
                 { driver.end_homotopy(false); }
#line 6027 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1660: // homotopy_setup: HOMOTOPY_SETUP '(' FROM_INITVAL_TO_ENDVAL ')' ';' END ';'
#line 3294 "../preprocessor/src/DynareBison.yy"
                 { driver.end_homotopy(true); }
#line 6033 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1661: // homotopy_setup: HOMOTOPY_SETUP '(' FROM_INITVAL_TO_ENDVAL ')' ';' homotopy_list END ';'
#line 3296 "../preprocessor/src/DynareBison.yy"
                 { driver.end_homotopy(true); }
#line 6039 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1664: // homotopy_item: symbol COMMA expression COMMA expression ';'
#line 3304 "../preprocessor/src/DynareBison.yy"
                { driver.homotopy_val(yystack_[5].value.as < string > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 6045 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1665: // homotopy_item: symbol COMMA expression ';'
#line 3306 "../preprocessor/src/DynareBison.yy"
                { driver.homotopy_val(yystack_[3].value.as < string > (), nullptr, yystack_[1].value.as < expr_t > ()); }
#line 6051 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1666: // forecast: FORECAST ';'
#line 3310 "../preprocessor/src/DynareBison.yy"
          { driver.forecast({}); }
#line 6057 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1667: // forecast: FORECAST '(' forecast_options ')' ';'
#line 3312 "../preprocessor/src/DynareBison.yy"
          { driver.forecast({}); }
#line 6063 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1668: // forecast: FORECAST symbol_list ';'
#line 3314 "../preprocessor/src/DynareBison.yy"
          { driver.forecast(yystack_[1].value.as < vector<string> > ()); }
#line 6069 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1669: // forecast: FORECAST '(' forecast_options ')' symbol_list ';'
#line 3316 "../preprocessor/src/DynareBison.yy"
          { driver.forecast(yystack_[1].value.as < vector<string> > ()); }
#line 6075 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1677: // conditional_forecast: CONDITIONAL_FORECAST '(' conditional_forecast_options ')' ';'
#line 3331 "../preprocessor/src/DynareBison.yy"
                       { driver.conditional_forecast(); }
#line 6081 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1685: // plot_conditional_forecast: PLOT_CONDITIONAL_FORECAST symbol_list ';'
#line 3346 "../preprocessor/src/DynareBison.yy"
                            { driver.plot_conditional_forecast(nullopt, yystack_[1].value.as < vector<string> > ()); }
#line 6087 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1686: // plot_conditional_forecast: PLOT_CONDITIONAL_FORECAST '(' PERIODS EQUAL INT_NUMBER ')' symbol_list ';'
#line 3348 "../preprocessor/src/DynareBison.yy"
                            { driver.plot_conditional_forecast(yystack_[3].value.as < string > (), yystack_[1].value.as < vector<string> > ()); }
#line 6093 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1687: // conditional_forecast_paths: CONDITIONAL_FORECAST_PATHS ';' conditional_forecast_paths_shock_list END ';'
#line 3352 "../preprocessor/src/DynareBison.yy"
                             { driver.conditional_forecast_paths(); }
#line 6099 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1690: // conditional_forecast_paths_shock_elem: VAR symbol ';' PERIODS period_list ';' VALUES value_list ';'
#line 3360 "../preprocessor/src/DynareBison.yy"
                                        { driver.add_det_shock(
                                              yystack_[7].value.as < string > (), yystack_[4].value.as < vector<pair<int, int>> > (), yystack_[1].value.as < vector<expr_t> > (),
                                              ParsingDriver::DetShockType::conditional_forecast); }
#line 6107 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1691: // $@32: %empty
#line 3365 "../preprocessor/src/DynareBison.yy"
                                            { driver.begin_steady_state_model(); }
#line 6113 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1692: // steady_state_model: STEADY_STATE_MODEL ';' $@32 steady_state_equation_list END ';'
#line 3366 "../preprocessor/src/DynareBison.yy"
                                                        { driver.reset_data_tree(); }
#line 6119 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1695: // steady_state_equation: symbol EQUAL expression ';'
#line 3374 "../preprocessor/src/DynareBison.yy"
                        { driver.add_steady_state_model_equal(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 6125 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1696: // steady_state_equation: '[' symbol_list ']' EQUAL expression ';'
#line 3376 "../preprocessor/src/DynareBison.yy"
                        { driver.add_steady_state_model_equal_multiple(yystack_[4].value.as < vector<string> > (), yystack_[1].value.as < expr_t > ()); }
#line 6131 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1697: // calib_smoother: CALIB_SMOOTHER ';'
#line 3380 "../preprocessor/src/DynareBison.yy"
                 { driver.calib_smoother({}); }
#line 6137 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1698: // calib_smoother: CALIB_SMOOTHER '(' calib_smoother_options_list ')' ';'
#line 3382 "../preprocessor/src/DynareBison.yy"
                 { driver.calib_smoother({}); }
#line 6143 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1699: // calib_smoother: CALIB_SMOOTHER symbol_list ';'
#line 3384 "../preprocessor/src/DynareBison.yy"
                 { driver.calib_smoother(yystack_[1].value.as < vector<string> > ()); }
#line 6149 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1700: // calib_smoother: CALIB_SMOOTHER '(' calib_smoother_options_list ')' symbol_list ';'
#line 3386 "../preprocessor/src/DynareBison.yy"
                 { driver.calib_smoother(yystack_[1].value.as < vector<string> > ()); }
#line 6155 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1722: // generate_irfs: GENERATE_IRFS ';' END ';'
#line 3415 "../preprocessor/src/DynareBison.yy"
                { driver.end_generate_irfs(); }
#line 6161 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1723: // generate_irfs: GENERATE_IRFS ';' generate_irfs_element_list END ';'
#line 3417 "../preprocessor/src/DynareBison.yy"
                { driver.end_generate_irfs(); }
#line 6167 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1724: // generate_irfs: GENERATE_IRFS '(' generate_irfs_options_list ')' ';' END ';'
#line 3419 "../preprocessor/src/DynareBison.yy"
                { driver.end_generate_irfs(); }
#line 6173 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1725: // generate_irfs: GENERATE_IRFS '(' generate_irfs_options_list ')' ';' generate_irfs_element_list END ';'
#line 3421 "../preprocessor/src/DynareBison.yy"
                { driver.end_generate_irfs(); }
#line 6179 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1732: // generate_irfs_element: NAME COMMA generate_irfs_exog_element_list ';'
#line 3437 "../preprocessor/src/DynareBison.yy"
                        { driver.add_generate_irfs_element(yystack_[3].value.as < string > ()); }
#line 6185 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1733: // generate_irfs_exog_element_list: generate_irfs_exog_element_list COMMA symbol EQUAL signed_number
#line 3441 "../preprocessor/src/DynareBison.yy"
                                  { driver.add_generate_irfs_exog_element(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 6191 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1734: // generate_irfs_exog_element_list: symbol EQUAL signed_number
#line 3443 "../preprocessor/src/DynareBison.yy"
                                  { driver.add_generate_irfs_exog_element(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 6197 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1735: // extended_path: EXTENDED_PATH ';'
#line 3447 "../preprocessor/src/DynareBison.yy"
                { driver.extended_path(); }
#line 6203 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1736: // extended_path: EXTENDED_PATH '(' extended_path_options_list ')' ';'
#line 3449 "../preprocessor/src/DynareBison.yy"
                { driver.extended_path(); }
#line 6209 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1744: // model_diagnostics: MODEL_DIAGNOSTICS ';'
#line 3464 "../preprocessor/src/DynareBison.yy"
                    { driver.model_diagnostics(); }
#line 6215 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1745: // calibration_range: '[' expression COMMA expression ']'
#line 3468 "../preprocessor/src/DynareBison.yy"
                    { yylhs.value.as < pair<expr_t,expr_t> > () = {yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()}; }
#line 6221 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1746: // calibration_range: PLUS
#line 3470 "../preprocessor/src/DynareBison.yy"
                    { yylhs.value.as < pair<expr_t,expr_t> > () = {driver.add_non_negative_constant("0"), driver.add_inf_constant()}; }
#line 6227 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1747: // calibration_range: MINUS
#line 3472 "../preprocessor/src/DynareBison.yy"
                    { yylhs.value.as < pair<expr_t,expr_t> > () = {driver.add_uminus(driver.add_inf_constant()),
                            driver.add_non_negative_constant("0")}; }
#line 6234 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1748: // moment_calibration: MOMENT_CALIBRATION ';' moment_calibration_list END ';'
#line 3477 "../preprocessor/src/DynareBison.yy"
                     { driver.end_moment_calibration(); }
#line 6240 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1751: // moment_calibration_item: symbol COMMA symbol COMMA calibration_range ';'
#line 3485 "../preprocessor/src/DynareBison.yy"
                          { driver.add_moment_calibration_item(yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), "0", yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 6246 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1752: // moment_calibration_item: symbol COMMA symbol '(' signed_integer ')' COMMA calibration_range ';'
#line 3487 "../preprocessor/src/DynareBison.yy"
                          { driver.add_moment_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 6252 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1753: // moment_calibration_item: symbol COMMA symbol '(' signed_integer_range ')' COMMA calibration_range ';'
#line 3489 "../preprocessor/src/DynareBison.yy"
                          { driver.add_moment_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 6258 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1754: // irf_calibration: IRF_CALIBRATION ';' irf_calibration_list END ';'
#line 3493 "../preprocessor/src/DynareBison.yy"
                  { driver.end_irf_calibration(); }
#line 6264 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1755: // irf_calibration: IRF_CALIBRATION '(' o_relative_irf ')' ';' irf_calibration_list END ';'
#line 3495 "../preprocessor/src/DynareBison.yy"
                  { driver.end_irf_calibration(); }
#line 6270 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1758: // irf_calibration_item: symbol COMMA symbol COMMA calibration_range ';'
#line 3503 "../preprocessor/src/DynareBison.yy"
                       { driver.add_irf_calibration_item(yystack_[5].value.as < string > (), "1", yystack_[3].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 6276 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1759: // irf_calibration_item: symbol '(' INT_NUMBER ')' COMMA symbol COMMA calibration_range ';'
#line 3505 "../preprocessor/src/DynareBison.yy"
                       { driver.add_irf_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 6282 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1760: // irf_calibration_item: symbol '(' integer_range ')' COMMA symbol COMMA calibration_range ';'
#line 3507 "../preprocessor/src/DynareBison.yy"
                       { driver.add_irf_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 6288 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1761: // smoother2histval: SMOOTHER2HISTVAL ';'
#line 3511 "../preprocessor/src/DynareBison.yy"
                   { driver.smoother2histval(); }
#line 6294 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1762: // smoother2histval: SMOOTHER2HISTVAL '(' smoother2histval_options_list ')' ';'
#line 3513 "../preprocessor/src/DynareBison.yy"
                   { driver.smoother2histval(); }
#line 6300 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1770: // shock_groups: SHOCK_GROUPS ';' shock_group_list END ';'
#line 3528 "../preprocessor/src/DynareBison.yy"
               { driver.end_shock_groups("default"); }
#line 6306 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1771: // shock_groups: SHOCK_GROUPS '(' NAME EQUAL symbol ')' ';' shock_group_list END ';'
#line 3530 "../preprocessor/src/DynareBison.yy"
               { driver.end_shock_groups(yystack_[5].value.as < string > ()); }
#line 6312 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1774: // shock_group_element: symbol EQUAL shock_name_list ';'
#line 3537 "../preprocessor/src/DynareBison.yy"
                                                       { driver.add_shock_group(yystack_[3].value.as < string > ()); }
#line 6318 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1775: // shock_group_element: QUOTED_STRING EQUAL shock_name_list ';'
#line 3538 "../preprocessor/src/DynareBison.yy"
                                                              { driver.add_shock_group(yystack_[3].value.as < string > ()); }
#line 6324 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1776: // shock_name_list: shock_name_list COMMA symbol
#line 3541 "../preprocessor/src/DynareBison.yy"
                                               { driver.add_shock_group_element(yystack_[0].value.as < string > ()); }
#line 6330 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1777: // shock_name_list: shock_name_list symbol
#line 3542 "../preprocessor/src/DynareBison.yy"
                                         { driver.add_shock_group_element(yystack_[0].value.as < string > ()); }
#line 6336 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1778: // shock_name_list: symbol
#line 3543 "../preprocessor/src/DynareBison.yy"
                         { driver.add_shock_group_element(yystack_[0].value.as < string > ()); }
#line 6342 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1779: // init2shocks: INIT2SHOCKS ';' init2shocks_list END ';'
#line 3547 "../preprocessor/src/DynareBison.yy"
              { driver.end_init2shocks("default"); }
#line 6348 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1780: // init2shocks: INIT2SHOCKS '(' NAME EQUAL symbol ')' ';' init2shocks_list END ';'
#line 3549 "../preprocessor/src/DynareBison.yy"
              { driver.end_init2shocks(yystack_[5].value.as < string > ()); }
#line 6354 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1783: // init2shocks_element: symbol symbol ';'
#line 3556 "../preprocessor/src/DynareBison.yy"
                                        { driver.add_init2shocks(yystack_[2].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 6360 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1784: // init2shocks_element: symbol COMMA symbol ';'
#line 3557 "../preprocessor/src/DynareBison.yy"
                                              { driver.add_init2shocks(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 6366 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1785: // matched_irfs: MATCHED_IRFS ';' matched_irfs_list END ';'
#line 3561 "../preprocessor/src/DynareBison.yy"
               { driver.matched_irfs(yystack_[2].value.as < map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (), false); }
#line 6372 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1786: // matched_irfs: MATCHED_IRFS '(' OVERWRITE ')' ';' matched_irfs_list END ';'
#line 3563 "../preprocessor/src/DynareBison.yy"
               { driver.matched_irfs(yystack_[2].value.as < map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (), true); }
#line 6378 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1787: // matched_irfs_list: matched_irfs_elem
#line 3567 "../preprocessor/src/DynareBison.yy"
                    { yylhs.value.as < map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > () = {yystack_[0].value.as < pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > ()}; }
#line 6384 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1788: // matched_irfs_list: matched_irfs_list matched_irfs_elem
#line 3569 "../preprocessor/src/DynareBison.yy"
                    {
                      yylhs.value.as < map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > () = yystack_[1].value.as < map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > ();
                      auto [it, success] = yylhs.value.as < map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > ().insert(yystack_[0].value.as < pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > ());
                      if (!success)
                        driver.error("matched_irfs: the pair endogenous " + yystack_[0].value.as < pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > ().first.first + " with exogenous " + yystack_[0].value.as < pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > ().first.second + " appears two times");
                    }
#line 6395 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1789: // matched_irfs_elem: matched_irfs_elem_var_varexo PERIODS period_list ';' matched_irfs_elem_values_weights
#line 3580 "../preprocessor/src/DynareBison.yy"
                    {
                      if (yystack_[2].value.as < vector<pair<int, int>> > ().size() != yystack_[0].value.as < pair<vector<expr_t>, vector<expr_t>> > ().first.size())
                        driver.error("matched_irfs: the 'periods' and 'values' keywords are not followed by the same number of elements");
                      if (yystack_[2].value.as < vector<pair<int, int>> > ().size() != yystack_[0].value.as < pair<vector<expr_t>, vector<expr_t>> > ().second.size())
                        driver.error("matched_irfs: the 'periods' and 'values' keywords are not followed by the same number of elements");
                      vector<tuple<int, int, expr_t, expr_t>> v;
                      v.reserve(yystack_[2].value.as < vector<pair<int, int>> > ().size());
                      for (size_t i {0}; i < yystack_[2].value.as < vector<pair<int, int>> > ().size(); i++)
                        v.emplace_back(yystack_[2].value.as < vector<pair<int, int>> > ()[i].first, yystack_[2].value.as < vector<pair<int, int>> > ()[i].second, yystack_[0].value.as < pair<vector<expr_t>, vector<expr_t>> > ().first[i], yystack_[0].value.as < pair<vector<expr_t>, vector<expr_t>> > ().second[i]);
                      yylhs.value.as < pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > () = {yystack_[4].value.as < pair<string,string> > (), v};
                    }
#line 6411 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1790: // matched_irfs_elem_var_varexo: VAR symbol ';' VAREXO symbol ';'
#line 3594 "../preprocessor/src/DynareBison.yy"
                               {
                                 driver.check_symbol_is_endogenous(yystack_[4].value.as < string > ());
                                 driver.check_symbol_is_exogenous(yystack_[1].value.as < string > (), false);
                                 yylhs.value.as < pair<string,string> > () = {yystack_[4].value.as < string > (), yystack_[1].value.as < string > ()};
                               }
#line 6421 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1791: // matched_irfs_elem_var_varexo: VAREXO symbol ';' VAR symbol ';'
#line 3600 "../preprocessor/src/DynareBison.yy"
                               {
                                 driver.check_symbol_is_endogenous(yystack_[1].value.as < string > ());
                                 driver.check_symbol_is_exogenous(yystack_[4].value.as < string > (), false);
                                 yylhs.value.as < pair<string,string> > () = {yystack_[1].value.as < string > (), yystack_[4].value.as < string > ()};
                               }
#line 6431 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1792: // matched_irfs_elem_values_weights: VALUES value_list ';'
#line 3608 "../preprocessor/src/DynareBison.yy"
                                   {
                                     yylhs.value.as < pair<vector<expr_t>, vector<expr_t>> > () = {yystack_[1].value.as < vector<expr_t> > (), vector(yystack_[1].value.as < vector<expr_t> > ().size(),
                                                      driver.add_non_negative_constant("1"))};
                                   }
#line 6440 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1793: // matched_irfs_elem_values_weights: VALUES value_list ';' WEIGHTS value_list ';'
#line 3613 "../preprocessor/src/DynareBison.yy"
                                   { yylhs.value.as < pair<vector<expr_t>, vector<expr_t>> > () = {yystack_[4].value.as < vector<expr_t> > (), yystack_[1].value.as < vector<expr_t> > ()}; }
#line 6446 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1794: // matched_irfs_elem_values_weights: WEIGHTS value_list ';' VALUES value_list ';'
#line 3615 "../preprocessor/src/DynareBison.yy"
                                   { yylhs.value.as < pair<vector<expr_t>, vector<expr_t>> > () = {yystack_[1].value.as < vector<expr_t> > (), yystack_[4].value.as < vector<expr_t> > ()}; }
#line 6452 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1795: // matched_irfs_weights: MATCHED_IRFS_WEIGHTS ';' matched_irfs_weights_list END ';'
#line 3619 "../preprocessor/src/DynareBison.yy"
                       { driver.matched_irfs_weights(yystack_[2].value.as < map<tuple<string, string, string, string, string, string>, expr_t> > (), false); }
#line 6458 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1796: // matched_irfs_weights: MATCHED_IRFS_WEIGHTS '(' OVERWRITE ')' ';' matched_irfs_weights_list END ';'
#line 3621 "../preprocessor/src/DynareBison.yy"
                       { driver.matched_irfs_weights(yystack_[2].value.as < map<tuple<string, string, string, string, string, string>, expr_t> > (), true); }
#line 6464 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1797: // matched_irfs_weights_list: matched_irfs_weights_elem
#line 3625 "../preprocessor/src/DynareBison.yy"
                            { yylhs.value.as < map<tuple<string, string, string, string, string, string>, expr_t> > () = {yystack_[0].value.as < pair<tuple<string, string, string, string, string, string>, expr_t> > ()}; }
#line 6470 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1798: // matched_irfs_weights_list: matched_irfs_weights_list matched_irfs_weights_elem
#line 3627 "../preprocessor/src/DynareBison.yy"
                            {
                              yylhs.value.as < map<tuple<string, string, string, string, string, string>, expr_t> > () = yystack_[1].value.as < map<tuple<string, string, string, string, string, string>, expr_t> > ();
                              auto [it, success] = yylhs.value.as < map<tuple<string, string, string, string, string, string>, expr_t> > ().insert(yystack_[0].value.as < pair<tuple<string, string, string, string, string, string>, expr_t> > ());
                              if (!success)
                                driver.error("matched_irfs: the tuple (" + get<0>(yystack_[0].value.as < pair<tuple<string, string, string, string, string, string>, expr_t> > ().first)
                                             + "(" + get<1>(yystack_[0].value.as < pair<tuple<string, string, string, string, string, string>, expr_t> > ().first) + ")," + get<2>(yystack_[0].value.as < pair<tuple<string, string, string, string, string, string>, expr_t> > ().first)
                                             + "," + get<3>(yystack_[0].value.as < pair<tuple<string, string, string, string, string, string>, expr_t> > ().first) + "(" + get<4>(yystack_[0].value.as < pair<tuple<string, string, string, string, string, string>, expr_t> > ().first) + "),"
                                             + get<5>(yystack_[0].value.as < pair<tuple<string, string, string, string, string, string>, expr_t> > ().first) + ") appears two times");
                            }
#line 6484 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1799: // matched_irfs_weights_elem: matched_irfs_weights_elem_var_varexo COMMA matched_irfs_weights_elem_var_varexo COMMA expression ';'
#line 3641 "../preprocessor/src/DynareBison.yy"
                            {
                              yylhs.value.as < pair<tuple<string, string, string, string, string, string>, expr_t> > () = {{get<0>(yystack_[5].value.as < tuple<string, string, string> > ()), get<1>(yystack_[5].value.as < tuple<string, string, string> > ()), get<2>(yystack_[5].value.as < tuple<string, string, string> > ()),
                                     get<0>(yystack_[3].value.as < tuple<string, string, string> > ()), get<1>(yystack_[3].value.as < tuple<string, string, string> > ()), get<2>(yystack_[3].value.as < tuple<string, string, string> > ())},
                                    yystack_[1].value.as < expr_t > ()};
                            }
#line 6494 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1800: // matched_irfs_weights_elem_var_varexo: symbol '(' INT_NUMBER ')' COMMA symbol
#line 3649 "../preprocessor/src/DynareBison.yy"
                                       {
                                         driver.check_symbol_is_endogenous(yystack_[5].value.as < string > ());
                                         driver.check_symbol_is_exogenous(yystack_[0].value.as < string > (), false);
                                         yylhs.value.as < tuple<string, string, string> > () = {yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), yystack_[0].value.as < string > ()};
                                       }
#line 6504 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1801: // matched_irfs_weights_elem_var_varexo: symbol '(' integer_range ')' COMMA symbol
#line 3655 "../preprocessor/src/DynareBison.yy"
                                       {
                                         driver.check_symbol_is_endogenous(yystack_[5].value.as < string > ());
                                         driver.check_symbol_is_exogenous(yystack_[0].value.as < string > (), false);
                                         yylhs.value.as < tuple<string, string, string> > () = {yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), yystack_[0].value.as < string > ()};
                                       }
#line 6514 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1802: // o_solve_algo: SOLVE_ALGO EQUAL INT_NUMBER
#line 3662 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("solve_algo", yystack_[0].value.as < string > ()); }
#line 6520 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1803: // o_stack_solve_algo: STACK_SOLVE_ALGO EQUAL INT_NUMBER
#line 3663 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_num("stack_solve_algo", yystack_[0].value.as < string > ()); }
#line 6526 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1804: // o_robust_lin_solve: ROBUST_LIN_SOLVE
#line 3664 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_num("simul.robust_lin_solve", "true"); }
#line 6532 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1805: // o_endogenous_terminal_period: ENDOGENOUS_TERMINAL_PERIOD
#line 3665 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("endogenous_terminal_period", "true"); }
#line 6538 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1806: // o_order: ORDER EQUAL INT_NUMBER
#line 3666 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_num("order", yystack_[0].value.as < string > ()); }
#line 6544 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1807: // o_replic: REPLIC EQUAL INT_NUMBER
#line 3667 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("replic", yystack_[0].value.as < string > ()); }
#line 6550 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1808: // o_drop: DROP EQUAL INT_NUMBER
#line 3668 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("drop", yystack_[0].value.as < string > ()); }
#line 6556 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1809: // o_ar: AR EQUAL INT_NUMBER
#line 3669 "../preprocessor/src/DynareBison.yy"
                           { driver.option_num("ar", yystack_[0].value.as < string > ()); }
#line 6562 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1810: // o_nocorr: NOCORR
#line 3670 "../preprocessor/src/DynareBison.yy"
                  { driver.option_num("nocorr", "true"); }
#line 6568 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1811: // o_nofunctions: NOFUNCTIONS
#line 3671 "../preprocessor/src/DynareBison.yy"
                            { driver.option_num("nofunctions", "true"); }
#line 6574 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1812: // o_nomoments: NOMOMENTS
#line 3672 "../preprocessor/src/DynareBison.yy"
                        { driver.option_num("nomoments", "true"); }
#line 6580 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1813: // o_nomodelsummary: NOMODELSUMMARY
#line 3673 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("nomodelsummary", "true"); }
#line 6586 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1814: // o_irf: IRF EQUAL INT_NUMBER
#line 3674 "../preprocessor/src/DynareBison.yy"
                             { driver.option_num("irf", yystack_[0].value.as < string > ()); }
#line 6592 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1815: // o_irf_shocks: IRF_SHOCKS EQUAL '(' symbol_list ')'
#line 3675 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_symbol_list("irf_shocks", yystack_[1].value.as < vector<string> > ()); }
#line 6598 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1816: // o_hp_filter: HP_FILTER EQUAL non_negative_number
#line 3676 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("hp_filter", yystack_[0].value.as < string > ()); }
#line 6604 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1817: // o_hp_ngrid: HP_NGRID EQUAL INT_NUMBER
#line 3677 "../preprocessor/src/DynareBison.yy"
                                       {
                                         driver.warning("The 'hp_ngrid' option is deprecated. It has been superseded by the 'filtered_theoretical_moments_grid' option.");
                                         driver.option_num("filtered_theoretical_moments_grid", yystack_[0].value.as < string > ());
                                       }
#line 6613 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1818: // o_filtered_theoretical_moments_grid: FILTERED_THEORETICAL_MOMENTS_GRID EQUAL INT_NUMBER
#line 3681 "../preprocessor/src/DynareBison.yy"
                                                                                         { driver.option_num("filtered_theoretical_moments_grid", yystack_[0].value.as < string > ()); }
#line 6619 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1819: // o_one_sided_hp_filter: ONE_SIDED_HP_FILTER EQUAL non_negative_number
#line 3682 "../preprocessor/src/DynareBison.yy"
                                                                      { driver.option_num("one_sided_hp_filter", yystack_[0].value.as < string > ()); }
#line 6625 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1820: // o_periods: PERIODS EQUAL INT_NUMBER
#line 3683 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_num("periods", yystack_[0].value.as < string > ()); }
#line 6631 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1821: // o_solver_periods: SOLVER_PERIODS EQUAL INT_NUMBER
#line 3684 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_num("ep.periods", yystack_[0].value.as < string > ()); }
#line 6637 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1822: // o_extended_path_order: ORDER EQUAL INT_NUMBER
#line 3685 "../preprocessor/src/DynareBison.yy"
                                               { driver.option_num("ep.stochastic.order", yystack_[0].value.as < string > ()); }
#line 6643 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1823: // o_hybrid: HYBRID
#line 3686 "../preprocessor/src/DynareBison.yy"
                  { driver.option_num("ep.stochastic.hybrid_order", "2"); }
#line 6649 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1824: // o_steady_maxit: MAXIT EQUAL INT_NUMBER
#line 3687 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("steady.maxit", yystack_[0].value.as < string > ()); }
#line 6655 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1825: // o_simul_maxit: MAXIT EQUAL INT_NUMBER
#line 3688 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("simul.maxit", yystack_[0].value.as < string > ()); }
#line 6661 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1826: // o_bandpass_filter: BANDPASS_FILTER
#line 3689 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("bandpass.indicator", "true"); }
#line 6667 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1827: // o_bandpass_filter: BANDPASS_FILTER EQUAL vec_int
#line 3691 "../preprocessor/src/DynareBison.yy"
                    {
                      driver.option_num("bandpass.indicator", "true");
                      driver.option_vec_int("bandpass.passband", yystack_[0].value.as < vector<int> > ());
                    }
#line 6676 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1828: // o_dp_maxit: MAXIT EQUAL INT_NUMBER
#line 3696 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("dp.maxit", yystack_[0].value.as < string > ()); }
#line 6682 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1829: // o_osr_maxit: MAXIT EQUAL INT_NUMBER
#line 3697 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_num("osr.maxit", yystack_[0].value.as < string > ()); }
#line 6688 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1830: // o_osr_tolf: TOLF EQUAL non_negative_number
#line 3698 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_num("osr.tolf", yystack_[0].value.as < string > ()); }
#line 6694 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1831: // o_pf_tolf: TOLF EQUAL non_negative_number
#line 3699 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("dynatol.f", yystack_[0].value.as < string > ()); }
#line 6700 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1832: // o_pf_tolx: TOLX EQUAL non_negative_number
#line 3700 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("dynatol.x", yystack_[0].value.as < string > ()); }
#line 6706 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1833: // o_steady_tolf: TOLF EQUAL non_negative_number
#line 3701 "../preprocessor/src/DynareBison.yy"
                                               { driver.option_num("solve_tolf", yystack_[0].value.as < string > ()); }
#line 6712 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1834: // o_steady_tolx: TOLX EQUAL non_negative_number
#line 3702 "../preprocessor/src/DynareBison.yy"
                                               { driver.option_num("solve_tolx", yystack_[0].value.as < string > ()); }
#line 6718 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1835: // o_opt_algo: OPT_ALGO EQUAL INT_NUMBER
#line 3703 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("osr.opt_algo", yystack_[0].value.as < string > ()); }
#line 6724 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1836: // o_opt_algo: OPT_ALGO EQUAL filename
#line 3704 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_str("osr.opt_algo", yystack_[0].value.as < string > ()); }
#line 6730 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1837: // o_markowitz: MARKOWITZ EQUAL non_negative_number
#line 3706 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("markowitz", yystack_[0].value.as < string > ()); }
#line 6736 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1838: // o_pf_steady_solve_algo: STEADY_SOLVE_ALGO EQUAL INT_NUMBER
#line 3709 "../preprocessor/src/DynareBison.yy"
                                                            { driver.option_num("simul.steady_solve_algo", yystack_[0].value.as < string > ()); }
#line 6742 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1839: // o_pf_steady_maxit: STEADY_MAXIT EQUAL INT_NUMBER
#line 3710 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("simul.steady_maxit", yystack_[0].value.as < string > ()); }
#line 6748 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1840: // o_pf_steady_tolf: STEADY_TOLF EQUAL non_negative_number
#line 3711 "../preprocessor/src/DynareBison.yy"
                                                         { driver.option_num("simul.steady_tolf", yystack_[0].value.as < string > ()); }
#line 6754 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1841: // o_pf_steady_tolx: STEADY_TOLX EQUAL non_negative_number
#line 3712 "../preprocessor/src/DynareBison.yy"
                                                         { driver.option_num("simul.steady_tolx", yystack_[0].value.as < string > ()); }
#line 6760 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1842: // o_pf_steady_markowitz: STEADY_MARKOWITZ EQUAL non_negative_number
#line 3713 "../preprocessor/src/DynareBison.yy"
                                                                   { driver.option_num("simul.steady_markowitz", yystack_[0].value.as < string > ()); }
#line 6766 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1843: // o_minimal_solving_periods: MINIMAL_SOLVING_PERIODS EQUAL non_negative_number
#line 3715 "../preprocessor/src/DynareBison.yy"
                                                                              { driver.option_num("minimal_solving_periods", yystack_[0].value.as < string > ()); }
#line 6772 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1844: // o_simul_replic: SIMUL_REPLIC EQUAL INT_NUMBER
#line 3716 "../preprocessor/src/DynareBison.yy"
                                               { driver.option_num("simul_replic", yystack_[0].value.as < string > ()); }
#line 6778 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1845: // o_qz_criterium: QZ_CRITERIUM EQUAL non_negative_number
#line 3717 "../preprocessor/src/DynareBison.yy"
                                                        { driver.option_num("qz_criterium", yystack_[0].value.as < string > ()); }
#line 6784 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1846: // o_qz_zero_threshold: QZ_ZERO_THRESHOLD EQUAL non_negative_number
#line 3718 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.option_num("qz_zero_threshold", yystack_[0].value.as < string > ()); }
#line 6790 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1847: // o_file: FILE EQUAL filename
#line 3719 "../preprocessor/src/DynareBison.yy"
                             { driver.option_str("file", yystack_[0].value.as < string > ()); }
#line 6796 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1848: // o_pac_name: MODEL_NAME EQUAL symbol
#line 3720 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_str("pac.model_name", yystack_[0].value.as < string > ()); }
#line 6802 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1849: // o_pac_aux_model_name: AUXILIARY_MODEL_NAME EQUAL symbol
#line 3721 "../preprocessor/src/DynareBison.yy"
                                                         { driver.option_str("pac.aux_model_name", yystack_[0].value.as < string > ()); }
#line 6808 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1850: // o_pac_discount: DISCOUNT EQUAL symbol
#line 3722 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_str("pac.discount", yystack_[0].value.as < string > ()); }
#line 6814 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1851: // $@33: %empty
#line 3723 "../preprocessor/src/DynareBison.yy"
                      { driver.begin_model(); }
#line 6820 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1852: // o_pac_growth: GROWTH $@33 EQUAL hand_side
#line 3723 "../preprocessor/src/DynareBison.yy"
                                                                { driver.set_pac_growth(yystack_[0].value.as < expr_t > ()); }
#line 6826 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1853: // o_pac_auxname: AUXNAME EQUAL symbol
#line 3724 "../preprocessor/src/DynareBison.yy"
                                     { driver.set_pac_auxname(yystack_[0].value.as < string > ()); }
#line 6832 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1854: // o_pac_kind: KIND EQUAL pac_target_kind
#line 3725 "../preprocessor/src/DynareBison.yy"
                                        { driver.set_pac_kind(yystack_[0].value.as < PacTargetKind > ()); }
#line 6838 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1855: // o_var_name: MODEL_NAME EQUAL symbol
#line 3726 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_str("var.model_name", yystack_[0].value.as < string > ()); }
#line 6844 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1856: // o_series: SERIES EQUAL symbol
#line 3727 "../preprocessor/src/DynareBison.yy"
                               { driver.option_str("series", yystack_[0].value.as < string > ()); }
#line 6850 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1857: // o_datafile: DATAFILE EQUAL filename
#line 3728 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_str("datafile", yystack_[0].value.as < string > ()); }
#line 6856 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1858: // o_filename: FILENAME EQUAL filename
#line 3729 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_str("filename", yystack_[0].value.as < string > ()); }
#line 6862 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1859: // o_var_eq_tags: EQTAGS EQUAL vec_str
#line 3730 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_vec_str("var.eqtags", yystack_[0].value.as < vector<string> > ()); }
#line 6868 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1860: // o_var_structural: STRUCTURAL
#line 3731 "../preprocessor/src/DynareBison.yy"
                              { driver.option_num("var.structural", "true"); }
#line 6874 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1861: // o_dirname: DIRNAME EQUAL filename
#line 3732 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_str("dirname", yystack_[0].value.as < string > ()); }
#line 6880 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1862: // o_huge_number: HUGE_NUMBER EQUAL non_negative_number
#line 3733 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_num("huge_number", yystack_[0].value.as < string > ()); }
#line 6886 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1863: // o_nobs: NOBS EQUAL vec_int
#line 3735 "../preprocessor/src/DynareBison.yy"
         { driver.option_vec_int("nobs", yystack_[0].value.as < vector<int> > ()); }
#line 6892 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1864: // o_nobs: NOBS EQUAL vec_int_number
#line 3737 "../preprocessor/src/DynareBison.yy"
         { driver.option_vec_int("nobs", yystack_[0].value.as < vector<int> > ()); }
#line 6898 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1865: // o_trend_component_model_name: MODEL_NAME EQUAL symbol
#line 3739 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_str("trend_component.name", yystack_[0].value.as < string > ()); }
#line 6904 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1866: // o_trend_component_model_targets: TARGETS EQUAL vec_str
#line 3740 "../preprocessor/src/DynareBison.yy"
                                                        { driver.option_vec_str("trend_component.targets", yystack_[0].value.as < vector<string> > ()); }
#line 6910 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1867: // o_trend_component_model_eq_tags: EQTAGS EQUAL vec_str
#line 3741 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_vec_str("trend_component.eqtags", yystack_[0].value.as < vector<string> > ()); }
#line 6916 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1868: // o_conditional_variance_decomposition: CONDITIONAL_VARIANCE_DECOMPOSITION EQUAL vec_int
#line 3743 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_vec_int("conditional_variance_decomposition", yystack_[0].value.as < vector<int> > ()); }
#line 6922 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1869: // o_conditional_variance_decomposition: CONDITIONAL_VARIANCE_DECOMPOSITION EQUAL vec_int_number
#line 3745 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_vec_int("conditional_variance_decomposition", yystack_[0].value.as < vector<int> > ()); }
#line 6928 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1870: // o_est_first_obs: FIRST_OBS EQUAL vec_int
#line 3748 "../preprocessor/src/DynareBison.yy"
                  { driver.option_vec_int("first_obs", yystack_[0].value.as < vector<int> > ()); }
#line 6934 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1871: // o_est_first_obs: FIRST_OBS EQUAL vec_int_number
#line 3750 "../preprocessor/src/DynareBison.yy"
                  { driver.option_vec_int("first_obs", yystack_[0].value.as < vector<int> > ()); }
#line 6940 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1872: // o_posterior_sampling_method: POSTERIOR_SAMPLING_METHOD EQUAL QUOTED_STRING
#line 3753 "../preprocessor/src/DynareBison.yy"
                              { driver.option_str("posterior_sampler_options.posterior_sampling_method", yystack_[0].value.as < string > ()); }
#line 6946 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1873: // o_first_obs: FIRST_OBS EQUAL INT_NUMBER
#line 3754 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_num("first_obs", yystack_[0].value.as < string > ()); }
#line 6952 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1874: // o_data_first_obs: FIRST_OBS EQUAL date_expr
#line 3755 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_date("firstobs", yystack_[0].value.as < string > ()); }
#line 6958 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1875: // o_first_simulation_period: FIRST_SIMULATION_PERIOD EQUAL INT_NUMBER
#line 3756 "../preprocessor/src/DynareBison.yy"
                                                                     { driver.option_num("first_simulation_period", yystack_[0].value.as < string > ()); }
#line 6964 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1876: // o_date_first_simulation_period: FIRST_SIMULATION_PERIOD EQUAL date_expr
#line 3757 "../preprocessor/src/DynareBison.yy"
                                                                         { driver.option_date("firstsimulationperiod", yystack_[0].value.as < string > ()); }
#line 6970 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1877: // o_last_simulation_period: LAST_SIMULATION_PERIOD EQUAL INT_NUMBER
#line 3758 "../preprocessor/src/DynareBison.yy"
                                                                   { driver.option_num("last_simulation_period", yystack_[0].value.as < string > ()); }
#line 6976 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1878: // o_date_last_simulation_period: LAST_SIMULATION_PERIOD EQUAL date_expr
#line 3759 "../preprocessor/src/DynareBison.yy"
                                                                       { driver.option_date("lastsimulationperiod", yystack_[0].value.as < string > ()); }
#line 6982 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1879: // o_last_obs: LAST_OBS EQUAL INT_NUMBER
#line 3760 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("last_obs", yystack_[0].value.as < string > ()); }
#line 6988 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1880: // o_data_last_obs: LAST_OBS EQUAL date_expr
#line 3761 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_date("lastobs", yystack_[0].value.as < string > ()); }
#line 6994 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1881: // o_keep_kalman_algo_if_singularity_is_detected: KEEP_KALMAN_ALGO_IF_SINGULARITY_IS_DETECTED
#line 3762 "../preprocessor/src/DynareBison.yy"
                                                                                            { driver.option_num("kalman.keep_kalman_algo_if_singularity_is_detected", "true"); }
#line 7000 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1882: // o_data_nobs: NOBS EQUAL INT_NUMBER
#line 3763 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("nobs", yystack_[0].value.as < string > ()); }
#line 7006 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1883: // o_shift: SHIFT EQUAL signed_number
#line 3764 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("shift", yystack_[0].value.as < string > ()); }
#line 7012 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1884: // o_shape: SHAPE EQUAL prior_distribution
#line 3765 "../preprocessor/src/DynareBison.yy"
                                         { driver.prior_shape = yystack_[0].value.as < PriorDistributions > (); }
#line 7018 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1885: // o_mode: MODE EQUAL signed_number
#line 3766 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("mode", yystack_[0].value.as < string > ()); }
#line 7024 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1886: // o_mean: MEAN EQUAL signed_number
#line 3767 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("mean", yystack_[0].value.as < string > ()); }
#line 7030 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1887: // o_mean_vec: MEAN EQUAL vec_value
#line 3768 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_vec_value("mean", yystack_[0].value.as < vector<string> > ()); }
#line 7036 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1888: // o_truncate: TRUNCATE EQUAL vec_value
#line 3769 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_vec_value("truncate", yystack_[0].value.as < vector<string> > ()); }
#line 7042 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1889: // o_stdev: STDEV EQUAL non_negative_number
#line 3770 "../preprocessor/src/DynareBison.yy"
                                          { driver.option_num("stdev", yystack_[0].value.as < string > ()); }
#line 7048 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1890: // o_jscale: JSCALE EQUAL non_negative_number
#line 3771 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_num("jscale", yystack_[0].value.as < string > ()); }
#line 7054 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1891: // o_init: INIT EQUAL signed_number
#line 3772 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("init", yystack_[0].value.as < string > ()); }
#line 7060 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1892: // o_bounds: BOUNDS EQUAL vec_value_w_inf
#line 3773 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_vec_value("bounds", yystack_[0].value.as < vector<string> > ()); }
#line 7066 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1893: // o_domain: DOMAINN EQUAL vec_value
#line 3774 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_vec_value("domain", yystack_[0].value.as < vector<string> > ()); }
#line 7072 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1894: // o_interval: INTERVAL EQUAL vec_value
#line 3775 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_vec_value("interval", yystack_[0].value.as < vector<string> > ()); }
#line 7078 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1895: // o_variance: VARIANCE EQUAL expression
#line 3776 "../preprocessor/src/DynareBison.yy"
                                       { driver.set_prior_variance(yystack_[0].value.as < expr_t > ()); }
#line 7084 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1896: // o_variance_mat: VARIANCE EQUAL vec_of_vec_value
#line 3777 "../preprocessor/src/DynareBison.yy"
                                                 { driver.option_vec_of_vec_value("variance", yystack_[0].value.as < vector<vector<string>> > ()); }
#line 7090 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1897: // o_prefilter: PREFILTER EQUAL INT_NUMBER
#line 3778 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_num("prefilter", yystack_[0].value.as < string > ()); }
#line 7096 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1898: // o_presample: PRESAMPLE EQUAL INT_NUMBER
#line 3779 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_num("presample", yystack_[0].value.as < string > ()); }
#line 7102 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1899: // o_lik_init: LIK_INIT EQUAL INT_NUMBER
#line 3780 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("lik_init", yystack_[0].value.as < string > ()); }
#line 7108 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1900: // o_nograph: NOGRAPH
#line 3782 "../preprocessor/src/DynareBison.yy"
            { driver.option_num("nograph", "true"); }
#line 7114 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1901: // o_nograph: GRAPH
#line 3784 "../preprocessor/src/DynareBison.yy"
            { driver.option_num("nograph", "false"); }
#line 7120 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1902: // o_posterior_nograph: POSTERIOR_NOGRAPH
#line 3787 "../preprocessor/src/DynareBison.yy"
            { driver.option_num("no_graph.posterior", "true"); }
#line 7126 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1903: // o_posterior_nograph: POSTERIOR_GRAPH
#line 3789 "../preprocessor/src/DynareBison.yy"
            { driver.option_num("no_graph.posterior", "false"); }
#line 7132 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1904: // o_psd_nograph: NOGRAPH
#line 3791 "../preprocessor/src/DynareBison.yy"
                        { driver.option_num("no_graph.plot_shock_decomposition", "true"); }
#line 7138 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1905: // o_shock_decomposition_nograph: NOGRAPH
#line 3792 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("no_graph.shock_decomposition", "true"); }
#line 7144 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1906: // o_init_state: INIT_STATE EQUAL INT_NUMBER
#line 3793 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("shock_decomp.init_state", yystack_[0].value.as < string > ()); }
#line 7150 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1907: // o_forecast_type: FORECAST EQUAL UNCONDITIONAL
#line 3795 "../preprocessor/src/DynareBison.yy"
                  { driver.option_str("shock_decomp.forecast_type", "unconditional"); }
#line 7156 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1908: // o_forecast_type: FORECAST EQUAL CONDITIONAL
#line 3797 "../preprocessor/src/DynareBison.yy"
                  { driver.option_str("shock_decomp.forecast_type", "conditional"); }
#line 7162 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1909: // o_shock_decomposition_presample: PRESAMPLE EQUAL INT_NUMBER
#line 3798 "../preprocessor/src/DynareBison.yy"
                                                             { driver.option_num("shock_decomp.presample", yystack_[0].value.as < string > ()); }
#line 7168 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1910: // o_shock_decomposition_forecast: FORECAST EQUAL INT_NUMBER
#line 3799 "../preprocessor/src/DynareBison.yy"
                                                           { driver.option_num("shock_decomp.forecast", yystack_[0].value.as < string > ()); }
#line 7174 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1911: // o_save_realtime: SAVE_REALTIME EQUAL vec_int
#line 3800 "../preprocessor/src/DynareBison.yy"
                                              { driver.option_vec_int("shock_decomp.save_realtime", yystack_[0].value.as < vector<int> > ()); }
#line 7180 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1912: // o_fast_realtime: FAST_REALTIME EQUAL vec_int
#line 3802 "../preprocessor/src/DynareBison.yy"
                  { driver.option_vec_int("shock_decomp.fast_realtime", yystack_[0].value.as < vector<int> > ()); }
#line 7186 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1913: // o_fast_realtime: FAST_REALTIME EQUAL vec_int_number
#line 3804 "../preprocessor/src/DynareBison.yy"
                  { driver.option_vec_int("shock_decomp.fast_realtime", yystack_[0].value.as < vector<int> > ()); }
#line 7192 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1914: // o_nodisplay: NODISPLAY
#line 3806 "../preprocessor/src/DynareBison.yy"
                        { driver.option_num("nodisplay", "true"); }
#line 7198 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1915: // o_icd_nodisplay: NODISPLAY
#line 3807 "../preprocessor/src/DynareBison.yy"
                            { driver.option_num("initial_condition_decomp.nodisplay", "true"); }
#line 7204 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1916: // o_psd_nodisplay: NODISPLAY
#line 3808 "../preprocessor/src/DynareBison.yy"
                            { driver.option_num("plot_shock_decomp.nodisplay", "true"); }
#line 7210 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1917: // o_psd_init2shocks: INIT2SHOCKS
#line 3809 "../preprocessor/src/DynareBison.yy"
                                { driver.option_str("plot_shock_decomp.init2shocks", "default"); }
#line 7216 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1918: // o_psd_init2shocks: INIT2SHOCKS EQUAL symbol
#line 3810 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_str("plot_shock_decomp.init2shocks", yystack_[0].value.as < string > ()); }
#line 7222 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1919: // o_icd_max_nrows: MAX_NROWS EQUAL INT_NUMBER
#line 3812 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("initial_condition_decomp.max_nrows", yystack_[0].value.as < string > ()); }
#line 7228 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1920: // o_psd_max_nrows: MAX_NROWS EQUAL INT_NUMBER
#line 3813 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("plot_shock_decomp.max_nrows", yystack_[0].value.as < string > ()); }
#line 7234 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1921: // o_graph_format: GRAPH_FORMAT EQUAL allowed_graph_formats
#line 3815 "../preprocessor/src/DynareBison.yy"
                 { driver.process_graph_format_option(); }
#line 7240 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1922: // o_graph_format: GRAPH_FORMAT EQUAL '(' list_allowed_graph_formats ')'
#line 3817 "../preprocessor/src/DynareBison.yy"
                 { driver.process_graph_format_option(); }
#line 7246 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1923: // o_icd_graph_format: GRAPH_FORMAT EQUAL allowed_graph_formats
#line 3820 "../preprocessor/src/DynareBison.yy"
                     { driver.initial_condition_decomp_process_graph_format_option(); }
#line 7252 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1924: // o_icd_graph_format: GRAPH_FORMAT EQUAL '(' list_allowed_graph_formats ')'
#line 3822 "../preprocessor/src/DynareBison.yy"
                     { driver.initial_condition_decomp_process_graph_format_option(); }
#line 7258 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1925: // o_psd_graph_format: GRAPH_FORMAT EQUAL allowed_graph_formats
#line 3825 "../preprocessor/src/DynareBison.yy"
                     { driver.plot_shock_decomp_process_graph_format_option(); }
#line 7264 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1926: // o_psd_graph_format: GRAPH_FORMAT EQUAL '(' list_allowed_graph_formats ')'
#line 3827 "../preprocessor/src/DynareBison.yy"
                     { driver.plot_shock_decomp_process_graph_format_option(); }
#line 7270 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1927: // o_shock_decomposition_with_epilogue: WITH_EPILOGUE
#line 3829 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_num("shock_decomp.with_epilogue", "true"); }
#line 7276 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1928: // o_icd_with_epilogue: WITH_EPILOGUE
#line 3830 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("initial_condition_decomp.with_epilogue", "true"); }
#line 7282 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1929: // allowed_graph_formats: EPS
#line 3832 "../preprocessor/src/DynareBison.yy"
                        { driver.add_graph_format("eps"); }
#line 7288 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1930: // allowed_graph_formats: FIG
#line 3834 "../preprocessor/src/DynareBison.yy"
                        { driver.add_graph_format("fig"); }
#line 7294 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1931: // allowed_graph_formats: PDF
#line 3836 "../preprocessor/src/DynareBison.yy"
                        { driver.add_graph_format("pdf"); }
#line 7300 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1932: // allowed_graph_formats: NONE
#line 3838 "../preprocessor/src/DynareBison.yy"
                        { driver.add_graph_format("none"); }
#line 7306 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1935: // o_subsample_name: symbol EQUAL date_expr ':' date_expr
#line 3845 "../preprocessor/src/DynareBison.yy"
                   { driver.set_subsample_name_equal_to_date_range(yystack_[4].value.as < string > (), yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 7312 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1936: // o_bvar_conf_sig: CONF_SIG EQUAL non_negative_number
#line 3847 "../preprocessor/src/DynareBison.yy"
                                                     { driver.option_num("bvar.conf_sig", yystack_[0].value.as < string > ()); }
#line 7318 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1937: // o_forecasts_conf_sig: CONF_SIG EQUAL non_negative_number
#line 3848 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("forecasts.conf_sig", yystack_[0].value.as < string > ()); }
#line 7324 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1938: // o_conditional_forecast_conf_sig: CONF_SIG EQUAL non_negative_number
#line 3849 "../preprocessor/src/DynareBison.yy"
                                                                     { driver.option_num("conditional_forecast.conf_sig", yystack_[0].value.as < string > ()); }
#line 7330 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1939: // o_mh_conf_sig: MH_CONF_SIG EQUAL non_negative_number
#line 3850 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_num("mh_conf_sig", yystack_[0].value.as < string > ()); }
#line 7336 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1940: // o_mh_replic: MH_REPLIC EQUAL INT_NUMBER
#line 3851 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_num("mh_replic", yystack_[0].value.as < string > ()); }
#line 7342 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1941: // o_posterior_max_subsample_draws: POSTERIOR_MAX_SUBSAMPLE_DRAWS EQUAL INT_NUMBER
#line 3852 "../preprocessor/src/DynareBison.yy"
                                                                                 { driver.option_num("posterior_max_subsample_draws", yystack_[0].value.as < string > ()); }
#line 7348 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1942: // o_mh_drop: MH_DROP EQUAL non_negative_number
#line 3853 "../preprocessor/src/DynareBison.yy"
                                              { driver.option_num("mh_drop", yystack_[0].value.as < string > ()); }
#line 7354 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1943: // o_mh_jscale: MH_JSCALE EQUAL non_negative_number
#line 3854 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("mh_jscale", yystack_[0].value.as < string > ()); }
#line 7360 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1944: // o_mh_tune_jscale: MH_TUNE_JSCALE EQUAL non_negative_number
#line 3856 "../preprocessor/src/DynareBison.yy"
                 { driver.option_num("mh_tune_jscale.target", yystack_[0].value.as < string > ()); driver.option_num("mh_tune_jscale.status", "true"); }
#line 7366 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1945: // o_mh_tune_jscale: MH_TUNE_JSCALE
#line 3857 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("mh_tune_jscale.status", "true"); }
#line 7372 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1946: // o_mh_tune_guess: MH_TUNE_GUESS EQUAL non_negative_number
#line 3858 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("mh_tune_jscale.guess", yystack_[0].value.as < string > ()); }
#line 7378 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1947: // o_optim: OPTIM EQUAL '(' name_value_pair_with_boolean_list ')'
#line 3859 "../preprocessor/src/DynareBison.yy"
                                                                 { driver.option_str("optim_opt", yystack_[1].value.as < string > ()); }
#line 7384 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1948: // o_posterior_sampler_options: POSTERIOR_SAMPLER_OPTIONS EQUAL '(' name_value_pair_with_suboptions_list ')'
#line 3860 "../preprocessor/src/DynareBison.yy"
                                                                                                           { driver.option_str("posterior_sampler_options.sampling_opt", yystack_[1].value.as < string > ()); }
#line 7390 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1949: // o_proposal_distribution: PROPOSAL_DISTRIBUTION EQUAL symbol
#line 3861 "../preprocessor/src/DynareBison.yy"
                                                             { driver.option_str("posterior_sampler_options.posterior_sampling_method.proposal_distribution", yystack_[0].value.as < string > ()); }
#line 7396 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1950: // o_no_posterior_kernel_density: NO_POSTERIOR_KERNEL_DENSITY
#line 3863 "../preprocessor/src/DynareBison.yy"
                             { driver.option_num("estimation.moments_posterior_density.indicator", "false"); }
#line 7402 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1951: // o_mh_init_scale: MH_INIT_SCALE EQUAL non_negative_number
#line 3865 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("mh_init_scale", yystack_[0].value.as < string > ()); }
#line 7408 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1952: // o_mh_init_scale_factor: MH_INIT_SCALE_FACTOR EQUAL non_negative_number
#line 3866 "../preprocessor/src/DynareBison.yy"
                                                                        { driver.option_num("mh_init_scale_factor", yystack_[0].value.as < string > ()); }
#line 7414 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1953: // o_mode_file: MODE_FILE EQUAL filename
#line 3867 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_str("mode_file", yystack_[0].value.as < string > ()); }
#line 7420 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1954: // o_mode_compute: MODE_COMPUTE EQUAL INT_NUMBER
#line 3868 "../preprocessor/src/DynareBison.yy"
                                               { driver.option_num("mode_compute", yystack_[0].value.as < string > ()); }
#line 7426 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1955: // o_mode_compute: MODE_COMPUTE EQUAL symbol
#line 3869 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_str("mode_compute", yystack_[0].value.as < string > ()); }
#line 7432 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1956: // o_mode_check: MODE_CHECK
#line 3870 "../preprocessor/src/DynareBison.yy"
                          { driver.option_num("mode_check.status", "true"); }
#line 7438 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1957: // o_mode_check_neighbourhood_size: MODE_CHECK_NEIGHBOURHOOD_SIZE EQUAL signed_number_w_inf
#line 3871 "../preprocessor/src/DynareBison.yy"
                                                                                          { driver.option_num("mode_check.neighbourhood_size", yystack_[0].value.as < string > ()); }
#line 7444 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1958: // o_mode_check_number_of_points: MODE_CHECK_NUMBER_OF_POINTS EQUAL INT_NUMBER
#line 3872 "../preprocessor/src/DynareBison.yy"
                                                                             { driver.option_num("mode_check.number_of_points", yystack_[0].value.as < string > ()); }
#line 7450 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1959: // o_mode_check_symmetric_plots: MODE_CHECK_SYMMETRIC_PLOTS EQUAL INT_NUMBER
#line 3873 "../preprocessor/src/DynareBison.yy"
                                                                           { driver.option_num("mode_check.symmetric_plots", yystack_[0].value.as < string > ()); }
#line 7456 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1960: // o_prior_trunc: PRIOR_TRUNC EQUAL non_negative_number
#line 3874 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_num("prior_trunc", yystack_[0].value.as < string > ()); }
#line 7462 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1961: // o_mh_posterior_mode_estimation: MH_POSTERIOR_MODE_ESTIMATION
#line 3875 "../preprocessor/src/DynareBison.yy"
                                                              { driver.option_num("mh_posterior_mode_estimation", "true"); }
#line 7468 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1962: // o_mh_nblocks: MH_NBLOCKS EQUAL INT_NUMBER
#line 3876 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("mh_nblck", yystack_[0].value.as < string > ()); }
#line 7474 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1963: // o_load_mh_file: LOAD_MH_FILE
#line 3877 "../preprocessor/src/DynareBison.yy"
                              { driver.option_num("load_mh_file", "true"); }
#line 7480 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1964: // o_load_results_after_load_mh: LOAD_RESULTS_AFTER_LOAD_MH
#line 3878 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("load_results_after_load_mh", "true"); }
#line 7486 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1965: // o_loglinear: LOGLINEAR
#line 3879 "../preprocessor/src/DynareBison.yy"
                        { driver.option_num("loglinear", "true"); }
#line 7492 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1966: // o_linear_approximation: LINEAR_APPROXIMATION
#line 3880 "../preprocessor/src/DynareBison.yy"
                                              { driver.option_num("linear_approximation", "true"); }
#line 7498 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1967: // o_logdata: LOGDATA
#line 3881 "../preprocessor/src/DynareBison.yy"
                    { driver.option_num("logdata", "true"); }
#line 7504 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1968: // o_conditional_likelihood: CONDITIONAL_LIKELIHOOD
#line 3882 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("conditional_likelihood.status", "true"); }
#line 7510 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1969: // o_nodiagnostic: NODIAGNOSTIC
#line 3883 "../preprocessor/src/DynareBison.yy"
                              { driver.option_num("nodiagnostic", "true"); }
#line 7516 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1970: // o_bayesian_irf: BAYESIAN_IRF
#line 3884 "../preprocessor/src/DynareBison.yy"
                              { driver.option_num("bayesian_irf", "true"); }
#line 7522 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1971: // o_dsge_var: DSGE_VAR EQUAL non_negative_number
#line 3886 "../preprocessor/src/DynareBison.yy"
             { driver.option_num("dsge_var", yystack_[0].value.as < string > ()); }
#line 7528 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1972: // o_dsge_var: DSGE_VAR EQUAL INF_CONSTANT
#line 3888 "../preprocessor/src/DynareBison.yy"
             { driver.option_num("dsge_var", "Inf"); }
#line 7534 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1973: // o_dsge_var: DSGE_VAR
#line 3890 "../preprocessor/src/DynareBison.yy"
             { driver.option_str("dsge_var", "NaN"); }
#line 7540 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1974: // o_dsge_varlag: DSGE_VARLAG EQUAL INT_NUMBER
#line 3892 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("dsge_varlag", yystack_[0].value.as < string > ()); }
#line 7546 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1975: // o_tex: TEX
#line 3893 "../preprocessor/src/DynareBison.yy"
            { driver.option_num("TeX", "true"); }
#line 7552 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1976: // o_forecast: FORECAST EQUAL INT_NUMBER
#line 3894 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("forecast", yystack_[0].value.as < string > ()); }
#line 7558 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1977: // o_smoother: SMOOTHER
#line 3895 "../preprocessor/src/DynareBison.yy"
                      { driver.option_num("smoother", "true"); }
#line 7564 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1978: // o_moments_varendo: MOMENTS_VARENDO
#line 3896 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("moments_varendo", "true"); }
#line 7570 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1979: // o_contemporaneous_correlation: CONTEMPORANEOUS_CORRELATION
#line 3897 "../preprocessor/src/DynareBison.yy"
                                                            { driver.option_num("contemporaneous_correlation", "true"); }
#line 7576 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1980: // o_filtered_vars: FILTERED_VARS
#line 3898 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("filtered_vars", "true"); }
#line 7582 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1981: // o_relative_irf: RELATIVE_IRF
#line 3899 "../preprocessor/src/DynareBison.yy"
                              { driver.option_num("relative_irf", "true"); }
#line 7588 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1982: // o_fast_kalman_filter: FAST_KALMAN_FILTER
#line 3900 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("fast_kalman_filter", "true"); }
#line 7594 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1983: // o_kalman_algo: KALMAN_ALGO EQUAL INT_NUMBER
#line 3901 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("kalman_algo", yystack_[0].value.as < string > ()); }
#line 7600 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1984: // o_kalman_tol: KALMAN_TOL EQUAL non_negative_number
#line 3902 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_num("kalman_tol", yystack_[0].value.as < string > ()); }
#line 7606 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1985: // o_diffuse_kalman_tol: DIFFUSE_KALMAN_TOL EQUAL non_negative_number
#line 3903 "../preprocessor/src/DynareBison.yy"
                                                                    { driver.option_num("diffuse_kalman_tol", yystack_[0].value.as < string > ()); }
#line 7612 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1986: // o_schur_vec_tol: SCHUR_VEC_TOL EQUAL non_negative_number
#line 3904 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("schur_vec_tol", yystack_[0].value.as < string > ()); }
#line 7618 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1987: // o_marginal_density: MARGINAL_DENSITY EQUAL LAPLACE
#line 3906 "../preprocessor/src/DynareBison.yy"
                     { driver.option_str("mc_marginal_density", "laplace"); }
#line 7624 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1988: // o_marginal_density: MARGINAL_DENSITY EQUAL MODIFIEDHARMONICMEAN
#line 3908 "../preprocessor/src/DynareBison.yy"
                     { driver.option_str("mc_marginal_density", "modifiedharmonicmean"); }
#line 7630 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1989: // o_print: PRINT
#line 3910 "../preprocessor/src/DynareBison.yy"
                { driver.option_num("noprint", "false"); }
#line 7636 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1990: // o_noprint: NOPRINT
#line 3911 "../preprocessor/src/DynareBison.yy"
                    { driver.option_num("noprint", "true"); }
#line 7642 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1991: // o_xls_sheet: XLS_SHEET EQUAL symbol
#line 3912 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_str("xls_sheet", yystack_[0].value.as < string > ()); }
#line 7648 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1992: // o_xls_sheet: XLS_SHEET EQUAL QUOTED_STRING
#line 3913 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_str("xls_sheet", yystack_[0].value.as < string > ()); }
#line 7654 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1993: // o_xls_range: XLS_RANGE EQUAL range
#line 3915 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_str("xls_range", yystack_[0].value.as < string > ()); }
#line 7660 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1994: // o_filter_step_ahead: FILTER_STEP_AHEAD EQUAL vec_int
#line 3916 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_vec_int("filter_step_ahead", yystack_[0].value.as < vector<int> > ()); }
#line 7666 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1995: // o_taper_steps: TAPER_STEPS EQUAL vec_int
#line 3917 "../preprocessor/src/DynareBison.yy"
                                          { driver.option_vec_int("convergence.geweke.taper_steps", yystack_[0].value.as < vector<int> > ()); }
#line 7672 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1996: // o_geweke_interval: GEWEKE_INTERVAL EQUAL vec_value
#line 3918 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_vec_value("convergence.geweke.geweke_interval", yystack_[0].value.as < vector<string> > ()); }
#line 7678 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1997: // o_raftery_lewis_diagnostics: RAFTERY_LEWIS_DIAGNOSTICS
#line 3919 "../preprocessor/src/DynareBison.yy"
                                                        { driver.option_num("convergence.rafterylewis.indicator", "true"); }
#line 7684 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1998: // o_raftery_lewis_qrs: RAFTERY_LEWIS_QRS EQUAL vec_value
#line 3920 "../preprocessor/src/DynareBison.yy"
                                                        { driver.option_vec_value("convergence.rafterylewis.qrs", yystack_[0].value.as < vector<string> > ()); }
#line 7690 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1999: // o_brooks_gelman_plotrows: BROOKS_GELMAN_PLOTROWS EQUAL INT_NUMBER
#line 3921 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.option_num("convergence.brooksgelman.plotrows", yystack_[0].value.as < string > ()); }
#line 7696 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2000: // o_constant: CONSTANT
#line 3922 "../preprocessor/src/DynareBison.yy"
                      { driver.option_num("noconstant", "false"); }
#line 7702 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2001: // o_noconstant: NOCONSTANT
#line 3923 "../preprocessor/src/DynareBison.yy"
                          { driver.option_num("noconstant", "true"); }
#line 7708 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2002: // o_mh_recover: MH_RECOVER
#line 3924 "../preprocessor/src/DynareBison.yy"
                          { driver.option_num("mh_recover", "true"); }
#line 7714 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2003: // o_mh_initialize_from_previous_mcmc: MH_INITIALIZE_FROM_PREVIOUS_MCMC
#line 3925 "../preprocessor/src/DynareBison.yy"
                                                                      { driver.option_num("mh_initialize_from_previous_mcmc.status", "true"); }
#line 7720 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2004: // o_mh_initialize_from_previous_mcmc_directory: MH_INITIALIZE_FROM_PREVIOUS_MCMC_DIRECTORY EQUAL filename
#line 3926 "../preprocessor/src/DynareBison.yy"
                                                                                                         { driver.option_str("mh_initialize_from_previous_mcmc.directory", yystack_[0].value.as < string > ()); }
#line 7726 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2005: // o_mh_initialize_from_previous_mcmc_record: MH_INITIALIZE_FROM_PREVIOUS_MCMC_RECORD EQUAL filename
#line 3927 "../preprocessor/src/DynareBison.yy"
                                                                                                   { driver.option_str("mh_initialize_from_previous_mcmc.record", yystack_[0].value.as < string > ()); }
#line 7732 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2006: // o_mh_initialize_from_previous_mcmc_prior: MH_INITIALIZE_FROM_PREVIOUS_MCMC_PRIOR EQUAL filename
#line 3928 "../preprocessor/src/DynareBison.yy"
                                                                                                 { driver.option_str("mh_initialize_from_previous_mcmc.prior", yystack_[0].value.as < string > ()); }
#line 7738 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2007: // o_diffuse_filter: DIFFUSE_FILTER
#line 3929 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_num("diffuse_filter", "true"); }
#line 7744 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2008: // o_plot_priors: PLOT_PRIORS EQUAL INT_NUMBER
#line 3930 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_num("plot_priors", yystack_[0].value.as < string > ()); }
#line 7750 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2009: // o_aim_solver: AIM_SOLVER
#line 3931 "../preprocessor/src/DynareBison.yy"
                         { driver.option_num("aim_solver", "true"); }
#line 7756 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2010: // o_partial_information: PARTIAL_INFORMATION
#line 3932 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_num("partial_information", "true"); }
#line 7762 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2011: // o_sub_draws: SUB_DRAWS EQUAL INT_NUMBER
#line 3933 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("sub_draws", yystack_[0].value.as < string > ()); }
#line 7768 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2012: // o_planner_discount: PLANNER_DISCOUNT EQUAL expression
#line 3934 "../preprocessor/src/DynareBison.yy"
                                                       { driver.set_planner_discount(yystack_[0].value.as < expr_t > ()); }
#line 7774 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2013: // o_planner_discount_latex_name: PLANNER_DISCOUNT_LATEX_NAME EQUAL TEX_NAME
#line 3935 "../preprocessor/src/DynareBison.yy"
                                                                           { driver.set_planner_discount_latex_name(yystack_[0].value.as < string > ()); }
#line 7780 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2014: // o_lyapunov: LYAPUNOV EQUAL FIXED_POINT
#line 3936 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("lyapunov_fp", "true"); }
#line 7786 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2015: // o_lyapunov: LYAPUNOV EQUAL DOUBLING
#line 3937 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("lyapunov_db", "true"); }
#line 7792 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2016: // o_lyapunov: LYAPUNOV EQUAL SQUARE_ROOT_SOLVER
#line 3938 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("lyapunov_srs", "true"); }
#line 7798 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2017: // o_lyapunov: LYAPUNOV EQUAL DEFAULT
#line 3939 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("lyapunov_fp", "false"); driver.option_num("lyapunov_db", "false"); driver.option_num("lyapunov_srs", "false"); }
#line 7804 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2018: // o_lyapunov_complex_threshold: LYAPUNOV_COMPLEX_THRESHOLD EQUAL non_negative_number
#line 3940 "../preprocessor/src/DynareBison.yy"
                                                                                    { driver.option_num("lyapunov_complex_threshold", yystack_[0].value.as < string > ()); }
#line 7810 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2019: // o_lyapunov_fixed_point_tol: LYAPUNOV_FIXED_POINT_TOL EQUAL non_negative_number
#line 3941 "../preprocessor/src/DynareBison.yy"
                                                                                { driver.option_num("lyapunov_fixed_point_tol", yystack_[0].value.as < string > ()); }
#line 7816 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2020: // o_lyapunov_doubling_tol: LYAPUNOV_DOUBLING_TOL EQUAL non_negative_number
#line 3942 "../preprocessor/src/DynareBison.yy"
                                                                          { driver.option_num("lyapunov_doubling_tol", yystack_[0].value.as < string > ()); }
#line 7822 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2021: // o_dr: DR EQUAL CYCLE_REDUCTION
#line 3943 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("dr_cycle_reduction", "true"); }
#line 7828 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2022: // o_dr: DR EQUAL LOGARITHMIC_REDUCTION
#line 3944 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("dr_logarithmic_reduction", "true"); }
#line 7834 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2023: // o_dr: DR EQUAL DEFAULT
#line 3945 "../preprocessor/src/DynareBison.yy"
                          { driver.option_num("dr_cycle_reduction", "false"); driver.option_num("dr_logarithmic_reduction", "false"); }
#line 7840 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2024: // o_dr_cycle_reduction_tol: DR_CYCLE_REDUCTION_TOL EQUAL non_negative_number
#line 3946 "../preprocessor/src/DynareBison.yy"
                                                                            { driver.option_num("dr_cycle_reduction_tol", yystack_[0].value.as < string > ()); }
#line 7846 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2025: // o_dr_logarithmic_reduction_tol: DR_LOGARITHMIC_REDUCTION_TOL EQUAL non_negative_number
#line 3947 "../preprocessor/src/DynareBison.yy"
                                                                                        { driver.option_num("dr_logarithmic_reduction_tol", yystack_[0].value.as < string > ()); }
#line 7852 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2026: // o_dr_logarithmic_reduction_maxiter: DR_LOGARITHMIC_REDUCTION_MAXITER EQUAL INT_NUMBER
#line 3948 "../preprocessor/src/DynareBison.yy"
                                                                                       { driver.option_num("dr_logarithmic_reduction_maxiter", yystack_[0].value.as < string > ()); }
#line 7858 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2027: // o_psd_detail_plot: DETAIL_PLOT
#line 3949 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("plot_shock_decomp.detail_plot", "true"); }
#line 7864 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2028: // o_icd_detail_plot: DETAIL_PLOT
#line 3950 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("initial_condition_decomp.detail_plot", "true"); }
#line 7870 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2029: // o_psd_interactive: INTERACTIVE
#line 3951 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("plot_shock_decomp.interactive", "true"); }
#line 7876 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2030: // o_psd_screen_shocks: SCREEN_SHOCKS
#line 3952 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("plot_shock_decomp.screen_shocks", "true"); }
#line 7882 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2031: // o_psd_steadystate: STEADYSTATE
#line 3953 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("plot_shock_decomp.steadystate", "true"); }
#line 7888 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2032: // o_icd_steadystate: STEADYSTATE
#line 3954 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("initial_condition_decomp.steadystate", "true"); }
#line 7894 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2033: // o_icd_fig_name: FIG_NAME EQUAL filename
#line 3955 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_str("initial_condition_decomp.fig_name", yystack_[0].value.as < string > ()); }
#line 7900 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2034: // o_psd_fig_name: FIG_NAME EQUAL filename
#line 3956 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_str("plot_shock_decomp.fig_name", yystack_[0].value.as < string > ()); }
#line 7906 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2035: // o_psd_type: TYPE EQUAL QOQ
#line 3958 "../preprocessor/src/DynareBison.yy"
             { driver.option_str("plot_shock_decomp.type", "qoq"); }
#line 7912 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2036: // o_psd_type: TYPE EQUAL YOY
#line 3960 "../preprocessor/src/DynareBison.yy"
             { driver.option_str("plot_shock_decomp.type", "yoy"); }
#line 7918 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2037: // o_psd_type: TYPE EQUAL AOA
#line 3962 "../preprocessor/src/DynareBison.yy"
             { driver.option_str("plot_shock_decomp.type", "aoa"); }
#line 7924 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2038: // o_icd_type: TYPE EQUAL QOQ
#line 3965 "../preprocessor/src/DynareBison.yy"
             { driver.option_str("initial_condition_decomp.type", "qoq"); }
#line 7930 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2039: // o_icd_type: TYPE EQUAL YOY
#line 3967 "../preprocessor/src/DynareBison.yy"
             { driver.option_str("initial_condition_decomp.type", "yoy"); }
#line 7936 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2040: // o_icd_type: TYPE EQUAL AOA
#line 3969 "../preprocessor/src/DynareBison.yy"
             { driver.option_str("initial_condition_decomp.type", "aoa"); }
#line 7942 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2041: // o_icd_plot_init_date: PLOT_INIT_DATE EQUAL date_expr
#line 3971 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_date("initial_condition_decomp.plot_init_date", yystack_[0].value.as < string > ()); }
#line 7948 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2042: // o_icd_plot_end_date: PLOT_END_DATE EQUAL date_expr
#line 3972 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_date("initial_condition_decomp.plot_end_date", yystack_[0].value.as < string > ()); }
#line 7954 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2043: // o_psd_plot_init_date: PLOT_INIT_DATE EQUAL date_expr
#line 3973 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_date("plot_shock_decomp.plot_init_date", yystack_[0].value.as < string > ()); }
#line 7960 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2044: // o_psd_plot_end_date: PLOT_END_DATE EQUAL date_expr
#line 3974 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_date("plot_shock_decomp.plot_end_date", yystack_[0].value.as < string > ()); }
#line 7966 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2045: // o_icd_write_xls: WRITE_XLS
#line 3975 "../preprocessor/src/DynareBison.yy"
                            { driver.option_num("initial_condition_decomp.write_xls", "true"); }
#line 7972 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2046: // o_psd_write_xls: WRITE_XLS
#line 3976 "../preprocessor/src/DynareBison.yy"
                            { driver.option_num("plot_shock_decomp.write_xls", "true"); }
#line 7978 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2047: // o_psd_realtime: REALTIME EQUAL INT_NUMBER
#line 3977 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("plot_shock_decomp.realtime", yystack_[0].value.as < string > ()); }
#line 7984 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2048: // o_psd_vintage: VINTAGE EQUAL INT_NUMBER
#line 3978 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_num("plot_shock_decomp.vintage", yystack_[0].value.as < string > ()); }
#line 7990 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2049: // o_psd_diff: DIFF
#line 3979 "../preprocessor/src/DynareBison.yy"
                  { driver.option_num("plot_shock_decomp.diff", "true"); }
#line 7996 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2050: // o_icd_diff: DIFF
#line 3980 "../preprocessor/src/DynareBison.yy"
                  { driver.option_num("initial_condition_decomp.diff", "true"); }
#line 8002 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2051: // o_psd_flip: FLIP
#line 3981 "../preprocessor/src/DynareBison.yy"
                  { driver.option_num("plot_shock_decomp.flip", "true"); }
#line 8008 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2052: // o_icd_flip: FLIP
#line 3982 "../preprocessor/src/DynareBison.yy"
                  { driver.option_num("initial_condition_decomp.flip", "true"); }
#line 8014 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2053: // o_bvar_prior_tau: BVAR_PRIOR_TAU EQUAL signed_number
#line 3983 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_num("bvar_prior_tau", yystack_[0].value.as < string > ()); }
#line 8020 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2054: // o_bvar_prior_decay: BVAR_PRIOR_DECAY EQUAL non_negative_number
#line 3984 "../preprocessor/src/DynareBison.yy"
                                                                { driver.option_num("bvar_prior_decay", yystack_[0].value.as < string > ()); }
#line 8026 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2055: // o_bvar_prior_lambda: BVAR_PRIOR_LAMBDA EQUAL signed_number
#line 3985 "../preprocessor/src/DynareBison.yy"
                                                            { driver.option_num("bvar_prior_lambda", yystack_[0].value.as < string > ()); }
#line 8032 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2056: // o_bvar_prior_mu: BVAR_PRIOR_MU EQUAL non_negative_number
#line 3986 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("bvar_prior_mu", yystack_[0].value.as < string > ()); }
#line 8038 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2057: // o_bvar_prior_omega: BVAR_PRIOR_OMEGA EQUAL INT_NUMBER
#line 3987 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_num("bvar_prior_omega", yystack_[0].value.as < string > ()); }
#line 8044 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2058: // o_bvar_prior_flat: BVAR_PRIOR_FLAT
#line 3988 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("bvar_prior_flat", "true"); }
#line 8050 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2059: // o_bvar_prior_train: BVAR_PRIOR_TRAIN EQUAL INT_NUMBER
#line 3989 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_num("bvar_prior_train", yystack_[0].value.as < string > ()); }
#line 8056 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2060: // o_bvar_replic: BVAR_REPLIC EQUAL INT_NUMBER
#line 3990 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("bvar_replic", yystack_[0].value.as < string > ()); }
#line 8062 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2061: // o_stderr_multiples: STDERR_MULTIPLES
#line 3991 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_num("irf_opt.stderr_multiples", "true"); }
#line 8068 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2062: // o_diagonal_only: DIAGONAL_ONLY
#line 3992 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("irf_opt.diagonal_only", "true"); }
#line 8074 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2063: // o_number_of_particles: NUMBER_OF_PARTICLES EQUAL INT_NUMBER
#line 3993 "../preprocessor/src/DynareBison.yy"
                                                             { driver.option_num("particle.number_of_particles", yystack_[0].value.as < string > ()); }
#line 8080 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2064: // o_particle_filter_options: PARTICLE_FILTER_OPTIONS EQUAL '(' name_value_pair_with_boolean_list ')'
#line 3994 "../preprocessor/src/DynareBison.yy"
                                                                                                    { driver.option_str("particle.particle_filter_options", yystack_[1].value.as < string > ()); }
#line 8086 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2066: // o_resampling: RESAMPLING EQUAL NONE
#line 3996 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_num("particle.resampling.status.systematic", "false"); driver.option_num("particle.resampling.status.none", "true"); }
#line 8092 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2067: // o_resampling: RESAMPLING EQUAL GENERIC
#line 3997 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_num("particle.resampling.status.systematic", "false"); driver.option_num("particle.resampling.status.generic", "true"); }
#line 8098 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2068: // o_resampling_threshold: RESAMPLING_THRESHOLD EQUAL non_negative_number
#line 3998 "../preprocessor/src/DynareBison.yy"
                                                                        { driver.option_num("particle.resampling.threshold", yystack_[0].value.as < string > ()); }
#line 8104 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2069: // o_resampling_method: RESAMPLING_METHOD EQUAL KITAGAWA
#line 3999 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_num("particle.resampling.method.kitagawa", "true"); driver.option_num("particle.resampling.method.smooth", "false"); driver.option_num("particle.resampling.smethod.stratified", "false"); }
#line 8110 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2070: // o_resampling_method: RESAMPLING_METHOD EQUAL SMOOTH
#line 4000 "../preprocessor/src/DynareBison.yy"
                                               { driver.option_num("particle.resampling.method.kitagawa", "false"); driver.option_num("particle.resampling.method.smooth", "true"); driver.option_num("particle.resampling.smethod.stratified", "false"); }
#line 8116 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2071: // o_resampling_method: RESAMPLING_METHOD EQUAL STRATIFIED
#line 4001 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_num("particle.resampling.method.kitagawa", "false"); driver.option_num("particle.resampling.method.smooth", "false"); driver.option_num("particle.resampling.method.stratified", "true"); }
#line 8122 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2072: // o_cpf_weights: CPF_WEIGHTS EQUAL AMISANOTRISTANI
#line 4002 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("particle.cpf_weights_method.amisanotristani", "true"); driver.option_num("particle.cpf_weights_method.murrayjonesparslow", "false"); }
#line 8128 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2073: // o_cpf_weights: CPF_WEIGHTS EQUAL MURRAYJONESPARSLOW
#line 4003 "../preprocessor/src/DynareBison.yy"
                                                     { driver.option_num("particle.cpf_weights_method.amisanotristani", "false"); driver.option_num("particle.cpf_weights_method.murrayjonesparslow", "true"); }
#line 8134 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2074: // o_filter_algorithm: FILTER_ALGORITHM EQUAL symbol
#line 4004 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_str("particle.filter_algorithm", yystack_[0].value.as < string > ()); }
#line 8140 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2075: // o_nonlinear_filter_initialization: NONLINEAR_FILTER_INITIALIZATION EQUAL INT_NUMBER
#line 4005 "../preprocessor/src/DynareBison.yy"
                                                                                     { driver.option_num("particle.initialization", yystack_[0].value.as < string > ()); }
#line 8146 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2076: // o_proposal_approximation: PROPOSAL_APPROXIMATION EQUAL CUBATURE
#line 4006 "../preprocessor/src/DynareBison.yy"
                                                                 { driver.option_num("particle.proposal_approximation.cubature", "true"); driver.option_num("particle.proposal_approximation.unscented", "false"); driver.option_num("particle.proposal_approximation.montecarlo", "false"); }
#line 8152 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2077: // o_proposal_approximation: PROPOSAL_APPROXIMATION EQUAL UNSCENTED
#line 4007 "../preprocessor/src/DynareBison.yy"
                                                         { driver.option_num("particle.proposal_approximation.cubature", "false"); driver.option_num("particle.proposal_approximation.unscented", "true"); driver.option_num("particle.proposal_approximation.montecarlo", "false"); }
#line 8158 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2078: // o_proposal_approximation: PROPOSAL_APPROXIMATION EQUAL MONTECARLO
#line 4008 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("particle.proposal_approximation.cubature", "false"); driver.option_num("particle.proposal_approximation.unscented", "false"); driver.option_num("particle.proposal_approximation.montecarlo", "true"); }
#line 8164 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2079: // o_distribution_approximation: DISTRIBUTION_APPROXIMATION EQUAL CUBATURE
#line 4009 "../preprocessor/src/DynareBison.yy"
                                                                         { driver.option_num("particle.distribution_approximation.cubature", "true"); driver.option_num("particle.distribution_approximation.unscented", "false"); driver.option_num("particle.distribution_approximation.montecarlo", "false"); }
#line 8170 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2080: // o_distribution_approximation: DISTRIBUTION_APPROXIMATION EQUAL UNSCENTED
#line 4010 "../preprocessor/src/DynareBison.yy"
                                                             { driver.option_num("particle.distribution_approximation.cubature", "false"); driver.option_num("particle.distribution_approximation.unscented", "true"); driver.option_num("particle.distribution_approximation.montecarlo", "false"); }
#line 8176 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2081: // o_distribution_approximation: DISTRIBUTION_APPROXIMATION EQUAL MONTECARLO
#line 4011 "../preprocessor/src/DynareBison.yy"
                                                              { driver.option_num("particle.distribution_approximation.cubature", "false"); driver.option_num("particle.distribution_approximation.unscented", "false"); driver.option_num("particle.distribution_approximation.montecarlo", "true"); }
#line 8182 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2082: // o_gsa_identification: IDENTIFICATION EQUAL INT_NUMBER
#line 4012 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_num("identification", yystack_[0].value.as < string > ()); }
#line 8188 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2083: // o_gsa_morris: MORRIS EQUAL INT_NUMBER
#line 4013 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("morris", yystack_[0].value.as < string > ()); }
#line 8194 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2084: // o_gsa_stab: STAB EQUAL INT_NUMBER
#line 4014 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("stab", yystack_[0].value.as < string > ()); }
#line 8200 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2085: // o_gsa_redform: REDFORM EQUAL INT_NUMBER
#line 4015 "../preprocessor/src/DynareBison.yy"
                                          { driver.option_num("redform", yystack_[0].value.as < string > ()); }
#line 8206 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2086: // o_gsa_pprior: PPRIOR EQUAL INT_NUMBER
#line 4016 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("pprior", yystack_[0].value.as < string > ()); }
#line 8212 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2087: // o_gsa_prior_range: PRIOR_RANGE EQUAL INT_NUMBER
#line 4017 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("prior_range", yystack_[0].value.as < string > ()); }
#line 8218 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2088: // o_gsa_ppost: PPOST EQUAL INT_NUMBER
#line 4018 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_num("ppost", yystack_[0].value.as < string > ()); }
#line 8224 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2089: // o_gsa_ilptau: ILPTAU EQUAL INT_NUMBER
#line 4019 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("ilptau", yystack_[0].value.as < string > ()); }
#line 8230 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2090: // o_gsa_morris_nliv: MORRIS_NLIV EQUAL INT_NUMBER
#line 4020 "../preprocessor/src/DynareBison.yy"
                                                 { driver.option_num("morris_nliv", yystack_[0].value.as < string > ()); }
#line 8236 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2091: // o_gsa_morris_ntra: MORRIS_NTRA EQUAL INT_NUMBER
#line 4021 "../preprocessor/src/DynareBison.yy"
                                                 { driver.option_num("morris_ntra", yystack_[0].value.as < string > ()); }
#line 8242 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2092: // o_gsa_nsam: NSAM EQUAL INT_NUMBER
#line 4022 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("Nsam", yystack_[0].value.as < string > ()); }
#line 8248 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2093: // o_gsa_load_redform: LOAD_REDFORM EQUAL INT_NUMBER
#line 4023 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_num("load_redform", yystack_[0].value.as < string > ()); }
#line 8254 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2094: // o_gsa_load_rmse: LOAD_RMSE EQUAL INT_NUMBER
#line 4024 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("load_rmse", yystack_[0].value.as < string > ()); }
#line 8260 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2095: // o_gsa_load_stab: LOAD_STAB EQUAL INT_NUMBER
#line 4025 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("load_stab", yystack_[0].value.as < string > ()); }
#line 8266 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2096: // o_gsa_alpha2_stab: ALPHA2_STAB EQUAL non_negative_number
#line 4026 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("alpha2_stab", yystack_[0].value.as < string > ()); }
#line 8272 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2097: // o_gsa_logtrans_redform: LOGTRANS_REDFORM EQUAL INT_NUMBER
#line 4027 "../preprocessor/src/DynareBison.yy"
                                                           { driver.option_num("logtrans_redform", yystack_[0].value.as < string > ()); }
#line 8278 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2098: // o_gsa_threshold_redform: THRESHOLD_REDFORM EQUAL vec_value_w_inf
#line 4028 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.option_vec_value("threshold_redform", yystack_[0].value.as < vector<string> > ()); }
#line 8284 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2099: // o_gsa_ksstat_redform: KSSTAT_REDFORM EQUAL non_negative_number
#line 4029 "../preprocessor/src/DynareBison.yy"
                                                                { driver.option_num("ksstat_redform", yystack_[0].value.as < string > ()); }
#line 8290 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2100: // o_gsa_alpha2_redform: ALPHA2_REDFORM EQUAL non_negative_number
#line 4030 "../preprocessor/src/DynareBison.yy"
                                                                { driver.option_num("alpha2_redform", yystack_[0].value.as < string > ()); }
#line 8296 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2101: // o_gsa_namendo: NAMENDO EQUAL '(' symbol_list_or_wildcard ')'
#line 4031 "../preprocessor/src/DynareBison.yy"
                                                              { driver.option_symbol_list("namendo", yystack_[1].value.as < vector<string> > ()); }
#line 8302 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2102: // o_gsa_namlagendo: NAMLAGENDO EQUAL '(' symbol_list_or_wildcard ')'
#line 4032 "../preprocessor/src/DynareBison.yy"
                                                                    { driver.option_symbol_list("namlagendo", yystack_[1].value.as < vector<string> > ()); }
#line 8308 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2103: // o_gsa_namexo: NAMEXO EQUAL '(' symbol_list_or_wildcard ')'
#line 4033 "../preprocessor/src/DynareBison.yy"
                                                            { driver.option_symbol_list("namexo", yystack_[1].value.as < vector<string> > ()); }
#line 8314 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2104: // o_gsa_rmse: RMSE EQUAL INT_NUMBER
#line 4034 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("rmse", yystack_[0].value.as < string > ()); }
#line 8320 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2105: // o_gsa_lik_only: LIK_ONLY EQUAL INT_NUMBER
#line 4035 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("lik_only", yystack_[0].value.as < string > ()); }
#line 8326 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2106: // o_gsa_var_rmse: VAR_RMSE EQUAL '(' symbol_list_or_wildcard ')'
#line 4036 "../preprocessor/src/DynareBison.yy"
                                                                { driver.option_symbol_list("var_rmse", yystack_[1].value.as < vector<string> > ()); }
#line 8332 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2107: // o_gsa_pfilt_rmse: PFILT_RMSE EQUAL non_negative_number
#line 4037 "../preprocessor/src/DynareBison.yy"
                                                        { driver.option_num("pfilt_rmse", yystack_[0].value.as < string > ()); }
#line 8338 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2108: // o_gsa_istart_rmse: ISTART_RMSE EQUAL INT_NUMBER
#line 4038 "../preprocessor/src/DynareBison.yy"
                                                 { driver.option_num("istart_rmse", yystack_[0].value.as < string > ()); }
#line 8344 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2109: // o_gsa_alpha_rmse: ALPHA_RMSE EQUAL non_negative_number
#line 4039 "../preprocessor/src/DynareBison.yy"
                                                        { driver.option_num("alpha_rmse", yystack_[0].value.as < string > ()); }
#line 8350 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2110: // o_gsa_alpha2_rmse: ALPHA2_RMSE EQUAL non_negative_number
#line 4040 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("alpha2_rmse", yystack_[0].value.as < string > ()); }
#line 8356 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2111: // o_gsa_sample_file: GSA_SAMPLE_FILE EQUAL INT_NUMBER
#line 4042 "../preprocessor/src/DynareBison.yy"
                    { driver.option_num("gsa_sample_file", yystack_[0].value.as < string > ()); }
#line 8362 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2112: // o_gsa_sample_file: GSA_SAMPLE_FILE EQUAL filename
#line 4044 "../preprocessor/src/DynareBison.yy"
                    { driver.option_str("gsa_sample_file", yystack_[0].value.as < string > ()); }
#line 8368 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2113: // o_gsa_neighborhood_width: NEIGHBORHOOD_WIDTH EQUAL non_negative_number
#line 4046 "../preprocessor/src/DynareBison.yy"
                                                                        { driver.option_num("neighborhood_width", yystack_[0].value.as < string > ()); }
#line 8374 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2114: // o_gsa_pvalue_ks: PVALUE_KS EQUAL non_negative_number
#line 4047 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_num("pvalue_ks", yystack_[0].value.as < string > ()); }
#line 8380 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2115: // o_gsa_pvalue_corr: PVALUE_CORR EQUAL non_negative_number
#line 4048 "../preprocessor/src/DynareBison.yy"
                                                           { driver.option_num("pvalue_corr", yystack_[0].value.as < string > ()); }
#line 8386 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2116: // o_load_ident_files: LOAD_IDENT_FILES EQUAL INT_NUMBER
#line 4049 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_num("load_ident_files", yystack_[0].value.as < string > ()); }
#line 8392 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2117: // o_useautocorr: USEAUTOCORR EQUAL INT_NUMBER
#line 4050 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("useautocorr", yystack_[0].value.as < string > ()); }
#line 8398 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2118: // o_prior_mc: PRIOR_MC EQUAL INT_NUMBER
#line 4051 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("prior_mc", yystack_[0].value.as < string > ()); }
#line 8404 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2119: // o_advanced: ADVANCED EQUAL signed_integer
#line 4052 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("advanced", yystack_[0].value.as < string > ()); }
#line 8410 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2120: // o_max_dim_cova_group: MAX_DIM_COVA_GROUP EQUAL INT_NUMBER
#line 4053 "../preprocessor/src/DynareBison.yy"
                                                           { driver.option_num("max_dim_cova_group", yystack_[0].value.as < string > ()); }
#line 8416 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2121: // o_homotopy_mode: HOMOTOPY_MODE EQUAL INT_NUMBER
#line 4055 "../preprocessor/src/DynareBison.yy"
                                                 { driver.option_num("homotopy_mode", yystack_[0].value.as < string > ()); }
#line 8422 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2122: // o_homotopy_steps: HOMOTOPY_STEPS EQUAL INT_NUMBER
#line 4056 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_num("homotopy_steps", yystack_[0].value.as < string > ()); }
#line 8428 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2123: // o_homotopy_force_continue: HOMOTOPY_FORCE_CONTINUE EQUAL INT_NUMBER
#line 4057 "../preprocessor/src/DynareBison.yy"
                                                                    { driver.option_num("homotopy_force_continue", yystack_[0].value.as < string > ()); }
#line 8434 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2124: // o_nocheck: NOCHECK
#line 4058 "../preprocessor/src/DynareBison.yy"
                    { driver.option_num("steadystate.nocheck", "true"); }
#line 8440 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2125: // o_controlled_varexo: CONTROLLED_VAREXO EQUAL '(' symbol_list ')'
#line 4060 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.option_symbol_list("controlled_varexo", yystack_[1].value.as < vector<string> > ()); }
#line 8446 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2126: // o_parameter_set: PARAMETER_SET EQUAL PRIOR_MODE
#line 4062 "../preprocessor/src/DynareBison.yy"
                  { driver.option_str("parameter_set", "prior_mode"); }
#line 8452 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2127: // o_parameter_set: PARAMETER_SET EQUAL PRIOR_MEAN
#line 4064 "../preprocessor/src/DynareBison.yy"
                  { driver.option_str("parameter_set", "prior_mean"); }
#line 8458 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2128: // o_parameter_set: PARAMETER_SET EQUAL POSTERIOR_MEAN
#line 4066 "../preprocessor/src/DynareBison.yy"
                  { driver.option_str("parameter_set", "posterior_mean"); }
#line 8464 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2129: // o_parameter_set: PARAMETER_SET EQUAL POSTERIOR_MODE
#line 4068 "../preprocessor/src/DynareBison.yy"
                  { driver.option_str("parameter_set", "posterior_mode"); }
#line 8470 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2130: // o_parameter_set: PARAMETER_SET EQUAL POSTERIOR_MEDIAN
#line 4070 "../preprocessor/src/DynareBison.yy"
                  { driver.option_str("parameter_set", "posterior_median"); }
#line 8476 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2131: // o_parameter_set: PARAMETER_SET EQUAL MLE_MODE
#line 4072 "../preprocessor/src/DynareBison.yy"
                  { driver.option_str("parameter_set", "mle_mode"); }
#line 8482 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2132: // o_parameter_set: PARAMETER_SET EQUAL CALIBRATION
#line 4074 "../preprocessor/src/DynareBison.yy"
                  { driver.option_str("parameter_set", "calibration"); }
#line 8488 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2133: // o_nodecomposition: NODECOMPOSITION
#line 4076 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("nodecomposition", "true"); }
#line 8494 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2134: // o_spectral_density: SPECTRAL_DENSITY
#line 4077 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_num("SpectralDensity.trigger", "true"); }
#line 8500 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2135: // o_ms_drop: DROP EQUAL INT_NUMBER
#line 4078 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("ms.drop", yystack_[0].value.as < string > ()); }
#line 8506 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2136: // o_ms_mh_replic: MH_REPLIC EQUAL INT_NUMBER
#line 4079 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_num("ms.mh_replic", yystack_[0].value.as < string > ()); }
#line 8512 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2137: // o_freq: FREQ EQUAL INT_NUMBER
#line 4081 "../preprocessor/src/DynareBison.yy"
         { driver.option_num("ms.freq", yystack_[0].value.as < string > ()); }
#line 8518 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2138: // o_freq: FREQ EQUAL MONTHLY
#line 4083 "../preprocessor/src/DynareBison.yy"
         { driver.option_num("ms.freq", "12"); }
#line 8524 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2139: // o_freq: FREQ EQUAL QUARTERLY
#line 4085 "../preprocessor/src/DynareBison.yy"
         { driver.option_num("ms.freq", "4"); }
#line 8530 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2140: // o_initial_year: INITIAL_YEAR EQUAL INT_NUMBER
#line 4087 "../preprocessor/src/DynareBison.yy"
                                               { driver.option_num("ms.initial_year", yystack_[0].value.as < string > ()); }
#line 8536 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2141: // o_initial_subperiod: INITIAL_SUBPERIOD EQUAL INT_NUMBER
#line 4088 "../preprocessor/src/DynareBison.yy"
                                                         { driver.option_num("ms.initial_subperiod", yystack_[0].value.as < string > ()); }
#line 8542 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2142: // o_final_year: FINAL_YEAR EQUAL INT_NUMBER
#line 4089 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("ms.final_year", yystack_[0].value.as < string > ()); }
#line 8548 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2143: // o_final_subperiod: FINAL_SUBPERIOD EQUAL INT_NUMBER
#line 4090 "../preprocessor/src/DynareBison.yy"
                                                     { driver.option_num("ms.final_subperiod", yystack_[0].value.as < string > ()); }
#line 8554 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2144: // o_data: DATA EQUAL filename
#line 4091 "../preprocessor/src/DynareBison.yy"
                             { driver.option_str("ms.data", yystack_[0].value.as < string > ()); }
#line 8560 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2145: // o_vlist: VLIST EQUAL INT_NUMBER
#line 4092 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_num("ms.vlist", yystack_[0].value.as < string > ()); }
#line 8566 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2146: // o_vlistlog: VLISTLOG EQUAL '(' symbol_list ')'
#line 4093 "../preprocessor/src/DynareBison.yy"
                                                { driver.option_symbol_list("ms.vlistlog", yystack_[1].value.as < vector<string> > ()); }
#line 8572 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2147: // o_vlistper: VLISTPER EQUAL INT_NUMBER
#line 4094 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("ms.vlistper", yystack_[0].value.as < string > ()); }
#line 8578 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2148: // o_restriction_fname: RESTRICTION_FNAME EQUAL NAME
#line 4096 "../preprocessor/src/DynareBison.yy"
                      {
                        driver.warning("restriction_fname is now deprecated, and may be removed in a future version of Dynare. Use svar_identification instead.");
                        driver.option_str("ms.restriction_fname", yystack_[0].value.as < string > ());
                      }
#line 8587 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2149: // o_restriction_fname: RESTRICTION_FNAME EQUAL UPPER_CHOLESKY
#line 4101 "../preprocessor/src/DynareBison.yy"
                      {
                        driver.warning("restriction_fname is now deprecated, and may be removed in a future version of Dynare. Use svar_identification instead.");
                        driver.option_str("ms.restriction_fname", "upper_cholesky");
                      }
#line 8596 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2150: // o_restriction_fname: RESTRICTION_FNAME EQUAL LOWER_CHOLESKY
#line 4106 "../preprocessor/src/DynareBison.yy"
                      {
                        driver.warning("restriction_fname is now deprecated, and may be removed in a future version of Dynare. Use svar_identification instead.");
                        driver.option_str("ms.restriction_fname", "lower_cholesky");
                      }
#line 8605 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2151: // o_nlags: NLAGS EQUAL INT_NUMBER
#line 4111 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_num("ms.nlags", yystack_[0].value.as < string > ()); }
#line 8611 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2152: // o_cross_restrictions: CROSS_RESTRICTIONS
#line 4112 "../preprocessor/src/DynareBison.yy"
                                          { driver.option_num("ms.cross_restrictions", "true"); }
#line 8617 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2153: // o_contemp_reduced_form: CONTEMP_REDUCED_FORM
#line 4113 "../preprocessor/src/DynareBison.yy"
                                              { driver.option_num("ms.contemp_reduced_form", "true"); }
#line 8623 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2154: // o_real_pseudo_forecast: REAL_PSEUDO_FORECAST EQUAL INT_NUMBER
#line 4114 "../preprocessor/src/DynareBison.yy"
                                                               { driver.option_num("ms.real_pseudo_forecast", yystack_[0].value.as < string > ()); }
#line 8629 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2155: // o_no_bayesian_prior: NO_BAYESIAN_PRIOR
#line 4115 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("ms.bayesian_prior", "false"); }
#line 8635 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2156: // o_dummy_obs: DUMMY_OBS EQUAL INT_NUMBER
#line 4116 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_num("ms.dummy_obs", yystack_[0].value.as < string > ()); }
#line 8641 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2157: // o_nstates: NSTATES EQUAL INT_NUMBER
#line 4117 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_num("ms.nstates", yystack_[0].value.as < string > ()); }
#line 8647 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2158: // o_indxscalesstates: INDXSCALESSTATES EQUAL INT_NUMBER
#line 4118 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_num("ms.indxscalesstates", yystack_[0].value.as < string > ()); }
#line 8653 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2159: // o_alpha: ALPHA EQUAL non_negative_number
#line 4119 "../preprocessor/src/DynareBison.yy"
                                          { driver.option_num("ms.alpha", yystack_[0].value.as < string > ()); }
#line 8659 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2160: // o_beta: BETA EQUAL non_negative_number
#line 4120 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("ms.beta", yystack_[0].value.as < string > ()); }
#line 8665 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2161: // o_gsig2_lmdm: GSIG2_LMDM EQUAL INT_NUMBER
#line 4121 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("ms.gsig2_lmdm", yystack_[0].value.as < string > ()); }
#line 8671 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2162: // o_specification: SPECIFICATION EQUAL SIMS_ZHA
#line 4123 "../preprocessor/src/DynareBison.yy"
                  { driver.option_num("ms.specification", "1"); }
#line 8677 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2163: // o_specification: SPECIFICATION EQUAL NONE
#line 4125 "../preprocessor/src/DynareBison.yy"
                  { driver.option_num("ms.specification", "0"); }
#line 8683 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2164: // o_q_diag: Q_DIAG EQUAL non_negative_number
#line 4127 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_num("ms.q_diag", yystack_[0].value.as < string > ()); }
#line 8689 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2165: // o_flat_prior: FLAT_PRIOR EQUAL INT_NUMBER
#line 4128 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("ms.flat_prior", yystack_[0].value.as < string > ()); }
#line 8695 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2166: // o_ncsk: NCSK EQUAL INT_NUMBER
#line 4129 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("ms.ncsk", yystack_[0].value.as < string > ()); }
#line 8701 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2167: // o_nstd: NSTD EQUAL INT_NUMBER
#line 4130 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("ms.nstd", yystack_[0].value.as < string > ()); }
#line 8707 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2168: // o_ninv: NINV EQUAL INT_NUMBER
#line 4131 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("ms.ninv", yystack_[0].value.as < string > ()); }
#line 8713 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2169: // o_indxparr: INDXPARR EQUAL INT_NUMBER
#line 4132 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("ms.indxparr", yystack_[0].value.as < string > ()); }
#line 8719 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2170: // o_indxovr: INDXOVR EQUAL INT_NUMBER
#line 4133 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_num("ms.indxovr", yystack_[0].value.as < string > ()); }
#line 8725 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2171: // o_aband: ABAND EQUAL INT_NUMBER
#line 4134 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_num("ms.aband", yystack_[0].value.as < string > ()); }
#line 8731 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2172: // o_indxap: INDXAP EQUAL INT_NUMBER
#line 4135 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("ms.indxap", yystack_[0].value.as < string > ()); }
#line 8737 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2173: // o_apband: APBAND EQUAL INT_NUMBER
#line 4136 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("ms.apband", yystack_[0].value.as < string > ()); }
#line 8743 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2174: // o_indximf: INDXIMF EQUAL INT_NUMBER
#line 4137 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_num("ms.indximf", yystack_[0].value.as < string > ()); }
#line 8749 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2175: // o_indxfore: INDXFORE EQUAL INT_NUMBER
#line 4138 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("ms.indxfore", yystack_[0].value.as < string > ()); }
#line 8755 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2176: // o_foreband: FOREBAND EQUAL INT_NUMBER
#line 4139 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("ms.foreband", yystack_[0].value.as < string > ()); }
#line 8761 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2177: // o_indxgforhat: INDXGFOREHAT EQUAL INT_NUMBER
#line 4140 "../preprocessor/src/DynareBison.yy"
                                              { driver.option_num("ms.indxgforehat", yystack_[0].value.as < string > ()); }
#line 8767 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2178: // o_indxgimfhat: INDXGIMFHAT EQUAL INT_NUMBER
#line 4141 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("ms.indxgimfhat", yystack_[0].value.as < string > ()); }
#line 8773 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2179: // o_indxestima: INDXESTIMA EQUAL INT_NUMBER
#line 4142 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("ms.indxestima", yystack_[0].value.as < string > ()); }
#line 8779 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2180: // o_indxgdls: INDXGDLS EQUAL INT_NUMBER
#line 4143 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("ms.indxgdls", yystack_[0].value.as < string > ()); }
#line 8785 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2181: // o_eq_ms: EQ_MS EQUAL INT_NUMBER
#line 4144 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_num("ms.eq_ms", yystack_[0].value.as < string > ()); }
#line 8791 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2182: // o_cms: CMS EQUAL INT_NUMBER
#line 4145 "../preprocessor/src/DynareBison.yy"
                             { driver.option_num("ms.cms", yystack_[0].value.as < string > ()); }
#line 8797 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2183: // o_ncms: NCMS EQUAL INT_NUMBER
#line 4146 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("ms.ncms", yystack_[0].value.as < string > ()); }
#line 8803 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2184: // o_eq_cms: EQ_CMS EQUAL INT_NUMBER
#line 4147 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("ms.eq_cms", yystack_[0].value.as < string > ()); }
#line 8809 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2185: // o_tlindx: TLINDX EQUAL INT_NUMBER
#line 4148 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("ms.tlindx", yystack_[0].value.as < string > ()); }
#line 8815 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2186: // o_tlnumber: TLNUMBER EQUAL INT_NUMBER
#line 4149 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("ms.tlnumber", yystack_[0].value.as < string > ()); }
#line 8821 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2187: // o_cnum: CNUM EQUAL INT_NUMBER
#line 4150 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("ms.cnum", yystack_[0].value.as < string > ()); }
#line 8827 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2188: // o_k_order_solver: K_ORDER_SOLVER
#line 4151 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("k_order_solver", "true"); }
#line 8833 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2189: // o_pruning: PRUNING
#line 4152 "../preprocessor/src/DynareBison.yy"
                    { driver.option_num("pruning", "true"); }
#line 8839 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2190: // o_chain: CHAIN EQUAL INT_NUMBER
#line 4153 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_num("ms.chain", yystack_[0].value.as < string > ()); }
#line 8845 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2191: // o_restrictions: RESTRICTIONS EQUAL vec_of_vec_value
#line 4155 "../preprocessor/src/DynareBison.yy"
                 { driver.option_vec_of_vec_value("ms.restrictions", yystack_[0].value.as < vector<vector<string>> > ()); }
#line 8851 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2192: // o_duration: DURATION EQUAL non_negative_number
#line 4158 "../preprocessor/src/DynareBison.yy"
             { driver.option_num("ms.duration", yystack_[0].value.as < string > ()); }
#line 8857 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2193: // o_duration: DURATION EQUAL vec_value_w_inf
#line 4160 "../preprocessor/src/DynareBison.yy"
             { driver.option_vec_value("ms.duration", yystack_[0].value.as < vector<string> > ()); }
#line 8863 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2194: // o_number_of_regimes: NUMBER_OF_REGIMES EQUAL INT_NUMBER
#line 4162 "../preprocessor/src/DynareBison.yy"
                                                         { driver.option_num("ms.number_of_regimes", yystack_[0].value.as < string > ()); }
#line 8869 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2195: // o_number_of_lags: NUMBER_OF_LAGS EQUAL INT_NUMBER
#line 4163 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_num("ms.number_of_lags", yystack_[0].value.as < string > ()); }
#line 8875 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2196: // o_parameters: PARAMETERS EQUAL '[' symbol_list ']'
#line 4164 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_symbol_list("ms.parameters", yystack_[1].value.as < vector<string> > ()); }
#line 8881 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2197: // o_coefficients: COEFFICIENTS
#line 4165 "../preprocessor/src/DynareBison.yy"
                              { driver.option_str("ms.coefficients", "svar_coefficients"); }
#line 8887 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2198: // o_variances: VARIANCES
#line 4166 "../preprocessor/src/DynareBison.yy"
                        { driver.option_str("ms.variances", "svar_variances"); }
#line 8893 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2199: // o_equations: EQUATIONS EQUAL vec_int
#line 4168 "../preprocessor/src/DynareBison.yy"
              { driver.option_vec_int("ms.equations", yystack_[0].value.as < vector<int> > ()); }
#line 8899 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2200: // o_equations: EQUATIONS EQUAL vec_int_number
#line 4170 "../preprocessor/src/DynareBison.yy"
              { driver.option_vec_int("ms.equations", yystack_[0].value.as < vector<int> > ()); }
#line 8905 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2201: // o_silent_optimizer: SILENT_OPTIMIZER
#line 4172 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_num("silent_optimizer", "true"); }
#line 8911 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2202: // o_instruments: INSTRUMENTS EQUAL '(' symbol_list ')'
#line 4173 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_symbol_list("instruments", yystack_[1].value.as < vector<string> > ()); }
#line 8917 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2203: // o_ext_func_name: EXT_FUNC_NAME EQUAL namespace_qualified_filename
#line 4175 "../preprocessor/src/DynareBison.yy"
                                                                   { driver.external_function_option("name", yystack_[0].value.as < string > ()); }
#line 8923 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2204: // o_ext_func_nargs: EXT_FUNC_NARGS EQUAL INT_NUMBER
#line 4176 "../preprocessor/src/DynareBison.yy"
                                                   { driver.external_function_option("nargs", yystack_[0].value.as < string > ()); }
#line 8929 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2205: // o_first_deriv_provided: FIRST_DERIV_PROVIDED EQUAL namespace_qualified_filename
#line 4178 "../preprocessor/src/DynareBison.yy"
                         { driver.external_function_option("first_deriv_provided", yystack_[0].value.as < string > ()); }
#line 8935 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2206: // o_first_deriv_provided: FIRST_DERIV_PROVIDED
#line 4180 "../preprocessor/src/DynareBison.yy"
                         { driver.external_function_option("first_deriv_provided", ""); }
#line 8941 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2207: // o_second_deriv_provided: SECOND_DERIV_PROVIDED EQUAL namespace_qualified_filename
#line 4183 "../preprocessor/src/DynareBison.yy"
                          { driver.external_function_option("second_deriv_provided", yystack_[0].value.as < string > ()); }
#line 8947 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2208: // o_second_deriv_provided: SECOND_DERIV_PROVIDED
#line 4185 "../preprocessor/src/DynareBison.yy"
                          { driver.external_function_option("second_deriv_provided", ""); }
#line 8953 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2209: // o_filter_covariance: FILTER_COVARIANCE
#line 4188 "../preprocessor/src/DynareBison.yy"
                        { driver.option_num("filter_covariance", "true"); }
#line 8959 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2210: // o_updated_covariance: UPDATED_COVARIANCE
#line 4191 "../preprocessor/src/DynareBison.yy"
                        { driver.option_num("updated_covariance", "true"); }
#line 8965 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2211: // o_filter_decomposition: FILTER_DECOMPOSITION
#line 4194 "../preprocessor/src/DynareBison.yy"
                           { driver.option_num("filter_decomposition", "true"); }
#line 8971 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2212: // o_smoothed_state_uncertainty: SMOOTHED_STATE_UNCERTAINTY
#line 4197 "../preprocessor/src/DynareBison.yy"
                           { driver.option_num("smoothed_state_uncertainty", "true"); }
#line 8977 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2213: // o_smoother_redux: SMOOTHER_REDUX
#line 4200 "../preprocessor/src/DynareBison.yy"
                           { driver.option_num("smoother_redux", "true"); }
#line 8983 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2214: // o_selected_variables_only: SELECTED_VARIABLES_ONLY
#line 4203 "../preprocessor/src/DynareBison.yy"
                           { driver.option_num("selected_variables_only", "true"); }
#line 8989 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2215: // o_cova_compute: COVA_COMPUTE EQUAL INT_NUMBER
#line 4206 "../preprocessor/src/DynareBison.yy"
                 { driver.option_num("cova_compute", yystack_[0].value.as < string > ()); }
#line 8995 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2216: // o_output_file_tag: OUTPUT_FILE_TAG EQUAL filename
#line 4208 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_str("ms.output_file_tag", yystack_[0].value.as < string > ()); }
#line 9001 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2217: // o_file_tag: FILE_TAG EQUAL filename
#line 4209 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_str("ms.file_tag", yystack_[0].value.as < string > ()); }
#line 9007 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2218: // o_no_create_init: NO_CREATE_INIT
#line 4210 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("ms.create_init", "false"); }
#line 9013 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2219: // o_simulation_file_tag: SIMULATION_FILE_TAG EQUAL filename
#line 4211 "../preprocessor/src/DynareBison.yy"
                                                           { driver.option_str("ms.simulation_file_tag", yystack_[0].value.as < string > ()); }
#line 9019 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2220: // o_coefficients_prior_hyperparameters: COEFFICIENTS_PRIOR_HYPERPARAMETERS EQUAL vec_value
#line 4213 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_vec_value("ms.coefficients_prior_hyperparameters", yystack_[0].value.as < vector<string> > ()); }
#line 9025 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2221: // o_convergence_starting_value: CONVERGENCE_STARTING_VALUE EQUAL non_negative_number
#line 4215 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("ms.convergence_starting_value", yystack_[0].value.as < string > ()); }
#line 9031 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2222: // o_convergence_ending_value: CONVERGENCE_ENDING_VALUE EQUAL non_negative_number
#line 4217 "../preprocessor/src/DynareBison.yy"
                             { driver.option_num("ms.convergence_ending_value", yystack_[0].value.as < string > ()); }
#line 9037 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2223: // o_convergence_increment_value: CONVERGENCE_INCREMENT_VALUE EQUAL non_negative_number
#line 4219 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("ms.convergence_increment_value", yystack_[0].value.as < string > ()); }
#line 9043 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2224: // o_max_iterations_starting_value: MAX_ITERATIONS_STARTING_VALUE EQUAL INT_NUMBER
#line 4221 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("ms.max_iterations_starting_value", yystack_[0].value.as < string > ()); }
#line 9049 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2225: // o_max_iterations_increment_value: MAX_ITERATIONS_INCREMENT_VALUE EQUAL non_negative_number
#line 4223 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("ms.max_iterations_increment_value", yystack_[0].value.as < string > ()); }
#line 9055 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2226: // o_max_block_iterations: MAX_BLOCK_ITERATIONS EQUAL INT_NUMBER
#line 4225 "../preprocessor/src/DynareBison.yy"
                         { driver.option_num("ms.max_block_iterations", yystack_[0].value.as < string > ()); }
#line 9061 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2227: // o_max_repeated_optimization_runs: MAX_REPEATED_OPTIMIZATION_RUNS EQUAL INT_NUMBER
#line 4227 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("ms.max_repeated_optimization_runs", yystack_[0].value.as < string > ()); }
#line 9067 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2228: // o_function_convergence_criterion: FUNCTION_CONVERGENCE_CRITERION EQUAL non_negative_number
#line 4229 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("ms.function_convergence_criterion", yystack_[0].value.as < string > ()); }
#line 9073 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2229: // o_parameter_convergence_criterion: PARAMETER_CONVERGENCE_CRITERION EQUAL non_negative_number
#line 4231 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("ms.parameter_convergence_criterion", yystack_[0].value.as < string > ()); }
#line 9079 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2230: // o_number_of_large_perturbations: NUMBER_OF_LARGE_PERTURBATIONS EQUAL INT_NUMBER
#line 4233 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("ms.number_of_large_perturbations", yystack_[0].value.as < string > ()); }
#line 9085 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2231: // o_number_of_small_perturbations: NUMBER_OF_SMALL_PERTURBATIONS EQUAL INT_NUMBER
#line 4235 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("ms.number_of_small_perturbations", yystack_[0].value.as < string > ()); }
#line 9091 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2232: // o_number_of_posterior_draws_after_perturbation: NUMBER_OF_POSTERIOR_DRAWS_AFTER_PERTURBATION EQUAL INT_NUMBER
#line 4237 "../preprocessor/src/DynareBison.yy"
                                                 { driver.option_num("ms.number_of_posterior_draws_after_perturbation", yystack_[0].value.as < string > ()); }
#line 9097 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2233: // o_max_number_of_stages: MAX_NUMBER_OF_STAGES EQUAL INT_NUMBER
#line 4239 "../preprocessor/src/DynareBison.yy"
                         { driver.option_num("ms.max_number_of_stages", yystack_[0].value.as < string > ()); }
#line 9103 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2234: // o_random_function_convergence_criterion: RANDOM_FUNCTION_CONVERGENCE_CRITERION EQUAL non_negative_number
#line 4241 "../preprocessor/src/DynareBison.yy"
                                          { driver.option_num("ms.random_function_convergence_criterion", yystack_[0].value.as < string > ()); }
#line 9109 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2235: // o_random_parameter_convergence_criterion: RANDOM_PARAMETER_CONVERGENCE_CRITERION EQUAL non_negative_number
#line 4243 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("ms.random_parameter_convergence_criterion", yystack_[0].value.as < string > ()); }
#line 9115 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2236: // o_thinning_factor: THINNING_FACTOR EQUAL INT_NUMBER
#line 4244 "../preprocessor/src/DynareBison.yy"
                                                     { driver.option_num("ms.thinning_factor", yystack_[0].value.as < string > ()); }
#line 9121 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2237: // o_adaptive_mh_draws: ADAPTIVE_MH_DRAWS EQUAL INT_NUMBER
#line 4245 "../preprocessor/src/DynareBison.yy"
                                                         { driver.option_num("ms.adaptive_mh_draws", yystack_[0].value.as < string > ()); }
#line 9127 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2238: // o_save_draws: SAVE_DRAWS
#line 4246 "../preprocessor/src/DynareBison.yy"
                          { driver.option_num("ms.save_draws", "true"); }
#line 9133 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2239: // o_proposal_draws: PROPOSAL_DRAWS EQUAL INT_NUMBER
#line 4247 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_num("ms.proposal_draws", yystack_[0].value.as < string > ()); }
#line 9139 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2240: // o_use_mean_center: USE_MEAN_CENTER
#line 4248 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("ms.use_mean_center", "true"); }
#line 9145 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2241: // o_proposal_type: PROPOSAL_TYPE EQUAL INT_NUMBER
#line 4249 "../preprocessor/src/DynareBison.yy"
                                                 { driver.option_num("ms.proposal_type", yystack_[0].value.as < string > ()); }
#line 9151 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2242: // o_proposal_lower_bound: PROPOSAL_LOWER_BOUND EQUAL signed_number
#line 4250 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.option_num("ms.proposal_lower_bound", yystack_[0].value.as < string > ()); }
#line 9157 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2243: // o_proposal_upper_bound: PROPOSAL_UPPER_BOUND EQUAL signed_number
#line 4251 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.option_num("ms.proposal_upper_bound", yystack_[0].value.as < string > ()); }
#line 9163 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2244: // o_parameter_uncertainty: PARAMETER_UNCERTAINTY
#line 4252 "../preprocessor/src/DynareBison.yy"
                                                { driver.option_num("ms.parameter_uncertainty", "true"); }
#line 9169 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2245: // o_horizon: HORIZON EQUAL INT_NUMBER
#line 4253 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_num("ms.horizon", yystack_[0].value.as < string > ()); }
#line 9175 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2246: // o_filtered_probabilities: FILTERED_PROBABILITIES
#line 4254 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("ms.filtered_probabilities", "true"); }
#line 9181 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2247: // o_real_time_smoothed: REAL_TIME_SMOOTHED
#line 4255 "../preprocessor/src/DynareBison.yy"
                                          { driver.option_num("ms.real_time_smoothed_probabilities", "true"); }
#line 9187 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2248: // o_no_error_bands: NO_ERROR_BANDS
#line 4256 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("ms.error_bands", "false"); }
#line 9193 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2249: // o_error_band_percentiles: ERROR_BAND_PERCENTILES EQUAL vec_value
#line 4257 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.option_vec_value("ms.percentiles", yystack_[0].value.as < vector<string> > ()); }
#line 9199 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2250: // o_shock_draws: SHOCK_DRAWS EQUAL INT_NUMBER
#line 4258 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("ms.shock_draws", yystack_[0].value.as < string > ()); }
#line 9205 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2251: // o_shocks_per_parameter: SHOCKS_PER_PARAMETER EQUAL INT_NUMBER
#line 4259 "../preprocessor/src/DynareBison.yy"
                                                               { driver.option_num("ms.shocks_per_parameter", yystack_[0].value.as < string > ()); }
#line 9211 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2252: // o_free_parameters: FREE_PARAMETERS EQUAL vec_value
#line 4260 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_vec_value("ms.free_parameters", yystack_[0].value.as < vector<string> > ()); }
#line 9217 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2253: // o_median: MEDIAN
#line 4261 "../preprocessor/src/DynareBison.yy"
                  { driver.option_num("ms.median", "1"); }
#line 9223 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2254: // o_median: MEDIAN EQUAL signed_number
#line 4262 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_num("median", yystack_[0].value.as < string > ()); }
#line 9229 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2255: // o_regimes: REGIMES
#line 4263 "../preprocessor/src/DynareBison.yy"
                    { driver.option_num("ms.regimes", "true"); }
#line 9235 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2256: // o_regime: REGIME EQUAL INT_NUMBER
#line 4264 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("ms.regime", yystack_[0].value.as < string > ()); }
#line 9241 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2257: // o_data_obs_nbr: DATA_OBS_NBR EQUAL INT_NUMBER
#line 4265 "../preprocessor/src/DynareBison.yy"
                                               { driver.option_num("ms.forecast_data_obs", yystack_[0].value.as < string > ()); }
#line 9247 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2258: // o_discretionary_tol: DISCRETIONARY_TOL EQUAL non_negative_number
#line 4266 "../preprocessor/src/DynareBison.yy"
                                                                 { driver.option_num("discretionary_tol", yystack_[0].value.as < string > ()); }
#line 9253 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2259: // o_analytic_derivation: ANALYTIC_DERIVATION
#line 4267 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_num("analytic_derivation", "1"); }
#line 9259 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2260: // o_analytic_derivation_mode: ANALYTIC_DERIVATION_MODE EQUAL signed_number
#line 4268 "../preprocessor/src/DynareBison.yy"
                                                                          { driver.option_num("analytic_derivation_mode", yystack_[0].value.as < string > ()); }
#line 9265 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2261: // o_endogenous_prior: ENDOGENOUS_PRIOR
#line 4269 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_num("endogenous_prior", "true"); }
#line 9271 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2262: // o_use_univariate_filters_if_singularity_is_detected: USE_UNIVARIATE_FILTERS_IF_SINGULARITY_IS_DETECTED EQUAL INT_NUMBER
#line 4270 "../preprocessor/src/DynareBison.yy"
                                                                                                                         { driver.option_num("use_univariate_filters_if_singularity_is_detected", yystack_[0].value.as < string > ()); }
#line 9277 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2263: // o_mcmc_jumping_covariance: MCMC_JUMPING_COVARIANCE EQUAL HESSIAN
#line 4272 "../preprocessor/src/DynareBison.yy"
                            { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 9283 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2264: // o_mcmc_jumping_covariance: MCMC_JUMPING_COVARIANCE EQUAL PRIOR_VARIANCE
#line 4273 "../preprocessor/src/DynareBison.yy"
                            { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 9289 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2265: // o_mcmc_jumping_covariance: MCMC_JUMPING_COVARIANCE EQUAL IDENTITY_MATRIX
#line 4275 "../preprocessor/src/DynareBison.yy"
                            { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 9295 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2266: // o_mcmc_jumping_covariance: MCMC_JUMPING_COVARIANCE EQUAL filename
#line 4277 "../preprocessor/src/DynareBison.yy"
                            { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 9301 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2267: // o_rescale_prediction_error_covariance: RESCALE_PREDICTION_ERROR_COVARIANCE
#line 4279 "../preprocessor/src/DynareBison.yy"
                                                                            { driver.option_num("rescale_prediction_error_covariance", "true"); }
#line 9307 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2268: // o_use_penalized_objective_for_hessian: USE_PENALIZED_OBJECTIVE_FOR_HESSIAN
#line 4280 "../preprocessor/src/DynareBison.yy"
                                                                            { driver.option_num("hessian.use_penalized_objective", "true"); }
#line 9313 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2269: // o_irf_plot_threshold: IRF_PLOT_THRESHOLD EQUAL non_negative_number
#line 4281 "../preprocessor/src/DynareBison.yy"
                                                                    { driver.option_num("impulse_responses.plot_threshold", yystack_[0].value.as < string > ()); }
#line 9319 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2270: // o_dr_display_tol: DR_DISPLAY_TOL EQUAL non_negative_number
#line 4282 "../preprocessor/src/DynareBison.yy"
                                                            { driver.option_num("dr_display_tol", yystack_[0].value.as < string > ()); }
#line 9325 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2271: // o_consider_all_endogenous: CONSIDER_ALL_ENDOGENOUS
#line 4283 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_str("endo_vars_for_moment_computations_in_estimation", "all_endogenous_variables"); }
#line 9331 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2272: // o_consider_all_endogenous_and_auxiliary: CONSIDER_ALL_ENDOGENOUS_AND_AUXILIARY
#line 4284 "../preprocessor/src/DynareBison.yy"
                                                                                { driver.option_str("endo_vars_for_moment_computations_in_estimation", "all_endogenous_and_auxiliary_variables"); }
#line 9337 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2273: // o_consider_only_observed: CONSIDER_ONLY_OBSERVED
#line 4285 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_str("endo_vars_for_moment_computations_in_estimation", "only_observed_variables"); }
#line 9343 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2274: // o_no_homotopy: NO_HOMOTOPY
#line 4286 "../preprocessor/src/DynareBison.yy"
                            { driver.option_num("no_homotopy", "true"); }
#line 9349 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2275: // o_endval_steady: ENDVAL_STEADY
#line 4287 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("simul.endval_steady", "true"); }
#line 9355 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2276: // o_homotopy_max_completion_share: HOMOTOPY_MAX_COMPLETION_SHARE EQUAL non_negative_number
#line 4288 "../preprocessor/src/DynareBison.yy"
                                                                                          { driver.option_num("simul.homotopy_max_completion_share", yystack_[0].value.as < string > ()); }
#line 9361 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2277: // o_homotopy_min_step_size: HOMOTOPY_MIN_STEP_SIZE EQUAL non_negative_number
#line 4289 "../preprocessor/src/DynareBison.yy"
                                                                            { driver.option_num("simul.homotopy_min_step_size", yystack_[0].value.as < string > ()); }
#line 9367 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2278: // o_homotopy_initial_step_size: HOMOTOPY_INITIAL_STEP_SIZE EQUAL non_negative_number
#line 4290 "../preprocessor/src/DynareBison.yy"
                                                                                    { driver.option_num("simul.homotopy_initial_step_size", yystack_[0].value.as < string > ()); }
#line 9373 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2279: // o_homotopy_step_size_increase_success_count: HOMOTOPY_STEP_SIZE_INCREASE_SUCCESS_COUNT EQUAL INT_NUMBER
#line 4291 "../preprocessor/src/DynareBison.yy"
                                                                                                         { driver.option_num("simul.homotopy_step_size_increase_success_count", yystack_[0].value.as < string > ()); }
#line 9379 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2280: // o_homotopy_linearization_fallback: HOMOTOPY_LINEARIZATION_FALLBACK
#line 4292 "../preprocessor/src/DynareBison.yy"
                                                                    { driver.option_num("simul.homotopy_linearization_fallback", "true"); }
#line 9385 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2281: // o_homotopy_marginal_linearization_fallback: HOMOTOPY_MARGINAL_LINEARIZATION_FALLBACK
#line 4293 "../preprocessor/src/DynareBison.yy"
                                                                                      { driver.option_num("simul.homotopy_marginal_linearization_fallback", "0.01"); }
#line 9391 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2282: // o_homotopy_marginal_linearization_fallback: HOMOTOPY_MARGINAL_LINEARIZATION_FALLBACK EQUAL non_negative_number
#line 4294 "../preprocessor/src/DynareBison.yy"
                                                                                                                { driver.option_num("simul.homotopy_marginal_linearization_fallback", yystack_[0].value.as < string > ()); }
#line 9397 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2283: // o_homotopy_exclude_varexo: HOMOTOPY_EXCLUDE_VAREXO EQUAL '(' symbol_list ')'
#line 4295 "../preprocessor/src/DynareBison.yy"
                                                                              { driver.option_symbol_list("simul.homotopy_exclude_varexo", yystack_[1].value.as < vector<string> > ()); }
#line 9403 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2284: // o_infile: INFILE EQUAL filename
#line 4297 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_str("infile", yystack_[0].value.as < string > ()); }
#line 9409 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2285: // o_invars: INVARS EQUAL '(' symbol_list ')'
#line 4298 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_symbol_list("invars", yystack_[1].value.as < vector<string> > ()); }
#line 9415 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2286: // o_period: PERIOD EQUAL INT_NUMBER
#line 4299 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("period", yystack_[0].value.as < string > ()); }
#line 9421 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2287: // o_outfile: OUTFILE EQUAL filename
#line 4300 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_str("outfile", yystack_[0].value.as < string > ()); }
#line 9427 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2288: // o_outvars: OUTVARS EQUAL '(' symbol_list ')'
#line 4301 "../preprocessor/src/DynareBison.yy"
                                              { driver.option_symbol_list("outvars", yystack_[1].value.as < vector<string> > ()); }
#line 9433 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2289: // o_lmmcp: LMMCP
#line 4302 "../preprocessor/src/DynareBison.yy"
                { driver.option_num("lmmcp.status", "true"); }
#line 9439 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2290: // o_function: FUNCTION EQUAL filename
#line 4303 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_str("function", yystack_[0].value.as < string > ()); }
#line 9445 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2291: // o_sampling_draws: SAMPLING_DRAWS EQUAL INT_NUMBER
#line 4304 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_num("sampling_draws", yystack_[0].value.as < string > ()); }
#line 9451 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2292: // o_use_shock_groups: USE_SHOCK_GROUPS
#line 4305 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_str("plot_shock_decomp.use_shock_groups", "default"); }
#line 9457 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2293: // o_use_shock_groups: USE_SHOCK_GROUPS EQUAL symbol
#line 4306 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_str("plot_shock_decomp.use_shock_groups", yystack_[0].value.as < string > ()); }
#line 9463 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2294: // o_colormap: COLORMAP EQUAL symbol
#line 4308 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("plot_shock_decomp.colormap", yystack_[0].value.as < string > ()); }
#line 9469 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2295: // o_icd_colormap: COLORMAP EQUAL symbol
#line 4309 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("initial_condition_decomp.colormap", yystack_[0].value.as < string > ()); }
#line 9475 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2296: // o_no_init_estimation_check_first_obs: NO_INIT_ESTIMATION_CHECK_FIRST_OBS
#line 4310 "../preprocessor/src/DynareBison.yy"
                                                                          { driver.option_num("no_init_estimation_check_first_obs", "true"); }
#line 9481 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2297: // o_heteroskedastic_filter: HETEROSKEDASTIC_FILTER
#line 4311 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("heteroskedastic_filter", "true"); }
#line 9487 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2298: // o_pfwee_constant_simulation_length: CONSTANT_SIMULATION_LENGTH
#line 4312 "../preprocessor/src/DynareBison.yy"
                                                                { driver.option_num("pfwee.constant_simulation_length", "true"); }
#line 9493 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2299: // o_fsolve_options: FSOLVE_OPTIONS EQUAL '(' name_value_pair_with_boolean_list ')'
#line 4313 "../preprocessor/src/DynareBison.yy"
                                                                                  { driver.option_str("fsolve_options", yystack_[1].value.as < string > ()); }
#line 9499 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2300: // o_bartlett_kernel_lag: BARTLETT_KERNEL_LAG EQUAL INT_NUMBER
#line 4316 "../preprocessor/src/DynareBison.yy"
                                                             { driver.option_num("mom.bartlett_kernel_lag", yystack_[0].value.as < string > ()); }
#line 9505 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2301: // o_weighting_matrix: WEIGHTING_MATRIX EQUAL vec_str
#line 4317 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_vec_cellstr("mom.weighting_matrix", yystack_[0].value.as < vector<string> > ()); }
#line 9511 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2302: // o_weighting_matrix_scaling_factor: WEIGHTING_MATRIX_SCALING_FACTOR EQUAL non_negative_number
#line 4318 "../preprocessor/src/DynareBison.yy"
                                                                                              { driver.option_num("mom.weighting_matrix_scaling_factor", yystack_[0].value.as < string > ()); }
#line 9517 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2303: // o_analytic_standard_errors: ANALYTIC_STANDARD_ERRORS
#line 4319 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_num("mom.analytic_standard_errors", "true"); }
#line 9523 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2304: // o_analytic_jacobian: ANALYTIC_JACOBIAN
#line 4320 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("mom.analytic_jacobian", "true"); }
#line 9529 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2305: // o_mom_method: MOM_METHOD EQUAL GMM
#line 4322 "../preprocessor/src/DynareBison.yy"
               { driver.option_str("mom.mom_method", "GMM"); }
#line 9535 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2306: // o_mom_method: MOM_METHOD EQUAL SMM
#line 4324 "../preprocessor/src/DynareBison.yy"
               { driver.option_str("mom.mom_method", "SMM"); }
#line 9541 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2307: // o_mom_method: MOM_METHOD EQUAL IRF_MATCHING
#line 4326 "../preprocessor/src/DynareBison.yy"
               { driver.option_str("mom.mom_method", "IRF_MATCHING"); }
#line 9547 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2308: // o_simulation_method: SIMULATION_METHOD EQUAL STOCH_SIMUL
#line 4328 "../preprocessor/src/DynareBison.yy"
               { driver.option_str("mom.simulation_method", "STOCH_SIMUL"); }
#line 9553 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2309: // o_penalized_estimator: PENALIZED_ESTIMATOR
#line 4329 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_num("mom.penalized_estimator", "true"); }
#line 9559 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2310: // o_verbose: VERBOSE
#line 4330 "../preprocessor/src/DynareBison.yy"
                    { driver.option_num("mom.verbose", "true"); }
#line 9565 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2311: // o_simulation_multiple: SIMULATION_MULTIPLE EQUAL INT_NUMBER
#line 4331 "../preprocessor/src/DynareBison.yy"
                                                             { driver.option_num("mom.simulation_multiple", yystack_[0].value.as < string > ()); }
#line 9571 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2312: // o_mom_burnin: BURNIN EQUAL INT_NUMBER
#line 4332 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("mom.burnin", yystack_[0].value.as < string > ()); }
#line 9577 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2313: // o_bounded_shock_support: BOUNDED_SHOCK_SUPPORT
#line 4333 "../preprocessor/src/DynareBison.yy"
                                                { driver.option_num("mom.bounded_shock_support", "true"); }
#line 9583 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2314: // o_mom_seed: SEED EQUAL INT_NUMBER
#line 4334 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("mom.seed", yystack_[0].value.as < string > ()); }
#line 9589 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2315: // o_additional_optimizer_steps: ADDITIONAL_OPTIMIZER_STEPS EQUAL vec_int
#line 4335 "../preprocessor/src/DynareBison.yy"
                                                                        { driver.option_vec_int("additional_optimizer_steps", yystack_[0].value.as < vector<int> > ()); }
#line 9595 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2316: // o_mom_se_tolx: SE_TOLX EQUAL non_negative_number
#line 4336 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("mom.se_tolx", yystack_[0].value.as < string > ()); }
#line 9601 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2317: // o_irf_matching_file: IRF_MATCHING_FILE EQUAL filename
#line 4337 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_str("mom.irf_matching_file.name", yystack_[0].value.as < string > ()); }
#line 9607 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2318: // o_add_tiny_number_to_cholesky: ADD_TINY_NUMBER_TO_CHOLESKY EQUAL non_negative_number
#line 4338 "../preprocessor/src/DynareBison.yy"
                                                                                      { driver.option_num("add_tiny_number_to_cholesky", yystack_[0].value.as < string > ()); }
#line 9613 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2319: // o_analytical_girf: ANALYTICAL_GIRF
#line 4340 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("irf_opt.analytical_GIRF", "true"); }
#line 9619 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2320: // o_irf_in_percent: IRF_IN_PERCENT
#line 4341 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("irf_opt.percent", "true"); }
#line 9625 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2321: // o_emas_girf: EMAS_GIRF
#line 4342 "../preprocessor/src/DynareBison.yy"
                        { driver.option_num("irf_opt.ergodic_mean_irf", "true"); }
#line 9631 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2322: // o_emas_drop: EMAS_DROP EQUAL INT_NUMBER
#line 4343 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_num("irf_opt.EM.drop", yystack_[0].value.as < string > ()); }
#line 9637 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2323: // o_emas_tolf: EMAS_TOLF EQUAL non_negative_number
#line 4344 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("irf_opt.EM.tolf", yystack_[0].value.as < string > ()); }
#line 9643 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2324: // o_emas_max_iter: EMAS_MAX_ITER EQUAL INT_NUMBER
#line 4345 "../preprocessor/src/DynareBison.yy"
                                                 { driver.option_num("irf_opt.EM.iter", yystack_[0].value.as < string > ()); }
#line 9649 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2325: // o_non_zero: NON_ZERO
#line 4346 "../preprocessor/src/DynareBison.yy"
                      { driver.option_num("non_zero", "true"); }
#line 9655 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2326: // o_no_identification_strength: NO_IDENTIFICATION_STRENGTH
#line 4349 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("no_identification_strength", "true"); }
#line 9661 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2327: // o_no_identification_reducedform: NO_IDENTIFICATION_REDUCEDFORM
#line 4350 "../preprocessor/src/DynareBison.yy"
                                                                { driver.option_num("no_identification_reducedform", "true"); }
#line 9667 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2328: // o_no_identification_moments: NO_IDENTIFICATION_MOMENTS
#line 4351 "../preprocessor/src/DynareBison.yy"
                                                        { driver.option_num("no_identification_moments", "true"); }
#line 9673 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2329: // o_no_identification_minimal: NO_IDENTIFICATION_MINIMAL
#line 4352 "../preprocessor/src/DynareBison.yy"
                                                        { driver.option_num("no_identification_minimal", "true"); }
#line 9679 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2330: // o_no_identification_spectrum: NO_IDENTIFICATION_SPECTRUM
#line 4353 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("no_identification_spectrum", "true"); }
#line 9685 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2331: // o_normalize_jacobians: NORMALIZE_JACOBIANS EQUAL INT_NUMBER
#line 4354 "../preprocessor/src/DynareBison.yy"
                                                             { driver.option_num("normalize_jacobians", yystack_[0].value.as < string > ()); }
#line 9691 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2332: // o_grid_nbr: GRID_NBR EQUAL INT_NUMBER
#line 4355 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("grid_nbr", yystack_[0].value.as < string > ()); }
#line 9697 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2333: // o_tol_rank: TOL_RANK EQUAL non_negative_number
#line 4356 "../preprocessor/src/DynareBison.yy"
                                                { driver.option_num("tol_rank", yystack_[0].value.as < string > ()); }
#line 9703 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2334: // o_tol_deriv: TOL_DERIV EQUAL non_negative_number
#line 4357 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("tol_deriv", yystack_[0].value.as < string > ()); }
#line 9709 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2335: // o_tol_sv: TOL_SV EQUAL non_negative_number
#line 4358 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_num("tol_sv", yystack_[0].value.as < string > ()); }
#line 9715 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2336: // o_checks_via_subsets: CHECKS_VIA_SUBSETS EQUAL INT_NUMBER
#line 4359 "../preprocessor/src/DynareBison.yy"
                                                           { driver.option_num("checks_via_subsets", yystack_[0].value.as < string > ()); }
#line 9721 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2337: // o_max_dim_subsets_groups: MAX_DIM_SUBSETS_GROUPS EQUAL INT_NUMBER
#line 4360 "../preprocessor/src/DynareBison.yy"
                                                                   { driver.option_num("max_dim_subsets_groups", yystack_[0].value.as < string > ()); }
#line 9727 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2338: // o_block_static: BLOCK_STATIC
#line 4361 "../preprocessor/src/DynareBison.yy"
                              { driver.option_num("block_static", "true"); }
#line 9733 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2339: // o_block_dynamic: BLOCK_DYNAMIC
#line 4362 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("block_dynamic", "true"); }
#line 9739 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2340: // o_incidence: INCIDENCE
#line 4363 "../preprocessor/src/DynareBison.yy"
                        { driver.option_num("incidence", "true"); }
#line 9745 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2341: // o_evaluate_planner_objective_periods: PERIODS EQUAL INT_NUMBER
#line 4366 "../preprocessor/src/DynareBison.yy"
                                                                { driver.option_num("ramsey.periods", yystack_[0].value.as < string > ()); }
#line 9751 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2342: // o_evaluate_planner_objective_drop: DROP EQUAL INT_NUMBER
#line 4367 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("ramsey.drop", yystack_[0].value.as < string > ()); }
#line 9757 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2343: // o_occbin_simul_maxit: SIMUL_MAXIT EQUAL INT_NUMBER
#line 4370 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_num("simul.maxit", yystack_[0].value.as < string > ()); }
#line 9763 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2344: // o_occbin_simul_periods: SIMUL_PERIODS EQUAL INT_NUMBER
#line 4371 "../preprocessor/src/DynareBison.yy"
                                                        { driver.option_num("simul.periods", yystack_[0].value.as < string > ()); }
#line 9769 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2345: // o_occbin_simul_curb_retrench: SIMUL_CURB_RETRENCH
#line 4372 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_num("simul.curb_retrench", "true"); }
#line 9775 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2346: // o_occbin_simul_check_ahead_periods: SIMUL_CHECK_AHEAD_PERIODS EQUAL INT_NUMBER
#line 4373 "../preprocessor/src/DynareBison.yy"
                                                                                { driver.option_num("simul.check_ahead_periods", yystack_[0].value.as < string > ()); }
#line 9781 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2347: // o_occbin_simul_max_check_ahead_periods: SIMUL_MAX_CHECK_AHEAD_PERIODS EQUAL INT_NUMBER
#line 4374 "../preprocessor/src/DynareBison.yy"
                                                                                        { driver.option_num("simul.max_check_ahead_periods", yystack_[0].value.as < string > ()); }
#line 9787 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2348: // o_occbin_simul_reset_check_ahead_periods: SIMUL_RESET_CHECK_AHEAD_PERIODS
#line 4375 "../preprocessor/src/DynareBison.yy"
                                                                           { driver.option_num("simul.reset_check_ahead_periods_in_new_period", "true"); }
#line 9793 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2349: // o_occbin_simul_debug: SIMUL_DEBUG
#line 4376 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("simul.debug", "true"); }
#line 9799 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2350: // o_occbin_simul_periodic_solution: SIMUL_PERIODIC_SOLUTION
#line 4377 "../preprocessor/src/DynareBison.yy"
                                                           { driver.option_num("simul.periodic_solution", "true"); }
#line 9805 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2351: // o_occbin_likelihood_inversion_filter: LIKELIHOOD_INVERSION_FILTER
#line 4380 "../preprocessor/src/DynareBison.yy"
                                                                   { driver.option_num("likelihood.inversion_filter", "true"); }
#line 9811 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2352: // o_occbin_likelihood_piecewise_kalman_filter: LIKELIHOOD_PIECEWISE_KALMAN_FILTER
#line 4381 "../preprocessor/src/DynareBison.yy"
                                                                                 { driver.option_num("likelihood.inversion_filter", "false"); }
#line 9817 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2353: // o_occbin_likelihood_maxit: LIKELIHOOD_MAXIT EQUAL INT_NUMBER
#line 4382 "../preprocessor/src/DynareBison.yy"
                                                              { driver.option_num("likelihood.maxit", yystack_[0].value.as < string > ()); }
#line 9823 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2354: // o_occbin_likelihood_periods: LIKELIHOOD_PERIODS EQUAL INT_NUMBER
#line 4383 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.option_num("likelihood.periods", yystack_[0].value.as < string > ()); }
#line 9829 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2355: // o_occbin_likelihood_curb_retrench: LIKELIHOOD_CURB_RETRENCH
#line 4384 "../preprocessor/src/DynareBison.yy"
                                                             { driver.option_num("likelihood.curb_retrench", "true"); }
#line 9835 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2356: // o_occbin_likelihood_check_ahead_periods: LIKELIHOOD_CHECK_AHEAD_PERIODS EQUAL INT_NUMBER
#line 4385 "../preprocessor/src/DynareBison.yy"
                                                                                          { driver.option_num("likelihood.check_ahead_periods", yystack_[0].value.as < string > ()); }
#line 9841 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2357: // o_occbin_likelihood_max_check_ahead_periods: LIKELIHOOD_MAX_CHECK_AHEAD_PERIODS EQUAL INT_NUMBER
#line 4386 "../preprocessor/src/DynareBison.yy"
                                                                                                  { driver.option_num("likelihood.max_check_ahead_periods", yystack_[0].value.as < string > ()); }
#line 9847 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2358: // o_occbin_likelihood_periodic_solution: LIKELIHOOD_PERIODIC_SOLUTION
#line 4387 "../preprocessor/src/DynareBison.yy"
                                                                     { driver.option_num("likelihood.periodic_solution", "true"); }
#line 9853 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2359: // o_occbin_likelihood_max_kalman_iterations: LIKELIHOOD_MAX_KALMAN_ITERATIONS EQUAL INT_NUMBER
#line 4388 "../preprocessor/src/DynareBison.yy"
                                                                                              { driver.option_num("likelihood.max_number_of_iterations", yystack_[0].value.as < string > ()); }
#line 9859 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2360: // o_occbin_smoother_inversion_filter: SMOOTHER_INVERSION_FILTER
#line 4389 "../preprocessor/src/DynareBison.yy"
                                                               { driver.option_num("smoother.inversion_filter", "true"); }
#line 9865 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2361: // o_occbin_smoother_piecewise_kalman_filter: SMOOTHER_PIECEWISE_KALMAN_FILTER
#line 4390 "../preprocessor/src/DynareBison.yy"
                                                                             { driver.option_num("smoother.inversion_filter", "false"); }
#line 9871 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2362: // o_occbin_smoother_maxit: SMOOTHER_MAXIT EQUAL INT_NUMBER
#line 4391 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("smoother.maxit", yystack_[0].value.as < string > ()); }
#line 9877 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2363: // o_occbin_smoother_periods: SMOOTHER_PERIODS EQUAL INT_NUMBER
#line 4392 "../preprocessor/src/DynareBison.yy"
                                                              { driver.option_num("smoother.periods", yystack_[0].value.as < string > ()); }
#line 9883 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2364: // o_occbin_smoother_curb_retrench: SMOOTHER_CURB_RETRENCH
#line 4393 "../preprocessor/src/DynareBison.yy"
                                                         { driver.option_num("smoother.curb_retrench", "true"); }
#line 9889 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2365: // o_occbin_smoother_check_ahead_periods: SMOOTHER_CHECK_AHEAD_PERIODS EQUAL INT_NUMBER
#line 4394 "../preprocessor/src/DynareBison.yy"
                                                                                      { driver.option_num("smoother.check_ahead_periods", yystack_[0].value.as < string > ()); }
#line 9895 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2366: // o_occbin_smoother_max_check_ahead_periods: SMOOTHER_MAX_CHECK_AHEAD_PERIODS EQUAL INT_NUMBER
#line 4395 "../preprocessor/src/DynareBison.yy"
                                                                                              { driver.option_num("smoother.max_check_ahead_periods", yystack_[0].value.as < string > ()); }
#line 9901 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2367: // o_occbin_smoother_debug: SMOOTHER_DEBUG
#line 4396 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_num("smoother.debug", "true"); }
#line 9907 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2368: // o_occbin_smoother_periodic_solution: SMOOTHER_PERIODIC_SOLUTION
#line 4397 "../preprocessor/src/DynareBison.yy"
                                                                 { driver.option_num("smoother.periodic_solution", "true"); }
#line 9913 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2369: // o_occbin_filter_use_relaxation: FILTER_USE_RELEXATION
#line 4398 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_num("filter.use_relaxation", "true"); }
#line 9919 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2370: // o_occbin_write_regimes_periods: PERIODS EQUAL vec_int
#line 4402 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_vec_int("write_regimes.periods", yystack_[0].value.as < vector<int> > ()); }
#line 9925 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2371: // o_occbin_write_regimes_periods: PERIODS EQUAL vec_int_number
#line 4404 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_vec_int("write_regimes.periods", yystack_[0].value.as < vector<int> > ()); }
#line 9931 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2372: // o_occbin_write_regimes_filename: FILENAME EQUAL filename
#line 4405 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_str("write_regimes.filename", yystack_[0].value.as < string > ()); }
#line 9937 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2373: // o_occbin_write_regimes_smoother: SMOOTHER
#line 4406 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_str("write_regimes.type", "smoother"); }
#line 9943 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2374: // o_occbin_write_regimes_simul: SIMUL
#line 4407 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_str("write_regimes.type", "simul"); }
#line 9949 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2375: // o_occbin_graph_noconstant: NOCONSTANT
#line 4410 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("graph.steady_state", "false"); }
#line 9955 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2376: // range: symbol ':' symbol
#line 4413 "../preprocessor/src/DynareBison.yy"
        { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ':' + yystack_[0].value.as < string > (); }
#line 9961 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2377: // integer_range: INT_NUMBER ':' INT_NUMBER
#line 4416 "../preprocessor/src/DynareBison.yy"
                { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ':' + yystack_[0].value.as < string > (); }
#line 9967 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2378: // integer_range_w_inf: INT_NUMBER ':' INT_NUMBER
#line 4419 "../preprocessor/src/DynareBison.yy"
                      { yylhs.value.as < pair<string,string> > () = {yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()}; }
#line 9973 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2379: // integer_range_w_inf: INT_NUMBER ':' INF_CONSTANT
#line 4421 "../preprocessor/src/DynareBison.yy"
                      { yylhs.value.as < pair<string,string> > () = {yystack_[2].value.as < string > (), "Inf"}; }
#line 9979 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2380: // signed_integer_range: signed_integer ':' signed_integer
#line 4425 "../preprocessor/src/DynareBison.yy"
                       { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ':' + yystack_[0].value.as < string > (); }
#line 9985 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2381: // signed_integer_range: MINUS '(' signed_integer ':' signed_integer ')'
#line 4427 "../preprocessor/src/DynareBison.yy"
                       { yylhs.value.as < string > () = "-(" + yystack_[3].value.as < string > () + ':' + yystack_[1].value.as < string > () + ")"; }
#line 9991 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2382: // vec_int_number: INT_NUMBER
#line 4430 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < vector<int> > () = {stoi(yystack_[0].value.as < string > ())}; }
#line 9997 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2383: // vec_int_elem: vec_int_number
#line 4433 "../preprocessor/src/DynareBison.yy"
               { yylhs.value.as < vector<int> > () = yystack_[0].value.as < vector<int> > (); }
#line 10003 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2384: // vec_int_elem: INT_NUMBER ':' INT_NUMBER
#line 4435 "../preprocessor/src/DynareBison.yy"
               {
                 yylhs.value.as < vector<int> > () = {};
                 for (int i = stoi(yystack_[2].value.as < string > ()); i <= stoi(yystack_[0].value.as < string > ()); i++)
                   yylhs.value.as < vector<int> > ().push_back(i);
               }
#line 10013 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2385: // vec_int_1: '[' vec_int_elem
#line 4443 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < vector<int> > () = yystack_[0].value.as < vector<int> > (); }
#line 10019 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2386: // vec_int_1: '[' COMMA vec_int_elem
#line 4445 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < vector<int> > () = yystack_[0].value.as < vector<int> > (); }
#line 10025 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2387: // vec_int_1: vec_int_1 vec_int_elem
#line 4447 "../preprocessor/src/DynareBison.yy"
            {
              yylhs.value.as < vector<int> > () = yystack_[1].value.as < vector<int> > ();
              yylhs.value.as < vector<int> > ().insert(yylhs.value.as < vector<int> > ().end(), yystack_[0].value.as < vector<int> > ().begin(), yystack_[0].value.as < vector<int> > ().end());
            }
#line 10034 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2388: // vec_int_1: vec_int_1 COMMA vec_int_elem
#line 4452 "../preprocessor/src/DynareBison.yy"
            {
              yylhs.value.as < vector<int> > () = yystack_[2].value.as < vector<int> > ();
              yylhs.value.as < vector<int> > ().insert(yylhs.value.as < vector<int> > ().end(), yystack_[0].value.as < vector<int> > ().begin(), yystack_[0].value.as < vector<int> > ().end());
            }
#line 10043 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2389: // vec_int: vec_int_1 ']'
#line 4458 "../preprocessor/src/DynareBison.yy"
          { yylhs.value.as < vector<int> > () = yystack_[1].value.as < vector<int> > (); }
#line 10049 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2390: // vec_int: vec_int_1 COMMA ']'
#line 4459 "../preprocessor/src/DynareBison.yy"
          { yylhs.value.as < vector<int> > () = yystack_[2].value.as < vector<int> > (); }
#line 10055 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2391: // vec_str_1: '[' QUOTED_STRING
#line 4463 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < vector<string> > () = {yystack_[0].value.as < string > ()}; }
#line 10061 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2392: // vec_str_1: '[' COMMA QUOTED_STRING
#line 4465 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < vector<string> > () = {yystack_[0].value.as < string > ()}; }
#line 10067 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2393: // vec_str_1: vec_str_1 QUOTED_STRING
#line 4467 "../preprocessor/src/DynareBison.yy"
            {
              yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > ();
              yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
            }
#line 10076 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2394: // vec_str_1: vec_str_1 COMMA QUOTED_STRING
#line 4472 "../preprocessor/src/DynareBison.yy"
            {
              yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > ();
              yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
            }
#line 10085 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2395: // vec_str: vec_str_1 ']'
#line 4478 "../preprocessor/src/DynareBison.yy"
          { yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > (); }
#line 10091 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2396: // vec_str: vec_str_1 COMMA ']'
#line 4479 "../preprocessor/src/DynareBison.yy"
          { yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > (); }
#line 10097 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2397: // vec_value_1: '[' signed_number
#line 4483 "../preprocessor/src/DynareBison.yy"
              { yylhs.value.as < vector<string> > () = {yystack_[0].value.as < string > ()}; }
#line 10103 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2398: // vec_value_1: '[' COMMA signed_number
#line 4485 "../preprocessor/src/DynareBison.yy"
              { yylhs.value.as < vector<string> > () = {yystack_[0].value.as < string > ()}; }
#line 10109 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2399: // vec_value_1: vec_value_1 signed_number
#line 4487 "../preprocessor/src/DynareBison.yy"
              {
                yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > ();
                yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
              }
#line 10118 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2400: // vec_value_1: vec_value_1 COMMA signed_number
#line 4492 "../preprocessor/src/DynareBison.yy"
              {
                yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > ();
                yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
              }
#line 10127 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2401: // vec_value: vec_value_1 ']'
#line 4498 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > (); }
#line 10133 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2402: // vec_value: vec_value_1 COMMA ']'
#line 4499 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > (); }
#line 10139 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2403: // vec_value_w_inf_1: signed_number_w_inf
#line 4503 "../preprocessor/src/DynareBison.yy"
                    { yylhs.value.as < vector<string> > () = {yystack_[0].value.as < string > ()}; }
#line 10145 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2404: // vec_value_w_inf_1: vec_value_w_inf_1 signed_number_w_inf
#line 4505 "../preprocessor/src/DynareBison.yy"
                    {
                      yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > ();
                      yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
                    }
#line 10154 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2405: // vec_value_w_inf_1: vec_value_w_inf_1 COMMA signed_number_w_inf
#line 4510 "../preprocessor/src/DynareBison.yy"
                    {
                      yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > ();
                      yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
                    }
#line 10163 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2406: // vec_value_w_inf: '[' vec_value_w_inf_1 ']'
#line 4517 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > (); }
#line 10169 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2407: // vec_of_vec_value_1: vec_of_vec_value_1 COMMA vec_value
#line 4521 "../preprocessor/src/DynareBison.yy"
                     {
                       yylhs.value.as < vector<vector<string>> > () = yystack_[2].value.as < vector<vector<string>> > ();
                       yylhs.value.as < vector<vector<string>> > ().push_back(yystack_[0].value.as < vector<string> > ());
                     }
#line 10178 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2408: // vec_of_vec_value_1: vec_value
#line 4526 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < vector<vector<string>> > () = {yystack_[0].value.as < vector<string> > ()}; }
#line 10184 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2409: // vec_of_vec_value: '[' vec_of_vec_value_1 ']'
#line 4530 "../preprocessor/src/DynareBison.yy"
                   { yylhs.value.as < vector<vector<string>> > () = yystack_[1].value.as < vector<vector<string>> > (); }
#line 10190 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2410: // symbol: NAME
#line 4533 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10196 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2411: // symbol: ALPHA
#line 4534 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10202 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2412: // symbol: BETA
#line 4535 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10208 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2413: // symbol: NINV
#line 4536 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10214 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2414: // symbol: ABAND
#line 4537 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10220 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2415: // symbol: CMS
#line 4538 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10226 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2416: // symbol: NCMS
#line 4539 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10232 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2417: // symbol: CNUM
#line 4540 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10238 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2418: // symbol: GAMMA
#line 4541 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10244 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2419: // symbol: INV_GAMMA
#line 4542 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10250 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2420: // symbol: INV_GAMMA1
#line 4543 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10256 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2421: // symbol: INV_GAMMA2
#line 4544 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10262 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2422: // symbol: NORMAL
#line 4545 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10268 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2423: // symbol: UNIFORM
#line 4546 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10274 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2424: // symbol: EPS
#line 4547 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10280 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2425: // symbol: PDF
#line 4548 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10286 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2426: // symbol: FIG
#line 4549 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10292 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2427: // symbol: NONE
#line 4550 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10298 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2428: // symbol: DR
#line 4551 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10304 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2429: // symbol: PRIOR
#line 4552 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10310 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2430: // symbol: TRUE
#line 4553 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10316 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2431: // symbol: FALSE
#line 4554 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10322 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2432: // symbol: BIND
#line 4555 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10328 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2433: // symbol: RELAX
#line 4556 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10334 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2434: // symbol: ERROR_BIND
#line 4557 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10340 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2435: // symbol: ERROR_RELAX
#line 4558 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10346 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2436: // symbol: KIND
#line 4559 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10352 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2437: // symbol: LL
#line 4560 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10358 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2438: // symbol: DL
#line 4561 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10364 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2439: // symbol: DD
#line 4562 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10370 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2440: // symbol: ADD
#line 4563 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10376 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2441: // symbol: MULTIPLY
#line 4564 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10382 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2442: // symbol: MFS
#line 4565 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10388 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;


#line 10392 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // parser::context.
  parser::context::context (const parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    const int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        const int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        const int yychecklim = yylast_ - yyn + 1;
        const int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }






  int
  parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short parser::yypact_ninf_ = -3833;

  const short parser::yytable_ninf_ = -2430;

  const short
  parser::yypact_[] =
  {
    7743,   451,   455,  -164, 13495,  -136,   119,  -102,   -38,   -37,
   14145,   607,    -6,     2,   186, 15055,   302,   -17,   461,   702,
      27,    32, -3833,    41, 15213,    84,   768,    93,   773,   814,
     860,   121,   960,   127,   147,   173,  1034, 13589,  1112,  1119,
     201,   245,   257, -3833,  1120,   267,   308,   329, 15327, 20713,
   20713, -3833, 15948,  1147,  1148,  1161,  1190, 20713,   221,  1195,
    1198, 15373,  1199,  1202,  1206,   354,  1209, 15416, 15574,  1210,
   15628,   387, 15674,  1230,  1246,  1250,  1253, 15736, -3833, -3833,
   -3833, -3833, -3833, 20713, 15990, 20713, 20713, -3833, -3833, 20713,
     369, 15790, 20713,  1257,  1260,  1263,   445,   373,   457,   464,
    1266,  1267,   590,  1272, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833,  1276,   598, 15832,  1277,  1280,  1286,
    1289,  1299,  1305, -3833,   606,   585,   611,   597,   614,   630,
     662,   619,   677, -3833, -3833, -3833, -3833, -3833, -3833,  1306,
   16149,   703,   710,   713, 20713,   721,  1310,  1314,  1317,   449,
    7120, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833,   377, -3833, -3833,  1171, -3833, -3833,  1215,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833,   381,   741,  2835,   744,  3461,  1408,
   -3833,  3041,  4995, -3833,   440, -3833,  1254,   592,  1175, 20713,
   -3833,  1456,  5052,   362, 20225, 20225, 20713,   410, -3833, 11752,
    5298, 17141,  1287, 17607, 17717,  1578, -3833,  1349,  1500, 20713,
    1588, -3833,  1434,  6061, 20713, 20713,  1562,  1671, 20713,   847,
   -3833,   536, 20713,  1579,  1671, 20713,  1288, 20225,  1440, -3833,
   -3833,   454, -3833,  1442,   869,  3866, -3833, -3833,   180,  1235,
     276, -3833, 20713, 20713,   534,   556, 20713, 20713, 20713, -3833,
   12079,  6117,  7835,  7865,   218, 14114,  1356,  7909, -3833,   557,
   -3833, 11533, -3833,   531, -3833, 20043,  8166, 20225,   583,   360,
    1268,  1369, -3833,  1430,  8210, 20319,  1468, -3833,  4276, -3833,
    1353, -3833, -3833,  1613, -3833, 12302,  8241, -3833,  1455,  8267,
   -3833,  1196, -3833, 12377,  8333,  1469, -3833,  3049,  8425, -3833,
     633, -3833, 10005, -3833,  1727, -3833,  1251, -3833,  1421,  8583,
    8639,   480,  8671,  8741,  8831, 20713, 20713,  8857,   726, -3833,
    3402,  9015,  9042,  1357, -3833,  1481, -3833,  1510, -3833,  1514,
   -3833,   350, -3833,   292, -3833, 18223, -3833, 18223,   591, 20713,
    1511, -3833,  6334,  1179, -3833,  2529,  9104, -3833,  4508, -3833,
   12473, -3833,  1243, -3833,  1274, -3833,   892, -3833,  4498,  1008,
    1041, -3833,   979, -3833,   932,   236,   236, -3833, 20713, -3833,
   12635, -3833,  9202,  7661,  7661,   454,  9289, 17141, -3833,  1042,
    1083,  1507, 20713,  1512,  1262, -3833, -3833, 12666, 20713, 13653,
   17790, 15250, 19898, -3833,  1750, -3833,  1755,  1777,  1778,  1786,
    1809, -3833,  1812,  1819,  1820, -3833,  1823,  1824,  1827,  1853,
   -3833,  1881,  1186, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
    1864,  1889,  1909, -3833,  1951,  1232, -3833, -3833, -3833,  1966,
    1950, -3833,  1967,  1971, -3833, -3833,  1989, -3833, -3833, -3833,
   -3833, -3833, -3833,  1297,  2019, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, 20713, -3833, -3833, -3833, -3833, -3833,
   -3833,  1308, -3833,  2014,  2023,  2024,  2032,  2033,  2038,  2042,
    2045,  2046,  2047, -3833,   352, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833,  2048,  2049,  2053,
    2054,   353, -3833, -3833, -3833, -3833, -3833, -3833, 20713,   588,
   -3833,  2076,  2060, -3833, -3833, -3833,  2061, -3833,  2065,  2066,
    2067, -3833,  2069, -3833,  2070, -3833,  1374,  2095, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833,  1379, -3833,  1381,  1384, 18335, -3833,   463,
    1385,  2085, -3833, -3833,  2087,  2088, -3833, -3833, -3833,  2089,
    2090,  2092, -3833, -3833, -3833,  2097,  2105,  2107, -3833,  2109,
    2110, -3833, -3833,  2111,  2112, -3833,  2119,  2120,  2122, -3833,
    2126,  2127, -3833, -3833, -3833,  2133,  2136,  2137,  2138,  2141,
    2142,  2145,  2147,  2148,  2149, -3833,  2150,  2154, -3833, -3833,
    2155,  2157,  2158,  2161, -3833,  2162,  2163,  2164,  2165,  2169,
   -3833, -3833,  2171,  2172,  2173,  2174, -3833,  2175,  2176,  2177,
    2182,  2183,  2187,  2194,  2195,  2196,  2197,  2198, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833,  2200,  2203, -3833,
    2207, -3833,  2208,  2209,  2210,  2212, -3833, -3833, -3833,  2215,
    2216,  2217, -3833,  2219, -3833,  2223, -3833, -3833, -3833,  2226,
    2230,  2237,   356, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, 20713, -3833, 20713,  7038,
   -3833,   392, -3833,  1396, 20713, 20713, 17400, -3833,  2259, 20713,
   20713, 17487, -3833,  2265,  1547, -3833,  2253,  2255, -3833,  1557,
    2279, -3833, -3833, -3833, -3833, -3833, -3833, -3833,   237, 18412,
   -3833,  2281,  2261,  2262,  2266,  2268,  2269,   379, -3833,   418,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833,  1571, 18447, -3833,
    1575,  1577,  2289,  2296,  2302,  2304,  2314,  2315,   420, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, 18493, -3833,  2337,  1619,  2320,  2324,  2326,  2336,
    2338,  2339,  2348,  2350,  2356, -3833, -3833, -3833, -3833, -3833,
    2357,  2359,  2360,  2362,  2371,  2374,  2381,  1689,  2413, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, 18519, -3833,  2393,  1697,   421, 18605,
   -3833,   388,  1705,  1709,  2414, 14114, 13956,  2469, -3833, -3833,
    2475,  2479, -3833, -3833,  2485, -3833,  2488,  2490, -3833,   422,
    2492,  1785,   621, 20225, -3833,  1797, -3833, -3833, -3833,   423,
   -3833, -3833, -3833, -3833, 20713, -3833,   600, -3833,  2500, -3833,
     327, -3833, 18713, -3833,  2523, 18764, -3833,  1805,  1813,  2532,
     576, -3833,  1837,  2558, -3833, -3833, 18794, -3833,  1843, 18832,
   18871,  5760,  2544,  2550,  2563, -3833,  2568,  2571,  2597,  2600,
    2610, -3833, -3833, -3833, -3833, -3833, -3833, -3833,  2612,  2616,
   -3833,   424, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, 20713, -3833,
     223,  1919, 14219,  1129, -3833, -3833, -3833,  1920,  1921,  1923,
    1925,  1926,  1927, 14114, 14114,  1937,  1939,  1943,  1944,  1947,
    1953,  1958,  1960,  1962,  1973,  1974,  1975,  1977,  1978,  1979,
    1985,  1986,  1991,  1993,  1994,  1995,  1997,  1999,  2000,  2002,
    2006,  2008, 14114,  3094, -3833,    51,  1311,  2648, -3833, -3833,
     426, -3833, -3833, -3833, -3833,  2664,  2665, -3833,  2707,  2712,
   -3833, -3833,  2713, -3833,  2714,  2716,  2720,  2721,  2725,  2727,
    2729,  2735,  2737, -3833,  2738,  2739,   428, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833,   429, -3833, -3833, -3833, -3833, -3833,
     431, -3833, -3833, -3833,  2041, 20713, 20713,   561, -3833, -3833,
     432,   433,  2741, 20713,   647, -3833,  2044,  2745,  2748, -3833,
    2750,  2751, -3833,  2059,  2773, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833,  2761, 18146, -3833,  2764,  2766, -3833, -3833,   435,
   -3833,  2768,  2770,  2771,  2772,  2775,  2074,  2795, -3833, -3833,
   -3833, -3833, -3833, 12001,   439, -3833,  2777,  2778, -3833,   443,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,  2780,  2781,
    2783,  2788,  2096,  2810, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833,  2794,  2797,  2798,
     446, -3833, -3833, -3833, -3833, -3833,   448, -3833, -3833, -3833,
   -3833,  1321,   609, -3833,  2799,  2804,   459, -3833, -3833, -3833,
   -3833, -3833,  2806,  2807,  2101,  2832, -3833, -3833,  2812,  2814,
    2815,  2816,  2817,  2821, -3833, -3833, -3833,  2824,  2828, -3833,
    2829,  2830,  2833,  2834, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833,  2836,  2114,  2853, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833,  2139,  2856, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833,  2839,  2840, -3833, -3833,  2143,  2862,
   -3833, -3833, -3833, -3833, -3833,  2146,  2865, -3833, -3833, -3833,
    2846,   462,  2848, -3833, -3833, -3833,  9360, -3833,  9405, -3833,
   -3833,  2849,  2850,  2863,  2866,  2867,  2869,  2870,   466, -3833,
    2873, -3833, -3833, -3833, -3833, -3833,  2877,  2879,  2880, -3833,
    2881,  2883,  2884, -3833, -3833, -3833,  2886,  2887,  2189,  2910,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, 20713, -3833,  2537, -3833,  2191,  2192,  2193,  2893, -3833,
    2898,   468, -3833, -3833, -3833, -3833,   802,  2900,  2901,  2928,
     469, -3833, -3833, -3833, -3833,  2929,  2944,  2957,  2958,  2959,
    2960,  2962,  2964,  2966,  2968,  2969,  2970,  2971,  2972,  2973,
    2974,  2978,  2980,  2983,  2984,  2985,  2986,  2987,  2988,  2989,
    2993,  2995,  2996,  2997,  2998,  2999,  2301,  3022, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
    2303,  3003,  3006,  3008,  3010,   471, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, 19030, -3833, 17912,  3011,  3012,  3013,
    3015,  3016,  3017,  3018,  3021,  3023,  3024,  3026, -3833,  3027,
   -3833,  3028,  3029,  3030,  3031, -3833,  3033,  3034,  3035,  3036,
    3040,  3044,  3045,  3046,  3047,  3048,  3050,  3054,  3055,  3057,
    3058,  3061,  3063,  3065,  3066,  3079,  3080,  3086,  3089,  3096,
    3098,  3099,  3100,  3101,  3043,  2403, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833,  3103, -3833, -3833,  3107,  3109,  3110,
    3111,  3112,  3113,  3114,  3117,  3118,  3119, -3833,  3127,  3070,
    2430, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833,  3153,  2434, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833,  3134, -3833,  3137,  3150,  3152,  3154,  3156,
    3159,  3161,  3162,  3163,  3165,  3179,  3180,  3181,  3182,  3183,
    3174,  2486, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833,  3184,  3188, -3833,
    3191,  3213,  2496, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
    3196,  3197,  3198,  3199, -3833,  3222,  2503, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833,  3224,  2505, -3833, -3833,
   -3833, -3833,  3205,  3228,  2520, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,   840,
    3220,  3223,  3227,  3230,  3231,  3232,   473, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833,  3052, -3833, -3833,  3233,   475, -3833,
   -3833, -3833, -3833, -3833,  3234,  3237,  3239,  3241,   476, -3833,
   -3833, -3833, -3833, -3833,  3242,  3246,   477, -3833, -3833, -3833,
     478,  3071,  2525,  3248,  3253,  3254,  3256,  3257,  3259, -3833,
   -3833, -3833, -3833,  3260,  3261, -3833,  3262,  3263,  3264,  3266,
    2572,  3293, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, 20713, -3833,   479,  3273,   481,   483, -3833,
    2578, 17186, -3833, -3833,  2576, 20713, 20713,   595, -3833,  3060,
    2577, 19097, -3833,  3298,  2582,  2583, -3833,  2585,  2587,  2592,
    2586,   496, -3833,  3291,  2594,  2598,  2599,  2595,  2601,  2602,
    2605,  2603, -3833,  2607,  2621,  2622,  2623, -3833, 15250, 15250,
    2624,  2627,  2628,  2629,  2630,  2631,  2632,  2633,  2634,  2637,
    2638,  2639,  2641,  2642,  2644,  2647,  2649,  2650,  2655,  2659,
    2660,  2661, 15250,  3777, -3833,   120, -3833, -3833,  2662,   382,
    2643,   621,  1350,   621,  3296,  1350,  3297, 20225,  3300,   306,
    3301,  3303, 20412, 20713,  2835,  3305,  3306,   621,  3308,  3461,
    3309,  3136,  2682,  3315,   621,  1472, 16195,  3041, -3833, 20713,
    3316,  3319,  3320,   621,   621,   621,  3321,   621,  3322,  2694,
    1254,  2697,   621,  2696,  3329,  3331,   592,  2705,  2706,  2709,
   -3833, 20713, 20225,  1208,  1160,  1500,  1500, 20713,  3334, 16249,
    1456, -3833, 16308, 16355,  2711, -3833, 15250, 15250, 15250,  2718,
    3339,  3340,  3172,   621, 20713,   621,   621,   621,  3351, 20225,
     306,  1165,   306,  3352,  2726,   621,   621,  3356,  1431,   621,
     621,   621,   621,   621,   621,   621,   621,   621,  3358,  3366,
   20225, 20225, 20225,  3367,   570,  3368,  3369, 20383, 20225,  3371,
    2682,  2742,  2742,  3374, 19830,  3375,   495,   621,  1501,  1323,
    3377, 20713,  1412,  1496,  2752,  3379,  3380,   621,  2754,   579,
    3385,  3388,  1352,  2760,  3401,  2682,  3403,   621,  3405, 11752,
   16409,  3318, -3833,  2779, -3833,   883, -3833,  2782,  3497,  3501,
    2785, -3833, 15250,  3509,  3512,  2796, -3833, 15250,  2801,  3430,
    3431,  2808,  1349,  3434,  2809,  2811, -3833, 15250,  3265,  3267,
    3286,  3287,  3289,  1588,  2837,  1434, 16466,  2803,  2838, -3833,
     492,  2843, 20713, 20225,   564,   617,   672,   737,  1671,  2847,
    2854, -3833, 15250,  2855,  1350,   621,  3440,  3466,   492,  3467,
    3468, 20016,  3473,  3480,  3483,   621,   621,   621,  3484,  3485,
    2859,   536,  2860, -3833, 15250,  2861,  2885,  2888, -3833, 20713,
    3489,  2890,  2891, -3833, 13548,  5689, 20713, 20713, 12824, -3833,
    1022, -3833,   621,   621,  2882,  2892,  3510,  3513,   454,  2895,
     516, 20225,  2896,  2894,   621,   180,  2902,  2905,  2906, -3833,
    3514,  2908, -3833,  2909, -3833, 20713,  2911, -3833,   492, -3833,
   20713,  2912, -3833,  2913,   556,  2914, -3833, 15250,  2915,  2916,
    5944, 20713,  6082,   621,  3520, 20067,   621,  3525,  3527,   621,
    3528,   621,  3537, 12079, 16513,   230,  1919, -3833, -3833, 20713,
   -3833,  3614, 13008, -3833, -3833, 14114, 14114, 14114, 14114, 20713,
   20713,  3258,  3258, 14114, 14114, 14114, 14114, 14114, 14114, 14114,
   14114, 14114, 14114, 14114, 14114, 14114, 14114, 14114, 14114, 14114,
   14114, 14114, 14114, 14114, 14114, 14114, 14114, 14114,   492, 20713,
    3581, 14114, 14114, 14114, 14114, 14114, 14114, 14114, 14114, 14114,
   14114, 14114,  2938, 20713,  2939, -3833, -3833, -3833,  3567,   557,
    2942,   621,   621,  3572,   621,  3574,  3575,  3578,   621,   621,
     621,   621,   621,   621,  3579,   621,  2951, 11533,  2954,   531,
    2955, 20043,  2956,  2961,  3674,   470,  2963, -3833,    -5,  2965,
    3441,  2967,  3587,  2975,  2976, -3833,  2977,   484,  3591, 20713,
   20713, 16567,  1430, 20713,  2981, -3833, 20713, 20713,  4276,  2982,
   20225,  2990, 20225,  3001,  3593,  2991,  1353, 20713,  5640, -3833,
    3664,  1613,  3000,   621,  2682, 12302, 16624,  3596,   306,  3598,
    2682, 16671,  1455,  3002, 15250,  3343,  1196,  3005, 12377, 16727,
   15250, 15250, 15250, 15250,  3007, -3833,  3600,   621,  3049, 16782,
    3601,  3605,  3009,   633,  3607,  3610,  3613,  3615,  3628,  3633,
    3635,  3637,  3638,  3640,  3641,  3649,  3650,  3032, 10005,  3051,
    1727, 20225,   306,  3053,  1251, 16829,  1421, -3833,  3166, 20713,
   -3833, 20713, -3833, -3833, 20713, -3833, -3833, -3833, 20713, 15250,
   20713, 20713,  3651,   492,   726,  3056, 20225,  1391,  3653,  3654,
    1203,  1500,  1500, 20713,  3655, 16885,  3402,  3400, -3833,  3059,
    3062,  3067, 20713,  3064,   350,  3069,  3726,  3727,  3730, -3833,
    3741,  3743,   497, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   20713,  3064,  3064,   292,  3087,  3675,  3676,  3677,  3681,  3682,
    3684,  3687,  3688,  3690,  3692,  3693,  3697,  3716,   621,  3731,
    3104,   621,   621,  3108,  3116,  3120,  3733,  3736,  3121,   621,
    3738,   621,   621,   621,   621,   621,  3115, 18223,  3124, 20225,
    1500,  1500,  3739,   591,  3125,  3126, -3833, 20713,  3129, 20713,
     397,  3740,  3748,  3754,  3757, 20225,  3769,  3142,  3772,   542,
    3774,  3775,  3784,  3786,  3788,   621,   621,  3789,  3790,  3791,
    3792,  3793,  3794,   621,  3796,  3797,  3798,  3800,  3803,  3804,
    3805,  3807,  3808,  3812,  3813,  3815,  3818,  3819,  3820,  3821,
    3822,  3823,  2742,  6334,  3200, -3833,  3824, 20225,  3825, 20225,
   20225,  2742,  3828,  3829,  2742,  1350,  3830,  2529, 16941,  4508,
    3204,   197,   621,   621,   621,  3833,   621,  3834,  3835,   621,
     621,  3836,  3837,  3840,  3841,   621,   621, 12473,  3215,  3853,
    3855,  3857,  1243,  3236,  3858,  1350,  1350,  3860,  1274,  3238,
     892,  3240,  3861,  4498,  3243,  3271,   117,  3244,  3245,   805,
   -3833,  3201,  3270,  3864,   580,  3869,  3873,  1041,  3247, -3833,
     610, -3833,   306,   979,  3250, 20500,  3888, 20500, 20500,   932,
    3268, 20225,  3890,   236,  3269,  3275,  3569,   613, -3833,  3276,
     621,  1164,  3531,  3891,  3064,   621,  3892,  3893,   621,  3897,
   20225,   621,  3277, 12635,   376, -3833, 11015,  3278,  3724,  3280,
    3281, -3833,  3282, -3833,  3283,  3304,  3310,  3311, -3833,  3932,
    3312,  3313, -3833, 20713,  3933,  3317,  3314, 20713, 20713, -3833,
    3921, 20713,  3323,  1500, 20713, 20713, -3833, 20739, 20713, 20713,
   -3833, 20438, 15250, 15250, 15250, 15250,  3634,  3634, 15250, 15250,
   15250, 15250, 15250, 15250, 15250, 15250, 15250, 15250, 15250, 15250,
   15250, 15250, 15250, 15250, 15250, 15250, 15250, 15250, 15250, 15250,
    3832, 15250, 15250, 15250, 15250, 15250, 15250, 15250, 15250, 15250,
   15250, 15250, -3833,  3324,  1737,  3325,   409, -3833,   621,   621,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,   608,
   -3833,   348, -3833, -3833, -3833, -3833, -3833, -3833,  3328, -3833,
    3330, -3833, -3833, -3833, -3833,  3337,  3338, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,  9447, -3833,
    9475, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
    3771, -3833, -3833, -3833, 20713, -3833, -3833, -3833, -3833,  3799,
   -3833,  3342, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
    1138, -3833,  3643,  3643, -3833, -3833, -3833,  9563, -3833, -3833,
    9661, -3833,  9721, -3833,  7691,  7801,  8052, 20713,  3344, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
    1138, -3833, -3833, -3833, -3833, 20713, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,   650,
     654, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833,   655,   375, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,  3771, -3833,
   -3833, -3833,  3771, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
    3773, -3833, -3833, -3833, -3833, -3833, -3833, -3833,  9748, 20713,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,  8086,
    4041,  3348,  4042, 17141, 20713, 15250, -3833,  1423, 20713, 15250,
   -3833,  8133, 17513, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
    1465, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
    9819, 19954, -3833, -3833,  3958,  3969,  3347, 20713, -3833, -3833,
    3643, -3833,  3643, -3833,  3643, -3833,  3643, -3833, -3833, -3833,
    1010, 19137, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833,  8175, 20713, -3833, -3833,  4060,  1157,  3350, 20713,
   -3833, 14114,  3354,  8206, -3833,   386,  4047,  3357, -3833, -3833,
   14114, -3833, -3833, -3833, 20713, 20225, -3833, -3833, -3833, -3833,
   -3833, -3833,  4927, -3833,   621,  3353, -3833, -3833,  3838, -3833,
   -3833,  1235, -3833,   539, -3833,  3359,   419,  4055, -3833,   634,
   -3833, -3833,  3856, -3833, -3833, 20713,  8240, 15250, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833,  9906,  1919, -3833, -3833, -3833,  3816, -3833, -3833,
    1550,  1566,  3927,  4053,  3361,  3363,  4066,  4088,  4227,  4267,
    4279,  4356,  4507,  4544,  4567,  4615,  4627,  4806,  4845,  4863,
    4901,  5125,  5179,  5245,  5273,  2579,  5302,  5418,   427,   506,
    5430,  3364,  3370, -3833,  2484,  2484,  1158,  1158,  1158,  1158,
    1275,  1275,  3258,  3258,  3679, -3833, -3833, 14114,  3373, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, 20713, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, 20713, 20713, 15250,   501, -3833,  3381,
    4064,   594,  3382,  1235,   498,  3846, -3833,   666, -3833, -3833,
   -3833, -3833, -3833, -3833, 10022, -3833, 10064, -3833, -3833, 10092,
    3408, -3833, -3833, -3833, 20713, -3833, 20713, -3833, -3833, -3833,
     368,  3372, -3833, 15250, -3833, -3833, -3833, -3833, -3833, -3833,
   10120, -3833, -3833, -3833, -3833, -3833, -3833, 10180, -3833, 20713,
    5065, -3833, -3833, -3833, -3833, -3833, 10278,  8395,  8471,  8552,
    8613, -3833, -3833, -3833, -3833, -3833, 10365, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, 10436, -3833, 14114,  4078, 10481, 14114,
   -3833, -3833, 14114, -3833,  5065, -3833, -3833,  3411, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,  1138, -3833,
    3643,  3643, -3833, -3833, -3833, 10523, -3833, -3833, -3833, -3833,
   -3833, -3833,   573,   346, -3833, -3833, -3833, 20713, 20713, 20713,
    4079, 20713,  1193,   802,  3425, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833,   570, -3833, -3833, -3833, 16037,
   16037, 16037, -3833, -3833, 16037, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
    3426, -3833,  3424, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, 20713, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, 14114, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, 10639, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833,  3997,  4056,  3428, -3833, -3833,  3432,
   -3833, 20713,  2742, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833,  4126,  3433, -3833, -3833, -3833, -3833, -3833, -3833,  3427,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833,  3435,  3443, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, 20713, -3833, -3833, 20713, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833,  3787,  3801, -3833,  3444,   485,  1083, -3833,  4176,
    1330,  3457, 20713,   724,  4179,  3481, -3833, -3833,   157,  4200,
    3487,  3494,  3505,  4204,  3488, -3833,  3507,  2701,  2774,  5464,
    5476,  5560,  5584,  5607,  5649,  5662,  5810,  5839,  6062,  6104,
    6116,  6195,  6246,  6320,  6333,  6349,  6369,  6490,  6508,  6529,
    6556,   521,   540, -3833,  2841,  2841,  1354,  1354,  1354,  1354,
    1326,  1326,  3634,  3634,  3679, 15250,  4188,  4190,  4211,   499,
   -3833, -3833, -3833, -3833,  1467,  3516,  4216, -3833, -3833,  4148,
    3521, -3833, -3833,   316, -3833, -3833, 20713, -3833, -3833,  3523,
   -3833, -3833,  4241, -3833, -3833,   500,  1300,  3932,  3529, -3833,
     502, -3833, -3833, -3833, -3833, -3833, -3833, 19192,  3539,   503,
    1407, -3833, -3833,  1350, -3833,   602, -3833, -3833,   504,   507,
    4257, -3833, -3833,   508, -3833, -3833,   883, -3833, 15250, 17447,
    4258,  2800, 15250,  4259,  8642, -3833,  3543, 17559, 15250, -3833,
   -3833,  3545,   413,  3541, -3833, -3833,  4245, 19223, 15250, -3833,
    3550, 19398, -3833, 19438,   150,  4178,  4269,  4270, 19556,  6592,
   -3833, -3833, 14114, 14114, -3833,  8707,  3102, -3833,   509, 13956,
   -3833,  3551, -3833,  3932,   680,   150,   663,  4251, 20713, -3833,
    1350,  3557,   638,  3559, 15250, -3833,  8803, -3833, -3833, -3833,
   14114, 14114, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833,  4013, -3833, -3833, 14114, -3833,
   14114, -3833, -3833,  3560, -3833,  3094,   517, 20713,  3157,  4261,
    4262,  8859, 15250,  3568,  4194,  3580,   653,  3582, -3833,   690,
    4052,  3585,  3932,  3586,   709, -3833, 20713, -3833, -3833, -3833,
    3588,  3522,  3702,  4271, -3833,  8889, -3833, -3833,  4837, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833,  6630, -3833, -3833,  6704,
    3094,   644,   518, -3833,  4027, -3833,   284, -3833, -3833, -3833,
   -3833, -3833, 14114, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833,   371, -3833, 18110,  3576,  3584,  3589,  3590, -3833,  3609,
    4875,  6788, -3833,  4298,  3611, -3833, -3833,   631, -3833,   411,
   15250, -3833,  1418, -3833,  1109, -3833,   417, 13956, 20713, 20713,
    4217,  4218,  3595,   205,   701, 15250,  4306,  4324, 19596,  4309,
    4310,  4318,  4319,  4320,  4321,  4322,  4323,  4343,   519, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   20713,  3603,  1500, 20713,  3642,  3870, 20713,  3644,  4264, 15250,
   15250, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, 15250, -3833, 15250, -3833,  5065,   520,  3104,
     621,  1350,  1737,  3657,  4350,  4354,   522, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,  1737,  3658,
   -3833,  4286, -3833, -3833, -3833, -3833,  1453,  3771, -3833, -3833,
     552, 20136,  1138, -3833,  3661, 20713, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833,   995,  3773, -3833,  5065,  4380,  4381,  4384,
   -3833,  3668, 15250, 15250,  9024, 15250, -3833, -3833,  3669,  9040,
    1737,  3670,   442, 15250,  3671,  9230, -3833,  3673,  3678, -3833,
   -3833, 15250,  3685, -3833, 20713, 20713,  3686, 20713,  1061,  9412,
   -3833, -3833, 20225, -3833, 12982, -3833,   554,  3689,  3694,   456,
    1340,  3667, 15250,  4370, -3833, -3833,  3695, -3833,  9875, -3833,
    6867,  6898,   523,  3147,  3365, 14114, 14114, -3833, 10681, -3833,
   15250, 15250, -3833, 10029,  1235,  3672, -3833,  3696,  1235,  3699,
   -3833,  3698,  1235,   558, -3833,  3700, -3833, 20319, -3833, -3833,
   15250, -3833, -3833, 20713, 14114, 20713, -3833, -3833, -3833, -3833,
   -3833, -3833,  3094,   570, -3833, -3833, -3833, -3833, -3833, -3833,
   20713, -3833, 20713, -3833,  3847, -3833,  2742, -3833, 10100, 14114,
   14114, 14114, 14114,  1418, -3833, 14114, 14114, 20713,   716, -3833,
   -3833, -3833, 13390,  3703,  3704, -3833,  3680,  4314,   637,   637,
   -3833,  3706, 10493, 20713, 20713,  3707,  1350,  2742,   621,  3270,
    1350,  2742,  1634,  2742,  2742,   724,  3708,  3709,  4295,  3643,
    3712, 20778, -3833,  3714, 20620, -3833,  6910,  7052,  3407,  3420,
   15250, -3833, -3833, -3833, -3833, -3833, -3833,  1350, 15250,  1467,
    3710,   524,  1467, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
    4049, -3833,  3691,   453,  3715, -3833, -3833, 19650,  4145, -3833,
   -3833, 15250, 15250, 15250, -3833,  3462, 10559, -3833, 10650, -3833,
   -3833,   525,  1467,  3717,  4398, 10957, -3833, -3833, -3833, -3833,
    3546, -3833,  4450,  4452, -3833, 10737, 14114, -3833, -3833, -3833,
    3746,   684, -3833, -3833,   492,   492,  4465,  4466, 11021,  1350,
   -3833, -3833, -3833, -3833,   314, -3833, 14114, 14114,  7066,  3094,
   -3833, 11070, 11304, -3833,   731,  3750, -3833,   740, -3833,  3751,
     742,  1108, -3833, 18214, 11405, 10839,  7161, 10895, -3833, 19715,
   10941, 14416,  4379,  3922, -3833, -3833, 11444, 11672, 11684, 11706,
   -3833, 11723, 11799,  3753,  3755, -3833,  3756, -3833, -3833,  4395,
   -3833, 15250,   364, -3833,   551, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
    3764,  3765,  3494,  3766,  3767, -3833,  3779, -3833, -3833, 15250,
   15250,  5065, -3833,  5065, -3833, -3833,  3778,   526,   637,  1737,
    3785,   444,  3802,  4496, -3833,   527,  4505, -3833,  4506, 15250,
   -3833, -3833,  3806,   528,  1737,  3809, -3833, 15250,   150,   150,
   -3833, 11814, -3833,   637,   637,   637,  3795, -3833,   150,   150,
   -3833, -3833,  3810,  3811,  7174,  7244, -3833, -3833, -3833,  3817,
    1235,  3831,  1235,  3839,   637,   637,  3842, -3833, -3833, 20713,
   -3833,  3843, -3833, 14532, 14834,  3826,  6129,  4486, 14416, -3833,
    4509,  4418, -3833, -3833, -3833, -3833,   250, -3833, -3833, -3833,
   -3833, -3833,  7256,   640,  3848, 15250, -3833,  4157,  4413, 20804,
    4021, 20686,  4415,  7327,  7455, -3833,  3844,   593,   529,  1467,
    3845,  4500, -3833,   661,  4145, -3833,  1476, 15250, 11827, -3833,
    3849,   530,  1467,  2941,  3850,  3851, -3833,   596,   599,   604,
     492,  3862,  3863, -3833, -3833, -3833, -3833, -3833,   774, -3833,
     807, -3833,   615,   622, -3833, 11053, -3833,  3859,  3871, 20713,
   14948, -3833,  6129, -3833, 20713,  4522, 14114, 20713,  1193,   250,
   -3833, -3833, 15250, -3833,   637,  7497,   637,  3494,  3814, -3833,
   -3833,  3867, -3833, -3833, -3833, -3833, -3833,  3875,   532,  1737,
    3874, -3833,  4524,  4525, -3833, -3833,  3879,   533, -3833, -3833,
   -3833, -3833, -3833, -3833,  3827, -3833, -3833,  3880,  3894, -3833,
   -3833, -3833, 20713, 20713,  4532,  3889, 14416, 11099, 20713, 12158,
    3895,  3907, -3833,  7565,   635, -3833,   665,  4038,  4431, -3833,
    3910,   535,  1467, 15250, 15250, -3833,  3911, -3833, -3833, -3833,
    4537,  4539,  4451, 20713,  3912, -3833, 11140, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833,  3913,   537, -3833,  4540,
   -3833,  4459,  4460,  3852,  4553, -3833, -3833, -3833,  3914, 15250,
    3854,  3868, -3833,  4464, -3833,  5065, -3833, -3833,  3887, -3833
  };

  const short
  parser::yydefact_[] =
  {
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2431,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2410,     0,     0,     0,     0,     0,     0,
       0,  1199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2430,  2432,
    2433,  2434,  2435,     0,     0,     0,     0,  1097,  1102,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2411,  2412,  2414,  2413,  2415,  2416,
    2417,  2418,  2419,  2420,  2421,  2422,  2423,  2424,  2425,  2426,
    2428,  2427,  2429,  2442,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   486,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2436,  2437,  2438,  2439,  2440,  2441,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     2,    47,    48,    95,    97,     5,   128,    32,    34,
      33,   121,     6,     7,     8,     4,     9,    10,    16,    12,
     111,    13,    14,    15,    31,   122,   123,   124,   129,   130,
      11,   125,   126,   127,    17,    19,    89,    90,    91,    92,
      18,    20,    21,    56,   112,   113,   114,   115,   118,   116,
     117,    22,    93,    23,    25,    27,    26,    28,    51,    29,
      30,    37,    38,     0,    35,    36,     0,    39,    40,     0,
      24,    41,    45,    42,    43,    44,    46,    49,    50,    52,
      53,    54,    74,    75,    76,    55,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    67,    68,    69,    70,   104,
     102,   103,   101,   100,    99,    98,    71,    72,    73,    86,
      88,    87,    94,   105,    96,   106,   107,   108,   109,   110,
     119,   120,   131,   132,     0,     0,     0,     0,     0,     0,
    1697,     0,     0,   137,     0,   559,     0,     0,     0,     0,
    1317,     0,     0,     0,     0,     0,     0,     0,   947,     0,
       0,     0,     0,     0,     0,     0,  1735,     0,     0,     0,
       0,  1666,     0,     0,     0,     0,     0,     0,     0,     0,
    1144,     0,     0,     0,     0,     0,     0,     0,     0,   324,
     371,     0,  1186,     0,  1193,     0,  1185,   565,     0,     0,
       0,  1744,     0,     0,     0,     0,     0,     0,     0,  1134,
       0,     0,     0,     0,   155,     0,     0,     0,   572,     0,
     579,     0,   609,     0,   615,     0,     0,     0,     0,     0,
       0,     0,  1305,     0,     0,     0,     0,   720,     0,  1761,
       0,  1691,   545,     0,   733,     0,     0,  1309,     0,     0,
    1202,     0,  1204,     0,     0,     0,  1279,     0,     0,  1215,
       0,  1221,     0,  1252,     0,  1264,     0,  1272,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1313,
       0,     0,     0,   142,  1298,     0,  1300,     0,  1302,     0,
    1304,     0,   191,     0,  1531,     0,  1533,     0,     0,     0,
       0,  1403,     0,     0,  1457,     0,     0,  1421,     0,  1529,
       0,  1490,     0,  1479,     0,  1467,     0,  1439,     0,     0,
       0,   310,     0,   507,     0,     0,     0,   328,     0,   621,
       0,  1321,     0,     0,     0,     0,     0,     0,   355,     0,
       0,     0,     0,     0,     0,     1,     3,     0,     0,     0,
       0,     0,     0,  1342,     0,  2058,     0,     0,     0,     0,
       0,  2000,     0,     0,     0,  2001,     0,     0,     0,     0,
    1330,  1341,     0,  1331,  1336,  1334,  1337,  1335,  1332,  1333,
    1338,  1339,  1323,  1324,  1325,  1326,  1327,  1328,  1329,  1350,
       0,     0,     0,  1344,  1349,     0,  1346,  1345,  1347,     0,
       0,  1980,     0,     0,  1965,  2007,     0,  2209,  2210,  2211,
    2212,  2213,  2297,     0,  1702,  1705,  1721,  1709,  1706,  1708,
    1703,  1707,  1713,  1718,  1719,  1704,  1714,  1717,  1710,  1711,
    1712,  1715,  1716,  1720,     0,  1699,   135,   219,   220,   221,
     222,     0,  2124,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   563,     0,   562,   549,   554,   556,   557,
     553,   564,   550,   551,   552,   555,   558,     0,     0,     0,
       0,     0,  1678,  1681,  1680,  1682,  1683,  1684,     0,     0,
    1688,     0,     0,  2045,  2032,  2028,     0,  2052,     0,     0,
       0,  1915,     0,  2050,     0,  1928,     0,  1644,  1651,  1657,
    1652,  1658,  1646,  1647,  1653,  1645,  1649,  1650,  1648,  1654,
    1655,  1656,  1319,     0,   133,     0,     0,     0,   301,     0,
       0,     0,  2009,  2259,     0,     0,  1970,  2201,  2133,     0,
       0,     0,  2271,  2272,  2273,     0,     0,     0,  2261,     0,
       0,  1881,  1901,     0,     0,  1968,     0,     0,     0,  1982,
       0,     0,  1963,  1964,  1967,     0,     0,     0,     0,     0,
       0,     0,     0,  1945,     0,  1961,     0,     0,  2002,  2003,
       0,     0,     0,     0,  1956,     0,     0,     0,     0,     0,
    1978,  1979,     0,     0,     0,     0,  1997,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2268,  2267,
    1914,  1969,  1900,  1902,  1903,  2061,  2062,     0,     0,  2010,
       0,  1950,     0,     0,  1973,     0,  1981,  1977,  1975,     0,
       0,     0,  2214,     0,  2296,     0,  2319,  2320,  2321,     0,
       0,     0,     0,   952,  1008,  1018,  1039,   993,  1029,  1042,
     953,  1064,  1065,   954,  1027,   955,  1069,  1071,   956,   957,
     958,   959,   960,   961,   962,   963,   964,   965,  1050,   966,
     967,   968,   969,   970,  1070,  1067,  1068,   971,   972,   973,
     974,   976,   977,   979,   978,   980,   981,   982,   983,   984,
     985,   986,  1000,   988,   989,   991,   992,   994,   995,   996,
     997,   998,   999,   990,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,  1043,  1044,  1046,  1045,  1047,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1019,  1020,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1080,  1081,  1054,  1055,  1056,
    1057,  1058,  1061,  1059,  1060,  1062,  1063,   987,  1066,  1021,
    1022,  1023,  1024,  1025,  1026,  1028,  1038,  1040,  1041,  1048,
    1073,  1072,  1049,  1051,  1052,  1053,  1082,  1083,   975,  1074,
    1075,  1076,  1077,  1078,  1079,   949,     0,   814,     0,     0,
     808,     0,   812,     0,     0,     0,     0,   834,     0,     0,
       0,     0,   828,     0,     0,  1823,     0,     0,  2289,     0,
    1738,  1739,  1740,  1741,  1742,  1743,   863,   864,     0,     0,
     844,     0,     0,     0,     0,     0,     0,     0,   318,     0,
    1670,  1672,  1674,  1675,  1676,  1673,  1668,     0,     0,   308,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   284,
     296,   286,   285,   295,   287,   288,   289,   290,   291,   292,
     293,   294,     0,  1662,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2326,  2327,  2328,  2329,  2330,
       0,     0,     0,     0,     0,     0,     0,     0,  1147,  1181,
    1156,  1148,  1155,  1159,  1161,  1162,  1163,  1165,  1168,  1160,
    1182,  1164,  1154,  1157,  1150,  1149,  1151,  1152,  1153,  1158,
    1166,  1167,  1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,
    1177,  1178,  1179,  1180,     0,   279,     0,     0,     0,     0,
    1756,     0,     0,     0,     0,     0,     0,     0,   357,   361,
       0,   364,   366,   363,     0,   362,     0,     0,   370,     0,
       0,     0,     0,     0,  1183,  1195,  2338,  2339,  2340,     0,
     568,   569,   570,   571,     0,   532,     0,   528,     0,   530,
       0,   526,     0,  1749,     0,     0,  1114,     0,     0,     0,
       0,  1731,     0,  1727,  1728,  1729,     0,  1110,     0,     0,
       0,     0,     0,     0,     0,  2188,     0,     0,     0,     0,
       0,  1810,  1811,  1812,  1813,  1990,  1989,  2189,     0,     0,
    1125,     0,  1124,   739,   740,   741,   742,   743,   744,   746,
     747,   748,   752,   753,   763,   764,   765,   766,  1126,  1127,
    1128,   767,   768,   769,  1130,   774,   749,   750,   751,  1129,
     783,   745,   754,   770,   771,   772,   773,   777,   778,   779,
     780,   761,   762,   775,   776,  1131,  1132,  1133,   781,   782,
     755,   756,   757,   758,   759,   760,  1136,  1122,     0,   216,
     153,   161,     0,     0,   158,   794,   793,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1200,   392,   388,  1187,     0,  1685,  2275,
       0,   575,   576,   577,   578,     0,     0,  1966,     0,     0,
    2274,  1805,     0,  1804,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2280,  2281,     0,     0,   582,   590,   583,
     591,   587,   586,   593,   594,   584,   597,   598,   599,   600,
     601,   585,   588,   596,   595,   589,   602,   603,   604,   605,
     606,   607,   608,   592,     0,   612,   613,   614,  2298,   620,
       0,   618,   619,   165,     0,     0,     0,     0,   468,   469,
       0,     0,     0,     0,     0,   483,     0,     0,     0,  1905,
    2292,     0,  1927,     0,  1590,  1592,  1597,  1596,  1601,  1595,
    1598,  1599,  1600,  1602,  1603,  1605,  1606,  1604,  1591,  1593,
    1594,  1307,     0,     0,  1773,     0,     0,   724,   725,     0,
     723,     0,     0,     0,     0,     0,     0,  1764,  1765,  1766,
    1767,  1768,  1769,     0,     0,   548,     0,  1826,  2134,     0,
     784,   738,   789,   788,   785,   786,   787,   735,     0,     0,
       0,     0,     0,  1608,  1610,  1612,  1611,  1615,  1616,  1617,
    1618,  1619,  1620,  1609,  1613,  1614,  1311,     0,     0,     0,
       0,  1289,  1290,  1291,  1292,  1295,     0,  1294,  1296,  1297,
    1206,     0,     0,  1210,     0,     0,     0,  1284,  1285,  1287,
    1286,  1281,     0,     0,     0,  1218,  1219,  1220,     0,     0,
       0,     0,     0,     0,  2345,  2355,  2364,     0,     0,  2348,
       0,     0,     0,     0,  2349,  2367,  2350,  2358,  2368,  2351,
    2360,  2369,  2352,  2361,     0,     0,  1224,  1226,  1225,  1227,
    1228,  1229,  1232,  1231,  1230,  1240,  1241,  1234,  1233,  1235,
    1236,  1237,  1238,  1239,  1248,  1249,  1243,  1242,  1244,  1245,
    1246,  1250,  1247,  1251,     0,  1255,  1257,  1256,  1258,  1259,
    1260,  1261,  1262,  1263,     0,     0,  2374,  2373,     0,  1267,
    1268,  1269,  1270,  1271,  2375,     0,  1277,  1278,  1274,  1116,
       0,     0,     0,   170,   213,   214,     0,  1101,     0,  1106,
     215,     0,     0,     0,     0,     0,     0,     0,     0,   202,
       0,  2046,  2029,  2030,  2031,  2027,     0,     0,     0,  2051,
       0,     0,     0,  1916,  1904,  2049,  1917,     0,     0,  1622,
    1640,  1625,  1641,  1642,  1626,  1627,  1628,  1629,  1630,  1632,
    1631,  1636,  1637,  1633,  1634,  1635,  1638,  1639,  1623,  1624,
    1315,     0,   217,   140,   145,     0,     0,     0,     0,  1860,
       0,     0,   181,   182,   183,   184,     0,     0,     0,     0,
       0,   187,   188,   189,   190,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1536,  1583,  1569,
    1570,  1571,  1572,  1573,  1585,  1574,  1575,  1576,  1577,  1578,
    1580,  1579,  1584,  1586,  1537,  1538,  1539,  1540,  1541,  1542,
    1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,
    1561,  1553,  1554,  1562,  1564,  1563,  1555,  1556,  1565,  1557,
    1558,  1559,  1560,  1566,  1567,  1568,  1581,  1582,  1587,  1588,
       0,     0,     0,     0,     0,     0,   869,   870,   871,   872,
     873,   874,   875,   876,     0,  1782,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2152,     0,
    2153,     0,     0,     0,     0,  2155,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1402,     0,  1353,  1399,  1354,  1355,
    1356,  1357,  1358,  1359,  1360,  1361,  1362,  1363,  1364,  1365,
    1366,  1367,  1368,  1369,  1370,  1371,  1372,  1373,  1374,  1375,
    1376,  1377,  1378,  1379,  1380,  1381,  1382,  1383,  1384,  1385,
    1386,  1387,  1388,  1389,  1390,  1391,  1392,  1393,  1394,  1395,
    1396,  1397,  1398,  1400,     0,  2244,  2255,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2253,  2246,     0,  1456,
       0,  1441,  1442,  1443,  1450,  1444,  1445,  1446,  1447,  1448,
    1449,  1451,  1452,  1454,  1453,  1459,  2248,  1420,     0,  1405,
    1406,  1407,  1413,  1417,  1418,  1408,  1409,  1410,  1411,  1412,
    1414,  1416,  1415,     0,  2218,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1528,     0,  1498,  1499,  1500,  1493,  1494,  1495,  1496,  1497,
    1501,  1502,  1503,  1504,  1505,  1506,  1507,  1508,  1509,  1510,
    1511,  1492,  1512,  1513,  1514,  1515,  1516,  1517,  1518,  1519,
    1520,  1521,  1522,  1523,  1524,  1525,  1526,     0,     0,  2238,
       0,  1489,     0,  1484,  1483,  1481,  1482,  1485,  1486,  1487,
       0,     0,     0,     0,  2240,  1478,     0,  1469,  1470,  1471,
    1475,  1476,  1472,  1473,  1474,  2247,  1466,     0,  1461,  1462,
    1463,  1464,     0,  1438,     0,  1423,  1424,  1425,  1430,  1435,
    1436,  1427,  1428,  1429,  1431,  1432,  1434,  1433,  1426,     0,
       0,     0,     0,     0,     0,     0,     0,   510,   511,   513,
     512,   514,   515,   516,     0,  2197,  2198,     0,     0,   519,
     523,   520,   521,   522,     0,     0,  2206,  2208,     0,   728,
     729,   730,   731,   732,     0,     0,     0,   717,   718,   719,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2303,
    2304,  2309,  2310,     0,     0,  2313,     0,     0,     0,     0,
       0,   624,   686,   700,   640,   695,   696,   634,   635,   644,
     679,   691,   641,   692,   683,   682,   643,   655,   666,   689,
     656,   662,   668,   667,   685,   690,   680,   657,   678,   677,
     673,   674,   675,   676,   693,   664,   663,   647,   648,   649,
     681,   707,   699,   701,   684,   713,   712,   706,   642,   697,
     698,   632,   665,   658,   659,   661,   660,   688,   627,   705,
     650,   651,   653,   652,   636,   637,   639,   638,   646,   694,
     702,   633,   654,   708,   630,   710,   711,   629,   628,   670,
     703,   687,   709,   704,   669,   631,   671,   626,   672,   645,
     625,  1322,   452,     0,   453,     0,   386,     0,     0,   178,
       0,     0,   839,  2325,     0,     0,     0,     0,  1787,     0,
       0,     0,  1797,     0,     0,     0,   888,     0,     0,     0,
       0,     0,   883,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   271,     0,     0,     0,     0,   270,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   226,   225,  1187,   879,   941,   884,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   136,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1689,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   134,     0,     0,     0,   300,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   811,     0,   807,   274,   810,     0,     0,     0,
       0,   833,     0,     0,     0,     0,   827,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   843,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   307,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1663,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   278,     0,     0,     0,     0,  1757,     0,
       0,     0,     0,   168,     0,     0,     0,     0,     0,   377,
       0,   378,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1197,     0,     0,     0,     0,     0,   531,
       0,     0,   527,     0,  1750,     0,     0,  1113,     0,  1722,
       0,     0,  1730,     0,     0,     0,  1109,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   154,   159,   156,   164,     0,
     147,     0,     0,   151,   149,     0,     0,     0,     0,     0,
       0,   409,   408,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   389,   390,   391,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   467,     0,     0,
       0,     0,     0,     0,     0,   482,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1772,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1694,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1209,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   176,     0,     0,
     172,     0,  1098,  1099,     0,  1103,  1104,   205,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   141,   143,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1851,
       0,     0,     0,   194,   195,   196,   197,   198,   199,   200,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1781,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   166,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     489,     0,     0,     0,     0,     0,     0,     0,     0,   314,
       0,   313,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   330,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   384,     0,     0,     0,     0,
       0,   841,     0,   840,     0,     0,     0,     0,  1788,     0,
       0,     0,  1798,     0,     0,     0,     0,     0,     0,   878,
       0,     0,     0,     0,     0,     0,   922,     0,     0,     0,
     940,     0,     0,     0,     0,     0,   239,   238,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,     0,     0,     0,     0,  2054,     0,     0,
     797,  2055,  2056,  2057,  2053,  2059,  1857,  1873,  2382,     0,
    1864,     0,  1863,  1897,  1898,  1992,  1991,  1993,     0,  1340,
       0,  2060,  1936,  1976,  1348,     0,     0,  1994,  1983,  1985,
    2132,  2126,  2127,  2129,  2128,  2130,  2131,  1698,     0,  1701,
       0,  2121,  2122,  2123,  1833,  1834,  1837,  1824,  1846,  1802,
       0,   561,   560,  1938,     0,  1820,  1807,  1679,  1677,     0,
    1687,     0,  2033,  2038,  2039,  2040,  1929,  1931,  1930,  1932,
       0,  1923,  2041,  2042,  2295,  1919,  1318,     0,  1643,  1140,
       0,  1138,     0,   297,     0,     0,     0,     0,     0,  1809,
    1872,  1862,  1949,  1937,  2024,  2025,  2026,  1861,  1871,  1870,
       0,  1921,  1869,  1868,  1814,     0,  2269,  1984,  1899,  2015,
    2017,  2014,  2016,  2019,  2020,  1939,  1942,  1951,  1952,  1943,
    1944,  1946,  1962,  1940,  2004,  2005,  2006,  1941,   800,     0,
       0,   802,   801,  1957,  1959,  1958,  1954,  1955,  1953,  2011,
    1995,     0,     0,  1996,  1998,  1999,  2264,  2263,  2265,  2266,
    2063,  2065,  2067,  2066,  2068,  2069,  2071,  2070,  2072,  2073,
    2075,  2074,  2076,  2077,  2078,  2079,  2080,  2081,     0,  1806,
    2008,  1960,     0,  1972,  1971,  1974,  2262,  2021,  2022,  2023,
       0,  2215,  2315,  2322,  2323,  2324,   951,   948,     0,     0,
     805,   855,   856,   858,   859,   861,   857,   860,   862,   275,
       0,     0,     0,     0,     0,     0,   832,     0,     0,     0,
     824,     0,     0,  1822,  1821,  1736,  1737,   865,   866,   842,
       0,   323,   320,   319,   322,   321,   317,   316,  1671,  1667,
       0,     0,   305,   792,     0,     0,     0,     0,  1856,  1858,
    1874,  1875,  1876,  1877,  1878,  1879,  1880,   283,   281,  1659,
       0,     0,  2260,  1986,  2116,  2120,  2119,  2118,  2117,  2111,
    2112,  2087,  2331,  2332,  2333,  2334,  2335,  2336,  2337,  1145,
    1146,   276,     0,     0,   282,  1754,     0,     0,     0,     0,
    1142,     0,     0,     0,   326,     0,     0,     0,   375,   376,
       0,   380,   368,   358,     0,     0,   359,   360,   369,   373,
    1987,  1988,     0,  1194,     0,     0,   567,   566,     0,   524,
     529,     0,  1748,     0,  1112,     0,     0,     0,  1723,     0,
    1726,  1107,     0,  1108,  1117,     0,     0,     0,  1120,  2270,
    1808,  1835,  1836,  1816,  1817,  1818,  1830,  1829,  1845,  1844,
    1123,  1135,     0,   160,   157,   162,   148,     0,   152,   150,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   387,   401,   402,   397,   398,   399,   400,
     393,   394,   396,   395,   403,  1201,  1188,     0,     0,   574,
     573,  1831,  1832,  1825,  1843,  1803,  1838,  1839,  1840,  1841,
    1842,  2276,  2277,  2278,  2279,  2282,     0,   581,   580,   611,
     610,   617,   616,  1143,     0,     0,     0,     0,   458,     0,
       0,     0,     0,     0,     0,     0,   479,     0,  1908,  1907,
    1906,  2293,  2294,  1306,     0,  1589,     0,  1778,  1770,     0,
       0,   722,   721,  2284,     0,  2287,     0,  2286,  1762,  1763,
       0,     0,  1693,     0,   547,   546,  1819,  1827,   737,   734,
       0,  1910,  1913,  1912,  1909,  1911,  1310,     0,  1607,     0,
    2012,  2013,  1288,  1203,  1293,  1205,     0,     0,     0,     0,
       0,  1208,  1828,  2258,  1283,  1280,     0,  2342,  2341,  1216,
    1217,  2343,  2353,  2362,  2344,  2354,  2363,  2346,  2347,  2356,
    2357,  2365,  2366,  2359,  1222,  1223,  1253,  1254,  2372,  2371,
    2370,  1265,  1266,  1273,     0,  1276,     0,     0,     0,     0,
    1100,  1105,     0,   210,   211,   204,   207,   208,   209,   212,
     203,   201,  2034,  2035,  2036,  2037,  2047,  2048,     0,  1925,
    2043,  2044,  1918,  1920,  1314,     0,  1621,   144,  1299,  1301,
    1303,  1855,     0,     0,  1859,   180,   179,     0,     0,     0,
       0,     0,     0,     0,     0,  1865,  1866,  1867,   186,   185,
    2082,  2083,  2084,  2085,  2086,  2088,  2089,  2090,  2091,  2092,
    2093,  2094,  2095,  2096,  2097,     0,  2098,  2099,  2100,     0,
       0,     0,  2104,  2105,     0,  2107,  2108,  2109,  2110,  2113,
    2114,  2115,  1532,  1535,  1534,  1847,  1882,   868,   867,  1779,
       0,  1783,     0,  2137,  2138,  2139,  2140,  2141,  2142,  2143,
    2144,  2145,     0,  2147,  2148,  2149,  2150,  2151,  2154,  2156,
    2157,  2158,  2159,  2160,  2171,  2168,  2182,  2183,  2187,  2161,
    2164,  2165,  2166,  2167,  2169,  2170,  2172,  2173,  2174,  2175,
    2176,  2177,  2178,  2179,  2180,  2181,  2184,  2185,  2186,  2220,
    1401,  1404,     0,  2256,  2216,  2245,  2219,  2217,  2249,  2251,
    2250,  2252,  2254,  2236,  1455,  1458,     0,  1419,  1422,  2162,
    2163,  2221,  2222,  2223,  2224,  2225,  2226,  2227,  2228,  2229,
    2230,  2231,  2232,  2233,  2234,  2235,  1527,  1530,  2135,  2136,
    2237,  1488,  1491,  2241,  2243,  2242,  2239,  1477,  1480,  1465,
    1468,  2257,  1437,  1440,     0,     0,     0,   495,   496,     0,
     488,     0,     0,  2191,  2190,  2192,  2193,  2194,  2195,   509,
     508,     0,     0,   312,  2200,  2199,   518,   517,  1190,  1189,
    2203,  2204,  2205,  2207,   727,   726,  2290,  2291,   716,   714,
     715,     0,     0,   331,   339,  2018,  2305,  2306,  2307,  2308,
    2300,  2301,  2302,  2311,  2314,  2316,  2312,  2317,  2318,   622,
     623,     0,   454,   455,     0,   456,   448,   385,   449,   451,
     838,   356,     0,     0,  1785,   538,     0,     0,  1795,     0,
       0,     0,     0,     0,     0,     0,   882,   877,     0,     0,
       0,   923,     0,     0,     0,   941,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,   236,   237,   232,   233,   234,   235,
     227,   228,   230,   229,   231,     0,     0,     0,     0,     0,
     936,   937,   938,   939,     0,   942,   886,   795,   796,     0,
    2382,  2383,  2385,     0,  2389,  2387,     0,  1343,  1351,     0,
    1700,   218,     0,  1088,  1090,     0,     0,     0,     0,  1933,
       0,  1320,  1141,  1139,   302,   303,   304,     0,     0,     0,
       0,   798,   799,     0,  2397,     0,  2401,  2399,     0,     0,
       0,  1092,  1095,     0,   950,   813,   274,   809,   274,     0,
       0,     0,     0,     0,     0,   831,     0,     0,     0,  1669,
     880,   943,   890,     0,   790,   791,     0,     0,     0,  1665,
       0,     0,   280,     0,     0,     0,     0,     0,     0,     0,
     325,   327,     0,     0,   372,     0,     0,  1191,     0,     0,
    1184,     0,  1196,     0,     0,     0,     0,     0,     0,  1732,
       0,     0,     0,     0,     0,  1118,     0,  1137,   163,   146,
       0,     0,   432,   433,   405,   406,   410,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   442,   443,   411,     0,   430,   431,     0,   439,
       0,   441,   444,     0,   407,   445,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   478,     0,
       0,     0,     0,     0,     0,  1308,     0,  1775,  1777,  1774,
       0,     0,     0,     0,  1692,     0,   736,  1312,     0,  1207,
    1211,  1212,  1213,  1214,  1282,  1275,     0,   174,   171,     0,
     206,     0,     0,  1316,     0,  2391,     0,  2393,  2395,  1848,
    1850,  1849,     0,  1853,   352,   353,   354,  1854,   193,   192,
    2403,     0,   139,   138,     0,     0,     0,     0,  1784,     0,
       0,     0,  1460,     0,     0,   491,   487,     0,  2408,     0,
       0,   311,     0,   329,     0,   383,     0,     0,     0,     0,
       0,     0,   534,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   911,
     912,   920,   918,   913,   916,   915,   921,   919,   917,   914,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   258,   259,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   268,
     269,   256,   257,     0,   265,     0,   267,   272,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   899,   900,   908,
     906,   901,   904,   903,   909,   907,   905,   902,     0,     0,
    2386,     0,  2390,  2388,  2376,  1352,     0,     0,  2299,  2125,
       0,     0,     0,  1924,     0,     0,  1922,  1815,  2398,  2402,
    2400,  1947,  2064,     0,     0,  1948,   275,     0,     0,     0,
     815,     0,     0,     0,     0,     0,   829,   825,     0,     0,
       0,     0,     0,     0,     0,     0,  1660,     0,     0,  1746,
    1747,     0,     0,  2377,     0,     0,     0,     0,     0,     0,
     379,   365,     0,   367,     0,  1198,     0,     0,     0,     0,
       0,     0,     0,     0,  1734,  1724,     0,  1111,     0,  1121,
       0,     0,     0,     0,     0,     0,     0,   437,     0,  2283,
       0,     0,   471,     0,     0,     0,   460,     0,     0,     0,
     477,     0,     0,     0,   481,     0,  1776,     0,  2285,  2288,
       0,  1695,  2202,     0,     0,     0,  2379,  2378,  1926,  2392,
    2394,  2396,  1852,     0,  2406,  2404,  2101,  2102,  2103,  2106,
       0,  2146,     0,   492,     0,  2196,     0,  2409,     0,     0,
       0,     0,     0,   332,   333,     0,     0,     0,     0,   341,
     345,   457,     0,     0,     0,   537,   533,     0,     0,     0,
    1789,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1935,
       0,     0,   924,     0,     0,   942,     0,     0,     0,     0,
       0,   263,  1892,  1890,  1891,   935,   929,     0,     0,     0,
       0,     0,     0,  2384,   804,  1084,   803,  1085,  1089,  1091,
       0,   881,   945,   894,     0,  1934,   298,     0,     0,  1093,
    1096,   274,   274,   274,   806,     0,     0,   837,     0,   826,
     845,     0,     0,   944,   892,     0,   306,  1664,  1661,   277,
       0,  1758,     0,     0,  1755,     0,     0,   382,   447,  1192,
       0,     0,   525,  1751,     0,     0,     0,     0,     0,     0,
    1725,  1119,   434,   435,     0,   412,     0,     0,     0,   446,
    1686,     0,     0,   470,     0,     0,   459,     0,   461,     0,
       0,     0,   480,     0,     0,     0,     0,     0,  2405,     0,
       0,     0,     0,   490,  2407,   315,     0,     0,     0,     0,
     334,     0,     0,     0,     0,   342,     0,  1790,  1791,     0,
     536,     0,     0,   544,     0,  1786,  1799,  1800,  1801,  1796,
    1883,  1887,  1889,  1896,  1885,  1894,   846,   847,   849,   850,
     852,   848,   851,   853,   854,  1884,  1893,  1888,   910,   889,
       0,     0,   925,     0,     0,   943,     0,   260,   261,     0,
       0,   273,  1886,  1895,   898,   885,     0,     0,     0,     0,
       0,     0,     0,     0,  1086,     0,   819,   816,   820,     0,
     835,   830,     0,     0,     0,     0,   309,     0,     0,     0,
     169,     0,   374,     0,     0,     0,     0,  2380,     0,     0,
    1115,  1733,     0,     0,     0,     0,   404,   473,   472,     0,
       0,     0,     0,     0,     0,     0,     0,  1696,   177,     0,
     173,     0,   167,     0,     0,     0,   499,     0,   500,   501,
       0,     0,   335,   336,   337,   338,     0,   343,   344,   340,
     450,   535,     0,     0,  1792,     0,   543,     0,     0,     0,
       0,     0,     0,     0,     0,   930,     0,     0,     0,     0,
     946,   896,   299,     0,     0,  1094,     0,   274,     0,   931,
       0,     0,     0,     0,     0,     0,   381,     0,     0,     0,
       0,     0,     0,   413,   414,   438,   440,   463,     0,   462,
       0,   464,     0,     0,  1771,     0,  1780,     0,     0,     0,
       0,   493,     0,   502,     0,     0,     0,     0,     0,   346,
     347,   541,     0,   542,     0,     0,     0,   927,     0,   926,
     945,     0,   944,   264,   266,   887,  1690,     0,     0,     0,
       0,  1087,     0,   821,   836,   891,     0,     0,  1745,  1759,
    1760,   474,   475,   476,     0,  1752,  1753,     0,     0,   484,
     485,   175,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   348,     0,     0,   540,     0,     0,     0,   933,
       0,     0,     0,   274,   274,   932,     0,  2381,   466,   465,
       0,     0,     0,     0,     0,   498,     0,   349,   350,   351,
     539,  1793,  1794,   928,   946,   895,     0,     0,   817,   822,
     893,     0,     0,     0,     0,   494,   497,   934,     0,     0,
       0,     0,   503,     0,   897,   823,   504,   505,     0,   506
  };

  const short
  parser::yypgoto_[] =
  {
   -3833, -3833,  4447, -3833,    96, -1974, -3593,  -882, -3833,  -921,
     -83, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833,  1906, -3833, -3833,  1891, -3833, -3833, -3833,
    1049, -3833, -3833,  1945, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833,  2813, -3833, -3833, -2271, -3833,  1360, -1045,
   -3833, -3833,  4283,  2273, -3833, -2717,  -669, -3833,  1425,  -965,
   -3833, -3833, -3833,  1804, -3833, -3833, -3833,  2313, -3833, -3833,
   -3833, -3833, -3833, -3833,  1790, -3833,   357, -3833, -3833, -3833,
     343, -3833, -3833,    -7,    -3, -3833,  2263,  4198, -3833, -3833,
   -3833, -3326, -2040, -2145,  -482,  1652, -3833, -3833, -1989, -3833,
   -3833, -3833, -3833,  4208, -3833,  1273, -1300,  -353, -2778, -3833,
    1279, -1312, -3833, -3833, -3833,  1834, -3833, -3833, -3833,   -18,
   -3833,   112, -3833, -3833, -3833,  1854, -3833, -3833,  1849, -3833,
   -3833,  3623,  1424, -3247, -2972, -3833, -3833,  -313, -3833, -3833,
    2494, -3833, -3833,  2292, -3833, -3833,  -233, -3833, -3833,   101,
   -3833, -3833,  2170, -3833, -3833,  2167, -3833,  1828, -3833, -3833,
   -3833,  4254,  1851, -3833, -3833,  2151, -3833, -3833,  1856, -3833,
   -3833,   -69,  2131, -2222,  2361, -1619, -3833, -3196, -3833, -3833,
    1548,  -904,  -217, -3833, -3832, -3833,  1538,  -927, -3833, -3833,
    3872, -3833, -3833,  2640, -3833, -3833,  3876, -3833, -3520, -3833,
    -321, -3833, -3833, -3833,  1990, -3833, -3833,  4247, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3546,   361, -3833,
     384, -3833,  4243, -3833, -3537,   581, -3833,  4252, -3833, -3833,
    2422, -2893, -3833,   562, -2311,   541, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833,  4397,  -500, -3833, -3833,  3659,
   -3833, -3833, -3833, -3833, -3833,  2287, -3833, -3833, -3833, -3833,
   -3833, -3833,  2364, -3833, -3833,   -36,   472, -2098, -3833,  2331,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833,  3345, -3833,  2135,
   -3833, -3833,  2121, -3833, -3833,  2123, -3833, -3833,  2116, -3833,
   -3833,  2115, -3833, -3833, -3833,  2144, -3833,  2166, -3833,  -272,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
     -50,  2570, -3833, -3833,  2569, -3833, -3833, -3833,  1996, -3833,
   -3833,  1981, -3833, -3833,  1924, -3833, -3833,  1964, -3833, -3833,
    1955, -3833, -3833,  1949, -3833, -3833,  1968, -3833, -3833,  1969,
   -3833, -3833,  -378, -3833,  2227, -3833,  2199, -3833,  2130, -3833,
    2562, -3833, -3833,  1572,  -986, -3833, -3833,  2452, -3833, -3833,
    2584, -3833, -3833, -3833,  4189, -3833, -3833, -3833,  2224, -3833,
    2604, -3833, -3833,  2369, -3833,  1517, -1103, -3833, -3833,  2481,
   -3833, -3833, -3189, -3833, -3833,  3729, -3833,  1567, -1049, -3833,
    2239, -3833, -3833,   543, -1354,  2251, -3833,   560, -1693, -3833,
    1051, -1827, -3833, -3833, -3833,  1047, -1814,  1922,   238, -3833,
   -3833, -3833,  -287,  -281,  -462,  -210, -3833, -3833, -3833, -3833,
     -99,   -81, -3833, -3833, -3833, -3833,   467, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833,  -173, -3833, -3833, -3833, -3833, -3833, -3833, -3833,  -450,
    -283, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
    -361,  -185, -3833, -3833, -3833,  -446,  -339,  -202, -3833, -3833,
   -3833,   -46, -3833,  -445,  -197,  -348, -3833, -3833, -3833, -3833,
   -3833,  -345, -3833, -3833, -3258, -3257, -3256, -3833, -3833, -3236,
   -3192, -3833, -3833, -3833, -3191, -3173, -3833, -3833,  -255,  -190,
     -15,  -158, -3833, -3833,  -269, -3833, -3833, -3833, -3833, -3833,
   -3833,  -114, -3833, -3833, -3833, -3833, -3833,   -98, -3833, -3833,
    -191, -3833, -2015, -2537,  1912, -3833,    33, -3833,  -289,  -443,
    -439,  -434,  -431,  -427,  -425,  -332,  -419, -3833,  -412, -3833,
    -369,  -278,  -368,  -363,  -362,  -360,  -335,  -312,  -334,  -325,
    -319,  -318,   215, -3833,  -315, -3833,  -310, -3833, -3833, -3833,
    -286,  -285, -3833, -3833,   -45,   -44,  -280, -3833,   -19, -3833,
    -226,  -308, -3833,   134,  -262,  -207,  -194,   -24,  -302,  -301,
    -300,  -298,  -295,   -16,   -12,  -293,  -275,  -271,  -265,  -264,
     -33,  -259,  -276,     6,  -258,  -296, -3833,  -253, -3833,  -249,
    -246,  -266,  -261,  -257,  -250, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833,   -48,   -21, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833,  -192, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
    -172,  -157, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
     160,  -235, -3833, -3833, -3833,  -397,  -394,  -390,  -389,  -388,
   -3833, -3833, -3833, -3833, -3833,  -383,  -374,  -367, -3833,  -356,
   -3833, -3833, -3833,  -277,  -228,  -213, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833,  -241,  -238,  -407, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833,  -328,  -274, -3833, -3833, -3833, -3833,     9,    11,
      18,    21,    34, -3833,  -236,   -57,   -25, -3833,  -373,  -201,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833,  -122, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833,  -380,  -129,  -184, -3833, -3833,  -120,   -89,
     -87,   -75,  -460,   -71,   -66, -3833, -3833,   349,   -79, -3833,
   -3833,  -234, -3833,  -231,    35, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833,  -203, -3833, -3833,   -39,   -30, -3833, -3833,
      42, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833,  -229, -3833, -3833, -3833,
      55,    61,    66,    71,   106,   107, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833,  -322,  -316,  -306,  -292,  -243,  -208,
    -130,  -111, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833, -3833,
   -3833, -3833, -3833, -3833, -3833, -3833, -3833,  1929, -3833, -3833,
   -1385, -2627, -3833, -1858, -3833, -2339, -3833, -2169, -3833, -2556,
   -3833,   538,     0
  };

  const short
  parser::yydefgoto_[] =
  {
       0,   160,   161,   162,  4083,  4084,   442,  2490,  1213,  1214,
     373,   163,   164,  3672,   165,  3281,   166,  3529,  4314,  3526,
     167,   168,  1601,  1602,   169,  1610,  1611,   170,  1606,  2712,
    2713,   171,  1548,  1549,  3532,   172,   173,   174,   175,   176,
     177,   601,   178,  4226,  2993,  4178,  4229,   179,  1064,  1065,
     180,   181,   988,   989,   182,   677,   678,   183,   978,   979,
     184,  1984,  2880,  2881,  3741,   185,   967,   968,   186,  1075,
    2424,   187,  2011,  2897,  2898,  4343,  4344,   188,  4104,  4348,
    4349,  4350,  4699,  4700,  4077,   189,  1088,  1089,   190,  1076,
    3959,  2428,  2429,  2914,  2915,  2430,  2544,  4016,  2431,   191,
     192,  4107,   193,  2125,   194,  1327,  1328,  4028,  4029,   195,
    1334,  1335,   196,   479,  2869,  2870,  4491,  4746,  4493,  4617,
    4618,  4619,   197,   198,  1976,  1977,   199,  1988,  1989,   200,
    1110,  1111,  1106,  3796,  4512,   201,  1384,   613,   202,   614,
     615,   203,  1099,  1100,   204,  1260,  1367,   205,  1286,  1319,
     206,  1314,  1315,   207,  1320,  1321,   208,  2030,  2031,   209,
     210,  2006,  2007,   211,  1369,  1370,   212,  1998,  1999,   213,
    1389,  1425,  1391,  3236,  2194,  4513,  3132,  3133,  4408,   214,
     929,   930,   931,  3201,  4230,   215,   941,   942,   216,   936,
     937,   217,  2131,  2132,   218,   959,   960,  4535,  3202,   957,
    3240,   219,   220,  1705,  1706,   221,   222,   223,  2151,   224,
    2995,  4199,  2936,  4241,  4575,  4560,  4720,  4186,  4187,  4128,
    4129,   225,   226,   227,  3859,  3860,   228,   229,   230,   792,
     793,  3883,  4565,  3884,  3885,  3912,  3913,   231,   435,  1536,
     232,   436,  1538,   233,   234,  1126,  1127,   235,  1115,  1116,
     236,   237,  1130,   238,  1151,  1152,   239,   240,   241,   242,
     243,   244,  1027,  1028,   245,   354,  2195,  3750,  3958,   355,
     246,   375,  2542,   247,   248,   249,  1432,  1433,   250,  1444,
    1445,   251,  1475,  1476,   252,  1504,  1505,   253,  1518,  1519,
     254,  1525,  1526,   255,  1436,  1437,  1420,  1421,  1426,  1438,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   530,
     531,   532,   265,   554,   555,   266,   267,  1764,  1765,   268,
    1847,  1848,   269,  1953,  1954,   270,  1829,  1830,   271,  1946,
    1947,   272,  1935,  1936,   273,  1921,  1922,   274,  1880,  1881,
     275,   276,  1646,  1647,  1343,  1344,  1402,  1403,  1568,  1569,
     656,   657,   277,  1002,  1003,   278,   969,   970,   279,   631,
     632,   280,   281,   639,   640,   282,  1383,  2608,  2609,   283,
     573,   574,   284,  1122,  1123,  1120,  1121,  3316,   285,   949,
     950,   286,  4252,   287,  1112,  1113,   288,  1069,  1070,   289,
    1376,  1377,   290,  1363,  1364,  3446,   291,  1714,  1715,   292,
    2137,  2138,  2139,  4360,   293,  2141,  2142,  2143,  1153,  1289,
    1290,  1291,  1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161,
    1162,  1163,  1164,  1165,  1166,  1392,  1167,   952,   953,   954,
     617,  1292,  1393,  1439,  1168,  1169,  1293,  1294,   618,   619,
    1170,  1295,  1296,  1297,  1298,  1299,  1300,  1301,  1171,  1172,
    1173,  1707,  2714,  2715,  2716,  2717,  3570,  2718,  2719,  1603,
     990,   533,   992,  1604,  1605,   801,   802,   534,  1612,  1613,
    1614,  1175,   805,   806,   535,   995,   996,   997,   998,   999,
    1000,  1001,   807,  1711,  4188,  4189,  4190,  4191,  4133,  4192,
    4193,  3861,  3862,  3863,  4194,  4195,  4196,  4138,   536,   537,
    1654,  1176,   812,  1570,  1349,  1350,  1351,  1408,  1409,  1410,
    1411,  1177,   658,  1571,  1572,   659,  1573,  1178,   660,  1574,
    1352,   661,  3889,  3890,  2152,   556,  1658,   635,  1659,   817,
     818,   819,   820,   821,   822,   823,   824,   825,   826,   827,
     828,  1660,   830,   831,   832,   833,   834,   835,   836,   837,
     838,   839,  1661,  1302,   841,   842,   843,   844,   845,   846,
    1180,   557,   849,   850,  1181,   580,  1182,   854,  1662,   856,
     582,  1040,  1091,  1183,  1184,   538,   539,   585,   861,   862,
     863,   864,   865,   540,   541,   868,   869,   870,   871,   872,
    1663,   874,  1185,  1186,   877,  1428,  1423,   878,  2091,   879,
     880,  1187,  1188,  1189,  1190,  1575,   662,  1576,  1577,  1578,
     663,   664,  1579,  1580,   665,   666,   667,  1581,  1582,   668,
    1583,  1584,  1585,  1586,   669,  1587,   670,   542,   543,   544,
     545,   546,   547,   548,   558,  1191,  1192,   887,   888,   889,
     890,   891,   892,   893,   894,   895,   896,  1664,  1665,  1666,
    1667,  1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,  1676,
    1677,  1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,
    1687,  1688,  1689,  1690,  1691,  1692,  1043,  1693,  1694,  1695,
    1696,  1697,  1046,  1047,  1048,   622,   623,   624,   625,   636,
     587,   897,  1396,  1923,  1924,  1768,  1769,  1770,  1771,  1772,
    1773,  1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,  1782,
    1783,  1784,  1785,  1786,  1787,  1788,  1897,  1789,  1790,  1791,
    1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,
    1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,
    1812,  1193,  1194,  1978,  1979,  1980,  1981,  1982,  1983,  1991,
    1992,  1993,   898,  1429,  2000,  2001,  2002,  2003,   588,   589,
     590,   591,   592,   904,   905,  1831,  1832,  1900,  1833,  1813,
    1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,
    1912,  1913,  1914,  1915,  1916,  1834,  1928,  1929,  1940,  1941,
    1942,  1943,  1944,  1835,  1836,  1837,  1951,  1856,  1838,  1839,
    1840,  1841,  4197,  1843,  1844,  1968,  1440,  1698,  1699,   907,
     908,   909,   910,   911,  1198,  1199,   913,   914,   915,  1305,
    1264,  1306,  1307,  1308,  1309,  1310,  1311,  1312,  1378,  1379,
    1380,  1381,  1382,  1313,  2008,  2009,  1359,  1360,   671,   916,
     593,  1322,   626,  2104,  2105,  2106,  2107,  2108,  2109,  2110,
    2111,  2112,  2113,  2114,  2115,  2116,   918,  2118,  2119,  2120,
    1200,  1201,  1202,  1203,  1204,  1205,  2134,  1052,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1101,
    1102,  1103,  1446,  1447,  1477,  1478,  1479,  1480,  1481,  1482,
    1483,  1484,  1485,  1486,  1487,  1488,  1489,  1490,  1491,  1492,
    1493,  1494,  1495,  1496,  1497,  1498,  1499,  1500,  1501,  1502,
    1503,  1520,  1521,  1522,  1523,  1527,  3017,  3278,  3538,  4271,
    3871,  3872,  3011,  3012,  3563,  3564,  3142,  3143,  4081,  3596,
    4099,  3733,  2196
  };

  const short
  parser::yytable_[] =
  {
     294,   432,   433,   434,   303,  1842,  1105,   958,  2265,  2595,
     303,  2124,  2124,  2379,  2356,   303,  2391,  2462,  1965,  2413,
    2418,  2766,  2585,   621,   303,  2344,   633,  2577,  2034,  1037,
     816,  1174,   795,   847,   848,  1329,   799,   356,  1179,   853,
    2035,   829,  1195,   875,  2038,  2041,   578,  2048,   303,   303,
     374,  2049,   303,   881,  1029,  1038,  2050,   303,   882,  2051,
    1030,   303,   883,  2052,   808,  2053,  1072,   303,   303,   884,
     303,  2055,   303,  1885,  3200,  1990,  1886,   303,  2056,  1700,
    1887,  1888,  1889,   303,   374,   374,   374,  1890,  1853,   303,
    1385,   303,   443,   857,   583,  1851,  1891,  1708,  1959,   576,
     302,  1939,  1506,  1892,   577,  1957,   312,   584,  1507,   796,
    1709,   320,   858,  1710,  1893,  1422,   575,   803,  1508,  1304,
     333,  2057,  2059,  1304,   955,   859,   303,  2060,  2061,   809,
    2062,  1031,  1509,   620,   800,   993,  1304,  1424,  1348,  1407,
     994,  1427,   993,  3144,   371,   372,  1261,   994,   377,  1042,
     303,  2039,   991,   386,   303,  2063,  2065,   394,  2054,   991,
     294,   811,  2100,   406,   409,  2066,   414,  1354,   418,  1044,
    1395,  2067,  2068,   429,   972,  2069,  3256,  1767,  2064,   430,
    2070,  1510,  2073,  1034,  1045,   437,  1355,   441,  2077,  2078,
    2079,  1346,  2080,  1894,  1263,  2081,  1347,  2082,  1317,  1356,
    1652,  2047,  1652,  2032,  2071,   813,  1405,  2036,  1345,  2033,
    2072,  1406,  2058,  1263,  2088,  2083,  1511,  1412,   973,  2084,
     797,   814,   466,  1404,  2094,  2085,  2086,  1035,  2074,  2095,
     620,  2087,  2089,  2096,   974,  2043,  3315,  2090,   798,  3071,
    2097,  2092,  1895,  1036,  2093,  1648,   492,  1648,   553,  2098,
     496,  1712,  2099,  1650,  2101,  1650,  2102,  1896,  1651,  2103,
    1651,  2117,  1051,  1883,  1713,  1653,  3101,  1653,   586,  1901,
    1649,   885,  1649,   804,   851,   852,  1884,  1766,   675,   676,
    2130,  3285,   581,  2075,  1855,  1882,   873,  3911,  2040,  2487,
    2488,  1197,  1950,  2042,  1512,   860,  2076,  1655,   886,  1655,
     855,  1150,   596,   866,   810,  2037,  3381,   867,  1041,   641,
    2928,  1073,   596,  1513,   356,   356,   679,  1124,  3736,  1095,
     596,   932,  1039,   938,   943,   876,  1033,  2932,   899,   961,
     900,  2494,  2044,   596,   977,   980,  1390,   901,  1004,  1854,
     902,  1656,  1066,  1656,  1125,  1071,  1852,   356,  1857,  1960,
    1927,  1324,   815,   903,   912,   356,  1958,  1657,  1961,  1657,
    1357,   917,  1114,  1117,  3027,   975,  1128,  1128,  1131,  1414,
    3897,   596,   596,  1210,   919,  1256,  2045,   596,  1415,  1858,
     920,  1859,  3576,  3577,  3875,   921,   596,   356,  3288,  1962,
     922,  1963,  2046,  1860,   596,  1365,  4228,  1861,  4066,  4080,
    3873,  1588,  1862,  1964,  2240,  2246,   596,  1966,  2339,   596,
    1589,  1849,  1967,  1898,   596,  1925,  4633,  1937,   596,  1948,
     594,  1955,  3099,  4323,  3103,   923,   924,  3905,  3781,   596,
     596,  2373,  1210,  1210,  1210,  1537,  1539,   596,  3781,  3289,
    2419,   596,  1593,  1850,  2345,  1899,   680,  1926,  3008,  1938,
     507,  1949,  3140,  1956,   511,  -923,  4592,  1215,  3870,  1716,
      22,  3539,  1077,  4336,  1215,  1078,   596,   637,  1215,  3781,
    2375,  3968,  2388,  2388,  2438,  2445,  2483,  3182,  2549,  4008,
    2567,  2569,  1287,  2571,  2578,  2580,  -925,  2598,  2012,  1079,
    3870,  2611,   596,  2126,  2126,  2615,   596,   932,  2626,  1368,
    2628,  1049,  2144,  1080,   673,  3128,  1216,  2150,  2153,  2157,
    2161,  2638,  2200,  1216,  2668,  1303,   579,  1216,  2684,  1303,
    2704,  2723,  3425,  2763,  1081,  2877,  -927,  2883,  2889,  2893,
    2893,  2916,  1303,  2916,   840,  2438,  2266,  4111,  2004,  3623,
     683,  1006,   684,  3426,   616,  4130,  4131,  4132,  2941,  3573,
    4030,  4182,  4207,  1358,  4212,  4212,  4207,   794,  4010,  4207,
    4224,  4262,  1107,  3899,  1607,  3771,  3865,  4134,  1413,  4286,
    4212,  4375,  4390,  4173,  4399,  4464,  4182,  4182,  4399,  4654,
    4399,  4182,  4182,  3001,  4399,  4399,  3004,  4182,   522,  4399,
    4567,  3965,  4175,   295,  2228,  4249,  4250,   297,  3935,  4433,
    4320,  4650,  2363,  4633,  4111,  1118,  4111,   299,  1353,  1325,
    4111,  4135,  4136,  1107,   522,  4358,  1211,    43,  1082,  1288,
    1394,  2486,  1598,  1288,  1608,  4064,  2466,  4112,  3343,  2466,
    4137,  1325,  2576,  4264,  3233,   304,  1288,   627,  2248,   628,
    4210,   616,  1325,  3669,  1215,  4633,  1330,  2461,  4633,  1701,
     982,  4633,  3678,   702,   703,  3681,  4633,  1530,   956,  2249,
    3869,  4401,  4067,  1215,  4445,  4025,  2927,  4633,   906,   307,
    3429,  2448,  1215,  1215,  4633,  3549,  1702,   679,  3300,  1703,
    2634,  3742,  2363,   594,  3762,  3131,  1215,  4633,   562,  1215,
    1050,  1007,  1215,  1216,  4112,  1215,  4112,  1215,  1442,   711,
    4112,  1325,  1008,  4431,  3128,  3971,  3007,  3903,  1215,  4276,
    1083,   956,  1216,  3173,  1215,  1215,  4266,  4633,  2584,  1196,
    3725,  1216,  1216,    22,  4297,  3151,  3152,  3689,  1215,   597,
    1215,   308,  3301,  1215,   309,  1216,  3726,  4033,  1216,  4490,
    3430,  1216,  1084,  1215,  1216,  3690,  1216,  1215,  1215,   313,
    3870,  4267,   323,  2449,  1215,   565,  3467,  1216,  1215,  3241,
    3473,  4299,  3475,  1216,  1216,   314,   956,    78,    79,    80,
      81,    82,  4361,   315,   634,  3252,  4268,  1216,  4316,  1216,
    4305,  4352,  1216,  1119,  3901,  4303,  4317,  4504,  3902,  3752,
    3753,  3634,  1216,  3963,   951,   760,  1216,  1216,   328,   971,
     762,   329,  4599,  1216,  3520,  3233,  1541,  1216,  1032,  2998,
    2999,  4601,   330,  4603,  3243,   768,  3129,  3130,  1009,  1010,
    2998,  2999,  -436,   629,  3010,  1119,   566,  2543,   629,   765,
     766,   956,  4119,  4120,  4121,  4122,  4123,  4124,  4125,  4126,
    3438,  3439,  1011,   772,  4696,  4737,  1262,  1255,  1704,   629,
    1316,  4022,   598,   599,   600,   334,  4557,  3908,  1431,  2879,
    1085,  3909,  2896,   630,   337,  1262,  2531,  2532,  2533,  2534,
    2535,  2536,  2537,  2538,  2539,  2540,  3729,  2541,  4738,  3245,
      43,  2005,   566,  1119,   629,  4325,  4573,  1119,   305,  4065,
     306,  -262,   344,  3191,   778,  3098,  2543,  3102,   347,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   348,   630,
    1096,  1097,  1098,  4251,   123,  1443,  2341,  4142,  2342,   932,
    4697,  4788,  1531,  4698,  2348,  2349,   938,  3234,  3235,  2353,
    2354,   943,   349,  1012,  1013,  2531,  2532,  2533,  2534,  2535,
    2536,  2537,  2538,  2539,  2540,   316,  2541,   317,  3866,   961,
    2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,
     361,  2991,  4359,  1326,  1329,    22,  1215,  4405,   980,  2981,
    2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,  1212,
    2991,  4434,   387,  4651,  1212,  1326,  2998,  2999,  1542,  3192,
     638,  1212,  1004,  3624,  3625,  1609,  1326,  2135,  2136,  2364,
    1086,  4062,  1104,  1543,   362,  3129,  3130,  2162,   528,   529,
    1014,  1108,  4648,  1599,  3745,  1216,   363,  3193,  3194,  3195,
      78,    79,    80,    81,    82,  1331,   366,  4661,  2998,  2999,
    1109,  2998,  2999,  3153,  2998,  2999,  4127,  2998,  2999,  2998,
    2999,   143,   144,   145,   146,   147,   148,  2443,  4321,  1333,
    2998,  2999,  3938,  1600,  1066,  1326,  2163,  2998,  2999,  1071,
    1532,   321,  1108,   322,  2706,  1256,  1256,   367,  1333,  3009,
    2998,  2999,  2998,  2999,  2164,  2998,  2999,  3009,  1215,  2707,
    4202,  1109,  1104,   356,  4583,  3290,  2165,  2166,   368,  2451,
    2998,  2999,  1104,  4718,  2447,  1332,  2998,  2999,  3234,  4269,
    2998,  2999,  1114,  2135,  2136,  1117,  4727,  4130,  4131,  4132,
    4068,  1333,  3874,   401,  2241,  2247,  1128,  4488,  2340,  1128,
    2470,   674,    43,  4634,  4446,  4635,  4722,  1216,  2167,  4134,
     438,  1544,  4043,  1104,   451,  4324,  3635,  3636,   508,  3906,
    3782,  2374,  1104,  3196,  1104,   681,   415,   512, -2429,  2420,
    3952,  2346,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,  2492,  4761,  4135,  4136,  4337,  1104,   123,  3969, -2429,
    2376,  4351,  2389,  2416,  2439,  2446,  2484,  1545,  2550,  4009,
    2568,  2570,  4137,  2572,  2579,  2581,  3682,  2599,  2485,  2267,
    2268,  2612,  2491,  2491,   450,  2616,  4787,  1087,  2627,  1104,
    2629,    22,   296,  1256,  1256,   504,   298,  4454,   452, -2429,
     324,  2639,   325,  3472,  2669,   453,  3714,  3715,  2685,  3427,
    2705,  2724,  4200,  2764,   509,  2878,  4203,  2884,  2890,  2894,
    2895,  2917,  1256,  2919,  4113,  2920,  1015,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  2942,  3574,
    4031,  4183,  4208,  2708,  4213,  4216,  4221,  3519,  4011,  4222,
    4225,  4263,    78,    79,    80,    81,    82,  3197,   510,  4287,
    4318,  4376,  4391,  4174,  4400,  4465,  4556,  4572,  4646,  4655,
    4660,  4717,  4726,  1417,  4760,  4766,  1259,  4786,  1917,  4798,
    3966,  4405,  4176,  1546,   143,   144,   145,   146,   147,   148,
    4637,  4410,  4635,  4451,  2865,  2574,  2575,  4481,  2168,  2169,
    1970,  3911,  1514,  2583,  2170,  2171,  2172,  2173,  2174,  2175,
    2176,  2177,  2178,  2179,  2180,  2181,  2182,  2183,  2184,  2185,
    2186,  2187,   594,  3595,   481,  2188,  2189,  2190,  2191,  2865,
    1826,   458,  4716,  1365,  4635,  4731,   483,  4635,  4732,   463,
    4635,  4584,  4585,  4733,   602,  4635,  4219,   480,    43,   603,
     604,   605,   482,  2610,  4739,   484,  4635,  4514,   487,  4664,
    4665,  4740,    22,  4635,  4345,  4346,  2709,  4347,  1547,  4671,
    4672,   485,  3177,  3178,  4781,  4335,  4635,  2866,  4511,  2867,
    2868,  4702,   606,   607,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   486,  4782,   608,  4635,  1918,   609,   123,
    2998,  2999,  2866,  1215,  2867,  2868,  3198,  3179,   488,  2981,
    2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,   594,
    2991,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,
    2540,   326,  2541,   327,   493,  3922,   642,   643,  1818,   691,
     945,   494,  2710,   644,   495,  2711,  3191,   522,   645,   646,
     497,  3109,  1216,  1371,  1372,  2135,  2136,  3744,  4417,    22,
    2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,  2540,
     513,  2541,   522,   549,  1919,   523,  4474,  3928,  4604,  4605,
    4477,  1821,  3904,  3907,  4480,  4564,  3110,  3111,    78,    79,
      80,    81,    82,  1827,  1945,  1337,  2673,   335,  2676,   336,
     523,  3030,   338,  1515,   339,  4404,  1215,  1255,  1255,    43,
     559,   702,   703,   647,  1994,  1995,  1996,  1997,  1418,  1419,
    1398,  3158,  3159,  4098,  3344,  3345,   143,   144,   145,   146,
     147,   148,   610,   933,   648,  4119,  4184,  4121,  4185,  4123,
    4124,  4125,  4126,   340,   563,   341,  4647,   638,  1972,  1516,
     944,  2697,  3192,  1517,   956,  1216,  1985,  1986,   981,  1987,
     564,   611,  3980,  2537,  2538,  2539,  2540,  3346,  2541,  1005,
    3349,  4667,  4668,  4669,   776,  1067,   649,   650,  3981,  1074,
    3193,  3194,  3195,  4392,  1090,  1971,  4085,  4086,   946,   342,
    4087,   343,  4682,  4683,  2545,  2546,  2547,  1373,  1374,  4106,
    1092,   629,  3063,  3064,  3065,  4227,  1375,  1104,  1257,   565,
    1972,  1973,  1974,  1975,  2192,  1336,    43,  3162,  3163,  3164,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,  1524,
    1333,  1338,  3066,  3067,  3068,   123,  3069,   524,   962,   963,
     964,   965,   966,   760,  1339,  1255,  1255,   947,   762,    78,
      79,    80,    81,    82,  3066,  3067,  3068,  1399,  3069,  3066,
    3067,  3068,   524,  3069,  1716,   651,  2768,  1366,  1431,  1339,
     566,  1595,  2539,  2540,  1255,  2541,   629,   526,   522,   345,
     982,   346,  4754,   602,  4756,  3155,  3156,  3157,   603,   604,
     605,  3165,  3166,  3167,  4270,   566,  3196,  3066,  3067,  3068,
    1596,  3069,   983,  1400,  1597,  1594,   984,   985,   986,   987,
    1717,  4721,  2630,  2631,  2632,  2633,  4418,  1340,  3562,  4405,
    1814,   606,   607,  2989,  2990,  3112,  2991,  1969,   948,  3939,
    3031,  3032,  3033,  3034,  3035,  3036,  2133,  4345,  4346,  4127,
    4347,  3291,  1340,  2140,   608,  2998,  2999,   609,  2145,  2987,
    2988,  2989,  2990,   350,  2991,   351,    78,    79,    80,    81,
      82,  2146,   143,   144,   145,   146,   147,   148,  4339,  4340,
    4341,  4342,  4678,  2201,  4680,  3543,  3544,  3545,  2202,  1818,
    4447,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
    2203,  2204,  4406,  3766,  3767,  3768,   123,   528,   529,  2205,
    1818,  1341,  2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,
    2989,  2990,  1821,  2991,  3856,  3857,  3858,  4074,  4075,  4076,
    3197,   357,  2206,   358,  4419,  2207,  1341,   652,   359,   364,
     360,   365,  2208,  2209,  1920,  1828,  2210,  2211,  2998,  2999,
    2212,  2493,  1820,  1821,  2981,  2982,  2983,  2984,  2985,  2986,
    2987,  2988,  2989,  2990,  2130,  2991,   378,   380,   379,   381,
    1930,  1931,  1932,  1933,  1934,   653,  2213,  3945,   524,  3946,
     382,  3070,   383,  2214,  3072,  3073,  3100,  2216,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   621,  2215,   384,
     611,   385,  2217,   123,   388,   633,   389,   390,   395,   391,
     396,   397,   578,   398,  3548,   399,  3131,   400,   402,   410,
     403,   411,  2218,   143,   144,   145,   146,   147,   148,  2531,
    2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,  2540,   419,
    2541,   420,   612,  2219,  2220,  2531,  2532,  2533,  2534,  2535,
    2536,  2537,  2538,  2539,  2540,   421,  2541,   422,  2221,   423,
     583,   424,   425,  2222,   426,   576,   444,  1253,   445,   446,
     577,   447,   448,   584,   449,   454,   456,   455,   457,  3198,
    2223,   459,   575,   460,  2224,   461,   467,   462,   468,   469,
     816,   470,   795,   847,   848,   471,   799,   472,   473,   853,
     474,   829,  2225,   875,  3242,  3244,  3246,   620,   475,  2226,
     476,  2227,  4209,   881,   477,   489,   478,   490,   882,   498,
    2229,   499,   883,   500,   808,   501,   502,  2230,   503,   884,
     143,   144,   145,   146,   147,   148,  2231,  2232,  1448,  1037,
    3945,  1451,  4116,  1826,  1454,  2233,  2234,  1457,  1458,  1459,
    4455,  2235,  4456,   857,  1464,  2236,  1466,  1401,  2237,  2238,
    2239,  2242,  2243,  2126,  1029,  1038,  2244,  2245,  2251,   796,
    1030,   932,   858,  2252,  2253,  2925,  2926,   803,  2254,  2255,
    2256,  2144,  2257,  2258,  1174,   859,  2259,  2260,  2261,   809,
    4566,  1179,  4568,  2262,   800,  1195,  2263,  2269,  2270,   955,
    2271,  2272,  2273,  2274,  1342,  2275,  4526,  4494,  2347,   553,
    2276,  3006,  4527,  4528,  4529,  4530,  4531,  4532,  2277,  4217,
    2278,   811,  2279,  2280,  2281,  2282,   993,  4533,   654,  1342,
     655,   994,  2283,  2284,   586,  2285,  4534,  4415,  4521,  2286,
    2287,  1031,  4525,   991,  4536,  4537,  2288,   356,   581,  2289,
    2290,  2291,  3016,  3018,  2292,  2293,  3062,   972,  2294,  1042,
    2295,  2296,  2297,  2298,  3288,   813,   303,  2299,  2300,   303,
    2301,  2302,  4586,  4587,  2303,  2304,  2305,  2306,  2307,  1044,
     797,   814,  2308,  3097,  2309,  2310,  2311,  2312,  2313,  2314,
    2315,  3061,   356,  1034,  1045,  2316,  2317,  3074,   798,   303,
    2318,   973,   303,   303,  3124,  3125,  3126,  2319,  2320,  2321,
    2322,  2323,  3138,  2324,  3092,  3289,  2325,   974,  3149,   356,
    2326,  2327,  2328,  2329,  4218,  2330,  4220,  2928,  2331,  2332,
    2333,   885,  2334,   804,   851,   852,  2335,  1035,  3464,  2336,
     356,   356,   356,  2337,  2932,  1304,   873,  3137,   356,  1304,
    2338,  2352,  3288,  1036,   356,   860,  3399,  2357,   886,  2358,
     855,  3161,  3038,   866,   810,  3040,  2359,   867,  2360,  2361,
    1422,  2362,  1051,  2367,  2368,  2369,  1304,  1348,  1506,  2370,
     303,  2371,  2372,  2377,  1507,   876,  2380,  3239,   899,  2381,
     900,  4274,  1424,  1407,  1508,  3077,  3484,   901,  3080,  3082,
     902,   612,  2382,  3289,  1263,  3260,  1354,  1842,  1509,  2383,
    3550,  3551,   815,   903,   912,  2384,   303,  2385,  1041,  3613,
    1395,   917,  3238,   356,  1317,  1355,  4723,  2386,  2387,  2392,
    1346,  2393,  1039,  2394,   919,  1347,  1033,  2395,  1356,  2396,
     920,   356,  1708,  1965,  1197,   921,   637,  1345,   975,  2397,
     922,  2398,  2399,  1263,  1150,  1709,  1124,  1510,  1710,  3276,
    1405,  2400,  3978,  2401,  1256,  1406,  2126,  3286,  1256,  2402,
    2403,  1412,  2404,  2405,  3785,  2406,  3188,  1404,   620,  3332,
    3246,   356,   579,  1125,  2407,   923,   924,  2408,  4734,  1853,
    1885,  2034,  1511,  1886,  2409,  3313,  1851,  1887,  1888,  1889,
    3317,  2410,  3131,  2035,  1890,  2411,  2414,  2038,  2041,  2415,
    2048,  3327,  3230,  1891,  2049,   356,  1990,  2421,   616,  2050,
    1892,  2422,  2051,  1959,   303,  1939,  2052,  2423,  2053,  2491,
    1957,  1893,  2491,  4789,  2055,  1256,  1256,  1256,  1256,  3354,
    3355,  2056,  1652,  1256,  1256,  1256,  1256,  1256,  1256,  1256,
    1256,  1256,  1256,  1256,  1256,  1256,  1256,  1256,  1256,  1256,
    1256,  1256,  1256,  1256,  1256,  1256,  1256,  1256,  1767,  3382,
    1512,  1256,  1256,  1256,  1256,  1256,  1256,  1256,  1256,  1256,
    1256,  1256,  2432,  3396,  2057,  2059,  1390,  1648,  2433,  1513,
    2060,  2061,  2434,  2062,   840,  1650,  1712,  2441,  2435,  1357,
    1651,  2436,  4394,  2437,  3453,  2440,  3455,  1653,  2444,  1713,
    1894,  1049,  1649,  2450,  2039,  2455,  2458,   794,  2063,  2065,
    3342,  2054,  2459,  1414,  2460,  2100,  3528,  4407,  2066,  3441,
    3442,   303,  1415,  3447,  2067,  2068,  3447,  3450,  2069,  1655,
     356,  2064,   356,  2070,  4407,  2073,  4593,   303,  2610,  2463,
    2464,  2077,  2078,  2079,  2467,  2080,   303,  2473,  2081,  1895,
    2082,   303,  3808,  2474,  2047,  3518,  2032,  2071,  1766,   303,
    2036,  4005,  2033,  2072,  1896,  2058,  2475,  2088,  2083,   303,
    1883,  2476,  2084,  1656,  2477,  1855,  1901,  2094,  2085,  2086,
    3542,  2074,  2095,  1884,  2087,  2089,  2096,  1588,  2043,  1657,
    2090,   356,  1882,  2097,  2092,   303,  1589,  2093,  3417,   374,
    2478,  3530,  2098,  2479,  3531,  2099,  1950,  2101,  3533,  2102,
    3535,  3536,  2103,  2480,  2117,  2481,   356,  3444,   906,  2482,
    1212,  2495,  2496,  3552,  2497,   303,  2498,  2499,  2500,  1368,
    1854,  1303,  3561,  3460,  3131,  1303,  2075,  1852,  2503,  1857,
    2504,  2040,  3470,   634,  2505,  2506,  2042,  3477,  2507,  2076,
    3575,  2548,  2585,  3615,  2508,  3486,  2577,  2425,  2037,  2509,
    1927,  2510,  1303,  2511,  1960,  3496,  1254,  2551,  2552,  3630,
    1858,  1958,  1859,  1961,  2512,  2513,  2514,  4520,  2515,  2516,
    2517,  4524,  1358,  4149,  1860,  2044,  2518,  2519,  1861,   356,
    1050,  3524,  2520,  1862,  2521,  2522,  2523,  3620,  2524,  3622,
    2525,  2526,  1849,  2527,  1962,   356,  1963,  2528,  4552,  2529,
    2553,  3674,  1413,  3676,  3677,  2554,  2555,  2556,  1964,  2557,
    1898,  3555,  1966,  2558,  2559,  1925,  2766,  1967,  2560,  2045,
    2561,  1937,  2562,  1948,  1850,  1288,  1955,  1353,  2563,  1288,
    2564,  2565,  2566,  2573,  2582,  2046,  2586,   356,  2587,   356,
     356,  2588,  1899,  2589,  2590,  2592,  4150,  1926,   303,   951,
    1394,  2591,  1196,  1938,  2593,  1949,  1288,  2596,  1956,  2597,
    4591,  2600,   971,  2601,  2602,  2603,  2605,  2606,  2604,   616,
    2613,  2614,  4233,  2617,  2618,  3756,  2619,   514,   515,   516,
    1815,  2620,  2622,   517,   518,   519,   520,  2623,  2621,  2462,
    2624,  2625,  2636,  2642,  3777,  2501,  2502,  2637,  1032,  2640,
    2641,   521,  1816,  1817,  2643,  2644,  2657,  2645,  2646,  2647,
    2648,   356,   522,  4636,  2649,  4636,  1255,  2650,  2413,  2418,
    1255,  2651,  2652,  2653,  2530,  2658,  2654,  2655,  2660,  2656,
     356,  2659,  2661,  2662,  2664,  2663,  2126,  2666,  2665,  2667,
     523,  2670,  2677,  2678,  3686,  2533,  2534,  2535,  2536,  2537,
    2538,  2539,  2540,  2144,  2541,  2698,  2679,  3804,  3805,  2680,
    2681,  2153,  2682,  2683,  3809,  3810,  2686,  3812,  3813,  3814,
    2687,  3816,  2688,  2689,  2690,  2391,  2691,  2692,  1105,  2693,
    2694,  2695,  2696,  2699,  2700,  2701,  2702,  1255,  1255,  1255,
    1255,  2703,  2379,  2720,  2721,  1255,  1255,  1255,  1255,  1255,
    1255,  1255,  1255,  1255,  1255,  1255,  1255,  1255,  1255,  1255,
    1255,  1255,  1255,  1255,  1255,  1255,  1255,  1255,  1255,  1255,
    2356,  2722,  2725,  1255,  1255,  1255,  1255,  1255,  1255,  1255,
    1255,  1255,  1255,  1255,  4703,  2344,  1262,  2726,  2531,  2532,
    2533,  2534,  2535,  2536,  2537,  2538,  2539,  2540,  4636,  2541,
    2727,  2728,  2729,  2730,  4407,  2731,  1316,  2732,   596,  2733,
     596,  2734,  2735,  2736,  2737,  2738,  2739,  2740,  4636,  4636,
    4636,  2741,   682,  2742,   303,   684,  2743,  2744,  2745,  2746,
    2747,  2748,  2749,  4636,  4636,  1262,  2750,  1132,  2751,  2752,
    2753,  2754,  2755,  2756,  2757,  2758,  2759,   596,  1329,  2760,
     596,  2761,   596,  2762,  2769,  2770,  2771,   679,  2772,  2773,
    2774,  2775,   524,   525,  2776,  2813,  2777,  2778,   522,  2779,
    2780,  2781,  2782,  2783,  2784,   303,  2785,  2786,  2787,  2788,
     695,   696,   697,  2789,  1133,  1818,  1819,  2790,  2791,  2792,
    2793,  2794,  2827,  2795,   560,   561,   523,  2796,  2797,  2595,
    2798,  2799,   526,   527,  2800,  4636,  2801,  4636,  2802,  2803,
    2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,
    3886,  2991,  2804,  2805,   594,  1135,  1417,  1820,  1821,  2806,
    1822,  1823,  2807,  1824,  1825,  1826,   702,   703,   704,  2808,
    1827,  2809,  2810,  2811,  2812,  2814,  2815,  1136,  1137,  1138,
    2816,  1828,  2817,  2818,  2819,  2820,  2821,  2822,   596,  3915,
    2823,  2824,  2825,   562,    22,   563,   706,   707,   708,  4466,
    2826,  3900,  2828,   932,  3920,  2829,  2830,  2831,  3923,   594,
    2832,   564,   943,  2981,  2982,  2983,  2984,  2985,  2986,  2987,
    2988,  2989,  2990,  2833,  2991,  2834,  2847,  2835,  2265,  2836,
     596,  3933,  2837,  1434,  2838,  2839,  2840,   980,  2841,  2981,
    2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,    22,
    2991,  1004,  2842,  2843,  2844,  2845,  2846,  2849,  2848,  3957,
     565,  2850,   528,   529,  2851,  2852,  1095,   741,  2853,  2854,
    2855,  2856,  2857,  1066,  2858,  2859,  2860,  2861,  2862,  1071,
    2863,  1256,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,
    1256,  2991,  2864,  2871,   303,   356,  2872,  2899,   524,  4105,
    2873,  2879,   356,  2874,  2875,  2876,  2882,  2885,   760,  1141,
    2886,  1142,  2887,   762,  2888,  2891,  1143,  1144,  1145,  2892,
    2896,  2900,   765,   766,  2193,  3974,  2901,  2902,   768,  2903,
    2904,   566,  2905,  2906,  2907,  2908,  2909,  2910,   526,  2911,
     769,   629,   596,  4139,  2912,  2913,  2918,  2921,  2924,  2930,
    2933,    43,  2929,  2934,  1146,  2935,  2937,  3749,  2938,  3749,
    3749,  2939,  2940,  1147,  2943,  2944,  1148,   610,  2946,  2945,
    3189,  2947,  2948,  2949,  2950,   776,   630,  1149,  2952,  2951,
    2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,
    3956,  2991,  2953,  2954,  2955,  2958,   611,  1256,  2959,  2960,
    2961,  2962,  2963,  2964,  2965,  2966,    43,   778,  2967,  2968,
    2969,  1418,  2970,  2971,  1435,  2972,   303,  4467,  2973,  2996,
    2974,  2975,  1550,  1551,  4019,  4020,  2976,  1552,  1553,  1554,
    2977,  2978,  2979,  2994,  1555,  1556,  1254,  1254,  3003,  3005,
    1557,  1558,  3007,  3013,   596,  3014,  4038,  3020,  3021,  4038,
    3023,  3025,  3026,  2442,   303,  3009,   303,  3028,  3041,  4549,
     596,  3042,  3043,  3047,  3049,  3050,  3052,  3054,   528,   529,
     596,  3055,  4550,  3056,  3058,  3059,  3075,   596,  3060,   303,
    3083,  3088,  3089,   514,   515,   516,   596,  3087,  3090,   517,
     518,   519,   520,  3096,  3104,   550,   596,  3105,  3108,  1559,
    3122,    78,    79,    80,    81,    82,   551,   521,  3123,  3127,
    3134,  3135,  4018,  3139,  4569,  3141,  3145,  3150,   522,  3160,
    1560,  3169,  3170,  3168,   596,  3172,  1256,  3175,  1210,  1256,
    3176,  3180,  1256,  2531,  2532,  2533,  2534,  2535,  2536,  2537,
    2538,  2539,  2540,  3181,  2541,  3183,   523,  3185,  3190,  3204,
    4041,  3203,  4042,  3205,  3206,   596,    78,    79,    80,    81,
      82,  3208,  1561,  1562,  3209,  3210,   552,  4069,  4070,  4071,
    3212,  4073,  3213,  3214,   594,  4048,  3217,  3215,  3218,  3231,
    3219,  3221,  3254,  3222,  1254,  1254,  2531,  2532,  2533,  2534,
    2535,  2536,  2537,  2538,  2539,  2540,   780,  2541,  4577,   303,
     303,   303,  3223,  3224,   303,  3225,  3227,  3232,  3255,  3257,
    3258,  2449,  3237,  1254,    22,  3261,  3248,   567,   568,   569,
     570,   571,  3262,  3249,  3251,  3263,  3267,  3268,  3269,  3271,
    3273,  3277,   303,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,  3296,  3294,  3274,  3297,  3310,  3275,   123,  3279,
    3280,  1563,  3330,  3295,  3299,  3304,  1564,  3334,  3303,  3335,
    3337,  3307,  1256,  1329,  3308,  3309,  4300,  3311,  3312,  3339,
    3314,  3318,  3319,  3321,  3323,  3324,   596,  3347,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,  3395,  2541,  3398,
    3397,  3400,   572,   123,  3403,  4728,  3405,  3406,   524,   525,
    3407,  3414,  3416,  3418,  3420,  3422,  3424,  3432,  4090,  3434,
    3423,   303,  3428,  3440,  3431,  3457,  3433,  3463,  3471,  1340,
    3474,  3481,  3492,  3497,  3435,  3436,  3437,  3498,  2265,  3501,
    3448,  3452,  3502,  1255,   594,  3503,  3527,  3504,   526,   527,
    3458,  3454,  1255,   786,   787,   788,   789,   790,   791,  3465,
    3505,    43,  3456,  3479,  3483,  3506,  3491,  3507,  3499,  3508,
    3509,  2126,  3510,  3511,  2126,   143,   144,   145,   146,   147,
     148,  3512,  3513,  3537,    22,  3546,  3547,  3553,  3557,  3567,
    3568,  3514,  2144,  3569,  2531,  2532,  2533,  2534,  2535,  2536,
    2537,  2538,  2539,  2540,  3571,  2541,  3572,  3580,  3581,  3582,
    3516,  4379,  3521,  3583,  3584,  3541,  3585,  4097,  3558,  3586,
    3587,  3559,  3588,  1341,  3589,  3590,  3560,  3562,  3566,  3591,
     143,   144,   145,   146,   147,   148,  2981,  2982,  2983,  2984,
    2985,  2986,  2987,  2988,  2989,  2990,  3579,  2991,  3592,  2981,
    2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,  1255,
    2991,  1565,  3724,  3594,  4261,  3602,  4204,  3595,  3603,  3599,
    3606,  3616,  3626,  3769,  3612,  3761,   596,  3600,   528,   529,
    3627,  3601,  3604,  3614,  3618,  3619,  3628,   679,  3621,  3629,
     596,  2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,
    2990,  3631,  2991,  3632,  3633,  4139,  3637,  3638,  1093,   932,
    1566,    78,    79,    80,    81,    82,  3639,   943,  3640,  4289,
    3641,  3644,  3645,  3646,  3647,  3648,  3649,   980,  3651,  3652,
    3653,  1004,  3654,  1066,  2472,  3655,  3656,  3657,  1071,  3658,
    3659,    43,  1256,  1256,  3660,  3661,   596,  3662,    22,  1256,
    3663,  3664,  3665,  3666,  3667,  3668,  3673,  3675,  4273,  3671,
    3679,  3680,  3683,  3688,  3731,  3694,  3696,  3697,  3700,  3701,
    1256,  1256,  3702,  3703,  3707,  2981,  2982,  2983,  2984,  2985,
    2986,  2987,  2988,  2989,  2990,  3708,  2991,  3709,  1255,  3710,
    3713,  1255,  3716,  3721,  1255,  3712,  3734,  3718,  1256,  3720,
    1256,  3737,  3723,  3727,  3728,  3738,  3740,   303,   596,  3747,
    2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,  2540,
    3751,  2541,  3757,  3770,  3773,  3774,  4306,  3755,  3759,  3776,
    3787,   596,   596,  3732,  3760,  3764,  3779,  3786,   596,  3788,
    3789,  3790,  3791,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,  1256,  3792,  3795,  3800,  3283,  2197,   123,  3793,
    3794,  3797,  3798,   596,  2991,  3803,  3802,  3882,  2363,  3910,
     596,  3887,  3807,  3916,  3918,  3855,  3864,   596,  3876,  3877,
    3934,    78,    79,    80,    81,    82,  3878,  1256,  4353,  4354,
    3879,  3935,  3944,  4288,  3888,    43,  3898,  3917,  2144,  3936,
    3953,  4300,  3947,  3950,  4300,  3962,  3954,  4300,  3970, -2430,
    3963,  3967,  3979,  3984,  1567,  3985,  4013,  4024,  4032,  4093,
    4377,  4044,  4014,  4380,  1255,  4017,  4383,  3350,  3351,  3352,
    3353,  4057,  4072,  4023,  4027,  3356,  3357,  3358,  3359,  3360,
    3361,  3362,  3363,  3364,  3365,  3366,  3367,  3368,  3369,  3370,
    3371,  3372,  3373,  3374,  3375,  3376,  3377,  3378,  3379,  3380,
    4040,  4061,   352,  3384,  3385,  3386,  3387,  3388,  3389,  3390,
    3391,  3392,  3393,  3394,  4079,  4088,  4089,  4095,  4094,  4100,
    4108,  4096,  4101,  2543,  4102,   143,   144,   145,   146,   147,
     148,  4414,  4103,  4109,  4110,   679,  2981,  2982,  2983,  2984,
    2985,  2986,  2987,  2988,  2989,  2990,  4449,  2991,  4115,  4117,
    4485,  4140,  4487,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,  4143,  4141,  4442,  4443,  4146,   443,   123,  4144,
    4147,  4179,   356,  4180,  1256,    78,    79,    80,    81,    82,
   -2429,  2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,
    2990,  4145,  2991,  4148,  4181,  1256,  1256,  4198,   596,  -924,
    3870,  4201,  4205,  4206,  4308,  2981,  2982,  2983,  2984,  2985,
    2986,  2987,  2988,  2989,  2990,  4211,  2991,  1365,  4215,  4223,
    4232,  4235,  4237,   374,  1256,   374,  4240,  4242,  4243,  4246,
    4253,  4254,  4255,  4265,  4272,  4300,  4275,  4300,  4277,  4282,
    1716,  4285,   443,   522,  4290,  4291,  4295,  4294,  4301,  1256,
    1256,  1256,  1256,  4319,  4310,  1256,  1256,  4503,  4326,  4296,
    4333,  4298,  1256,  3383,  4302,  4304,  4327,  4307,  4363,  4355,
    4356,  4328,  4329,  4517,  4518,  4357,  2531,  2532,  2533,  2534,
    2535,  2536,  2537,  2538,  2539,  2540,  4364,  2541,  4330,  4378,
    4334,  4543,  4366,  4367,  4546,   143,   144,   145,   146,   147,
     148,  4368,  4369,  4370,  4371,  4372,  4373,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,  4374,   679,  4381,  4382,
    4384,  4385,   123,  4397,  1255,  1255,  4396,  4398,  4403,  4402,
    4416,  1255,  4421,  4422,  1265,  1266,  4423,  4424,  4429,  4457,
    4436,  4432,  4438,  4459,  4475,  1593,  1256,  4439,  4492,  1267,
    4509,  3930,  1255,  1255,  4441,  4444,  4510,   608,  4452,  4558,
    1268,  4563,  4559,  4453,  4460,  4476,  1256,  1256,  4478,  4482,
    4479,  -926,  4507,  4508,  4309,  4515,  4519,  4539,  1269,  4555,
    1255,  4540,  1255,  1365,  4541,  1210,  4544,  1210,  4574,  1716,
    1593,  4561,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,
    2539,  2540,  4578,  2541,  4579,  2531,  2532,  2533,  2534,  2535,
    2536,  2537,  2538,  2539,  2540,  4582,  2541,  4588,  4589,  4600,
    4602,  4620,  4628,  4621,  4629,  4630,  4685,  2531,  2532,  2533,
    2534,  2535,  2536,  2537,  2538,  2539,  2540,  4631,  2541,  1270,
    4638,  4639,  4640,  4641,  1255,  1145,  2992,  4645,  4653,   143,
     144,   145,   146,   147,   148,  4642,  4649,  4656,  4657,  4691,
    4695,  4694,  2997,  3000,  3002,  4670,  3000,  4706,   629,  4411,
    4709,  4652,  4712,  -928,  4748,  4659,  4763,  4764,  3022,  1255,
    4662,  1146,  4673,  4674,  4772,  3029,  4677,  4783,  4784,  4791,
    4757,  4792,  4799,  4793,  3044,  3045,  3046,  4689,  3048,  4767,
    4679,  4800,  4801,  3053,  3843,  4803,  4808,   506,  4681,   374,
    3565,  4684,  4686,  4715,  3578,  4704,  4719,  1271,  4725,  4729,
    4730,  1272,  4078,   611,  4802,  1273,  4806,  1068,  3973,  3540,
    4742,  4735,  4736,  3943,  3091,  1094,  3093,  3094,  3095,  4708,
    4807,  4711,  4743,  4758,  4759,  4762,  3106,  3107,  4765,  4768,
    3113,  3114,  3115,  3116,  3117,  3118,  3119,  3120,  3121,  4809,
    4773,  3247,  3937,  4769,  4778,  3000,  2531,  2532,  2533,  2534,
    2535,  2536,  2537,  2538,  2539,  2540,  4779,  2541,  3154,  4785,
    4790,  4795,  4797,  4804,  3743,  1210,  3226,  3763,  3171,  4744,
    3174,  4505,  4752,  2128,   303,  4751,  1256,  4750,  3184,  3982,
    4500,  3298,  2127,  3730,  4026,   948,  2531,  2532,  2533,  2534,
    2535,  2536,  2537,  2538,  2539,  2540,  4034,  2541,  2531,  2532,
    2533,  2534,  2535,  2536,  2537,  2538,  2539,  2540,  4774,  2541,
    4693,  3739,  3746,  2452,  3051,  3964,  1255,  3306,  3421,  3419,
    2010,  3780,  4770,  4771,  3758,  3754,  3468,   596,   303,  3451,
    3927,  3919,  2156,  3617,  2149,  3000,  3253,  1255,  1255,  4538,
    4554,  3186,  2160,  4395,  1129,  4420,  3264,  3265,  3266,  4409,
    3340,  2923,  3302,  4794,  2457,  3270,   596,  2635,  3500,  3515,
    3522,  3525,  3494,  3517,  3019,  1254,  1255,  3722,  3024,  1254,
    4747,  3684,  3482,  3292,  3293,  2531,  2532,  2533,  2534,  2535,
    2536,  2537,  2538,  2539,  2540,  3305,  2541,  3717,  2351,  3670,
    3687,  1255,  1255,  1255,  1255,  3719,  3706,  1255,  1255,  3445,
    3711,  3478,  3078,  3941,  1255,  3983,  3556,  3228,  2250,  1815,
    3057,  3039,  3462,  3320,  3329,  2366,  3972,  3333,  3986,  1815,
    3336,  2454,  3338,  3216,  4776,  3459,  3948,  3449,  4114,  4118,
    4483,  1816,  1817,  3806,     0,  3799,  1254,  1254,  1254,  1254,
    3987,  1816,  1817,  3801,  1254,  1254,  1254,  1254,  1254,  1254,
    1254,  1254,  1254,  1254,  1254,  1254,  1254,  1254,  1254,  1254,
    1254,  1254,  1254,  1254,  1254,  1254,  1254,  1254,  1254,   594,
    4489,     0,  1254,  1254,  1254,  1254,  1254,  1254,  1254,  1254,
    1254,  1254,  1254,     0,     0,     0,     0,  4523,     0,     0,
       0,     0,  3401,  3402,     0,  3404,     0,     0,  1255,  3408,
    3409,  3410,  3411,  3412,  3413,     0,  3415,   594,     0,    22,
       0,     0,     0,  3949,     0,     0,     0,     0,  1255,  1255,
       0,     0,  3955,     0,     0,     0,  2531,  2532,  2533,  2534,
    2535,  2536,  2537,  2538,  2539,  2540,     0,  2541,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    22,     0,     0,
       0,     0,     0,     0,  3466,     0,     0,     0,     0,  1093,
       0,  2956,  2957,  2531,  2532,  2533,  2534,  2535,  2536,  2537,
    2538,  2539,  2540,     0,  2541,     0,     0,     0,  3493,  3988,
       0,     0,     0,     0,     0,  2980,  2531,  2532,  2533,  2534,
    2535,  2536,  2537,  2538,  2539,  2540,     0,  2541,     0,    22,
       0,     0,     0,     0,     0,  1259,  1274,  1275,  1276,  1277,
    1278,  1279,  1280,  1281,  1282,  1283,  1284,  1285,     0,  3989,
       0,     0,     0,     0,     0,     0,     0,   594,     0,  4015,
       0,  3990,     0,     0,  2531,  2532,  2533,  2534,  2535,  2536,
    2537,  2538,  2539,  2540,     0,  2541,  2531,  2532,  2533,  2534,
    2535,  2536,  2537,  2538,  2539,  2540,     0,  2541,     0,  3084,
    3085,  3086,     0,     0,  1818,  1819,    43,    22,     0,     0,
       0,     0,     0,     0,  1818,  1819,     0,     0,     0,  3593,
       0,     0,  3597,  3598,   594,     0,     0,     0,     0,     0,
    3605,     0,  3607,  3608,  3609,  3610,  3611,     0,     0,     0,
       0,     0,     0,     0,    43,     0,  1820,  1821,  3991,  1822,
    1823,     0,  1824,  1825,  1826,  1952,  1820,  1821,  1846,  1822,
    1823,     0,  1824,  1825,    22,     0,  3642,  3643,     0,  1827,
    1828,     0,     0,     0,  3650,     0,     0,     0,  3199,     0,
    1828,     0,     0,     0,     0,  3207,     0,     0,  1255,     0,
    3211,     0,     0,     0,     0,     0,    43,     0,  4056,     0,
    3220,  4059,     0,     0,  4060,     0,  3000,     0,     0,     0,
       0,     0,     0,  3691,  3692,  3693,     0,  3695,     0,     0,
    3698,  3699,     0,     0,     0,  3250,  3704,  3705,     0,     0,
       0,     0,     0,     0,     0,     0,  3000,  3000,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3272,     0,     0,
       0,     0,     0,     0,     0,  3735,    78,    79,    80,    81,
      82,     0,     0,   352,    43,  2531,  2532,  2533,  2534,  2535,
    2536,  2537,  2538,  2539,  2540,     0,  2541,     0,     0,     0,
       0,  3765,     0,     0,     0,     0,  3772,     0,     0,  3775,
       0,     0,  3778,     0,    78,    79,    80,    81,    82,  3992,
    3322,     0,     0,  3326,  2531,  2532,  2533,  2534,  2535,  2536,
    2537,  2538,  2539,  2540,     0,  2541,     0,     0,     0,     0,
       0,    43,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,
    2539,  2540,     0,  2541,     0,     0,  3993,     0,     0,     0,
       0,     0,     0,     0,  4091,     0,    78,    79,    80,    81,
      82,     0,     0,     0,     0,     0,     0,     0,     0,  3994,
    2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,  2540,
     594,  2541,     0,     0,     0,     0,     0,     0,     0,  3867,
    3868,     0,     0,     0,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,  3995,     0,     0,
      22,     0,     0,   123,    78,    79,    80,    81,    82,  3996,
       0,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,     0,
       0,   123,     0,     0,     0,     0,     0,  3480,     0,     0,
       0,     0,     0,  3487,  3488,  3489,  3490,     0,     0,     0,
       0,    78,    79,    80,    81,    82,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,     0,
       0,     0,     0,   123,     0,     0,     0,     0,     0,     0,
    3867,  3868,  3534,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3000,  3000,  2981,  2982,  2983,  2984,  2985,  2986,
    2987,  2988,  2989,  2990,     0,  2991,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,    43,     0,     0,
       0,   123,     0,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,  2531,  2532,  2533,  2534,  2535,  2536,
    2537,  2538,  2539,  2540,     0,  2541,     0,     0,  3997,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,     0,  4258,  4259,     0,     0,   123,  4312,
     143,   144,   145,   146,   147,   148,     0,  3998,  2531,  2532,
    2533,  2534,  2535,  2536,  2537,  2538,  2539,  2540,     0,  2541,
       0,     0,  4280,  4281,     0,  3999,     0,     0,     0,     0,
       0,     0,  1254,     0,     0,     0,     0,  4331,     0,     0,
       0,  1254,     0,     0,     0,     0,     0,     0,     0,     0,
    4283,     0,  4284,     0,     0,  3961,     0,     0,     0,     0,
       0,     0,     0,  4000,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,  2531,  2532,  2533,  2534,  2535,  2536,
    2537,  2538,  2539,  2540,     0,  2541,  3960,    78,    79,    80,
      81,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3461,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,
    2539,  2540,     0,  2541,  4322,     0,     0,     0,     0,     0,
       0,     0,    22,     0,     0,   143,   144,   145,   146,   147,
     148,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,
    2540,     0,  2541,     0,     0,     0,     0,     0,  1254,     0,
       0,     0,     0,     0,   595,  3817,  3818,  3819,  3820,     0,
       0,  3821,  3822,  3823,  3824,  3825,  3826,  3827,  3828,  3829,
    3830,  3831,  3832,  3833,  3834,  3835,  3836,  3837,  3838,  3839,
    3840,  3841,  3842,     0,  3844,  3845,  3846,  3847,  3848,  3849,
    3850,  3851,  3852,  3853,  3854,     0,     0,     0,     0,     0,
       0,     0,  2471,     0,     0,     0,     0,     0,     0,     0,
       0,   672,     0,     0,     0,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,     0,
       0,     0,    22,  1215,   123,     0,     0,  2531,  2532,  2533,
    2534,  2535,  2536,  2537,  2538,  2539,  2540,     0,  2541,  2531,
    2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,  2540,     0,
    2541,     0,     0,     0,     0,     0,     0,  1254,     0,    43,
    1254,     0,     0,  1254,  2162,     0,     0,  4001,     0,     0,
       0,     0,  1216,  2981,  2982,  2983,  2984,  2985,  2986,  2987,
    2988,  2989,  2990,     0,  2991,  2981,  2982,  2983,  2984,  2985,
    2986,  2987,  2988,  2989,  2990,     0,  2991,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4468,  4469,     0,
       0,     0,     0,  2163,     0,     0,     0,     0,     0,     0,
       0,  4002,     0,     0,     0,     0,  3000,     0,     0,     0,
       0,  2164,     0,     0,     0,     0,  4486,     0,     0,     0,
       0,     0,     0,  2165,  2166,     0,     0,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,  4496,  4497,  4498,  4499,     0,  3325,  4501,  4502,  2981,
    2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,    43,
    2991,     0,     0,     0,     0,  2167,     0,  4003,  3921,     0,
       0,     0,  3924,  2981,  2982,  2983,  2984,  2985,  2986,  2987,
    2988,  2989,  2990,  1254,  2991,     0,    22,  1215,     0,    78,
      79,    80,    81,    82,     0,  4004,  2981,  2982,  2983,  2984,
    2985,  2986,  2987,  2988,  2989,  2990,     0,  2991,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   925,     0,     0,
       0,     0,     0,     0,  4006,     0,     0,     0,  2162,     0,
       0,     0,     0,     0,     0,     0,  1216,     0,  2981,  2982,
    2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,  4581,  2991,
       0,  2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,
    2990,     0,  2991,   594,     0,     0,     0,     0,  4594,  4595,
       0,     0,     0,     0,     0,     0,     0,  2163,  2531,  2532,
    2533,  2534,  2535,  2536,  2537,  2538,  2539,  2540,     0,  2541,
    3976,     0,     0,     0,     0,  2164,     0,     0,     0,     0,
       0,     0,     0,    22,     0,     0,     0,  2165,  2166,    78,
      79,    80,    81,    82,     0,     0,     0,     0,     0,   594,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
    4007,     0,     0,    43,     0,     0,   123,     0,     0,  2167,
       0,     0,  4012,     0,     0,  2168,  2169,     0,     0,    22,
       0,  2170,  2171,  2172,  2173,  2174,  2175,  2176,  2177,  2178,
    2179,  2180,  2181,  2182,  2183,  2184,  2185,  2186,  2187,     0,
       0,     0,  2188,  2189,  2190,  2191,  4151,     0,     0,  4021,
       0,     0,     0,     0,     0,     0,     0,     0,  4152,  2981,
    2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,     0,
    2991,     0,     0,     0,  3000,     0,  3000,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4045,     0,  2981,  2982,
    2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,     0,  2991,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
      43,     0,     0,  1254,  1254,     0,   123,     0,     0,     0,
    1254,     0,     0,   143,   144,   145,   146,   147,   148,     0,
       0,  3000,  4153,     0,     0,     0,     0,     0,     0,     0,
       0,  1254,  1254,    78,    79,    80,    81,    82,  4749,     0,
       0,     0,     0,     0,     0,     0,  4154,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    43,     0,     0,  1254,
       0,  1254,     0,     0,     0,     0,     0,     0,     0,  4155,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2168,
    2169,   522,     0,     0,     0,  2170,  2171,  2172,  2173,  2174,
    2175,  2176,  2177,  2178,  2179,  2180,  2181,  2182,  2183,  2184,
    2185,  2186,  2187,  2607,     0,     0,  2188,  2189,  2190,  2191,
       0,  4156,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1254,  4157,     0,     0,     0,     0,   552,
       0,     0,  3000,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3284,     0,
      78,    79,    80,    81,    82,     0,     0,     0,  1254,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,     0,     0,
     123,  2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,
    2990,     0,  2991,     0,     0,     0,    78,    79,    80,    81,
      82,  2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,
    2990,  2192,  2991,     0,     0,     0,     0,     0,     0,     0,
       0,  4393,  3000,  2981,  2982,  2983,  2984,  2985,  2986,  2987,
    2988,  2989,  2990,     0,  2991,  2981,  2982,  2983,  2984,  2985,
    2986,  2987,  2988,  2989,  2990,     0,  2991,  3000,  2981,  2982,
    2983,  2984,  2985,  2986,  2987,  2988,  4690,  2990,     0,  2991,
       0,     0,  4158,     0,  3000,     0,     0,     0,     0,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,  4159,     0,     0,     0,     0,     0,   123,     0,     0,
       0,     0,     0,     0,     0,  1254,     0,   143,   144,   145,
     146,   147,   148,     0,  2981,  2982,  2983,  2984,  2985,  2986,
    2987,  2988,  2989,  2990,     0,  2991,  1254,  1254,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,  4177,     0,
       0,     0,     0,   123,     0,  1254,     0,     0,     0,     0,
       0,     0,     0,     0,  3000,  2981,  2982,  2983,  2984,  2985,
    2986,  2987,  2988,  2989,  2990,     0,  2991,     0,     0,     0,
    1254,  1254,  1254,  1254,     0,     0,  1254,  1254,     0,     0,
       0,     0,     0,  1254,     0,  2192,     0,     0,     0,  3000,
    3000,     0,     0,     0,     0,     0,     0,  3000,     0,  4522,
       0,  3000,     0,     0,     0,  4234,     0,     0,     0,     0,
       0,  4239,     0,     0,   143,   144,   145,   146,   147,   148,
       0,  4245,     0,     0,     0,     0,     0,     0,  3000,  2981,
    2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,     0,
    2991,     0,  2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,
    2989,  2990,     0,  2991,     0,     0,     0,  4278,  2981,  2982,
    2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,     0,  2991,
     143,   144,   145,   146,   147,   148,     0,  1254,  2981,  2982,
    2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,     0,  2991,
    3000,     0,     0,     0,     0,     0,     0,  1254,  1254,     0,
     976,     0,     0,     0,  4160,  4293,     0,     0,     0,     0,
       0,     0,  1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,
    1726,  3328,     0,     0,  1727,  1728,  1729,  1730,  1731,  1732,
    1733,  1734,  1735,     0,     0,  1736,  1737,  1738,  1739,  1740,
    1741,  1742,     0,  3000,     0,  3000,  4161,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1206,     0,  4162,     0,
       0,  1743,  1744,  1745,  1746,  1747,     0,     0,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
       0,     0,     0,  4338,     0,  1760,  1761,  1762,     0,  3000,
       0,     0,     0,     0,     0,     0,     0,     0,  4362,  2981,
    2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,     0,
    2991,     0,     0,     0,  3000,  3000,  3000,  2981,  2982,  2983,
    2984,  2985,  2986,  2987,  2988,  2989,  2990,     0,  2991,     0,
       0,     0,  4386,  4387,     0,  3000,  3000,  4163,  2981,  2982,
    2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,     0,  2991,
       0,     0,     0,     0,     0,     0,  4388,  1763,  4389,     0,
       0,     0,     0,     0,  3000,  2981,  2982,  2983,  2984,  2985,
    2986,  2987,  2988,  2989,  2990,     0,  2991,     0,  3000,     0,
       0,     0,     0,     0,  3000,     0,     0,     0,  4164,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3000,  3000,
    3000,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,
    2540,     0,  2541,  3000,  3000,  4425,  4426,     0,  4428,     0,
       0,     0,     0,     0,     0,     0,  4435,  1254,     0,     0,
       0,     0,     0,     0,  4440,  3000,     0,  3000,     0,  2531,
    2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,  2540,     0,
    2541,     0,     0,     0,     0,  4458,   926,     0,     0,     0,
       0,     0,  4165,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4471,  4472,  4166,     0,     0,     0,  2343,
       0,     0,     0,     0,     0,  3000,     0,  3000,     0,     0,
     505,  4167,     0,  4484,     0,     0,     0,     0,     0,     0,
      22,     0,     0,     0,     1,     2,     3,     0,     0,     0,
       0,  4168,     0,  2531,  2532,  2533,  2534,  2535,  2536,  2537,
    2538,  2539,  2540,     0,  2541,     0,     0,     0,     0,     0,
       4,     5,     6,     7,     8,     0,     0,     0,     9,     0,
       0,     0,     0,     0,     0,     0,    10,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    11,    12,    13,     0,
       0,     0,    14,     0,    15,    16,    17,    18,    19,     0,
       0,     0,     0,  4551,     0,     0,     0,     0,     0,    20,
      21,  4553,    22,     0,     0,     0,     0,     0,     0,    23,
       0,     0,     0,     0,     0,    24,     0,  2531,  2532,  2533,
    2534,  2535,  2536,  2537,  2538,  2539,  2540,     0,  2541,     0,
       0,    25,    26,    27,    28,     0,     0,     0,     0,     0,
       0,     0,     0,    29,     0,    30,    31,     0,     0,     0,
       0,     0,  4169,     0,     0,     0,     0,     0,     0,     0,
      32,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4170,     0,     0,     0,     0,     0,     0,    43,     0,    33,
       0,     0,     0,     0,     0,     0,     0,     0,    34,     0,
      35,  4171,     0,     0,  4616,     0,  2531,  2532,  2533,  2534,
    2535,  2536,  2537,  2538,  2539,  2540,     0,  2541,     0,     0,
       0,     0,     0,     0,  4632,     0,     0,     0,  4172,    36,
      37,    38,    39,     0,     0,    40,     0,  2531,  2532,  2533,
    2534,  2535,  2536,  2537,  2538,  2539,  2540,    41,  2541,  2981,
    2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,   927,
    2991,    42,  4643,  4644,  4257,     0,     0,     0,     0,    43,
       0,     0,     0,     0,    44,     0,     0,     0,     0,     0,
       0,     0,  4658,     0,     0,     0,     0,     0,   928,     0,
    4663,     0,     0,     0,     0,    45,    46,     0,    47,     0,
      48,    49,  4313,     0,     0,     0,     0,     0,     0,    50,
       0,     0,     0,     0,    51,    52,     0,     0,     0,    53,
      54,     0,     0,    55,    56,     0,  2956,  2957,     0,     0,
       0,  4692,     0,     0,     0,     0,     0,    78,    79,    80,
      81,    82,     0,     0,     0,     0,     0,     0,  4705,    57,
      58,     0,     0,    59,    60,    61,    62,     0,    63,     0,
       0,     0,     0,    64,     0,     0,    65,     0,     0,     0,
       0,    66,    67,     0,     0,    68,  4315,     0,     0,    69,
      70,    71,     0,     0,    72,     0,    73,    74,    75,    76,
      77,  2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,
    2990,     0,  2991,  3852,     0,  2531,  2532,  2533,  2534,  2535,
    2536,  2537,  2538,  2539,  2540,  4753,  2541,     0,     0,    78,
      79,    80,    81,    82,     0,    83,     0,     0,     0,     0,
       0,     0,    84,    85,    86,     0,    87,    88,    89,     0,
      90,    91,    92,    93,    94,    95,    96,     0,     0,     0,
       0,     0,    97,    98,     0,     0,     0,     0,    99,  4616,
    4332,     0,     0,     0,     0,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,     0,
       0,     0,     0,     0,   123,     0,     0,     0,   100,   101,
    2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,  2540,
       0,  2541,  4805,  2531,  2532,  2533,  2534,  2535,  2536,  2537,
    2538,  2539,  2540,     0,  2541,     0,     0,     0,     0,     0,
       0,     0,     0,   102,     0,     0,     0,     0,   103,  4462,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
    4463,     0,     0,     0,     0,     0,   123,     0,     0,     0,
       0,     0,  4547,  2531,  2532,  2533,  2534,  2535,  2536,  2537,
    2538,  2539,  2540,     0,  2541,  2981,  2982,  2983,  2984,  2985,
    2986,  2987,  2988,  2989,  2990,     0,  2991,     0,   124,   125,
       0,     0,   126,   127,     0,   128,   129,   130,   131,   132,
     133,   143,   144,   145,   146,   147,   148,     0,   134,     0,
       0,     0,     0,   135,   136,   137,     0,     0,     0,     0,
       0,   138,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    22,     0,     0,     0,     1,     2,     3,
       0,     0,     0,   139,   140,     0,  2981,  2982,  2983,  2984,
    2985,  2986,  2987,  2988,  2989,  2990,     0,  2991,     0,     0,
       0,     0,     0,     4,     5,     6,     7,     8,     0,     0,
       0,     9,     0,     0,     0,     0,   141,   142,     0,    10,
       0,     0,     0,   143,   144,   145,   146,   147,   148,    11,
      12,    13,   149,     0,     0,    14,     0,    15,    16,    17,
      18,    19,     0,     0,  4548,     0,     0,     0,     0,     0,
       0,     0,    20,    21,     0,    22,     0,     0,  4596,     0,
       0,     0,    23,     0,     0,     0,     0,     0,    24,     0,
       0,     0,     0,   150,     0,   151,   152,   153,   154,   155,
       0,     0,     0,   156,    25,    26,    27,    28,     0,     0,
       0,     0,     0,     0,     0,     0,    29,     0,    30,    31,
       0,     0,     0,     0,     0,   157,   158,   594,   159,     0,
       0,     0,     0,    32,  2981,  2982,  2983,  2984,  2985,  2986,
    2987,  2988,  2989,  2990,     0,  2991,     0,     0,     0,     0,
      43,     0,    33,     0,     0,     0,     0,  1208,     0,     0,
       0,    34,     0,    35,     0,     0,     0,    22,     0,     0,
       0,     0,     0,  4609,     0,     0,  2981,  2982,  2983,  2984,
    2985,  2986,  2987,  2988,  2989,  2990,  4675,  2991,     0,     0,
       0,     0,    36,    37,    38,    39,     0,    22,    40,     0,
       0,   594,     0,     0,     0,     0,     0,     0,     0,     0,
      41,     0,     0,     0,     0,     0,     0,  2122,     0,     0,
       0,     0,     0,     0,    42,     0,     0,     0,     0,     0,
       0,     0,    43,     0,     0,     0,     0,    44,     0,     0,
       0,    22,     0,     0,  2981,  2982,  2983,  2984,  2985,  2986,
    2987,  2988,  2989,  2990,     0,  2991,  4676,     0,    45,    46,
       0,    47,     0,    48,    49,     0,     0,     0,  4701,     0,
       0,     0,    50,     0,     0,     0,     0,    51,    52,     0,
       0,     0,    53,    54,     0,     0,    55,    56,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      78,    79,    80,    81,    82,     0,     0,     0,     0,     0,
       0,     0,    57,    58,     0,     0,    59,    60,    61,    62,
       0,    63,     0,     0,    43,     0,    64,     0,     0,    65,
       0,     0,     0,     0,    66,    67,     0,     0,    68,  4713,
       0,     0,    69,    70,    71,     0,     0,    72,     0,    73,
      74,    75,    76,    77,    43,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,
       0,  2991,    78,    79,    80,    81,    82,     0,    83,     0,
       0,     0,     0,     0,     0,    84,    85,    86,    43,    87,
      88,    89,     0,    90,    91,    92,    93,    94,    95,    96,
       0,     0,     0,     0,     0,    97,    98,     0,     0,     0,
       0,    99,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,     0,     0,     0,     0,   123,   594,     0,
       0,   100,   101,     0,     0,     0,     0,  4714,     0,     0,
       0,     0,     0,     0,    78,    79,    80,    81,    82,     0,
    2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,
       0,  2991,     0,     0,     0,     0,   102,     0,    22,     0,
       0,   103,   594,     0,    78,    79,    80,    81,    82,  4755,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   594,     0,     0,     0,     0,     0,   123,
       0,     0,    22,     0,     0,     0,     0,     0,    78,    79,
      80,    81,    82,     0,     0,     0,     0,     0,     0,   594,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   124,   125,    22,     0,   126,   127,  4780,   128,   129,
     130,   131,   132,   133,   143,   144,   145,   146,   147,   148,
       0,   134,     0,     0,     0,     0,   135,   136,   137,    22,
       0,     0,     0,     0,   138,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   594,   139,   140,     0,     0,
       0,   123,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,    43,     0,     0,     0,   141,
     142,   123,     0,     0,     0,    22,   143,   144,   145,   146,
     147,   148,     0,     0,  2123,   149,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    43,
    3894,     0,     0,     0,     0,   123,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   150,   594,   151,   152,
     153,   154,   155,     0,     0,     0,   156,     0,     0,     0,
      43,  2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,
    2990,     0,  2991,     0,     0,     0,     0,     0,   157,   158,
       0,   159,     0,     0,     0,     0,    43,    22,   143,   144,
     145,   146,   147,   148,     0,  2981,  2982,  2983,  2984,  2985,
    2986,  2987,  2988,  2989,  2990,     0,  2991,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    78,    79,    80,    81,    82,
    3895,     0,  2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,
    2989,  2990,    43,  2991,     0,     0,     0,     0,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,     0,     0,  1207,     0,     0,     0,     0,    78,
      79,    80,    81,    82,  2981,  2982,  2983,  2984,  2985,  2986,
    2987,  2988,  2989,  2990,     0,  2991,     0,     0,     0,     0,
       0,     0,     0,     0,  1209,   594,     0,     0,     0,     0,
      78,    79,    80,    81,    82,  2531,  2532,  2533,  2534,  2535,
    2536,  2537,  2538,  2539,  2540,     0,  2541,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    78,    79,    80,    81,
      82,     0,     0,     0,    43,    22,     0,     0,  1258,  2981,
    2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,     0,
    2991,   594,     0,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,     0,     0,
       0,     0,   123,  1208,     0,     0,     0,     0,     0,     0,
       0,    22,    78,    79,    80,    81,    82,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,    22,     0,     0,   123,     0,     0,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,  1208,     0,     0,     0,   123,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,     0,
       0,  3896,     0,   123,    78,    79,    80,    81,    82,     0,
       0,     0,    43,    22,  2981,  2982,  2983,  2984,  2985,  2986,
    2987,  2988,  2989,  2990,     0,  2991,     0,     0,     0,   143,
     144,   145,   146,   147,   148,  -818,     0,     0,     0,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,  1208,     0,     0,     0,     0,    43,   123,
       0,     0,     0,   143,   144,   145,   146,   147,   148,     0,
       0,     0,  3925,     0,     0,     0,     0,     0,     0,   594,
    2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,
      43,  2991,     0,    22,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,     0,  1323,     0,     0,     0,     0,
       0,     0,     0,     0,  3942,     0,     0,     0,     0,    22,
     143,   144,   145,   146,   147,   148,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,  3951,     0,     0,     0,  1361,
       0,   123,    78,    79,    80,    81,    82,     0,     0,     0,
      43,  2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,
    2990,     0,  2991,     0,     0,     0,     0,     0,     0,  3975,
    1397,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1416,     0,    78,    79,
      80,    81,    82,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,
    2989,  2990,     0,  2991,     0,     0,     0,   594,     0,     0,
      78,    79,    80,    81,    82,     0,     0,     0,     0,     0,
      43,  2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,
    2990,     0,  2991,     0,  1591,     0,     0,     0,     0,     0,
       0,     0,  1430,     0,     0,     0,    43,    22,   143,   144,
     145,   146,   147,   148,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,    22,     0,     0,     0,     0,   123,
      78,    79,    80,    81,    82,     0,  2531,  2532,  2533,  2534,
    2535,  2536,  2537,  2538,  2539,  2540,   594,  2541,     0,     0,
       0,     0,     0,     0,  4050,     0,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
       0,     0,     0,     0,  1441,   123,    22,     0,     0,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,     0,     0,     0,     0,   123,     0,     0,
      78,    79,    80,    81,    82,     0,     0,     0,     0,     0,
    4051,     0,  2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,
    2989,  2990,     0,  2991,   594,     0,    78,    79,    80,    81,
      82,     0,     0,     0,    43,     0,   143,   144,   145,   146,
     147,   148,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    43,     0,     0,    22,     0,     0,   123,  2981,  2982,
    2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,     0,  2991,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4052,   143,   144,   145,   146,   147,   148,  2981,  2982,
    2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,     0,  2991,
       0,   594,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1528,    43,   143,   144,   145,   146,   147,   148,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    22,  4053,     0,     0,     0,     0,   123,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,  1529,     0,
       0,  4236,  2671,   123,    78,    79,    80,    81,    82,     0,
       0,     0,     0,     0,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1533,    78,    79,    80,    81,    82,     0,     0,     0,     0,
       0,    43,    22,     0,     0,     0,     0,  2674,     0,     0,
       0,     0,     0,  2981,  2982,  2983,  2984,  2985,  2986,  2987,
    2988,  2989,  2990,     0,  2991,     0,  4260,     0,     0,  2981,
    2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,     0,
    2991,     0,     0,     0,     0,     0,     0,    22,     0,   594,
       0,     0,     0,    78,    79,    80,    81,    82,     0,     0,
    1534,     0,     0,     0,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,     0,     0,     0,   594,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    43,    22,
     143,   144,   145,   146,   147,   148,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,    22,     0,     0,
       0,   123,  4279,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,     0,     0,     0,     0,     0,   123,     0,
    1535,    78,    79,    80,    81,    82,     0,     0,     0,    43,
       0,     0,     0,     0,     0,   594,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1540,     0,  4292,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    43,    22,     0,     0,  4311,     0,
     123,     0,     0,     0,     0,     0,     0,     0,     0,  2981,
    2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,     0,
    2991,     0,     0,     0,     0,     0,     0,     0,    78,    79,
      80,    81,    82,     0,     0,     0,    43,     0,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   594,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    43,   143,   144,   145,   146,   147,
     148,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,    22,     0,     0,     0,     0,   123,    78,
      79,    80,    81,    82,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   594,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1590,     0,     0,   143,   144,   145,
     146,   147,   148,  4427,     0,     0,     0,     0,     0,     0,
     594,     0,     0,     0,    78,    79,    80,    81,    82,  4430,
       0,  1592,    43,    22,     0,     0,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
      22,     0,     0,     0,     0,   123,    78,    79,    80,    81,
      82,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,
    2540,     0,  2541,     0,     0,     0,     0,     0,     0,     0,
       0,   594,     0,  1845,    78,    79,    80,    81,    82,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
      43,    22,     0,     0,     0,     0,   123,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,   594,     0,
       0,   123,    78,    79,    80,    81,    82,     0,     0,     0,
      43,  2121,   143,   144,   145,   146,   147,   148,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,    43,    22,  4437,
       0,     0,     0,   123,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,     0,
       0,   123,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2129,     0,
      78,    79,    80,    81,    82,     0,     0,     0,    43,     0,
       0,     0,     0,     0,   594,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,    22,     0,  4036,     0,     0,   123,
      78,    79,    80,    81,    82,     0,     0,     0,     0,  2672,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
       0,     0,     0,     0,  4036,     0,     0,    78,    79,    80,
      81,    82,     0,     0,     0,    43,    22,     0,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,     0,     0,
       0,     0,   594,     0,  2675,     0,     0,     0,     0,     0,
       0,  4448,     0,     0,    22,     0,     0,     0,     0,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,    22,     0,     0,     0,  3880,   123,    78,    79,
      80,    81,    82,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   594,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3881,     0,   143,   144,   145,   146,
     147,   148,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    43,    22,     0,     0,     0,     0,   123,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,     0,
       0,     0,     0,     0,   123,    78,    79,    80,    81,    82,
       0,     0,     0,    43,  2981,  2982,  2983,  2984,  2985,  2986,
    2987,  2988,  2989,  2990,     0,  2991,     0,     0,     0,     0,
     594,     0,  3891,     0,     0,     0,     0,     0,     0,     0,
       0,    43,     0,     0,   143,   144,   145,   146,   147,   148,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    43,
      22,     0,     0,     0,     0,   123,  1448,  1449,  1450,  1451,
    1452,  1453,  1454,  1455,  1456,  1457,  1458,  1459,  1460,  1461,
    1462,  1463,  1464,  1465,  1466,  1467,  1468,  1469,  1470,  1471,
    1472,  1473,  1474,     0,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,     0,     0,     0,   594,     0,     0,
       0,    78,    79,    80,    81,    82,     0,     0,     0,    43,
    3892,   143,   144,   145,   146,   147,   148,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,    22,     0,     0,
       0,     0,   123,    78,    79,    80,    81,    82,  2981,  2982,
    2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,     0,  2991,
       0,     0,     0,     0,     0,     0,     0,     0,   594,     0,
    3893,    78,    79,    80,    81,    82,     0,     0,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3914,     0,    78,
      79,    80,    81,    82,     0,     0,     0,    43,    22,     0,
       0,     0,     0,  1208,     0,     0,     0,     0,     0,  2981,
    2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,     0,
    2991,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,    22,     0,   594,     0,     0,   123,    78,
      79,    80,    81,    82,     0,     0,     0,     0,  3929,   143,
     144,   145,   146,   147,   148,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    43,    22,     0,     0,     0,     0,
     123,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,     0,  4461,     0,     0,     0,   123,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,     0,     0,  3977,   123,    78,    79,    80,
      81,    82,     0,     0,     0,    43,     0,     0,     0,     0,
       0,   594,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
      43,    22,     0,   594,     0,     0,   123,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    78,    79,    80,    81,    82,     0,
       0,     0,    43,    22,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,     0,     0,  1591,
       0,  4035,     0,     0,     0,     0,     0,     0,  4473,     0,
       0,     0,     0,   143,   144,   145,   146,   147,   148,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,    22,
       0,     0,     0,  4037,   123,    78,    79,    80,    81,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4039,     0,   143,   144,   145,   146,   147,   148,  4495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      78,    79,    80,    81,    82,     0,     0,     0,    43,  4046,
       0,  1208,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,     0,
       0,   123,    78,    79,    80,    81,    82,     0,     0,     0,
      43,    22,  2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,
    2989,  2990,     0,  2991,     0,     0,     0,  1208,     0,  4047,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    43,    22,     0,     0,
       0,     0,   123,  1591,     0,     0,     0,     0,  2981,  2982,
    2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,     0,  2991,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,    22,     0,     0,     0,   123,    78,    79,
      80,    81,    82,     0,     0,     0,     0,  4049,   143,   144,
     145,   146,   147,   148,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,     0,     0,   123,
      78,    79,    80,    81,    82,     0,     0,     0,    43,  2981,
    2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,     0,
    2991,     0,     0,     0,     0,  1208,     0,    22,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4054,     0,    78,    79,    80,    81,
      82,     0,     0,     0,    43,    22,     0,     0,     0,     0,
       0,   594,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   143,   144,   145,   146,   147,   148,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
      43,    22,   594,     0,     0,   123,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4055,   143,   144,   145,   146,
     147,   148,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,    22,     0,     0,     0,     0,   123,    78,    79,
      80,    81,    82,     0,     0,     0,     0,     0,     0,     0,
    4058,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4516,     0,    43,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,     0,
       0,     0,  4063,   123,    78,    79,    80,    81,    82,     0,
       0,     0,    43,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,  4570,     0,
       0,  3783,     0,     0,     0,     0,     0,     0,     0,     0,
      78,    79,    80,    81,    82,     0,     0,     0,    43,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   143,   144,   145,   146,   147,   148,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    43,
       0,     0,     0,     0,     0,   123,  2981,  2982,  2983,  2984,
    2985,  2986,  2987,  2988,  2989,  2990,     0,  2991,  4092,     0,
       0,     0,     0,     0,    78,    79,    80,    81,    82,  4571,
     143,   144,   145,   146,   147,   148,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,     0,
    4470,   123,    78,    79,    80,    81,    82,     0,     0,     0,
    2981,  2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,
       0,  2991,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,     0,     0,     0,     0,   123,    78,    79,
      80,    81,    82,     0,     0,     0,  4580,     0,     0,  2981,
    2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,     0,
    2991,     0,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    78,
      79,    80,    81,    82,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,     0,
       0,   123,     0,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,     0,  4608,   123,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   143,   144,   145,   146,   147,   148,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
       0,     0,     0,     0,     0,   123,     0,     0,     0,     0,
       0,     0,     0,     0,  4610,     0,     0,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,  1265,  1266,     0,     0,     0,   123,     0,   143,   144,
     145,   146,   147,   148,     0,     0,  1267,     0,     0,     0,
    4612,     0,     0,     0,   608,     0,     0,  1268,     0,     0,
       0,     0,     0,     0,     0,     0,  4576,     0,     0,     0,
       0,     0,     0,     0,     0,  1269,   143,   144,   145,   146,
     147,   148,     0,  2981,  2982,  2983,  2984,  2985,  2986,  2987,
    2988,  2989,  2990,     0,  2991,   682,   683,     0,   684,   685,
       0,   686,     0,     0,     0,   687,     0,     0,     0,   688,
       0,   689,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,  3784,   690,
    4590,     0,     0,     0,     0,     0,  1270,   691,   521,     0,
       0,     0,  1145,     0,     0,   692,   693,   694,     0,   522,
       0,     0,     0,   695,   696,   697,     0,     0,     0,     0,
       0,     0,  4741,   143,   144,   145,   146,   147,   148,     0,
       0,   698,     0,     0,   699,   560,   561,   700,  1146,  4597,
       0,     0,     0,   701,  2981,  2982,  2983,  2984,  2985,  2986,
    2987,  2988,  2989,  2990,     0,  2991,     0,   552,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4775,   702,
     703,   704,     0,     0,  1271,     0,     0,     0,  1272,     0,
     611,     0,  1273,  2531,  2532,  2533,  2534,  2535,  2536,  2537,
    2538,  2539,  2540,     0,  2541,   705,     0,     0,     0,   706,
     707,   708,     0,   709,   562,   710,   563,     0,     0,  4796,
       0,     0,     0,     0,     0,   711,     0,     0,     0,   712,
     713,     0,   564,   714,   715,     0,     0,   716,   717,     0,
       0,     0,     0,     0,     0,     0,     0,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,     0,     0,   734,   735,   736,   737,   738,
     739,     0,   948,     0,     0,     0,     0,     0,     0,   740,
     741,   565,   742,   743,   744,   745,   746,   747,   748,     0,
     749,   750,     0,     0,   751,   752,     0,     0,     0,   753,
       0,     0,     0,     0,   754,   755,   756,     0,     0,     0,
     757,     0,   758,     0,     0,   759,     0,     0,     0,   524,
     525,   760,     0,   761,     0,     0,   762,   763,   764,     0,
       0,     0,     0,     0,     0,   765,   766,     0,     0,   767,
       0,   768,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   769,     0,     0,     0,     0,   770,   526,
     527,     0,     0,   771,     0,     0,     0,     0,     0,   772,
       0,     0,     0,     0,     0,     0,     0,   773,     0,     0,
     610,   774,   775,  4598,     0,     0,     0,     0,   776,     0,
       0,     0,   682,   683,  1006,   684,     0,     0,     0,     0,
       0,     0,   687,    22,   777,     0,     0,  1132,   689,   611,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     778,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,
    2540,     0,  2541,  2531,  2532,  2533,  2534,  2535,  2536,  2537,
    2538,  2539,  2540,     0,  2541,     0,     0,     0,     0,     0,
     695,   696,   697,     0,  1133,  2531,  2532,  2533,  2534,  2535,
    2536,  2537,  2538,  2539,  2540,     0,  2541,     0,     0,     0,
       0,   779,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,
    2539,  2540,     0,  2541,  4607,     0,     0,  1134,     0,   528,
     529,     0,     0,     0,     0,  1135,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   702,   703,   704,     0,
       0,     0,     0,     0,     0,     0,     0,  1136,  1137,  1138,
       0,     0,     0,  4622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   706,   707,   708,     0,
       0,     0,     0,     0,     0,     0,     0,  1139,  2531,  2532,
    2533,  2534,  2535,  2536,  2537,  2538,  2539,  2540,     0,  2541,
      43,     0,     0,  2531,  2532,  2533,  2534,  2535,  2536,  2537,
    2538,  2539,  2540,  1140,  2541,     0,  2981,  2982,  2983,  2984,
    2985,  2986,  2987,  2988,  2989,  2990,     0,  2991,     0,     0,
       0,     0,     0,  1274,  1275,  1276,  1277,  1278,  1279,  1280,
    1281,  1282,  1283,  1284,  1285,     0,     0,   741,     0,   780,
       0,     0,     0,     0,     0,   682,     0,     0,   684,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   688,
    1132,     0,     0,     0,     0,     0,     0,     0,   567,   568,
     569,   570,   571,     0,     0,     0,     0,   781,   760,  1141,
       0,  1142,     0,   762,     0,     0,  1143,  1144,  1145,     0,
       0,     0,   765,   766,     0,     0,   767,     0,   768,     0,
       0,     0,     0,   695,   696,   697,     0,  1133,     0,     0,
     769,   629,     0,     0,     0,     0,     0,     0,   782,   783,
     682,     0,     0,   684,  1146,     0,     0,     0,     0,     0,
       0,     0,     0,  1147,     0,  1132,  1148,   610,     0,     0,
      78,    79,    80,    81,    82,   776,   630,  1149,  1135,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   702,
     703,   704,   784,   572,     0,     0,   611,     0,     0,     0,
    1136,  1137,  1138,     0,  1386,     0,     0,   778,   695,   696,
     697,  4623,  1133,     0,     0,     0,     0,     0,     0,   706,
     707,   708,     0,  4624,     0,     0,     0,     0,   785,     0,
       0,     0,     0,     0,     0,     0,   786,   787,   788,   789,
     790,   791,   564,     0,     0,  4625,     0,     0,     0,     0,
       0,     0,     0,  1135,  1417,     0,     0,     0,     0,     0,
       0,     0,  4626,     0,   702,   703,   704,     0,     0,     0,
       0,     0,     0,     0,     0,  1136,  1137,  1138,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     741,     0,     0,     0,   706,   707,   708,     0,     0,     0,
     522,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,     0,     0,     0,     0,   123,     0,     0,
       0,   760,  1141,     0,  1142,     0,   762,     0,  4627,  1143,
    1144,  1145,     0,     0,     0,   765,   766,     0,     0,     0,
       0,   768,     0,  4666,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   769,   629,   741,  4724,  2531,  2532,  2533,
    2534,  2535,  2536,  2537,  2538,  2539,  2540,  1146,  2541,     0,
       0,     0,     0,     0,     0,     0,  1147,     0,     0,  1148,
     610,     0,     0,     0,     0,     0,   780,     0,   776,   630,
    1149,     0,     0,     0,     0,     0,   760,  1141,   682,  1142,
       0,   762,   685,     0,  1143,  1144,  1145,     0,   687,   611,
     765,   766,     0,     0,   689,     0,   768,     0,     0,     0,
     778,     0,     0,     0,     0,     0,     0,     0,   769,   629,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1146,     0,   143,   144,   145,   146,   147,   148,
       0,  1147,   522,     0,  1148,   610,   695,   696,   697,     0,
    1133,     0,     0,   776,   630,  1149,     0,     0,     0,     0,
       0,     0,     0,     0,  2147,     0,     0,   699,     0,     0,
     523,     0,     0,     0,   611,     0,     0,     0,     0,     0,
       0,     0,  1387,     0,     0,   778,     0,     0,     0,  1418,
       0,  1135,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   702,   703,     0,     0,     0,     0,    22,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2607,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2148,     0,     0,
    1007,     0,     0,   786,   787,   788,   789,   790,   791,     0,
       0,     0,   712,   713,     0,     0,   714,   715,     0,  2013,
     716,   717,     0,     0,     0,     0,     0,     0,     0,  1388,
     718,   719,     0,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,     0,     0,   734,   735,
     736,   737,   738,   739,     0,     0,     0,     0,     0,   780,
       0,     0,     0,     0,     0,   742,   743,   744,   745,   746,
     747,   748,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   758,     0,     0,     0,     0,
       0,     0,   524,     0,   760,  3287,   761,     0,     0,   762,
     528,   529,     0,     0,  1145,     0,     0,     0,     0,     0,
       0,     0,   767,     0,   768,    43,    22,  1215,     0,     0,
       0,     0,     0,     0,   780,     0,     0,  4777,     0,     0,
       0,   770,   526,     0,     0,     0,   771,     0,     0,     0,
       0,     0,   772,     0,     0,     0,     0,     0,     0,  1147,
       0,     0,  1148,   610,     0,     0,     0,     0,     0,     0,
       0,   776,   630,     0,     0,     0,  1216,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1718,  1719,  1720,  1721,  1722,     0,     0,     0,     0,
       0,     0,     0,   778,  1728,  1729,  1730,     0,     0,     0,
       0,  1735,  1863,     0,  1736,  1737,     0,  1217,     0,     0,
       0,     0,     0,     0,     0,     0,   786,   787,   788,   789,
     790,   791,     0,     0,     0,  1218,     0,     0,     0,     0,
    1743,     0,     0,     0,     0,     0,     0,  1219,  1220,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4450,     0,     0,     0,     0,     0,  1818,
       0,     0,   528,   529,     0,    78,    79,    80,    81,    82,
       0,     0,     0,    43,    22,  1215,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   786,   787,   788,   789,   790,   791,     0,     0,     0,
      22,     0,  1821,     0,     0,     0,  1864,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1216,     0,  1763,  1865,  1866,  1867,
    1868,  1869,  1870,  1871,  1872,     0,  1873,  1874,  1875,  1876,
    1877,  1878,  1879,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1217,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   780,  1218,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1219,  1220,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,     0,     0,
     781,     0,   123,    78,    79,    80,    81,    82,     0,     0,
       0,    43,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1221,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    43,     0,     0,
       0,  1222,   783,     0,     0,     0,     0,     0,     0,  1223,
    1224,     0,     0,     0,     0,  1225,  1226,  1227,  1228,  1229,
    1230,  1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,
    1240,  1241,  1242,  1243,  1244,     0,  1245,  1246,  1247,  1248,
    1249,  1250,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2014,  2015,
    2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,     0,  2024,
    2025,   785,     0,  2026,     0,  2027,  2028,  2029,     0,   143,
     144,   145,   146,   147,   148,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,     0,     0,
     123,    78,    79,    80,    81,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1221,     0,     0,     0,     0,     0,    78,    79,    80,
      81,    82,     0,     0,     0,     0,     0,     0,     0,  1222,
       0,     0,     0,     0,     0,     0,     0,  1223,  1224,     0,
       0,     0,     0,  1225,  1226,  1227,  1228,  1229,  1230,  1231,
    1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,  1240,  1241,
    1242,  1243,  1244,     0,  1245,  1246,  1247,  1248,  1249,  1250,
       0,  4506,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    22,  1215,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1251,   143,   144,   145,
     146,   147,   148,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,  1216,     0,     0,     0,     0,     0,   123,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,     0,
       0,     0,     0,     0,   123,     0,     0,     0,     0,     0,
       0,     0,     0,  1217,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    22,     0,     0,
       0,  1218,     0,     0,     0,  1252,     0,  2426,     0,  2427,
       0,     0,     0,  1219,  1220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3282,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    43,
      22,  1215,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1251,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    22,     0,     0,     0,     0,     0,     0,     0,     0,
    1216,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,  2154,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1217,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    43,    22,     0,     0,     0,  1218,
       0,     0,     0,  1252,     0,  2426,     0,  2427,     0,     0,
       0,  1219,  1220,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2155,     0,     0,     0,     0,     0,
    3348,     0,     0,     0,     0,     0,     0,     0,     0,    78,
      79,    80,    81,    82,     0,     0,     0,    43,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1221,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1222,     0,     0,
       0,     0,     0,     0,     0,  1223,  1224,     0,    43,     0,
       0,  1225,  1226,  1227,  1228,  1229,  1230,  1231,  1232,  1233,
    1234,  1235,  1236,  1237,  1238,  1239,  1240,  1241,  1242,  1243,
    1244,     0,  1245,  1246,  1247,  1248,  1249,  1250,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    78,    79,    80,    81,    82,     0,
       0,     0,    43,     0,     0,   352,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,     0,     0,     0,   123,    78,    79,    80,
      81,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1221,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1222,     0,     0,    78,    79,
      80,    81,    82,  1223,  1224,     0,     0,     0,     0,  1225,
    1226,  1227,  1228,  1229,  1230,  1231,  1232,  1233,  1234,  1235,
    1236,  1237,  1238,  1239,  1240,  1241,  1242,  1243,  1244,     0,
    1245,  1246,  1247,  1248,  1249,  1250,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,    22,  1215,
       0,   123,    78,    79,    80,    81,    82,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1251,   143,   144,   145,   146,   147,   148,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,  1216,     0,
       0,     0,     0,     0,   123,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,  1217,
       0,     0,     0,     0,     0,   123,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1218,     0,     0,
       0,  1252,     0,  2426,     0,  2427,     0,     0,     0,  1219,
    1220,     0,     0,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,    43,    22,  1215,     0,   123,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1251,   143,   144,   145,   146,   147,   148,    22,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1216,     0,     0,     0,
       0,     0,     0,     0,   300,     0,   301,     0,     0,     0,
       0,  2489,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1217,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    22,     0,     0,     0,  1218,     0,     0,     0,  1252,
       0,     0,     0,     0,     0,     0,     0,  1219,  1220,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    78,    79,    80,    81,    82,
     353,     0,     0,    43,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1221,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1222,    43,     0,     0,     0,     0,     0,
       0,  1223,  1224,     0,     0,     0,     0,  1225,  1226,  1227,
    1228,  1229,  1230,  1231,  1232,  1233,  1234,  1235,  1236,  1237,
    1238,  1239,  1240,  1241,  1242,  1243,  1244,     0,  1245,  1246,
    1247,  1248,  1249,  1250,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    43,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,    22,  1215,
       0,     0,   123,    78,    79,    80,    81,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1221,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    78,    79,    80,    81,    82,     0,
    2162,  1222,     0,     0,     0,     0,     0,     0,  1216,  1223,
    1224,     0,     0,     0,     0,  1225,  1226,  1227,  1228,  1229,
    1230,  1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,
    1240,  1241,  1242,  1243,  1244,     0,  1245,  1246,  1247,  1248,
    1249,  1250,     0,     0,     0,     0,     0,     0,     0,  2163,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2164,    78,    79,
      80,    81,    82,     0,    22,  1215,     0,     0,     0,  2165,
    2166,     0,     0,     0,     0,     0,     0,     0,  1251,   143,
     144,   145,   146,   147,   148,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,    43,  2162,     0,     0,     0,
     123,  2167,     0,     0,  1216,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,     0,
       0,   123,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2163,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1252,     0,  2426,
       0,  2427,     0,  2164,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2165,  2166,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
       0,     0,     0,     0,     0,   123,     0,     0,     0,     0,
       0,    43,     0,     0,     0,     0,     0,  2167,     0,     0,
       0,     0,     0,     0,     0,     0,  1251,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    78,    79,    80,    81,    82,
       0,     0,     0,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4613,  4614,     0,     0,     0,     0,  2170,  2171,  2172,
    2173,  2174,  2175,  2176,  2177,  2178,  2179,  2180,  2181,  2182,
    2183,  2184,  2185,  2186,  2187,  1252,     0,     0,  2188,  2189,
    2190,  2191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,     0,     0,   310,     0,   311,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    22,  1215,     0,     0,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,  2162,     0,
       0,     0,   123,     0,     0,     0,  1216,  2168,  2169,     0,
       0,     0,     0,  2170,  2171,  2172,  2173,  2174,  2175,  2176,
    2177,  2178,  2179,  2180,  2181,  2182,  2183,  2184,  2185,  2186,
    2187,     0,     0,     0,  2188,  2189,  2190,  2191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2163,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4615,     0,     0,  2164,     0,     0,     0,     0,
      22,  1215,     0,     0,     0,     0,     0,  2165,  2166,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,  2162,    43,     0,     0,     0,     0,   123,  2167,
    1216,     0,     0,     0,     0,     0,     0,     0,     0,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2163,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    22,  4687,  2164,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2165,  2166,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2192,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    43,     0,     0,
       0,     0,     0,  2167,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2168,
    2169,     0,     0,     0,     0,  2170,  2171,  2172,  2173,  2174,
    2175,  2176,  2177,  2178,  2179,  2180,  2181,  2182,  2183,  2184,
    2185,  2186,  2187,  2192,    43,    22,  2188,  2189,  2190,  2191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    22,  1215,     0,     0,     0,    78,    79,    80,
      81,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,  2162,     0,     0,     0,     0,     0,
     123,     0,  1216,  2168,  2169,     0,     0,     0,     0,  2170,
    2171,  2172,  2173,  2174,  2175,  2176,  2177,  2178,  2179,  2180,
    2181,  2182,  2183,  2184,  2185,  2186,  2187,     0,     0,    22,
    2188,  2189,  2190,  2191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2163,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4688,  2164,     0,     0,    78,    79,    80,    81,    82,     0,
       0,     0,    43,  2165,  2166,    22,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,    43,
       0,     0,     0,     0,   123,  2167,     0,     0,    22,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4745,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    43,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,  2192,     0,     0,     0,     0,
       0,   123,    78,    79,    80,    81,    82,     0,     0,     0,
       0,     0,    43,     0,     0,     0,     0,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    78,
      79,    80,    81,    82,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    43,    22,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2168,  2169,     0,     0,     0,
       0,  2170,  2171,  2172,  2173,  2174,  2175,  2176,  2177,  2178,
    2179,  2180,  2181,  2182,  2183,  2184,  2185,  2186,  2187,  2192,
      22,     0,  2188,  2189,  2190,  2191,    78,    79,    80,    81,
      82,     0,     0,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,    22,     0,     0,   123,
       0,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,     0,     0,     0,   123,     0,     0,     0,
       0,     0,     0,     0,     0,    78,    79,    80,    81,    82,
       0,     0,     0,    43,   318,     0,   319,     0,    22,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,    43,     0,     0,
       0,     0,    22,   123,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    43,    22,     0,     0,     0,     0,   123,
       0,     0,     0,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,     0,     0,
       0,     0,   123,    78,    79,    80,    81,    82,     0,     0,
       0,     0,   331,     0,   332,    43,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
       0,  2192,     0,     0,     0,     0,     0,    78,    79,    80,
      81,    82,     0,     0,     0,     0,     0,     0,     0,    43,
      22,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    78,    79,    80,    81,    82,     0,     0,
       0,    43,    22,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   369,     0,   370,   143,
     144,   145,   146,   147,   148,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,     0,    22,
     123,     0,     0,     0,     0,    78,    79,    80,    81,    82,
       0,     0,   392,     0,   393,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,     0,
       0,     0,     0,     0,   123,   404,     0,   405,     0,    78,
      79,    80,    81,    82,     0,     0,     0,    43,     0,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,     0,     0,
     123,    78,    79,    80,    81,    82,     0,     0,     0,    43,
       0,    22,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    43,    22,     0,     0,
       0,     0,   123,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,    22,     0,   407,     0,   408,   123,    78,    79,    80,
      81,    82,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,     0,     0,     0,     0,     0,   123,    78,
      79,    80,    81,    82,     0,     0,     0,   412,    43,   413,
      22,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    78,    79,    80,    81,
      82,     0,     0,   416,    43,   417,     0,    22,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   143,   144,   145,   146,   147,   148,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    43,     0,
       0,    22,     0,     0,   123,   427,     0,   428,     0,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,     0,     0,     0,   123,     0,    78,    79,
      80,    81,    82,     0,     0,     0,     0,    43,    22,   439,
       0,   440,     0,     0,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,     0,
       0,     0,     0,   123,    78,    79,    80,    81,    82,     0,
       0,   464,     0,   465,    43,    22,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    78,    79,
      80,    81,    82,     0,     0,     0,     0,     0,    43,    22,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   143,   144,   145,   146,   147,   148,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
       0,     0,     0,     0,     0,   123,     0,    78,    79,    80,
      81,    82,     0,     0,     0,    43,    22,     0,     0,   376,
     143,   144,   145,   146,   147,   148,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,     0,
       0,   123,     0,     0,    78,    79,    80,    81,    82,     0,
       0,   431,    43,    22,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
       0,     0,     0,     0,     0,   123,     0,  4082,    78,    79,
      80,    81,    82,     0,     0,     0,    43,     0,     0,    22,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,     0,
       0,     0,     0,     0,   123,    78,    79,    80,    81,    82,
       0,     0,     0,    43,    22,     0,     0,     0,   143,   144,
     145,   146,   147,   148,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,     0,
       0,   123,    78,    79,    80,    81,    82,     0,   491,     0,
      43,    22,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
       0,     0,     0,     0,  3037,   123,    78,    79,    80,    81,
      82,     0,     0,     0,     0,     0,    43,    22,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,  3076,     0,
       0,     0,   123,    78,    79,    80,    81,    82,     0,     0,
       0,    43,     0,    22,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,     0,     0,   123,
      78,    79,    80,    81,    82,     0,     0,  3079,    43,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,     0,
       0,     0,     0,   123,  3081,     0,    78,    79,    80,    81,
      82,     0,     0,     0,    43,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   143,
     144,   145,   146,   147,   148,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,  3187,     0,
     123,    78,    79,    80,    81,    82,     0,     0,     0,   926,
      43,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,     0,     0,     0,     0,   123,    78,    79,
      80,    81,    82,    22,   926,  3229,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,     0,  2922,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,    22,     0,
       0,     0,  3341,   123,    78,    79,    80,    81,    82,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,     0,     0,     0,  3443,     0,   123,     0,
      78,    79,    80,    81,    82,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   143,   144,   145,   146,   147,   148,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
       0,     0,     0,     0,     0,   123,     0,     0,     0,     0,
      43,     0,     0,  3469,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,    43,     0,     0,     0,     0,
    3476,   123,     0,     0,     0,     0,     0,     0,   934,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   927,     0,     0,   143,   144,   145,   146,   147,
     148,  2350,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   928,    22,     0,     0,   926,  3485,   123,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   927,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,  4231,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   939,   928,     0,     0,    22,
      78,    79,    80,    81,    82,     0,     0,     0,     0,     0,
       0,  3495,     0,     0,     0,     0,     0,     0,  2355,     0,
       0,   939,     0,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,     0,    22,
       0,     0,     0,     0,  3926,    78,    79,    80,    81,    82,
       0,     0,     0,     0,     0,     0,     0,     0,  3523,     0,
       0,     0,     0,     0,     0,    22,     0,   939,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   143,   144,   145,   146,   147,   148,
    4238,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    43,
       0,    22,     0,     0,  3554,   934,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,     0,     0,     0,    43,   123,     0,    22,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3685,     0,     0,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    43,     0,     0,     0,
       0,     0,   123,     0,     0,     0,     0,     0,     0,     0,
     935,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    43,     0,     0,   939,     0,     0,   927,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   928,     0,    78,
      79,    80,    81,    82,     0,     0,     0,     0,    43,    22,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,     0,     0,     0,   940,  2158,     0,
       0,     0,     0,     0,     0,     0,    78,    79,    80,    81,
      82,     0,     0,     0,     0,     0,    43,     0,     0,     0,
       0,     0,     0,   940,     0,     0,     0,     0,     0,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,     0,
       0,     0,    22,     0,     0,     0,    78,    79,    80,    81,
      82,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   940,
       0,  2159,    78,    79,    80,    81,    82,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,     0,     0,     0,   123,   935,    78,    79,
      80,    81,    82,     0,  2767,     0,    43,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,     0,
       0,     0,     0,   123,    22,     0,    78,    79,    80,    81,
      82,     0,     0,     0,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,    43,
       0,     0,     0,   123,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,   940,     0,   123,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   143,   144,   145,   146,   147,   148,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
       0,     0,     0,     0,     0,   123,    78,    79,    80,    81,
      82,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,     0,
       0,    43,   594,   123,     0,     0,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    78,
      79,    80,    81,    82,     0,     0,   143,   144,   145,   146,
     147,   148,    22,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2594,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   683,  1006,   684,
       0,     0,     0,     0,     0,     0,     0,     0,    22,     0,
       0,     0,   143,   144,   145,   146,   147,   148,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,   691,     0,
       0,     0,     0,   123,     0,     0,     0,     0,     0,     0,
     522,     0,     0,     0,     0,  4606,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    22,     0,   523,     0,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     702,   703,     0,     0,     0,     0,   123,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1615,     0,     0,    43,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   562,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   711,     0,     0,  1008,
       0,     0,     0,   564,     0,    43,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,  2264,     0,   718,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    22,     0,     0,
       0,   739,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   565,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,  1362,    43,     0,     0,     0,     0,   123,     0,
       0,     0,     0,   143,   144,   145,   146,   147,   148,     0,
     524,     0,   760,  2365,     0,     0,     0,   762,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    22,     0,     0,     0,     0,    78,
      79,    80,    81,    82,     0,     0,     0,     0,  2378,     0,
     526,   527,     0,     0,     0,     0,     0,     0,     0,     0,
    1362,     0,     0,     0,     0,     0,     0,     0,     0,    22,
       0,     0,     0,     0,     0,    78,    79,    80,    81,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2390,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    43,    22,     0,     0,     0,     0,
    2412,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    22,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1012,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,    43,     0,     0,     0,     0,   123,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2417,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    43,    22,     0,     0,
       0,     0,   123,  1616,  1617,  1618,  1619,  1014,  1620,  1621,
    1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,
    1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,
    1642,     0,     0,     0,    78,    79,    80,    81,    82,     0,
       0,     0,    43,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,    43,     0,
     123,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2453,     0,     0,     0,     0,     0,
       0,     0,     0,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,     0,     0,    22,     0,     0,     0,     0,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   143,
     144,   145,   146,   147,   148,  2456,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    78,    79,    80,    81,
      82,     0,     0,     0,    43,     0,    22,     0,     0,     0,
       0,  1643,  1644,  1645,     0,  2465,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,    22,     0,     0,     0,
       0,   123,    78,    79,    80,    81,    82,   143,   144,   145,
     146,   147,   148,  2468,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    78,    79,
      80,    81,    82,     0,    22,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2469,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    43,    22,     0,     0,     0,     0,   123,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,     0,
       0,     0,     0,   123,    78,    79,    80,    81,    82,     0,
       0,     0,     0,    43,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    43,     0,     0,     0,     0,     0,   123,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
       0,     0,     0,     0,     0,   123,     0,     0,     0,     0,
       0,    43,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,  2765,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    78,    79,    80,    81,    82,     0,     0,     0,
      43,     0,    22,     0,     0,     0,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,     0,
       0,   123,     0,    78,    79,    80,    81,    82,  2931,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,     0,     0,     0,    22,
       0,     0,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,  3940,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    22,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,  4214,     0,     0,     0,     0,     0,   123,
      78,    79,    80,    81,    82,     0,     0,     0,     0,    43,
       0,     0,     0,     0,    22,     0,     0,     0,   143,   144,
     145,   146,   147,   148,  4244,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,    22,     0,     0,     0,     0,
     123,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,    43,     0,     0,     0,
     123,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,     0,     0,     0,    43,     0,   123,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,     0,     0,     0,     0,   123,     0,    78,
      79,    80,    81,    82,     0,     0,     0,     0,     0,     0,
       0,    43,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4247,
       0,     0,    43,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,     0,     0,     0,
      22,     0,     0,     0,     0,     0,    78,    79,    80,    81,
      82,     0,     0,     0,     0,     0,     0,     0,     0,  4248,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      22,     0,     0,     0,     0,     0,    78,    79,    80,    81,
      82,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   143,   144,   145,   146,   147,   148,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,     0,     0,     0,   123,     0,     0,     0,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    78,    79,    80,    81,    82,  4256,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,    43,    22,     0,
       0,     0,     0,   123,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4365,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,    43,    22,     0,
       0,     0,     0,   123,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   143,   144,   145,   146,   147,   148,     0,
       0,  4562,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    22,     0,     0,     0,     0,     0,   123,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,     0,     0,   123,
     143,   144,   145,   146,   147,   148,  4611,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    78,    79,    80,
      81,    82,     0,     0,     0,    43,     0,    22,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    78,    79,    80,
      81,    82,     0,     0,     0,    43,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    43,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    22,     0,     0,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,     0,
       0,     0,     0,     0,   123,    78,    79,    80,    81,    82,
       0,     0,     0,     0,    43,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,     0,
      22,     0,     0,     0,   123,    78,    79,    80,    81,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    22,     0,     0,    78,
      79,    80,    81,    82,  2197,  2198,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    43,
       0,   143,   144,   145,   146,   147,   148,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,    22,     0,
    3930,  3931,   123,     0,    78,    79,    80,    81,    82,     0,
       0,   143,   144,   145,   146,   147,   148,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   352,    43,     0,     0,
       0,     0,   123,     0,     0,     0,     0,     0,  3259,    22,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,  1265,  1266,    43,     0,     0,   123,     0,     0,  3331,
       0,     0,     0,     0,     0,     0,  1267,     0,     0,     0,
       0,     0,     0,     0,   608,     0,     0,  1268,    22,    78,
      79,    80,    81,    82,     0,     0,     0,     0,     0,   143,
     144,   145,   146,   147,   148,  1269,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,    43,     0,     0,     0,     0,
       0,   123,     0,     0,     0,     0,     0,     0,     0,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,     0,
       0,     0,  4411,  4412,     0,     0,     0,    78,    79,    80,
      81,    82,     0,     0,     0,     0,  1270,     0,     0,     0,
       0,     0,  1145,     0,     0,     0,    43,    22,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   352,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1146,     0,
       0,     0,     0,    78,    79,    80,    81,    82,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
    3146,  3147,  3148,   352,  1271,    43,   123,     0,  1272,     0,
     611,     0,  1273,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,     0,     0,
       0,    22,     0,     0,     0,    78,    79,    80,    81,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,  2199,     0,     0,
       0,     0,     0,     0,   123,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    78,    79,    80,    81,
      82,     0,   948,     0,    43,    22,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,  3932,    22,     0,     0,     0,     0,     0,
     123,     0,     0,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,     0,     0,  3136,     0,     0,     0,     0,
      22,     0,     0,     0,     0,    78,    79,    80,    81,    82,
       0,   352,     0,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,    43,     0,
       0,     0,   123,     0,     0,     0,     0,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,     0,    22,     0,     0,  3815,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,     0,
       0,     0,     0,   123,    78,    79,    80,    81,    82,     0,
       0,     0,    43,     0,     0,  1362,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    43,     0,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,  4413,     0,    43,     0,     0,
       0,     0,   123,     0,     0,     0,     0,     0,     0,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,     0,
       0,     0,    22,     0,     0,     0,     0,  1318,    78,    79,
      80,    81,    82,     0,     0,     0,     0,     0,  3015,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    43,
     143,   144,   145,   146,   147,   148,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,  4545,    22,     0,
       0,   123,    78,    79,    80,    81,    82,     0,     0,     0,
       0,     0,     0,  1274,  1275,  1276,  1277,  1278,  1279,  1280,
    1281,  1282,  1283,  1284,  1285,    22,     0,     0,     0,     0,
       0,    78,    79,    80,    81,    82,  3748,     0,     0,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,     0,
       0,    22,     0,     0,     0,     0,     0,    78,    79,    80,
      81,    82,     0,  4710,     0,     0,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    43,
      22,     0,     0,     0,     0,   123,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    22,     0,     0,    78,
      79,    80,    81,    82,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,    43,     0,     0,     0,   123,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    43,     0,     0,     0,     0,     0,   123,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    43,     0,
       0,     0,     0,     0,   123,     0,     0,     0,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    78,
      79,    80,    81,    82,     0,     0,     0,    43,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,    43,     0,     0,   123,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    78,    79,    80,    81,    82,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    78,    79,
      80,    81,    82,     0,     0,     0,     0,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,     0,     0,     0,   123,    78,    79,    80,
      81,    82,     0,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,     0,     0,
       0,     0,   123,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,     0,     0,   123,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,  3811,     0,
       0,     0,     0,     0,     0,   123,     0,     0,     0,     0,
       0,     0,     0,   143,   144,   145,   146,   147,   148,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,  4542,     0,     0,
       0,     0,     0,     0,   123,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,  4707,     0,     0,     0,     0,     0,     0,
     123,     0,     0,     0,     0,     0,     0,     0,     0,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148
  };

  const short
  parser::yycheck_[] =
  {
       0,    84,    85,    86,     4,   465,   359,   328,   677,  1363,
      10,   493,   494,   978,   941,    15,  1002,  1120,   478,  1064,
    1069,  1714,  1334,   306,    24,   929,   307,  1327,   490,   341,
     319,   370,   319,   319,   319,   388,   319,    37,   370,   319,
     490,   319,   370,   319,   490,   490,   301,   490,    48,    49,
      50,   490,    52,   319,   341,   341,   490,    57,   319,   490,
     341,    61,   319,   490,   319,   490,   346,    67,    68,   319,
      70,   490,    72,   470,  2345,   482,   470,    77,   490,   457,
     470,   470,   470,    83,    84,    85,    86,   470,   468,    89,
     403,    91,    92,   319,   301,   468,   470,   458,   478,   301,
       4,   474,   424,   470,   301,   478,    10,   301,   424,   319,
     458,    15,   319,   458,   470,   411,   301,   319,   424,   381,
      24,   490,   490,   385,   327,   319,   126,   490,   490,   319,
     490,   341,   424,   306,   319,   337,   398,   411,   393,   408,
     337,   413,   344,  2312,    48,    49,   379,   344,    52,   341,
     150,   490,   337,    57,   154,   490,   490,    61,   490,   344,
     160,   319,   490,    67,    68,   490,    70,   393,    72,   341,
     405,   490,   490,    77,   332,   490,  2398,   462,   490,    83,
     490,   424,   490,   341,   341,    89,   393,    91,   490,   490,
     490,   393,   490,   470,   379,   490,   393,   490,   383,   393,
     455,   490,   457,   490,   490,   319,   408,   490,   393,   490,
     490,   408,   490,   398,   490,   490,   424,   408,   332,   490,
     319,   319,   126,   408,   490,   490,   490,   341,   490,   490,
     403,   490,   490,   490,   332,   490,  2458,   490,   319,  2254,
     490,   490,   470,   341,   490,   455,   150,   457,   298,   490,
     154,   458,   490,   455,   490,   457,   490,   470,   455,   490,
     457,   490,   341,   470,   458,   455,  2281,   457,   301,   470,
     455,   319,   457,   319,   319,   319,   470,   462,   314,   315,
     497,  2426,   301,   490,   468,   470,   319,  3180,   490,  1210,
    1211,   370,   476,   490,   424,   319,   490,   455,   319,   457,
     319,   370,   302,   319,   319,   490,  2528,   319,   341,   309,
    2137,   347,   312,   424,   314,   315,   316,   365,  2874,   355,
     320,   321,   341,   323,   324,   319,   341,  2141,   319,   329,
     319,  1213,   490,   333,   334,   335,   405,   319,   338,   468,
     319,   455,   342,   457,   365,   345,   468,   347,   468,   478,
     472,   387,   319,   319,   319,   355,   478,   455,   478,   457,
     393,   319,   362,   363,  2222,   332,   366,   367,   368,   408,
    3087,   371,   372,   373,   319,   375,   490,   377,   408,   468,
     319,   468,  2721,  2722,  3011,   319,   386,   387,  2428,   478,
     319,   478,   490,   468,   394,   395,  3916,   468,    52,  3595,
      52,   440,   468,   478,    52,    52,   406,   478,    52,   409,
     440,   468,   478,   470,   414,   472,    52,   474,   418,   476,
      52,   478,  2280,    52,  2282,   319,   319,    52,    52,   429,
     430,    52,   432,   433,   434,   435,   436,   437,    52,  2428,
      52,   441,   442,   468,    52,   470,    36,   472,   142,   474,
      73,   476,  2310,   478,    73,    73,   142,    93,   142,   459,
      92,  2683,     8,    52,    93,    11,   466,   307,    93,    52,
      52,    52,    52,    52,    52,    52,    52,  2335,    52,    52,
      52,    52,   381,    52,    52,    52,    73,    52,   488,    35,
     142,    52,   492,   493,   494,    52,   496,   497,    52,   398,
      52,   341,   502,    49,   142,   134,   142,   507,   508,   509,
     510,    52,   512,   142,    52,   381,   301,   142,    52,   385,
      52,    52,    52,    52,    70,    52,    73,    52,    52,    52,
      52,    52,   398,    52,   319,    52,    73,    52,   302,   142,
       4,     5,     6,    73,   306,  3803,  3803,  3803,    52,    52,
      52,    52,    52,   393,    52,    52,    52,   319,    52,    52,
      52,    52,   286,  3100,   272,  2904,   157,  3803,   408,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,  2202,    52,    52,  2205,    52,    57,    52,
    4422,    52,    52,   142,   594,   445,   446,   142,   142,   157,
     316,   157,   445,    52,    52,    71,    52,   771,   393,    48,
      52,  3803,  3803,   286,    57,   410,   398,   249,   164,   381,
     405,   398,   272,   385,   332,    52,  1126,   142,   398,  1129,
    3803,    48,    71,  3959,   142,   771,   398,    45,   638,    47,
    3887,   403,    48,  2812,    93,    52,   286,    71,    52,    58,
      59,    52,  2821,   117,   118,  2824,    52,   177,    94,    71,
      52,  4198,   316,    93,  4257,    71,    71,    52,   319,   771,
     675,    71,    93,    93,    52,  2690,    85,   677,   162,    88,
      71,    71,   445,    52,    71,  2304,    93,    52,   152,    93,
     341,   155,    93,   142,   142,    93,   142,    93,    65,   163,
     142,    48,   166,  4240,   134,    71,   142,    52,    93,    71,
     256,    94,   142,   134,    93,    93,  3963,    52,    71,   370,
     603,   142,   142,    92,    71,   230,   231,   530,    93,   289,
      93,   769,   216,    93,   771,   142,   619,    71,   142,  4332,
     745,   142,   288,    93,   142,   548,   142,    93,    93,   142,
     142,    71,   769,  1106,    93,   219,  2614,   142,    93,   142,
    2618,    71,  2620,   142,   142,   771,    94,   399,   400,   401,
     402,   403,    71,   771,   307,  2394,  3965,   142,   134,   142,
      71,  4107,   142,   249,   134,  4032,   142,    71,   134,  2887,
    2888,   249,   142,   292,   327,   259,   142,   142,   771,   332,
     264,   769,    71,   142,  2662,   142,    80,   142,   341,   445,
     446,    71,   771,    71,   142,   279,   445,   446,   282,   283,
     445,   446,   771,   292,  2209,   249,   290,   776,   292,   273,
     274,    94,   108,   109,   110,   111,   112,   113,   114,   115,
     356,   357,   306,   307,   594,    71,   379,   375,   257,   292,
     383,   350,   412,   413,   414,   771,  4402,  3168,   249,   249,
     406,  3172,   249,   327,   771,   398,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    71,   450,    71,   142,
     249,   645,   290,   249,   292,  4081,  4432,   249,   769,   316,
     771,   771,   771,    10,   358,  2280,   776,  2282,   771,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   771,   327,
     740,   741,   742,   773,   556,   292,   926,   770,   928,   929,
     680,  4763,   452,   683,   934,   935,   936,   445,   446,   939,
     940,   941,   769,   407,   408,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   769,   450,   771,   549,   959,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     769,   450,   767,   412,  1327,    92,    93,   316,   978,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   771,
     450,   549,   771,   549,   771,   412,   445,   446,   272,   116,
     412,   771,  1002,   606,   607,   713,   412,   412,   413,   772,
     556,  3548,   412,   287,   769,   445,   446,   134,   427,   428,
     484,   745,  4559,   673,  2882,   142,   769,   144,   145,   146,
     399,   400,   401,   402,   403,   675,   769,  4574,   445,   446,
     764,   445,   446,   548,   445,   446,   322,   445,   446,   445,
     446,   683,   684,   685,   686,   687,   688,  1093,   774,   412,
     445,   446,    52,   713,  1064,   412,   183,   445,   446,  1069,
     590,   769,   745,   771,   272,  1075,  1076,   769,   412,   773,
     445,   446,   445,   446,   201,   445,   446,   773,    93,   287,
     774,   764,   412,  1093,   410,    73,   213,   214,   769,   772,
     445,   446,   412,  4649,  1104,   745,   445,   446,   445,   446,
     445,   446,  1112,   412,   413,  1115,  4662,  4375,  4375,  4375,
     774,   412,   774,   769,   772,   772,  1126,  4323,   772,  1129,
    1130,   769,   249,   769,    73,   771,  4656,   142,   255,  4375,
     771,   415,   774,   412,   771,   774,   604,   605,   771,   774,
     774,   772,   412,   270,   412,   745,   769,   776,   776,   771,
     774,   769,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    52,  4719,  4375,  4375,   774,   412,   556,   769,   776,
     772,   774,   772,   772,   772,   772,   772,   471,   772,   772,
     772,   772,  4375,   772,   772,   772,  2825,   772,  1208,   746,
     747,   772,  1212,  1213,   769,   772,  4762,   763,   772,   412,
     772,    92,   771,  1223,  1224,   776,   771,   771,   771,   776,
     769,   772,   771,  2618,   772,   771,  2855,  2856,   772,   769,
     772,   772,  3869,   772,    73,   772,  3873,   772,   772,   772,
     772,   772,  1252,   772,   769,   772,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   772,   772,
     772,   772,   772,   471,   772,   772,   772,  2662,   772,   772,
     772,   772,   399,   400,   401,   402,   403,   404,    73,   772,
     772,   772,   772,   772,   772,   772,   772,   772,   772,   772,
     772,   772,   772,   107,   772,   772,   749,   772,    65,   772,
     771,   316,   772,   587,   683,   684,   685,   686,   687,   688,
     769,   769,   771,   769,   519,  1325,  1326,   769,   445,   446,
     289,  4224,    81,  1333,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,    52,   773,   769,   472,   473,   474,   475,   519,
     636,   771,   769,  1363,   771,   769,   769,   771,   769,   771,
     771,   687,   688,   769,   120,   771,   774,   771,   249,   125,
     126,   127,   771,  1383,   769,   771,   771,  4359,   769,  4578,
    4579,   769,    92,   771,   678,   679,   594,   681,   672,  4588,
    4589,   771,    50,    51,   769,   774,   771,   602,   771,   604,
     605,   771,   158,   159,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   771,   769,   181,   771,   194,   184,   556,
     445,   446,   602,    93,   604,   605,   563,    95,   771,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    52,
     450,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   769,   450,   771,   771,    52,    20,    21,   586,    45,
     131,   771,   680,    27,   771,   683,    10,    57,    32,    33,
     769,    60,   142,   140,   141,   412,   413,  2882,  4215,    92,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     769,   450,    57,   769,   271,    85,  4294,    52,   410,   411,
    4298,   629,  3141,  3142,  4302,  4418,    95,    96,   399,   400,
     401,   402,   403,   641,   642,   105,  1536,   769,  1538,   771,
      85,    69,   769,   292,   771,    92,    93,  1075,  1076,   249,
     142,   117,   118,    97,   622,   623,   624,   625,   362,   363,
     105,   238,   239,  3732,  2485,  2486,   683,   684,   685,   686,
     687,   688,   318,   286,   118,   108,   109,   110,   111,   112,
     113,   114,   115,   769,   154,   771,  4558,   412,   609,   338,
      12,  1591,   116,   342,    94,   142,   617,   618,    36,   620,
     170,   347,    52,   445,   446,   447,   448,  2489,   450,   762,
    2492,  4583,  4584,  4585,   326,    36,   160,   161,    52,   179,
     144,   145,   146,  4179,   182,   584,  3600,  3601,   279,   769,
    3604,   771,  4604,  4605,   323,   324,   325,   284,   285,  3784,
     771,   292,   434,   435,   436,  3916,   293,   412,   292,   219,
     609,   610,   611,   612,   771,   286,   249,   245,   246,   247,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   258,
     412,   251,   544,   545,   546,   556,   548,   257,   100,   101,
     102,   103,   104,   259,   264,  1223,  1224,   348,   264,   399,
     400,   401,   402,   403,   544,   545,   546,   252,   548,   544,
     545,   546,   257,   548,  1714,   259,  1716,   249,   249,   264,
     290,   240,   447,   448,  1252,   450,   292,   297,    57,   769,
      59,   771,  4704,   120,  4706,   234,   235,   236,   125,   126,
     127,   245,   246,   247,  3966,   290,   270,   544,   545,   546,
     240,   548,    81,   298,   240,   398,    85,    86,    87,    88,
     249,  4654,   441,   442,   443,   444,   771,   337,   773,   316,
     591,   158,   159,   447,   448,   344,   450,   769,   429,   769,
     308,   309,   310,   311,   312,   313,   744,   678,   679,   322,
     681,   769,   337,   286,   181,   445,   446,   184,   286,   445,
     446,   447,   448,   769,   450,   771,   399,   400,   401,   402,
     403,   549,   683,   684,   685,   686,   687,   688,   400,   401,
     402,   403,  4600,    73,  4602,   434,   435,   436,    73,   586,
     769,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      73,    73,   399,   689,   690,   691,   556,   427,   428,    73,
     586,   431,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   629,   450,   137,   138,   139,   684,   685,   686,
     404,   769,    73,   771,  4223,    73,   431,   431,   769,   769,
     771,   771,    73,    73,   651,   652,    73,    73,   445,   446,
      73,   772,   628,   629,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,  2131,   450,   769,   769,   771,   771,
     646,   647,   648,   649,   650,   469,    73,   770,   257,   772,
     769,   771,   771,    52,  2255,  2256,   771,    73,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,  2240,   772,   769,
     347,   771,    73,   556,   769,  2246,   771,   769,   769,   771,
     771,   769,  2227,   771,   771,   769,  3595,   771,   769,   769,
     771,   771,    73,   683,   684,   685,   686,   687,   688,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   769,
     450,   771,   748,    52,   772,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   769,   450,   771,    52,   769,
    2227,   771,   769,    73,   771,  2227,   769,   375,   771,   769,
    2227,   771,   769,  2227,   771,   769,   769,   771,   771,   563,
      73,   769,  2227,   771,    73,   769,   769,   771,   771,   769,
    2339,   771,  2339,  2339,  2339,   769,  2339,   771,   769,  2339,
     771,  2339,    73,  2339,  2385,  2386,  2387,  2240,   769,   772,
     771,    52,   772,  2339,   769,   769,   771,   771,  2339,   769,
     772,   771,  2339,   769,  2339,   771,   769,    73,   771,  2339,
     683,   684,   685,   686,   687,   688,    73,    73,   371,  2411,
     770,   374,   772,   636,   377,    73,    73,   380,   381,   382,
     770,    73,   772,  2339,   387,    73,   389,   662,    73,    73,
      73,    73,    73,  2123,  2411,  2411,    73,    73,    52,  2339,
    2411,  2131,  2339,    73,    73,  2135,  2136,  2339,    73,    73,
      73,  2141,    73,    73,  2483,  2339,   772,    52,   769,  2339,
    4421,  2483,  4423,   772,  2339,  2483,   772,   772,    73,  2362,
      73,    73,    73,    73,   734,    73,   532,  4336,   772,  2219,
      73,  2207,   538,   539,   540,   541,   542,   543,    73,   772,
      73,  2339,    73,    73,    73,    73,  2388,   553,   732,   734,
     734,  2388,    73,    73,  2227,    73,   562,  4212,  4367,    73,
      73,  2411,  4371,  2388,  4373,  4374,    73,  2207,  2227,    73,
      73,    73,  2212,  2213,    73,    73,  2252,  2375,    73,  2411,
      73,    73,    73,    73,  4264,  2339,  2226,    73,    73,  2229,
      73,    73,  4454,  4455,    73,    73,    73,    73,    73,  2411,
    2339,  2339,    73,  2279,    73,    73,    73,    73,    73,    73,
      73,  2251,  2252,  2411,  2411,    73,    73,  2257,  2339,  2259,
      73,  2375,  2262,  2263,  2300,  2301,  2302,    73,    73,    73,
      73,    73,  2308,    73,  2274,  4264,    73,  2375,  2314,  2279,
      73,    73,    73,    73,  3903,    73,  3905,  4114,    73,    73,
      73,  2339,    73,  2339,  2339,  2339,    73,  2411,  2611,    73,
    2300,  2301,  2302,    73,  4118,  2567,  2339,  2307,  2308,  2571,
      73,    52,  4352,  2411,  2314,  2339,  2549,    52,  2339,   772,
    2339,  2321,  2226,  2339,  2339,  2229,    73,  2339,    73,   772,
    2626,    52,  2411,    52,    73,    73,  2598,  2592,  2660,    73,
    2340,    73,    73,   772,  2660,  2339,   771,  2383,  2339,   772,
    2339,  3970,  2626,  2622,  2660,  2259,  2628,  2339,  2262,  2263,
    2339,   748,    73,  4352,  2549,  2401,  2592,  2827,  2660,    73,
    2691,  2692,  2339,  2339,  2339,    73,  2376,    73,  2411,  2757,
    2615,  2339,  2382,  2383,  2569,  2592,  4657,    73,    73,    52,
    2592,   772,  2411,    73,  2339,  2592,  2411,    73,  2592,    73,
    2339,  2401,  2763,  2863,  2483,  2339,  2246,  2592,  2375,    73,
    2339,    73,    73,  2598,  2483,  2763,  2464,  2660,  2763,  2419,
    2622,    73,  3343,    73,  2424,  2622,  2426,  2427,  2428,    73,
      73,  2622,    73,    73,  2916,    73,  2340,  2622,  2611,  2475,
    2761,  2441,  2227,  2464,    73,  2339,  2339,    73,  4670,  2829,
    2847,  2913,  2660,  2847,    73,  2455,  2829,  2847,  2847,  2847,
    2460,   772,  4081,  2913,  2847,    52,    73,  2913,  2913,   772,
    2913,  2471,  2376,  2847,  2913,  2475,  2883,   772,  2240,  2913,
    2847,   772,  2913,  2863,  2484,  2858,  2913,    73,  2913,  2489,
    2863,  2847,  2492,  4764,  2913,  2495,  2496,  2497,  2498,  2499,
    2500,  2913,  2757,  2503,  2504,  2505,  2506,  2507,  2508,  2509,
    2510,  2511,  2512,  2513,  2514,  2515,  2516,  2517,  2518,  2519,
    2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,  2813,  2529,
    2660,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,
    2540,  2541,    73,  2543,  2913,  2913,  2615,  2757,    73,  2660,
    2913,  2913,    73,  2913,  2339,  2757,  2763,   772,    73,  2592,
    2757,    73,  4181,    73,  2600,    73,  2602,  2757,   771,  2763,
    2847,  2411,  2757,    73,  2913,    52,   771,  2339,  2913,  2913,
    2484,  2913,   769,  2622,    52,  2913,  2669,  4206,  2913,  2589,
    2590,  2591,  2622,  2593,  2913,  2913,  2596,  2597,  2913,  2757,
    2600,  2913,  2602,  2913,  4223,  2913,  4464,  2607,  2608,   772,
      52,  2913,  2913,  2913,   771,  2913,  2616,    73,  2913,  2847,
    2913,  2621,  2943,    73,  2913,  2661,  2913,  2913,  2813,  2629,
    2913,    52,  2913,  2913,  2847,  2913,    73,  2913,  2913,  2639,
    2847,    73,  2913,  2757,    73,  2829,  2847,  2913,  2913,  2913,
    2686,  2913,  2913,  2847,  2913,  2913,  2913,  2696,  2913,  2757,
    2913,  2661,  2847,  2913,  2913,  2665,  2696,  2913,  2567,  2669,
      73,  2671,  2913,    73,  2674,  2913,  2860,  2913,  2678,  2913,
    2680,  2681,  2913,    73,  2913,    73,  2686,  2591,  2339,    73,
     771,   771,   771,  2693,   771,  2695,   771,   771,   771,  2598,
    2829,  2567,  2702,  2607,  4323,  2571,  2913,  2829,   771,  2829,
     771,  2913,  2616,  2246,   771,   771,  2913,  2621,   771,  2913,
    2720,    73,  4034,  2759,   771,  2629,  4026,  1075,  2913,   771,
    2852,   771,  2598,   771,  2863,  2639,   375,    73,    73,  2775,
    2829,  2863,  2829,  2863,   771,   771,   771,  4366,   771,   771,
     771,  4370,  2592,    52,  2829,  2913,   771,   771,  2829,  2759,
    2411,  2665,   771,  2829,   771,   771,   771,  2767,   771,  2769,
     771,   771,  2829,   771,  2863,  2775,  2863,   771,  4397,   771,
      73,  2817,  2622,  2819,  2820,    73,    73,    73,  2863,    73,
    2847,  2695,  2863,    73,    73,  2852,  4489,  2863,    73,  2913,
      73,  2858,    73,  2860,  2829,  2567,  2863,  2592,    73,  2571,
      73,    73,    73,   772,    73,  2913,   772,  2817,    73,  2819,
    2820,    73,  2847,    73,    73,    52,    52,  2852,  2828,  2362,
    2615,   772,  2483,  2858,    73,  2860,  2598,    73,  2863,    73,
    4459,    73,  2375,    73,    73,    73,   772,    52,    73,  2611,
      73,    73,    52,    73,    73,  2891,    73,    22,    23,    24,
     331,    73,    52,    28,    29,    30,    31,    73,   772,  3972,
      73,    73,    73,   772,  2910,  1223,  1224,    73,  2411,    73,
      73,    46,   353,   354,    52,    73,   772,    73,    73,    73,
      73,  2891,    57,  4512,    73,  4514,  2424,    73,  3943,  3948,
    2428,    73,    73,    73,  1252,    52,    73,    73,    52,    73,
    2910,   772,    73,    73,    52,   772,  2916,    52,   772,    73,
      85,    73,    73,    73,  2828,   441,   442,   443,   444,   445,
     446,   447,   448,  2933,   450,   398,    73,  2937,  2938,    73,
      73,  2941,    73,    73,  2944,  2945,    73,  2947,  2948,  2949,
      73,  2951,    73,    73,    73,  3941,    73,    73,  3311,    73,
      73,   772,    52,   772,   772,   772,    73,  2495,  2496,  2497,
    2498,    73,  3937,    73,    73,  2503,  2504,  2505,  2506,  2507,
    2508,  2509,  2510,  2511,  2512,  2513,  2514,  2515,  2516,  2517,
    2518,  2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,
    3927,    73,    73,  2531,  2532,  2533,  2534,  2535,  2536,  2537,
    2538,  2539,  2540,  2541,  4633,  3919,  2549,    73,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,  4647,   450,
      73,    73,    73,    73,  4653,    73,  2569,    73,  3038,    73,
    3040,    73,    73,    73,    73,    73,    73,    73,  4667,  4668,
    4669,    73,     3,    73,  3054,     6,    73,    73,    73,    73,
      73,    73,    73,  4682,  4683,  2598,    73,    18,    73,    73,
      73,    73,    73,   772,    52,   772,    73,  3077,  3431,    73,
    3080,    73,  3082,    73,    73,    73,    73,  3087,    73,    73,
      73,    73,   257,   258,    73,    52,    73,    73,    57,    73,
      73,    73,    73,    73,    73,  3105,    73,    73,    73,    73,
      61,    62,    63,    73,    65,   586,   587,    73,    73,    73,
      73,    73,    52,    73,    83,    84,    85,    73,    73,  4483,
      73,    73,   297,   298,    73,  4754,    73,  4756,    73,    73,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
    3054,   450,    73,    73,    52,   106,   107,   628,   629,    73,
     631,   632,    73,   634,   635,   636,   117,   118,   119,    73,
     641,    73,    73,    73,    73,   772,    73,   128,   129,   130,
      73,   652,    73,    73,    73,    73,    73,    73,  3188,  3189,
      73,    73,    73,   152,    92,   154,   147,   148,   149,    52,
      73,  3105,   772,  3203,  3204,    52,   772,    73,  3208,    52,
      73,   170,  3212,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    73,   450,    73,    52,    73,  3897,    73,
    3230,  3231,    73,   184,    73,    73,    73,  3237,    73,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    92,
     450,  3251,    73,    73,    73,    73,    73,    73,   772,  3295,
     219,    73,   427,   428,    73,    52,  3302,   218,   772,    73,
      73,    73,    73,  3273,    52,   772,    52,   772,    73,  3279,
      52,  3281,   441,   442,   443,   444,   445,   446,   447,   448,
    3290,   450,   772,    73,  3294,  3295,    73,   772,   257,  3781,
      73,   249,  3302,    73,    73,    73,    73,    73,   259,   260,
      73,   262,    73,   264,    73,    73,   267,   268,   269,    73,
     249,    73,   273,   274,   511,  3325,    73,    73,   279,    73,
      73,   290,    73,    73,    73,    73,    73,    73,   297,    73,
     291,   292,  3342,  3803,   772,    52,    73,   769,   772,   772,
      52,   249,   292,   771,   305,   772,   771,  2885,   771,  2887,
    2888,   769,   776,   314,    73,   771,   317,   318,   769,   771,
      52,   776,   771,   771,   769,   326,   327,   328,   771,   776,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
    3294,   450,   771,   771,   771,   771,   347,  3397,   771,   771,
     771,   771,   771,   771,   771,   771,   249,   358,   771,   771,
     771,   362,   771,   771,   365,   771,  3416,    52,   771,   776,
     771,   771,    20,    21,  3424,  3425,   771,    25,    26,    27,
     771,   771,   771,   771,    32,    33,  1075,  1076,   142,   142,
      38,    39,   142,   142,  3444,   142,  3446,   142,   142,  3449,
     142,   142,   316,  1092,  3454,   773,  3456,   142,   142,    52,
    3460,   142,   142,   142,   142,   771,   769,   771,   427,   428,
    3470,   142,    52,   142,   769,   769,   142,  3477,   769,  3479,
     769,   142,   142,    22,    23,    24,  3486,   769,   316,    28,
      29,    30,    31,   142,   142,    34,  3496,   771,   142,    97,
     142,   399,   400,   401,   402,   403,    45,    46,   142,   142,
     142,   142,  3416,   142,    52,   773,   142,   142,    57,   142,
     118,   142,   142,   771,  3524,   771,  3526,   142,  3528,  3529,
     142,   771,  3532,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   142,   450,   142,    85,   142,   769,    52,
    3454,   769,  3456,    52,   769,  3555,   399,   400,   401,   402,
     403,    52,   160,   161,    52,   769,   105,  3567,  3568,  3569,
     769,  3571,   142,   142,    52,  3479,   142,   769,   769,   776,
     769,   316,   142,   316,  1223,  1224,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   547,   450,    52,  3599,
    3600,  3601,   316,   316,  3604,   316,   769,   769,   142,   142,
     142,  3964,   769,  1252,    92,   142,   769,   576,   577,   578,
     579,   580,   142,   769,   769,   142,   142,   142,   769,   769,
     769,   142,  3632,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   142,   771,   769,   142,   142,   769,   556,   769,
     769,   259,   142,   771,   769,   771,   264,   142,   772,   142,
     142,   769,  3672,  4026,   769,   769,  4029,   769,   769,   142,
     769,   769,   769,   769,   769,   769,  3686,    73,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   769,   450,   142,
     771,   769,   671,   556,   142,   774,   142,   142,   257,   258,
     142,   142,   771,   769,   769,   769,    52,   286,  3632,   142,
     769,  3731,   769,   142,   769,   142,   769,    73,   142,   337,
     142,   398,   142,   142,   769,   769,   769,   142,  4417,   142,
     769,   769,   142,  3281,    52,   142,   590,   142,   297,   298,
     769,   771,  3290,   714,   715,   716,   717,   718,   719,   769,
     142,   249,   771,   771,   769,   142,   769,   142,   769,   142,
     142,  3781,   142,   142,  3784,   683,   684,   685,   686,   687,
     688,   142,   142,   142,    92,   142,   142,   142,   398,    73,
      73,   769,  3802,    73,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    73,   450,    73,   142,   142,   142,
     769,  4142,   769,   142,   142,   769,   142,  3731,   769,   142,
     142,   769,   142,   431,   142,   142,   769,   773,   769,   142,
     683,   684,   685,   686,   687,   688,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   769,   450,   142,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,  3397,
     450,   469,   601,   142,   772,   142,  3876,   773,   142,   771,
     142,   142,   142,   352,   769,   316,  3886,   771,   427,   428,
     142,   771,   771,   769,   769,   769,   142,  3897,   769,   142,
    3900,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   142,   450,   771,   142,  4375,   142,   142,    52,  3919,
     518,   399,   400,   401,   402,   403,   142,  3927,   142,   772,
     142,   142,   142,   142,   142,   142,   142,  3937,   142,   142,
     142,  3941,   142,  3943,  1131,   142,   142,   142,  3948,   142,
     142,   249,  3952,  3953,   142,   142,  3956,   142,    92,  3959,
     142,   142,   142,   142,   142,   142,   142,   142,  3968,   769,
     142,   142,   142,   769,   773,   142,   142,   142,   142,   142,
    3980,  3981,   142,   142,   769,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   142,   450,   142,  3526,   142,
     142,  3529,   142,   142,  3532,   769,   142,   769,  4008,   769,
    4010,   142,   769,   769,   769,   142,   769,  4017,  4018,   769,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     142,   450,   142,   142,   142,   142,  4036,   769,   769,   142,
     316,  4041,  4042,   773,   769,   769,   769,   769,  4048,   769,
     769,   769,   769,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,  4072,   769,   142,   142,  2424,   156,   556,   769,
     769,   769,   769,  4083,   450,   771,   769,   316,   445,   316,
    4090,   292,   769,    52,    52,   771,   771,  4097,   770,   769,
     142,   399,   400,   401,   402,   403,   769,  4107,  4108,  4109,
     772,   142,    52,  4017,   772,   249,   772,   769,  4118,   772,
      73,  4474,   772,   769,  4477,   772,   769,  4480,    73,   450,
     292,   772,   316,   772,   732,   772,   772,    73,   292,   142,
    4140,   769,   772,  4143,  3672,   772,  4146,  2495,  2496,  2497,
    2498,    73,    73,   772,   772,  2503,  2504,  2505,  2506,  2507,
    2508,  2509,  2510,  2511,  2512,  2513,  2514,  2515,  2516,  2517,
    2518,  2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,
     772,   770,   316,  2531,  2532,  2533,  2534,  2535,  2536,  2537,
    2538,  2539,  2540,  2541,   769,   769,   772,   769,   142,    73,
     413,   769,   769,   776,   769,   683,   684,   685,   686,   687,
     688,  4211,   769,   412,   770,  4215,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,  4262,   450,    52,   772,
    4313,    52,  4315,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    52,   772,  4254,  4255,    52,  4257,   556,   772,
     772,    73,  4262,    73,  4264,   399,   400,   401,   402,   403,
     776,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   776,   450,   776,    73,  4285,  4286,   771,  4288,    73,
     142,   770,   769,    52,   772,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   776,   450,  4307,   769,    52,
      52,    52,   769,  4313,  4314,  4315,   771,   776,    73,   769,
     142,    52,    52,   772,    73,  4678,   769,  4680,   769,   316,
    4330,   771,  4332,    57,    73,    73,   142,   769,   286,  4339,
    4340,  4341,  4342,   316,    73,  4345,  4346,  4347,   772,   769,
      52,   769,  4352,   772,   769,   769,   772,   769,    52,   142,
     142,   772,   772,  4363,  4364,   770,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    52,   450,   769,   776,
     769,  4381,    73,    73,  4384,   683,   684,   685,   686,   687,
     688,    73,    73,    73,    73,    73,    73,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    73,  4417,   776,   549,
     776,   157,   556,    73,  3952,  3953,   769,    73,   142,   771,
     769,  3959,    52,    52,   158,   159,    52,   769,   769,   772,
     769,   771,   769,    73,   772,  4445,  4446,   769,   601,   173,
     770,   156,  3980,  3981,   769,   769,   142,   181,   769,   410,
     184,   316,   771,   769,   769,   769,  4466,  4467,   769,   769,
     772,    73,   769,   769,   772,   769,   769,   769,   202,   769,
    4008,   772,  4010,  4483,   772,  4485,   772,  4487,   771,  4489,
    4490,   776,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,    52,   450,    52,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   769,   450,    52,    52,   769,
     769,   142,   769,   601,   769,   769,  4609,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   142,   450,   263,
     776,   776,   776,   776,  4072,   269,   769,   769,    52,   683,
     684,   685,   686,   687,   688,   776,   771,    52,    52,    73,
     142,    52,  2201,  2202,  2203,   770,  2205,   410,   292,   156,
     549,   769,   157,    73,    52,   769,    52,    52,  2217,  4107,
     771,   305,   772,   772,    52,  2224,   769,   549,   157,    52,
     776,    52,    52,   142,  2233,  2234,  2235,   771,  2237,   772,
     769,   142,   142,  2242,   772,    52,   142,   160,   769,  4609,
    2704,   769,   769,   769,  2723,   767,   771,   341,   769,   769,
     769,   345,  3573,   347,   772,   349,   772,   344,   772,  2684,
     771,   769,   769,  3273,  2273,   769,  2275,  2276,  2277,  4639,
     772,  4641,   771,   776,   769,   771,  2285,  2286,   769,   769,
    2289,  2290,  2291,  2292,  2293,  2294,  2295,  2296,  2297,   772,
     771,  2388,  3237,   769,   769,  2304,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   769,   450,  2317,   769,
     769,   769,   769,   769,  2880,  4685,  2373,  2897,  2327,  4689,
    2329,  4348,  4699,   495,  4694,  4698,  4696,  4697,  2337,   772,
    4343,  2438,   494,  2869,  3431,   429,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,  3437,   450,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,  4746,   450,
    4618,  2877,  2883,  1110,  2240,  3311,  4264,  2445,  2571,  2569,
     486,  2913,  4742,  4743,  2893,  2889,  2615,  4747,  4748,  2598,
    3212,  3203,   509,  2763,   507,  2394,  2395,  4285,  4286,  4375,
    4399,  2339,   510,  4182,   367,  4224,  2405,  2406,  2407,  4207,
    2483,  2131,  2441,  4773,  1115,  2411,  4776,  1432,  2643,  2658,
    2664,  2666,  2638,  2660,  2214,  2424,  4314,  2863,  2219,  2428,
    4694,  2827,  2626,  2432,  2433,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,  2444,   450,  2858,   936,  2813,
    2829,  4339,  4340,  4341,  4342,  2860,  2847,  4345,  4346,  2592,
    2852,  2622,  2260,  3251,  4352,   772,  2696,  2375,   639,   331,
    2246,  2227,  2608,  2464,  2473,   959,  3319,  2476,   772,   331,
    2479,  1112,  2481,  2362,  4748,  2606,  3279,  2596,  3797,  3802,
    4307,   353,   354,  2941,    -1,  2933,  2495,  2496,  2497,  2498,
     772,   353,   354,  2934,  2503,  2504,  2505,  2506,  2507,  2508,
    2509,  2510,  2511,  2512,  2513,  2514,  2515,  2516,  2517,  2518,
    2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,    52,
    4330,    -1,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,
    2539,  2540,  2541,    -1,    -1,    -1,    -1,  4369,    -1,    -1,
      -1,    -1,  2551,  2552,    -1,  2554,    -1,    -1,  4446,  2558,
    2559,  2560,  2561,  2562,  2563,    -1,  2565,    52,    -1,    92,
      -1,    -1,    -1,  3281,    -1,    -1,    -1,    -1,  4466,  4467,
      -1,    -1,  3290,    -1,    -1,    -1,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,    -1,
      -1,    -1,    -1,    -1,  2613,    -1,    -1,    -1,    -1,    52,
      -1,  2168,  2169,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,    -1,    -1,  2637,   772,
      -1,    -1,    -1,    -1,    -1,  2192,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,    -1,    92,
      -1,    -1,    -1,    -1,    -1,   749,   750,   751,   752,   753,
     754,   755,   756,   757,   758,   759,   760,   761,    -1,   772,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,  3397,
      -1,   772,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,    -1,  2266,
    2267,  2268,    -1,    -1,   586,   587,   249,    92,    -1,    -1,
      -1,    -1,    -1,    -1,   586,   587,    -1,    -1,    -1,  2738,
      -1,    -1,  2741,  2742,    52,    -1,    -1,    -1,    -1,    -1,
    2749,    -1,  2751,  2752,  2753,  2754,  2755,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   249,    -1,   628,   629,   772,   631,
     632,    -1,   634,   635,   636,   637,   628,   629,   630,   631,
     632,    -1,   634,   635,    92,    -1,  2785,  2786,    -1,   641,
     652,    -1,    -1,    -1,  2793,    -1,    -1,    -1,  2345,    -1,
     652,    -1,    -1,    -1,    -1,  2352,    -1,    -1,  4696,    -1,
    2357,    -1,    -1,    -1,    -1,    -1,   249,    -1,  3526,    -1,
    2367,  3529,    -1,    -1,  3532,    -1,  2825,    -1,    -1,    -1,
      -1,    -1,    -1,  2832,  2833,  2834,    -1,  2836,    -1,    -1,
    2839,  2840,    -1,    -1,    -1,  2392,  2845,  2846,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2855,  2856,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2414,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2874,   399,   400,   401,   402,
     403,    -1,    -1,   316,   249,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,    -1,    -1,
      -1,  2900,    -1,    -1,    -1,    -1,  2905,    -1,    -1,  2908,
      -1,    -1,  2911,    -1,   399,   400,   401,   402,   403,   772,
    2467,    -1,    -1,  2470,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,    -1,    -1,    -1,    -1,
      -1,   249,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,    -1,    -1,   772,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3672,    -1,   399,   400,   401,   402,
     403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   772,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      52,   450,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2998,
    2999,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   772,    -1,    -1,
      92,    -1,    -1,   556,   399,   400,   401,   402,   403,   772,
      -1,    -1,    -1,    -1,    -1,    -1,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,    -1,    -1,    -1,    -1,
      -1,   556,    -1,    -1,    -1,    -1,    -1,  2624,    -1,    -1,
      -1,    -1,    -1,  2630,  2631,  2632,  2633,    -1,    -1,    -1,
      -1,   399,   400,   401,   402,   403,    -1,    -1,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,    -1,    -1,    -1,
      -1,    -1,    -1,   556,    -1,    -1,    -1,    -1,    -1,    -1,
    3129,  3130,  2679,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3141,  3142,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,    -1,    -1,    -1,    -1,
     683,   684,   685,   686,   687,   688,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,    -1,   249,    -1,    -1,
      -1,   556,    -1,    -1,    -1,    -1,    -1,    -1,   683,   684,
     685,   686,   687,   688,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,    -1,    -1,   772,    -1,
      -1,    -1,    -1,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,    -1,  3952,  3953,    -1,    -1,   556,   772,
     683,   684,   685,   686,   687,   688,    -1,   772,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
      -1,    -1,  3980,  3981,    -1,   772,    -1,    -1,    -1,    -1,
      -1,    -1,  3281,    -1,    -1,    -1,    -1,   772,    -1,    -1,
      -1,  3290,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4008,    -1,  4010,    -1,    -1,  3304,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   772,    -1,    -1,    -1,    -1,   683,   684,
     685,   686,   687,   688,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   769,   399,   400,   401,
     402,   403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    71,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,  4072,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    92,    -1,    -1,   683,   684,   685,   686,   687,
     688,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,    -1,    -1,    -1,    -1,  3397,    -1,
      -1,    -1,    -1,    -1,   769,  2952,  2953,  2954,  2955,    -1,
      -1,  2958,  2959,  2960,  2961,  2962,  2963,  2964,  2965,  2966,
    2967,  2968,  2969,  2970,  2971,  2972,  2973,  2974,  2975,  2976,
    2977,  2978,  2979,    -1,  2981,  2982,  2983,  2984,  2985,  2986,
    2987,  2988,  2989,  2990,  2991,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   769,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,    -1,
      -1,    -1,    92,    93,   556,    -1,    -1,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,    -1,    -1,    -1,    -1,    -1,  3526,    -1,   249,
    3529,    -1,    -1,  3532,   134,    -1,    -1,   772,    -1,    -1,
      -1,    -1,   142,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4285,  4286,    -1,
      -1,    -1,    -1,   183,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   772,    -1,    -1,    -1,    -1,  3595,    -1,    -1,    -1,
      -1,   201,    -1,    -1,    -1,    -1,  4314,    -1,    -1,    -1,
      -1,    -1,    -1,   213,   214,    -1,    -1,    -1,    -1,    -1,
      -1,   683,   684,   685,   686,   687,   688,    -1,    -1,    -1,
      -1,  4339,  4340,  4341,  4342,    -1,    52,  4345,  4346,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   249,
     450,    -1,    -1,    -1,    -1,   255,    -1,   772,  3205,    -1,
      -1,    -1,  3209,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,  3672,   450,    -1,    92,    93,    -1,   399,
     400,   401,   402,   403,    -1,   772,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,    -1,    -1,
      -1,    -1,    -1,    -1,   772,    -1,    -1,    -1,   134,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   142,    -1,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,  4446,   450,
      -1,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    52,    -1,    -1,    -1,    -1,  4466,  4467,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   183,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
    3327,    -1,    -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    92,    -1,    -1,    -1,   213,   214,   399,
     400,   401,   402,   403,    -1,    -1,    -1,    -1,    -1,    52,
      -1,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     772,    -1,    -1,   249,    -1,    -1,   556,    -1,    -1,   255,
      -1,    -1,   772,    -1,    -1,   445,   446,    -1,    -1,    92,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,    -1,
      -1,    -1,   472,   473,   474,   475,   772,    -1,    -1,  3426,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   772,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,    -1,    -1,  3903,    -1,  3905,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3463,    -1,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
      -1,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     249,    -1,    -1,  3952,  3953,    -1,   556,    -1,    -1,    -1,
    3959,    -1,    -1,   683,   684,   685,   686,   687,   688,    -1,
      -1,  3970,   772,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3980,  3981,   399,   400,   401,   402,   403,  4696,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   772,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,    -1,  4008,
      -1,  4010,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   772,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,
     446,    57,    -1,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   773,    -1,    -1,   472,   473,   474,   475,
      -1,   772,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4072,   772,    -1,    -1,    -1,    -1,   105,
      -1,    -1,  4081,   683,   684,   685,   686,   687,   688,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,    -1,
     399,   400,   401,   402,   403,    -1,    -1,    -1,  4107,    -1,
      -1,    -1,    -1,    -1,    -1,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,    -1,    -1,    -1,    -1,    -1,
     556,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,    -1,    -1,   399,   400,   401,   402,
     403,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   771,   450,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4180,  4181,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,  4206,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
      -1,    -1,   772,    -1,  4223,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   772,    -1,    -1,    -1,    -1,    -1,   556,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4264,    -1,   683,   684,   685,
     686,   687,   688,    -1,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,  4285,  4286,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,    -1,  3855,    -1,
      -1,    -1,    -1,   556,    -1,  4314,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4323,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,    -1,    -1,
    4339,  4340,  4341,  4342,    -1,    -1,  4345,  4346,    -1,    -1,
      -1,    -1,    -1,  4352,    -1,   771,    -1,    -1,    -1,  4358,
    4359,    -1,    -1,    -1,    -1,    -1,    -1,  4366,    -1,  4368,
      -1,  4370,    -1,    -1,    -1,  3922,    -1,    -1,    -1,    -1,
      -1,  3928,    -1,    -1,   683,   684,   685,   686,   687,   688,
      -1,  3938,    -1,    -1,    -1,    -1,    -1,    -1,  4397,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,    -1,    -1,    -1,  3974,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     683,   684,   685,   686,   687,   688,    -1,  4446,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
    4459,    -1,    -1,    -1,    -1,    -1,    -1,  4466,  4467,    -1,
     769,    -1,    -1,    -1,   772,  4022,    -1,    -1,    -1,    -1,
      -1,    -1,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   769,    -1,    -1,   520,   521,   522,   523,   524,   525,
     526,   527,   528,    -1,    -1,   531,   532,   533,   534,   535,
     536,   537,    -1,  4512,    -1,  4514,   772,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   769,    -1,   772,    -1,
      -1,   557,   558,   559,   560,   561,    -1,    -1,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
      -1,    -1,    -1,  4100,    -1,   581,   582,   583,    -1,  4558,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4115,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,    -1,    -1,  4583,  4584,  4585,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
      -1,    -1,  4149,  4150,    -1,  4604,  4605,   772,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
      -1,    -1,    -1,    -1,    -1,    -1,  4173,   653,  4175,    -1,
      -1,    -1,    -1,    -1,  4633,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,  4647,    -1,
      -1,    -1,    -1,    -1,  4653,    -1,    -1,    -1,   772,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4667,  4668,
    4669,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,  4682,  4683,  4232,  4233,    -1,  4235,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4243,  4696,    -1,    -1,
      -1,    -1,    -1,    -1,  4251,  4704,    -1,  4706,    -1,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,    -1,    -1,    -1,  4272,    48,    -1,    -1,    -1,
      -1,    -1,   772,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4290,  4291,   772,    -1,    -1,    -1,    71,
      -1,    -1,    -1,    -1,    -1,  4754,    -1,  4756,    -1,    -1,
       0,   772,    -1,  4310,    -1,    -1,    -1,    -1,    -1,    -1,
      92,    -1,    -1,    -1,    14,    15,    16,    -1,    -1,    -1,
      -1,   772,    -1,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    43,    44,    -1,    -1,    -1,    48,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    66,    67,    68,    -1,
      -1,    -1,    72,    -1,    74,    75,    76,    77,    78,    -1,
      -1,    -1,    -1,  4390,    -1,    -1,    -1,    -1,    -1,    89,
      90,  4398,    92,    -1,    -1,    -1,    -1,    -1,    -1,    99,
      -1,    -1,    -1,    -1,    -1,   105,    -1,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,    -1,
      -1,   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   133,    -1,   135,   136,    -1,    -1,    -1,
      -1,    -1,   772,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     772,    -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,   169,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,    -1,
     180,   772,    -1,    -1,  4491,    -1,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,    -1,    -1,
      -1,    -1,    -1,    -1,  4511,    -1,    -1,    -1,   772,   209,
     210,   211,   212,    -1,    -1,   215,    -1,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   227,   450,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   321,
     450,   241,  4549,  4550,   772,    -1,    -1,    -1,    -1,   249,
      -1,    -1,    -1,    -1,   254,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4569,    -1,    -1,    -1,    -1,    -1,   350,    -1,
    4577,    -1,    -1,    -1,    -1,   275,   276,    -1,   278,    -1,
     280,   281,   772,    -1,    -1,    -1,    -1,    -1,    -1,   289,
      -1,    -1,    -1,    -1,   294,   295,    -1,    -1,    -1,   299,
     300,    -1,    -1,   303,   304,    -1,  4613,  4614,    -1,    -1,
      -1,  4618,    -1,    -1,    -1,    -1,    -1,   399,   400,   401,
     402,   403,    -1,    -1,    -1,    -1,    -1,    -1,  4635,   329,
     330,    -1,    -1,   333,   334,   335,   336,    -1,   338,    -1,
      -1,    -1,    -1,   343,    -1,    -1,   346,    -1,    -1,    -1,
      -1,   351,   352,    -1,    -1,   355,   772,    -1,    -1,   359,
     360,   361,    -1,    -1,   364,    -1,   366,   367,   368,   369,
     370,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,  4690,    -1,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,  4702,   450,    -1,    -1,   399,
     400,   401,   402,   403,    -1,   405,    -1,    -1,    -1,    -1,
      -1,    -1,   412,   413,   414,    -1,   416,   417,   418,    -1,
     420,   421,   422,   423,   424,   425,   426,    -1,    -1,    -1,
      -1,    -1,   432,   433,    -1,    -1,    -1,    -1,   438,  4746,
     772,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,    -1,
      -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,   478,   479,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,  4799,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   513,    -1,    -1,    -1,    -1,   518,   772,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     772,    -1,    -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,
      -1,    -1,   772,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,   588,   589,
      -1,    -1,   592,   593,    -1,   595,   596,   597,   598,   599,
     600,   683,   684,   685,   686,   687,   688,    -1,   608,    -1,
      -1,    -1,    -1,   613,   614,   615,    -1,    -1,    -1,    -1,
      -1,   621,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    92,    -1,    -1,    -1,    14,    15,    16,
      -1,    -1,    -1,   643,   644,    -1,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    43,    44,    -1,    -1,
      -1,    48,    -1,    -1,    -1,    -1,   676,   677,    -1,    56,
      -1,    -1,    -1,   683,   684,   685,   686,   687,   688,    66,
      67,    68,   692,    -1,    -1,    72,    -1,    74,    75,    76,
      77,    78,    -1,    -1,   772,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    90,    -1,    92,    -1,    -1,   772,    -1,
      -1,    -1,    99,    -1,    -1,    -1,    -1,    -1,   105,    -1,
      -1,    -1,    -1,   733,    -1,   735,   736,   737,   738,   739,
      -1,    -1,    -1,   743,   121,   122,   123,   124,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,   135,   136,
      -1,    -1,    -1,    -1,    -1,   765,   766,    52,   768,    -1,
      -1,    -1,    -1,   150,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,    -1,    -1,    -1,    -1,
     249,    -1,   169,    -1,    -1,    -1,    -1,    52,    -1,    -1,
      -1,   178,    -1,   180,    -1,    -1,    -1,    92,    -1,    -1,
      -1,    -1,    -1,   772,    -1,    -1,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   772,   450,    -1,    -1,
      -1,    -1,   209,   210,   211,   212,    -1,    92,   215,    -1,
      -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     227,    -1,    -1,    -1,    -1,    -1,    -1,   316,    -1,    -1,
      -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   249,    -1,    -1,    -1,    -1,   254,    -1,    -1,
      -1,    92,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   772,    -1,   275,   276,
      -1,   278,    -1,   280,   281,    -1,    -1,    -1,   772,    -1,
      -1,    -1,   289,    -1,    -1,    -1,    -1,   294,   295,    -1,
      -1,    -1,   299,   300,    -1,    -1,   303,   304,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     399,   400,   401,   402,   403,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   329,   330,    -1,    -1,   333,   334,   335,   336,
      -1,   338,    -1,    -1,   249,    -1,   343,    -1,    -1,   346,
      -1,    -1,    -1,    -1,   351,   352,    -1,    -1,   355,   772,
      -1,    -1,   359,   360,   361,    -1,    -1,   364,    -1,   366,
     367,   368,   369,   370,   249,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   399,   400,   401,   402,   403,    -1,   405,    -1,
      -1,    -1,    -1,    -1,    -1,   412,   413,   414,   249,   416,
     417,   418,    -1,   420,   421,   422,   423,   424,   425,   426,
      -1,    -1,    -1,    -1,    -1,   432,   433,    -1,    -1,    -1,
      -1,   438,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,    -1,    -1,    -1,    -1,    -1,   556,    52,    -1,
      -1,   478,   479,    -1,    -1,    -1,    -1,   772,    -1,    -1,
      -1,    -1,    -1,    -1,   399,   400,   401,   402,   403,    -1,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,    -1,    -1,    -1,    -1,   513,    -1,    92,    -1,
      -1,   518,    52,    -1,   399,   400,   401,   402,   403,   772,
      -1,    -1,    -1,    -1,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    52,    -1,    -1,    -1,    -1,    -1,   556,
      -1,    -1,    92,    -1,    -1,    -1,    -1,    -1,   399,   400,
     401,   402,   403,    -1,    -1,    -1,    -1,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   588,   589,    92,    -1,   592,   593,   772,   595,   596,
     597,   598,   599,   600,   683,   684,   685,   686,   687,   688,
      -1,   608,    -1,    -1,    -1,    -1,   613,   614,   615,    92,
      -1,    -1,    -1,    -1,   621,    -1,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    52,   643,   644,    -1,    -1,
      -1,   556,    -1,    -1,    -1,    -1,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   249,    -1,    -1,    -1,   676,
     677,   556,    -1,    -1,    -1,    92,   683,   684,   685,   686,
     687,   688,    -1,    -1,   773,   692,    -1,    -1,    -1,    -1,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   249,
     769,    -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   733,    52,   735,   736,
     737,   738,   739,    -1,    -1,    -1,   743,    -1,    -1,    -1,
     249,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,    -1,    -1,    -1,    -1,   765,   766,
      -1,   768,    -1,    -1,    -1,    -1,   249,    92,   683,   684,
     685,   686,   687,   688,    -1,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   683,   684,
     685,   686,   687,   688,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   399,   400,   401,   402,   403,
     769,    -1,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   249,   450,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   683,   684,   685,   686,   687,   688,    -1,    -1,
      -1,    -1,    -1,    -1,   769,    -1,    -1,    -1,    -1,   399,
     400,   401,   402,   403,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   769,    52,    -1,    -1,    -1,    -1,
     399,   400,   401,   402,   403,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   399,   400,   401,   402,
     403,    -1,    -1,    -1,   249,    92,    -1,    -1,   769,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    52,    -1,    -1,    -1,    -1,    -1,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,    -1,    -1,    -1,
      -1,    -1,   556,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    92,   399,   400,   401,   402,   403,    -1,    -1,    -1,
      -1,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,    -1,    -1,    92,    -1,    -1,   556,    -1,    -1,    -1,
      -1,    -1,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,    -1,    52,    -1,    -1,    -1,   556,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,    -1,    -1,    -1,
      -1,   769,    -1,   556,   399,   400,   401,   402,   403,    -1,
      -1,    -1,   249,    92,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,    -1,    -1,    -1,   683,
     684,   685,   686,   687,   688,   769,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    52,    -1,    -1,    -1,    -1,   249,   556,
      -1,    -1,    -1,   683,   684,   685,   686,   687,   688,    -1,
      -1,    -1,   769,    -1,    -1,    -1,    -1,    -1,    -1,    52,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     249,   450,    -1,    92,   683,   684,   685,   686,   687,   688,
      -1,    -1,    -1,    -1,    -1,   769,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   769,    -1,    -1,    -1,    -1,    92,
     683,   684,   685,   686,   687,   688,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   769,    -1,    -1,    -1,   769,
      -1,   556,   399,   400,   401,   402,   403,    -1,    -1,    -1,
     249,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,    -1,    -1,    -1,    -1,    -1,   769,
     769,    -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,
     687,   688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   769,    -1,   399,   400,
     401,   402,   403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,    -1,    -1,    -1,    52,    -1,    -1,
     399,   400,   401,   402,   403,    -1,    -1,    -1,    -1,    -1,
     249,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   769,    -1,    -1,    -1,   249,    92,   683,   684,
     685,   686,   687,   688,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    -1,    92,    -1,    -1,    -1,    -1,   556,
     399,   400,   401,   402,   403,    -1,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    52,   450,    -1,    -1,
      -1,    -1,    -1,    -1,   769,    -1,    -1,    -1,    -1,    -1,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,    -1,
      -1,    -1,    -1,    -1,   769,   556,    92,    -1,    -1,    -1,
      -1,    -1,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,    -1,    -1,    -1,    -1,    -1,   556,    -1,    -1,
     399,   400,   401,   402,   403,    -1,    -1,    -1,    -1,    -1,
     769,    -1,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,    52,    -1,   399,   400,   401,   402,
     403,    -1,    -1,    -1,   249,    -1,   683,   684,   685,   686,
     687,   688,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   249,    -1,    -1,    92,    -1,    -1,   556,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   769,   683,   684,   685,   686,   687,   688,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
      -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   769,   249,   683,   684,   685,   686,   687,   688,
      -1,    -1,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    92,   769,    -1,    -1,    -1,    -1,   556,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,    -1,   769,    -1,
      -1,   769,    52,   556,   399,   400,   401,   402,   403,    -1,
      -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,   688,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     769,   399,   400,   401,   402,   403,    -1,    -1,    -1,    -1,
      -1,   249,    92,    -1,    -1,    -1,    -1,    52,    -1,    -1,
      -1,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,   769,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,    52,
      -1,    -1,    -1,   399,   400,   401,   402,   403,    -1,    -1,
     769,    -1,    -1,    -1,   683,   684,   685,   686,   687,   688,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,    92,
     683,   684,   685,   686,   687,   688,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,    -1,    92,    -1,    -1,
      -1,   556,   769,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,    -1,    -1,    -1,    -1,    -1,   556,    -1,
     769,   399,   400,   401,   402,   403,    -1,    -1,    -1,   249,
      -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   769,    -1,   769,    -1,
      -1,    -1,    -1,    -1,    -1,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   249,    92,    -1,    -1,   769,    -1,
     556,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   399,   400,
     401,   402,   403,    -1,    -1,    -1,   249,    -1,   683,   684,
     685,   686,   687,   688,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   249,   683,   684,   685,   686,   687,
     688,    -1,    -1,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,    92,    -1,    -1,    -1,    -1,   556,   399,
     400,   401,   402,   403,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   769,    -1,    -1,   683,   684,   685,
     686,   687,   688,   769,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    -1,    -1,    -1,   399,   400,   401,   402,   403,   769,
      -1,   769,   249,    92,    -1,    -1,    -1,    -1,    -1,    -1,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,    -1,
      92,    -1,    -1,    -1,    -1,   556,   399,   400,   401,   402,
     403,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,   769,   399,   400,   401,   402,   403,    -1,
      -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,
     688,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     249,    92,    -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,    -1,    -1,    52,    -1,
      -1,   556,   399,   400,   401,   402,   403,    -1,    -1,    -1,
     249,   769,   683,   684,   685,   686,   687,   688,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   249,    92,   769,
      -1,    -1,    -1,   556,    -1,    -1,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,    -1,    -1,    -1,    -1,
      -1,   556,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   683,   684,   685,   686,   687,   688,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,    -1,
     399,   400,   401,   402,   403,    -1,    -1,    -1,   249,    -1,
      -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   683,   684,
     685,   686,   687,   688,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    -1,    92,    -1,    52,    -1,    -1,   556,
     399,   400,   401,   402,   403,    -1,    -1,    -1,    -1,   769,
     683,   684,   685,   686,   687,   688,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    52,    -1,    -1,   399,   400,   401,
     402,   403,    -1,    -1,    -1,   249,    92,    -1,   683,   684,
     685,   686,   687,   688,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    52,    -1,   769,    -1,    -1,    -1,    -1,    -1,
      -1,   769,    -1,    -1,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,    92,    -1,    -1,    -1,   769,   556,   399,   400,
     401,   402,   403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   769,    -1,   683,   684,   685,   686,
     687,   688,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   249,    92,    -1,    -1,    -1,    -1,   556,    -1,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,    -1,
      -1,    -1,    -1,    -1,   556,   399,   400,   401,   402,   403,
      -1,    -1,    -1,   249,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,    -1,    -1,    -1,    -1,
      52,    -1,   769,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   249,    -1,    -1,   683,   684,   685,   686,   687,   688,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   249,
      92,    -1,    -1,    -1,    -1,   556,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   683,   684,   685,   686,   687,   688,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,
      -1,   399,   400,   401,   402,   403,    -1,    -1,    -1,   249,
     769,   683,   684,   685,   686,   687,   688,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,    92,    -1,    -1,
      -1,    -1,   556,   399,   400,   401,   402,   403,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,
     769,   399,   400,   401,   402,   403,    -1,    -1,    -1,    -1,
      -1,    -1,   683,   684,   685,   686,   687,   688,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,    -1,   399,
     400,   401,   402,   403,    -1,    -1,    -1,   249,    92,    -1,
      -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,    -1,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,    92,    -1,    52,    -1,    -1,   556,   399,
     400,   401,   402,   403,    -1,    -1,    -1,    -1,   769,   683,
     684,   685,   686,   687,   688,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   249,    92,    -1,    -1,    -1,    -1,
     556,    -1,    -1,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,    -1,   769,    -1,    -1,    -1,   556,    -1,
      -1,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,    -1,    -1,    -1,    -1,   769,   556,   399,   400,   401,
     402,   403,    -1,    -1,    -1,   249,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,
     688,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     249,    92,    -1,    52,    -1,    -1,   556,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   683,   684,   685,
     686,   687,   688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   399,   400,   401,   402,   403,    -1,
      -1,    -1,   249,    92,    -1,   683,   684,   685,   686,   687,
     688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    52,
      -1,   769,    -1,    -1,    -1,    -1,    -1,    -1,   769,    -1,
      -1,    -1,    -1,   683,   684,   685,   686,   687,   688,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,    92,
      -1,    -1,    -1,   769,   556,   399,   400,   401,   402,   403,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   769,    -1,   683,   684,   685,   686,   687,   688,   769,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     399,   400,   401,   402,   403,    -1,    -1,    -1,   249,   769,
      -1,    52,    -1,    -1,    -1,    -1,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,    -1,    -1,    -1,    -1,
      -1,   556,   399,   400,   401,   402,   403,    -1,    -1,    -1,
     249,    92,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,    -1,    -1,    -1,    52,    -1,   769,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   683,   684,   685,   686,   687,   688,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   249,    92,    -1,    -1,
      -1,    -1,   556,    52,    -1,    -1,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
      -1,    -1,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,    -1,    92,    -1,    -1,    -1,   556,   399,   400,
     401,   402,   403,    -1,    -1,    -1,    -1,   769,   683,   684,
     685,   686,   687,   688,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    -1,    -1,    -1,    -1,    -1,    -1,   556,
     399,   400,   401,   402,   403,    -1,    -1,    -1,   249,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,    -1,    -1,    -1,    52,    -1,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   683,
     684,   685,   686,   687,   688,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   769,    -1,   399,   400,   401,   402,
     403,    -1,    -1,    -1,   249,    92,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,   688,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,    -1,
     249,    92,    52,    -1,    -1,   556,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   769,   683,   684,   685,   686,
     687,   688,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,    92,    -1,    -1,    -1,    -1,   556,   399,   400,
     401,   402,   403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     769,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   769,    -1,   249,    -1,    -1,    -1,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,    -1,    -1,    -1,
      -1,    -1,   769,   556,   399,   400,   401,   402,   403,    -1,
      -1,    -1,   249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   683,   684,   685,   686,   687,   688,   769,    -1,
      -1,   316,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     399,   400,   401,   402,   403,    -1,    -1,    -1,   249,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,   688,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   249,
      -1,    -1,    -1,    -1,    -1,   556,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   769,    -1,
      -1,    -1,    -1,    -1,   399,   400,   401,   402,   403,   769,
     683,   684,   685,   686,   687,   688,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,    -1,    -1,    -1,    -1,
     769,   556,   399,   400,   401,   402,   403,    -1,    -1,    -1,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,    -1,    -1,    -1,    -1,    -1,   556,   399,   400,
     401,   402,   403,    -1,    -1,    -1,   769,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,    -1,   683,   684,   685,   686,   687,   688,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   399,
     400,   401,   402,   403,    -1,    -1,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,    -1,    -1,    -1,    -1,
      -1,   556,    -1,    -1,    -1,    -1,    -1,    -1,   683,   684,
     685,   686,   687,   688,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    -1,    -1,    -1,    -1,    -1,   769,   556,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,   688,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,    -1,
      -1,    -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   769,    -1,    -1,    -1,    -1,    -1,
      -1,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   158,   159,    -1,    -1,    -1,   556,    -1,   683,   684,
     685,   686,   687,   688,    -1,    -1,   173,    -1,    -1,    -1,
     769,    -1,    -1,    -1,   181,    -1,    -1,   184,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   769,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   202,   683,   684,   685,   686,
     687,   688,    -1,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,     3,     4,    -1,     6,     7,
      -1,     9,    -1,    -1,    -1,    13,    -1,    -1,    -1,    17,
      -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   683,   684,   685,   686,   687,   688,   773,    37,
     769,    -1,    -1,    -1,    -1,    -1,   263,    45,    46,    -1,
      -1,    -1,   269,    -1,    -1,    53,    54,    55,    -1,    57,
      -1,    -1,    -1,    61,    62,    63,    -1,    -1,    -1,    -1,
      -1,    -1,   769,   683,   684,   685,   686,   687,   688,    -1,
      -1,    79,    -1,    -1,    82,    83,    84,    85,   305,   769,
      -1,    -1,    -1,    91,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,    -1,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,   117,
     118,   119,    -1,    -1,   341,    -1,    -1,    -1,   345,    -1,
     347,    -1,   349,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   143,    -1,    -1,    -1,   147,
     148,   149,    -1,   151,   152,   153,   154,    -1,    -1,   769,
      -1,    -1,    -1,    -1,    -1,   163,    -1,    -1,    -1,   167,
     168,    -1,   170,   171,   172,    -1,    -1,   175,   176,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,    -1,   203,   204,   205,   206,   207,
     208,    -1,   429,    -1,    -1,    -1,    -1,    -1,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,    -1,    -1,   232,   233,    -1,    -1,    -1,   237,
      -1,    -1,    -1,    -1,   242,   243,   244,    -1,    -1,    -1,
     248,    -1,   250,    -1,    -1,   253,    -1,    -1,    -1,   257,
     258,   259,    -1,   261,    -1,    -1,   264,   265,   266,    -1,
      -1,    -1,    -1,    -1,    -1,   273,   274,    -1,    -1,   277,
      -1,   279,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   291,    -1,    -1,    -1,    -1,   296,   297,
     298,    -1,    -1,   301,    -1,    -1,    -1,    -1,    -1,   307,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   315,    -1,    -1,
     318,   319,   320,   769,    -1,    -1,    -1,    -1,   326,    -1,
      -1,    -1,     3,     4,     5,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    13,    92,   342,    -1,    -1,    18,    19,   347,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     358,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,    -1,    -1,    -1,    -1,    -1,
      61,    62,    63,    -1,    65,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,    -1,    -1,    -1,
      -1,   409,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,   769,    -1,    -1,    98,    -1,   427,
     428,    -1,    -1,    -1,    -1,   106,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   117,   118,   119,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   128,   129,   130,
      -1,    -1,    -1,   769,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   147,   148,   149,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   158,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     249,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   184,   450,    -1,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,    -1,    -1,
      -1,    -1,    -1,   750,   751,   752,   753,   754,   755,   756,
     757,   758,   759,   760,   761,    -1,    -1,   218,    -1,   547,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,     6,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   576,   577,
     578,   579,   580,    -1,    -1,    -1,    -1,   585,   259,   260,
      -1,   262,    -1,   264,    -1,    -1,   267,   268,   269,    -1,
      -1,    -1,   273,   274,    -1,    -1,   277,    -1,   279,    -1,
      -1,    -1,    -1,    61,    62,    63,    -1,    65,    -1,    -1,
     291,   292,    -1,    -1,    -1,    -1,    -1,    -1,   626,   627,
       3,    -1,    -1,     6,   305,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   314,    -1,    18,   317,   318,    -1,    -1,
     399,   400,   401,   402,   403,   326,   327,   328,   106,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,
     118,   119,   670,   671,    -1,    -1,   347,    -1,    -1,    -1,
     128,   129,   130,    -1,   132,    -1,    -1,   358,    61,    62,
      63,   769,    65,    -1,    -1,    -1,    -1,    -1,    -1,   147,
     148,   149,    -1,   769,    -1,    -1,    -1,    -1,   706,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   714,   715,   716,   717,
     718,   719,   170,    -1,    -1,   769,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   106,   107,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   769,    -1,   117,   118,   119,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   128,   129,   130,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     218,    -1,    -1,    -1,   147,   148,   149,    -1,    -1,    -1,
      57,    -1,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,    -1,    -1,    -1,    -1,    -1,   556,    -1,    -1,
      -1,   259,   260,    -1,   262,    -1,   264,    -1,   769,   267,
     268,   269,    -1,    -1,    -1,   273,   274,    -1,    -1,    -1,
      -1,   279,    -1,   769,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   291,   292,   218,   769,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   305,   450,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   314,    -1,    -1,   317,
     318,    -1,    -1,    -1,    -1,    -1,   547,    -1,   326,   327,
     328,    -1,    -1,    -1,    -1,    -1,   259,   260,     3,   262,
      -1,   264,     7,    -1,   267,   268,   269,    -1,    13,   347,
     273,   274,    -1,    -1,    19,    -1,   279,    -1,    -1,    -1,
     358,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   291,   292,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   305,    -1,   683,   684,   685,   686,   687,   688,
      -1,   314,    57,    -1,   317,   318,    61,    62,    63,    -1,
      65,    -1,    -1,   326,   327,   328,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    48,    -1,    -1,    82,    -1,    -1,
      85,    -1,    -1,    -1,   347,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   430,    -1,    -1,   358,    -1,    -1,    -1,   362,
      -1,   106,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   117,   118,    -1,    -1,    -1,    -1,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   773,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,    -1,    -1,
     155,    -1,    -1,   714,   715,   716,   717,   718,   719,    -1,
      -1,    -1,   167,   168,    -1,    -1,   171,   172,    -1,   174,
     175,   176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   517,
     185,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,    -1,   203,   204,
     205,   206,   207,   208,    -1,    -1,    -1,    -1,    -1,   547,
      -1,    -1,    -1,    -1,    -1,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   250,    -1,    -1,    -1,    -1,
      -1,    -1,   257,    -1,   259,    71,   261,    -1,    -1,   264,
     427,   428,    -1,    -1,   269,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   277,    -1,   279,   249,    92,    93,    -1,    -1,
      -1,    -1,    -1,    -1,   547,    -1,    -1,   769,    -1,    -1,
      -1,   296,   297,    -1,    -1,    -1,   301,    -1,    -1,    -1,
      -1,    -1,   307,    -1,    -1,    -1,    -1,    -1,    -1,   314,
      -1,    -1,   317,   318,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   326,   327,    -1,    -1,    -1,   142,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   508,   509,   510,   511,   512,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   358,   521,   522,   523,    -1,    -1,    -1,
      -1,   528,   529,    -1,   531,   532,    -1,   183,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   714,   715,   716,   717,
     718,   719,    -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,
     557,    -1,    -1,    -1,    -1,    -1,    -1,   213,   214,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,   586,
      -1,    -1,   427,   428,    -1,   399,   400,   401,   402,   403,
      -1,    -1,    -1,   249,    92,    93,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   714,   715,   716,   717,   718,   719,    -1,    -1,    -1,
      92,    -1,   629,    -1,    -1,    -1,   633,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   142,    -1,   653,   654,   655,   656,
     657,   658,   659,   660,   661,    -1,   663,   664,   665,   666,
     667,   668,   669,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   183,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   547,   201,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   213,   214,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,    -1,    -1,    -1,
     585,    -1,   556,   399,   400,   401,   402,   403,    -1,    -1,
      -1,   249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   419,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,    -1,
      -1,   437,   627,    -1,    -1,    -1,    -1,    -1,    -1,   445,
     446,    -1,    -1,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,    -1,   472,   473,   474,   475,
     476,   477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,    -1,   704,
     705,   706,    -1,   708,    -1,   710,   711,   712,    -1,   683,
     684,   685,   686,   687,   688,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,    -1,    -1,    -1,    -1,    -1,
     556,   399,   400,   401,   402,   403,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   419,    -1,    -1,    -1,    -1,    -1,   399,   400,   401,
     402,   403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,    -1,
      -1,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,    -1,   472,   473,   474,   475,   476,   477,
      -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    92,    93,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   682,   683,   684,   685,
     686,   687,   688,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   142,    -1,    -1,    -1,    -1,    -1,   556,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,    -1,
      -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   183,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,    -1,
      -1,   201,    -1,    -1,    -1,   771,    -1,   773,    -1,   775,
      -1,    -1,    -1,   213,   214,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,
      92,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   682,   683,   684,   685,   686,   687,
     688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     142,   683,   684,   685,   686,   687,   688,    -1,    -1,    -1,
      -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   183,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   249,    92,    -1,    -1,    -1,   201,
      -1,    -1,    -1,   771,    -1,   773,    -1,   775,    -1,    -1,
      -1,   213,   214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   121,    -1,    -1,    -1,    -1,    -1,
     772,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   399,
     400,   401,   402,   403,    -1,    -1,    -1,   249,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   419,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   445,   446,    -1,   249,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,    -1,   472,   473,   474,   475,   476,   477,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   399,   400,   401,   402,   403,    -1,
      -1,    -1,   249,    -1,    -1,   316,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,    -1,    -1,    -1,    -1,    -1,   556,   399,   400,   401,
     402,   403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   419,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   437,    -1,    -1,   399,   400,
     401,   402,   403,   445,   446,    -1,    -1,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,    -1,
     472,   473,   474,   475,   476,   477,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,    -1,    -1,    92,    93,
      -1,   556,   399,   400,   401,   402,   403,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   682,   683,   684,   685,   686,   687,   688,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   142,    -1,
      -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   183,
      -1,    -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,    -1,    -1,
      -1,   771,    -1,   773,    -1,   775,    -1,    -1,    -1,   213,
     214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   683,   684,
     685,   686,   687,   688,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    -1,    -1,   249,    92,    93,    -1,   556,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     682,   683,   684,   685,   686,   687,   688,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   769,    -1,   771,    -1,    -1,    -1,
      -1,    52,   683,   684,   685,   686,   687,   688,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   183,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    92,    -1,    -1,    -1,   201,    -1,    -1,    -1,   771,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   213,   214,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,
     687,   688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   399,   400,   401,   402,   403,
     771,    -1,    -1,   249,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   419,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   437,   249,    -1,    -1,    -1,    -1,    -1,
      -1,   445,   446,    -1,    -1,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,    -1,   472,   473,
     474,   475,   476,   477,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,    -1,    92,    93,
      -1,    -1,   556,   399,   400,   401,   402,   403,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   419,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   399,   400,   401,   402,   403,    -1,
     134,   437,    -1,    -1,    -1,    -1,    -1,    -1,   142,   445,
     446,    -1,    -1,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,    -1,   472,   473,   474,   475,
     476,   477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   183,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   399,   400,
     401,   402,   403,    -1,    92,    93,    -1,    -1,    -1,   213,
     214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   682,   683,
     684,   685,   686,   687,   688,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,   249,   134,    -1,    -1,    -1,
     556,   255,    -1,    -1,   142,    -1,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,    -1,    -1,    -1,    -1,
      -1,   556,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   183,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   771,    -1,   773,
      -1,   775,    -1,   201,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   213,   214,    -1,    -1,    -1,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,    -1,
      -1,    -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,    -1,
      -1,   249,    -1,    -1,    -1,    -1,    -1,   255,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   682,   683,   684,   685,
     686,   687,   688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   399,   400,   401,   402,   403,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   683,   684,
     685,   686,   687,   688,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   445,   446,    -1,    -1,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   771,    -1,    -1,   472,   473,
     474,   475,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   683,   684,   685,   686,   687,   688,    -1,    -1,
      -1,    -1,    -1,    -1,   769,    -1,   771,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    93,    -1,    -1,
      -1,   399,   400,   401,   402,   403,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,    -1,   134,    -1,
      -1,    -1,   556,    -1,    -1,    -1,   142,   445,   446,    -1,
      -1,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,    -1,    -1,    -1,   472,   473,   474,   475,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   183,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   616,    -1,    -1,   201,    -1,    -1,    -1,    -1,
      92,    93,    -1,    -1,    -1,    -1,    -1,   213,   214,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   134,   249,    -1,    -1,    -1,    -1,   556,   255,
     142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   683,
     684,   685,   686,   687,   688,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   183,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,   616,   201,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   213,   214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   771,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,    -1,
      -1,    -1,    -1,   255,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,
     688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   399,   400,   401,   402,   403,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,
     446,    -1,    -1,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   771,   249,    92,   472,   473,   474,   475,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    92,    93,    -1,    -1,    -1,   399,   400,   401,
     402,   403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   134,    -1,    -1,    -1,    -1,    -1,
     556,    -1,   142,   445,   446,    -1,    -1,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,    -1,    -1,    92,
     472,   473,   474,   475,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   183,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     616,   201,    -1,    -1,   399,   400,   401,   402,   403,    -1,
      -1,    -1,   249,   213,   214,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,   249,
      -1,    -1,    -1,    -1,   556,   255,    -1,    -1,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   683,   684,   685,
     686,   687,   688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   616,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   771,    -1,    -1,    -1,    -1,
      -1,   556,   399,   400,   401,   402,   403,    -1,    -1,    -1,
      -1,    -1,   249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   683,   684,   685,   686,   687,   688,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   399,
     400,   401,   402,   403,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   249,    92,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   445,   446,    -1,    -1,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   771,
      92,    -1,   472,   473,   474,   475,   399,   400,   401,   402,
     403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   683,   684,
     685,   686,   687,   688,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    -1,    -1,    -1,    92,    -1,    -1,   556,
      -1,    -1,   399,   400,   401,   402,   403,    -1,    -1,    -1,
      -1,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,    -1,    -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   399,   400,   401,   402,   403,
      -1,    -1,    -1,   249,   769,    -1,   771,    -1,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   249,    -1,    -1,
      -1,    -1,    92,   556,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,
     687,   688,    -1,    -1,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   249,    92,    -1,    -1,    -1,    -1,   556,
      -1,    -1,    -1,   683,   684,   685,   686,   687,   688,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,    -1,    -1,    -1,
      -1,    -1,   556,   399,   400,   401,   402,   403,    -1,    -1,
      -1,    -1,   769,    -1,   771,   249,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     683,   684,   685,   686,   687,   688,    -1,    -1,    -1,    -1,
      -1,   771,    -1,    -1,    -1,    -1,    -1,   399,   400,   401,
     402,   403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,
     687,   688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   399,   400,   401,   402,   403,    -1,    -1,
      -1,   249,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   769,    -1,   771,   683,
     684,   685,   686,   687,   688,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,    -1,    -1,    -1,    -1,    92,
     556,    -1,    -1,    -1,    -1,   399,   400,   401,   402,   403,
      -1,    -1,   769,    -1,   771,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,    -1,
      -1,    -1,    -1,    -1,   556,   769,    -1,   771,    -1,   399,
     400,   401,   402,   403,    -1,    -1,    -1,   249,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,    -1,    -1,    -1,    -1,    -1,
     556,   399,   400,   401,   402,   403,    -1,    -1,    -1,   249,
      -1,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   683,   684,   685,
     686,   687,   688,    -1,    -1,    -1,    -1,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   249,    92,    -1,    -1,
      -1,    -1,   556,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   683,   684,   685,   686,   687,   688,    -1,    -1,    -1,
      -1,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,    92,    -1,   769,    -1,   771,   556,   399,   400,   401,
     402,   403,    -1,    -1,    -1,    -1,    -1,   683,   684,   685,
     686,   687,   688,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,    -1,    -1,    -1,    -1,    -1,   556,   399,
     400,   401,   402,   403,    -1,    -1,    -1,   769,   249,   771,
      92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   683,
     684,   685,   686,   687,   688,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   399,   400,   401,   402,
     403,    -1,    -1,   769,   249,   771,    -1,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   683,   684,   685,   686,   687,   688,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   249,    -1,
      -1,    92,    -1,    -1,   556,   769,    -1,   771,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,
     688,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,    -1,    -1,    -1,    -1,    -1,   556,    -1,   399,   400,
     401,   402,   403,    -1,    -1,    -1,    -1,   249,    92,   769,
      -1,   771,    -1,    -1,    -1,    -1,    -1,    -1,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,    -1,    -1,    -1,
      -1,    -1,    -1,   556,   399,   400,   401,   402,   403,    -1,
      -1,   769,    -1,   771,   249,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   683,   684,   685,   686,   687,   688,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   399,   400,
     401,   402,   403,    -1,    -1,    -1,    -1,    -1,   249,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   683,   684,   685,   686,   687,   688,    -1,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,    -1,
      -1,    -1,    -1,    -1,    -1,   556,    -1,   399,   400,   401,
     402,   403,    -1,    -1,    -1,   249,    92,    -1,    -1,   771,
     683,   684,   685,   686,   687,   688,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,    -1,    -1,    -1,    -1,
      -1,   556,    -1,    -1,   399,   400,   401,   402,   403,    -1,
      -1,   771,   249,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,    -1,
      -1,    -1,    -1,    -1,    -1,   556,    -1,   770,   399,   400,
     401,   402,   403,    -1,    -1,    -1,   249,    -1,    -1,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   683,   684,   685,   686,   687,   688,    -1,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,    -1,
      -1,    -1,    -1,    -1,   556,   399,   400,   401,   402,   403,
      -1,    -1,    -1,   249,    92,    -1,    -1,    -1,   683,   684,
     685,   686,   687,   688,    -1,    -1,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,    -1,    -1,    -1,    -1,
      -1,   556,   399,   400,   401,   402,   403,    -1,   769,    -1,
     249,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   683,   684,   685,   686,   687,   688,    -1,    -1,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,    -1,
      -1,    -1,    -1,    -1,   769,   556,   399,   400,   401,   402,
     403,    -1,    -1,    -1,    -1,    -1,   249,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   683,   684,   685,   686,   687,   688,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,    -1,   769,    -1,
      -1,    -1,   556,   399,   400,   401,   402,   403,    -1,    -1,
      -1,   249,    -1,    92,    -1,    -1,    -1,    -1,   683,   684,
     685,   686,   687,   688,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    -1,    -1,    -1,    -1,    -1,    -1,   556,
     399,   400,   401,   402,   403,    -1,    -1,   769,   249,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   683,   684,   685,   686,   687,   688,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,    -1,    -1,    -1,
      -1,    -1,    -1,   556,   769,    -1,   399,   400,   401,   402,
     403,    -1,    -1,    -1,   249,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   683,
     684,   685,   686,   687,   688,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,    -1,    -1,    -1,   769,    -1,
     556,   399,   400,   401,   402,   403,    -1,    -1,    -1,    48,
     249,    -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,
     687,   688,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,    -1,    -1,    -1,    -1,    -1,   556,   399,   400,
     401,   402,   403,    92,    48,   769,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     683,   684,   685,   686,   687,   688,    -1,    71,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,    -1,    92,    -1,
      -1,    -1,   769,   556,   399,   400,   401,   402,   403,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   683,   684,   685,
     686,   687,   688,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,    -1,    -1,    -1,   769,    -1,   556,    -1,
     399,   400,   401,   402,   403,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,   688,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,    -1,
      -1,    -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,    -1,
     249,    -1,    -1,   769,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     683,   684,   685,   686,   687,   688,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   249,    -1,    -1,    -1,    -1,
     769,   556,    -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   321,    -1,    -1,   683,   684,   685,   686,   687,
     688,    71,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   350,    92,    -1,    -1,    48,   769,   556,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,    -1,    -1,
      -1,    -1,   683,   684,   685,   686,   687,   688,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    48,   350,    -1,    -1,    92,
     399,   400,   401,   402,   403,    -1,    -1,    -1,    -1,    -1,
      -1,   769,    -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,
      -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,   683,   684,
     685,   686,   687,   688,    -1,    -1,    -1,    -1,    -1,    92,
      -1,    -1,    -1,    -1,    71,   399,   400,   401,   402,   403,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   769,    -1,
      -1,    -1,    -1,    -1,    -1,    92,    -1,    48,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,   688,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,
      -1,    92,    -1,    -1,   769,    48,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,    -1,    -1,    -1,    -1,   249,   556,    -1,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     769,    -1,    -1,    -1,    -1,    -1,    -1,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   249,    -1,    -1,    -1,
      -1,    -1,   556,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   249,    -1,    -1,    48,    -1,    -1,   321,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   350,    -1,   399,
     400,   401,   402,   403,    -1,    -1,    -1,    -1,   249,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,   688,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   350,    48,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   399,   400,   401,   402,
     403,    -1,    -1,    -1,    -1,    -1,   249,    -1,    -1,    -1,
      -1,    -1,    -1,   350,    -1,    -1,    -1,    -1,    -1,   683,
     684,   685,   686,   687,   688,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    92,    -1,    -1,    -1,   399,   400,   401,   402,
     403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   350,
      -1,   121,   399,   400,   401,   402,   403,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,    -1,    -1,    -1,    -1,    -1,   556,   350,   399,   400,
     401,   402,   403,    -1,    52,    -1,   249,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,    -1,    -1,    -1,
      -1,    -1,    -1,   556,    92,    -1,   399,   400,   401,   402,
     403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,    -1,    -1,   249,
      -1,    -1,    -1,   556,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    -1,    -1,    -1,    -1,   350,    -1,   556,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   683,   684,   685,   686,   687,   688,    -1,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,    -1,
      -1,    -1,    -1,    -1,    -1,   556,   399,   400,   401,   402,
     403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     683,   684,   685,   686,   687,   688,    -1,    -1,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,    -1,    -1,    -1,
      -1,   249,    52,   556,    -1,    -1,    -1,    -1,    -1,    -1,
     683,   684,   685,   686,   687,   688,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   399,
     400,   401,   402,   403,    -1,    -1,   683,   684,   685,   686,
     687,   688,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     4,     5,     6,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,
      -1,    -1,   683,   684,   685,   686,   687,   688,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,    -1,    45,    -1,
      -1,    -1,    -1,   556,    -1,    -1,    -1,    -1,    -1,    -1,
      57,    -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,
     683,   684,   685,   686,   687,   688,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,    85,    -1,
      -1,   399,   400,   401,   402,   403,    -1,    -1,    -1,    -1,
      -1,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     117,   118,    -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,    -1,   249,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   152,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   163,    -1,    -1,   166,
      -1,    -1,    -1,   170,    -1,   249,    -1,    -1,    -1,    -1,
     683,   684,   685,   686,   687,   688,    71,    -1,   185,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,    -1,
      -1,   208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   219,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   316,   249,    -1,    -1,    -1,    -1,   556,    -1,
      -1,    -1,    -1,   683,   684,   685,   686,   687,   688,    -1,
     257,    -1,   259,    71,    -1,    -1,    -1,   264,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    92,    -1,    -1,    -1,    -1,   399,
     400,   401,   402,   403,    -1,    -1,    -1,    -1,    71,    -1,
     297,   298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     316,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,
      -1,    -1,    -1,    -1,    -1,   399,   400,   401,   402,   403,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   249,    92,    -1,    -1,    -1,    -1,
      71,    -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,
     688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    92,    -1,   399,   400,   401,   402,   403,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   249,    -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    71,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   249,    92,    -1,    -1,
      -1,    -1,   556,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,    -1,    -1,    -1,   399,   400,   401,   402,   403,    -1,
      -1,    -1,   249,    -1,    -1,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,    -1,    -1,    -1,   249,    -1,
     556,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   683,   684,   685,   686,   687,   688,    -1,
      -1,    -1,    -1,    -1,    -1,    92,    -1,    -1,    -1,    -1,
      -1,   399,   400,   401,   402,   403,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   683,
     684,   685,   686,   687,   688,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   399,   400,   401,   402,
     403,    -1,    -1,    -1,   249,    -1,    92,    -1,    -1,    -1,
      -1,   638,   639,   640,    -1,    71,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,    92,    -1,    -1,    -1,
      -1,   556,   399,   400,   401,   402,   403,   683,   684,   685,
     686,   687,   688,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   399,   400,
     401,   402,   403,    -1,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    71,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   249,    92,    -1,    -1,    -1,    -1,   556,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,    -1,    -1,    -1,
      -1,    -1,    -1,   556,   399,   400,   401,   402,   403,    -1,
      -1,    -1,    -1,   249,    -1,    -1,    -1,    -1,   683,   684,
     685,   686,   687,   688,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   249,    -1,    -1,    -1,    -1,    -1,   556,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,    -1,
      -1,    -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,    -1,
      -1,   249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,
     688,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   399,   400,   401,   402,   403,    -1,    -1,    -1,
     249,    -1,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     683,   684,   685,   686,   687,   688,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,    -1,    -1,    -1,    -1,
      -1,   556,    -1,   399,   400,   401,   402,   403,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,
     687,   688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,
      -1,    -1,    -1,   399,   400,   401,   402,   403,    -1,    -1,
      -1,    -1,   683,   684,   685,   686,   687,   688,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,
      -1,   399,   400,   401,   402,   403,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    71,    -1,    -1,    -1,    -1,    -1,   556,
     399,   400,   401,   402,   403,    -1,    -1,    -1,    -1,   249,
      -1,    -1,    -1,    -1,    92,    -1,    -1,    -1,   683,   684,
     685,   686,   687,   688,    71,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,    92,    -1,    -1,    -1,    -1,
     556,    -1,    -1,    -1,    -1,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,    -1,   249,    -1,    -1,    -1,
     556,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    -1,    -1,    -1,    -1,   249,    -1,   556,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,
     687,   688,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,    -1,    -1,    -1,    -1,    -1,    -1,   556,    -1,   399,
     400,   401,   402,   403,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   249,    -1,    -1,    -1,    -1,    -1,   683,   684,   685,
     686,   687,   688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,
      -1,    -1,   249,    -1,    -1,    -1,    -1,   683,   684,   685,
     686,   687,   688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      92,    -1,    -1,    -1,    -1,    -1,   399,   400,   401,   402,
     403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,
      -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,
     688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      92,    -1,    -1,    -1,    -1,    -1,   399,   400,   401,   402,
     403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,   688,
      -1,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,    -1,    -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,
      -1,   399,   400,   401,   402,   403,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   399,   400,   401,   402,   403,    71,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   249,    92,    -1,
      -1,    -1,    -1,   556,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   249,    92,    -1,
      -1,    -1,    -1,   556,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   683,   684,   685,   686,   687,   688,    -1,
      -1,    71,    -1,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,    92,    -1,    -1,    -1,    -1,    -1,   556,    -1,
      -1,    -1,    -1,    -1,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    -1,    -1,    -1,    -1,    -1,    -1,   556,
     683,   684,   685,   686,   687,   688,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   399,   400,   401,
     402,   403,    -1,    -1,    -1,   249,    -1,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     683,   684,   685,   686,   687,   688,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   399,   400,   401,
     402,   403,    -1,    -1,    -1,   249,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,
     688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,
      -1,    -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,
     687,   688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    92,    -1,    -1,    -1,    -1,    -1,    -1,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,    -1,
      -1,    -1,    -1,    -1,   556,   399,   400,   401,   402,   403,
      -1,    -1,    -1,    -1,   249,    -1,    -1,    -1,    -1,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,    -1,
      92,    -1,    -1,    -1,   556,   399,   400,   401,   402,   403,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,    -1,   399,
     400,   401,   402,   403,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,
      -1,   683,   684,   685,   686,   687,   688,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,    -1,    92,    -1,
     156,   157,   556,    -1,   399,   400,   401,   402,   403,    -1,
      -1,   683,   684,   685,   686,   687,   688,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   316,   249,    -1,    -1,
      -1,    -1,   556,    -1,    -1,    -1,    -1,    -1,   142,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,   158,   159,   249,    -1,    -1,   556,    -1,    -1,   142,
      -1,    -1,    -1,    -1,    -1,    -1,   173,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   181,    -1,    -1,   184,    92,   399,
     400,   401,   402,   403,    -1,    -1,    -1,    -1,    -1,   683,
     684,   685,   686,   687,   688,   202,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   249,    -1,    -1,    -1,    -1,
      -1,   556,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   683,
     684,   685,   686,   687,   688,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   156,   157,    -1,    -1,    -1,   399,   400,   401,
     402,   403,    -1,    -1,    -1,    -1,   263,    -1,    -1,    -1,
      -1,    -1,   269,    -1,    -1,    -1,   249,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   316,   683,   684,   685,   686,   687,   688,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   305,    -1,
      -1,    -1,    -1,   399,   400,   401,   402,   403,    -1,    -1,
      -1,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   316,   341,   249,   556,    -1,   345,    -1,
     347,    -1,   349,    -1,    -1,    -1,    -1,    -1,   683,   684,
     685,   686,   687,   688,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    92,    -1,    -1,    -1,   399,   400,   401,   402,   403,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,    -1,
      -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   399,   400,   401,   402,
     403,    -1,   429,    -1,   249,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    92,    -1,    -1,    -1,    -1,    -1,
     556,    -1,    -1,   683,   684,   685,   686,   687,   688,    -1,
      -1,    -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,    -1,
      92,    -1,    -1,    -1,    -1,   399,   400,   401,   402,   403,
      -1,   316,    -1,    -1,    -1,    -1,    -1,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,    -1,   249,    -1,
      -1,    -1,   556,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   683,   684,   685,   686,   687,   688,    -1,    -1,    -1,
      -1,    -1,    92,    -1,    -1,   157,    -1,    -1,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,    -1,    -1,    -1,
      -1,    -1,    -1,   556,   399,   400,   401,   402,   403,    -1,
      -1,    -1,   249,    -1,    -1,   316,    -1,   683,   684,   685,
     686,   687,   688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   249,    -1,    -1,    -1,    -1,    -1,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,   249,    -1,    -1,
      -1,    -1,   556,    -1,    -1,    -1,    -1,    -1,    -1,   683,
     684,   685,   686,   687,   688,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    92,    -1,    -1,    -1,    -1,   674,   399,   400,
     401,   402,   403,    -1,    -1,    -1,    -1,    -1,   316,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,
     683,   684,   685,   686,   687,   688,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,    -1,    -1,   157,    92,    -1,
      -1,   556,   399,   400,   401,   402,   403,    -1,    -1,    -1,
      -1,    -1,    -1,   750,   751,   752,   753,   754,   755,   756,
     757,   758,   759,   760,   761,    92,    -1,    -1,    -1,    -1,
      -1,   399,   400,   401,   402,   403,   316,    -1,    -1,   683,
     684,   685,   686,   687,   688,    -1,    -1,    -1,    -1,    -1,
      -1,    92,    -1,    -1,    -1,    -1,    -1,   399,   400,   401,
     402,   403,    -1,   157,    -1,    -1,    -1,    -1,    -1,    -1,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   249,
      92,    -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,    -1,   399,
     400,   401,   402,   403,    -1,    -1,    -1,    -1,   683,   684,
     685,   686,   687,   688,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    -1,    -1,   249,    -1,    -1,    -1,   556,
      -1,    -1,    -1,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   249,    -1,    -1,    -1,    -1,    -1,   556,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   249,    -1,
      -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   683,   684,   685,   686,   687,   688,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   399,
     400,   401,   402,   403,    -1,    -1,    -1,   249,    -1,    -1,
      -1,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,    -1,    -1,   249,    -1,    -1,   556,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,
     687,   688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   399,   400,   401,   402,   403,
      -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,
     688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   399,   400,   401,   402,   403,    -1,    -1,    -1,
      -1,   683,   684,   685,   686,   687,   688,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   399,   400,
     401,   402,   403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
      -1,    -1,    -1,    -1,    -1,    -1,   556,   399,   400,   401,
     402,   403,    -1,   683,   684,   685,   686,   687,   688,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   399,   400,   401,   402,   403,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,    -1,    -1,    -1,    -1,
      -1,    -1,   556,    -1,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,    -1,    -1,    -1,    -1,    -1,    -1,   556,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,    -1,
      -1,    -1,    -1,    -1,    -1,   556,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   683,   684,   685,   686,   687,   688,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,    -1,    -1,
      -1,    -1,    -1,    -1,   556,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,    -1,    -1,    -1,    -1,    -1,    -1,
     556,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   683,
     684,   685,   686,   687,   688,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,
     687,   688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   683,   684,   685,   686,   687,   688,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   683,   684,   685,   686,   687,   688,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   683,   684,   685,
     686,   687,   688
  };

  const short
  parser::yystos_[] =
  {
       0,    14,    15,    16,    40,    41,    42,    43,    44,    48,
      56,    66,    67,    68,    72,    74,    75,    76,    77,    78,
      89,    90,    92,    99,   105,   121,   122,   123,   124,   133,
     135,   136,   150,   169,   178,   180,   209,   210,   211,   212,
     215,   227,   241,   249,   254,   275,   276,   278,   280,   281,
     289,   294,   295,   299,   300,   303,   304,   329,   330,   333,
     334,   335,   336,   338,   343,   346,   351,   352,   355,   359,
     360,   361,   364,   366,   367,   368,   369,   370,   399,   400,
     401,   402,   403,   405,   412,   413,   414,   416,   417,   418,
     420,   421,   422,   423,   424,   425,   426,   432,   433,   438,
     478,   479,   513,   518,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   556,   588,   589,   592,   593,   595,   596,
     597,   598,   599,   600,   608,   613,   614,   615,   621,   643,
     644,   676,   677,   683,   684,   685,   686,   687,   688,   692,
     733,   735,   736,   737,   738,   739,   743,   765,   766,   768,
     778,   779,   780,   788,   789,   791,   793,   797,   798,   801,
     804,   808,   812,   813,   814,   815,   816,   817,   819,   824,
     827,   828,   831,   834,   837,   842,   845,   848,   854,   862,
     865,   876,   877,   879,   881,   886,   889,   899,   900,   903,
     906,   912,   915,   918,   921,   924,   927,   930,   933,   936,
     937,   940,   943,   946,   956,   962,   965,   968,   971,   978,
     979,   982,   983,   984,   986,   998,   999,  1000,  1003,  1004,
    1005,  1014,  1017,  1020,  1021,  1024,  1027,  1028,  1030,  1033,
    1034,  1035,  1036,  1037,  1038,  1041,  1047,  1050,  1051,  1052,
    1055,  1058,  1061,  1064,  1067,  1070,  1077,  1078,  1079,  1080,
    1081,  1082,  1083,  1084,  1085,  1089,  1092,  1093,  1096,  1099,
    1102,  1105,  1108,  1111,  1114,  1117,  1118,  1129,  1132,  1135,
    1138,  1139,  1142,  1146,  1149,  1155,  1158,  1160,  1163,  1166,
    1169,  1173,  1176,  1181,  1709,   142,   771,   142,   771,   771,
     769,   771,   781,  1709,   771,   769,   771,   771,   769,   771,
     769,   771,   781,   142,   771,   771,   769,   771,   769,   771,
     781,   769,   771,   769,   769,   771,   769,   771,   771,   769,
     771,   769,   771,   781,   771,   769,   771,   771,   769,   771,
     769,   771,   769,   771,   771,   769,   771,   771,   771,   769,
     769,   771,   316,   771,  1042,  1046,  1709,   769,   771,   769,
     771,   769,   769,   769,   769,   771,   769,   769,   769,   769,
     771,   781,   781,   787,  1709,  1048,   771,   781,   769,   771,
     769,   771,   769,   771,   769,   771,   781,   771,   769,   771,
     769,   771,   769,   771,   781,   769,   771,   769,   771,   769,
     771,   769,   769,   771,   769,   771,   781,   769,   771,   781,
     769,   771,   769,   771,   781,   769,   769,   771,   781,   769,
     771,   769,   771,   769,   771,   769,   771,   769,   771,   781,
     781,   771,   787,   787,   787,  1015,  1018,   781,   771,   769,
     771,   781,   783,  1709,   769,   771,   769,   771,   769,   771,
     769,   771,   771,   771,   769,   771,   769,   771,   771,   769,
     771,   769,   771,   771,   769,   771,   781,   769,   771,   769,
     771,   769,   771,   769,   771,   769,   771,   769,   771,   890,
     771,   769,   771,   769,   771,   771,   771,   769,   771,   769,
     771,   769,   781,   771,   771,   771,   781,   769,   769,   771,
     769,   771,   769,   771,   776,     0,   779,    73,   771,    73,
      73,    73,   776,   769,    22,    23,    24,    28,    29,    30,
      31,    46,    57,    85,   257,   258,   297,   298,   427,   428,
    1086,  1087,  1088,  1238,  1244,  1251,  1275,  1276,  1352,  1353,
    1360,  1361,  1404,  1405,  1406,  1407,  1408,  1409,  1410,   769,
      34,    45,   105,  1087,  1090,  1091,  1302,  1338,  1411,   142,
      83,    84,   152,   154,   170,   219,   290,   576,   577,   578,
     579,   580,   671,  1147,  1148,  1238,  1244,  1251,  1275,  1329,
    1342,  1345,  1347,  1352,  1353,  1354,  1367,  1467,  1535,  1536,
    1537,  1538,  1539,  1617,    52,   769,  1709,   289,   412,   413,
     414,   818,   120,   125,   126,   127,   158,   159,   181,   184,
     318,   347,   748,   914,   916,   917,  1185,  1207,  1215,  1216,
    1218,  1227,  1462,  1463,  1464,  1465,  1619,    45,    47,   292,
     327,  1136,  1137,  1190,  1203,  1304,  1466,  1467,   412,  1140,
    1141,  1709,    20,    21,    27,    32,    33,    97,   118,   160,
     161,   259,   431,   469,   732,   734,  1127,  1128,  1289,  1292,
    1295,  1298,  1383,  1387,  1388,  1391,  1392,  1393,  1396,  1401,
    1403,  1615,   769,   142,   769,  1042,  1042,   832,   833,  1709,
      36,   745,     3,     4,     6,     7,     9,    13,    17,    19,
      37,    45,    53,    54,    55,    61,    62,    63,    79,    82,
      85,    91,   117,   118,   119,   143,   147,   148,   149,   151,
     153,   163,   167,   168,   171,   172,   175,   176,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   203,   204,   205,   206,   207,   208,
     217,   218,   220,   221,   222,   223,   224,   225,   226,   228,
     229,   232,   233,   237,   242,   243,   244,   248,   250,   253,
     259,   261,   264,   265,   266,   273,   274,   277,   279,   291,
     296,   301,   307,   315,   319,   320,   326,   342,   358,   409,
     547,   585,   626,   627,   670,   706,   714,   715,   716,   717,
     718,   719,  1006,  1007,  1185,  1189,  1192,  1197,  1198,  1227,
    1238,  1242,  1243,  1244,  1248,  1249,  1250,  1259,  1275,  1276,
    1277,  1278,  1279,  1288,  1294,  1303,  1305,  1306,  1307,  1308,
    1309,  1310,  1311,  1312,  1313,  1314,  1315,  1316,  1317,  1318,
    1319,  1320,  1321,  1322,  1323,  1324,  1325,  1326,  1327,  1328,
    1329,  1331,  1332,  1333,  1334,  1335,  1336,  1337,  1338,  1339,
    1340,  1341,  1342,  1343,  1344,  1345,  1346,  1347,  1352,  1353,
    1354,  1355,  1356,  1357,  1358,  1359,  1360,  1361,  1362,  1363,
    1364,  1365,  1366,  1367,  1368,  1369,  1370,  1371,  1374,  1376,
    1377,  1378,  1379,  1380,  1381,  1412,  1413,  1414,  1415,  1416,
    1417,  1418,  1419,  1420,  1421,  1422,  1423,  1468,  1529,  1535,
    1536,  1537,  1538,  1539,  1540,  1541,  1584,  1586,  1587,  1588,
    1589,  1590,  1591,  1593,  1594,  1595,  1616,  1617,  1633,  1637,
    1638,  1639,  1640,  1641,  1642,   769,    48,   321,   350,   957,
     958,   959,  1709,   286,    48,   350,   966,   967,  1709,    48,
     350,   963,   964,  1709,    12,   131,   279,   348,   429,  1156,
    1157,  1203,  1204,  1205,  1206,  1610,    94,   976,   977,   972,
     973,  1709,   100,   101,   102,   103,   104,   843,   844,  1133,
    1134,  1203,  1278,  1288,  1294,  1303,   769,  1709,   835,   836,
    1709,    36,    59,    81,    85,    86,    87,    88,   829,   830,
    1237,  1238,  1239,  1244,  1251,  1252,  1253,  1254,  1255,  1256,
    1257,  1258,  1130,  1131,  1709,   762,     5,   155,   166,   282,
     283,   306,   407,   408,   484,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,  1039,  1040,  1189,
    1190,  1192,  1203,  1277,  1278,  1288,  1294,  1324,  1337,  1345,
    1348,  1367,  1429,  1453,  1457,  1458,  1459,  1460,  1461,  1467,
    1584,  1585,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,
    1652,  1653,  1654,  1655,   825,   826,  1709,    36,   829,  1164,
    1165,  1709,  1343,  1042,   179,   846,   866,     8,    11,    35,
      49,    70,   164,   256,   288,   406,   556,   763,   863,   864,
     182,  1349,   771,    52,   769,  1042,   740,   741,   742,   919,
     920,  1656,  1657,  1658,   412,   884,   909,   286,   745,   764,
     907,   908,  1161,  1162,  1709,  1025,  1026,  1709,    71,   249,
    1152,  1153,  1150,  1151,  1412,  1413,  1022,  1023,  1709,  1022,
    1029,  1709,    18,    65,    98,   106,   128,   129,   130,   158,
     184,   260,   262,   267,   268,   269,   305,   314,   317,   328,
     948,  1031,  1032,  1185,  1189,  1190,  1191,  1192,  1193,  1194,
    1195,  1196,  1197,  1198,  1199,  1200,  1201,  1203,  1211,  1212,
    1217,  1225,  1226,  1227,  1243,  1248,  1278,  1288,  1294,  1312,
    1337,  1341,  1343,  1350,  1351,  1369,  1370,  1378,  1379,  1380,
    1381,  1412,  1413,  1518,  1519,  1529,  1584,  1585,  1591,  1592,
    1637,  1638,  1639,  1640,  1641,  1642,   769,   769,    52,   769,
    1709,   398,   771,   785,   786,    93,   142,   183,   201,   213,
     214,   419,   437,   445,   446,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   472,   473,   474,   475,   476,
     477,   682,   771,   872,   951,  1043,  1709,   292,   769,   749,
     922,   923,  1203,  1238,  1597,   158,   159,   173,   184,   202,
     263,   341,   345,   349,   750,   751,   752,   753,   754,   755,
     756,   757,   758,   759,   760,   761,   925,   926,  1185,  1186,
    1187,  1188,  1208,  1213,  1214,  1218,  1219,  1220,  1221,  1222,
    1223,  1224,  1330,  1350,  1351,  1596,  1598,  1599,  1600,  1601,
    1602,  1603,  1604,  1610,   928,   929,  1203,  1238,   674,   926,
     931,   932,  1618,   769,  1042,    48,   412,   882,   883,   884,
     286,   675,   745,   412,   887,   888,   286,   105,   251,   264,
     337,   431,   734,  1121,  1122,  1238,  1244,  1251,  1275,  1281,
    1282,  1283,  1297,  1329,  1347,  1352,  1353,  1367,  1467,  1613,
    1614,   769,   316,  1170,  1171,  1709,   249,   923,   926,   941,
     942,   140,   141,   284,   285,   293,  1167,  1168,  1605,  1606,
    1607,  1608,  1609,  1143,   913,   914,   132,   430,   517,   947,
     948,   949,  1202,  1209,  1329,  1468,  1469,   769,   105,   252,
     298,   662,  1123,  1124,  1238,  1244,  1251,  1281,  1284,  1285,
    1286,  1287,  1297,  1467,  1613,  1614,   769,   107,   362,   363,
    1073,  1074,  1372,  1373,  1530,   948,  1075,  1076,  1372,  1530,
     769,   249,  1053,  1054,   184,   365,  1071,  1072,  1076,  1210,
    1583,   769,    65,   292,  1056,  1057,  1659,  1660,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,  1059,  1060,  1661,  1662,  1663,
    1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,
    1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,
    1684,  1685,  1686,  1687,  1062,  1063,  1661,  1662,  1663,  1664,
    1665,  1666,  1667,  1668,    81,   292,   338,   342,  1065,  1066,
    1688,  1689,  1690,  1691,   258,  1068,  1069,  1692,   769,   769,
     177,   452,   590,   769,   769,   769,  1016,  1709,  1019,  1709,
     769,    80,   272,   287,   415,   471,   587,   672,   809,   810,
      20,    21,    25,    26,    27,    32,    33,    38,    39,    97,
     118,   160,   161,   259,   264,   469,   518,   732,  1125,  1126,
    1280,  1290,  1291,  1293,  1296,  1382,  1384,  1385,  1386,  1389,
    1390,  1394,  1395,  1397,  1398,  1399,  1400,  1402,  1613,  1614,
     769,    52,   769,  1709,   398,   240,   240,   240,   272,   673,
     713,   799,   800,  1236,  1240,  1241,   805,   272,   332,   713,
     802,   803,  1245,  1246,  1247,   133,   480,   481,   482,   483,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   638,   639,   640,  1119,  1120,  1192,  1238,
    1244,  1251,  1275,  1276,  1277,  1278,  1288,  1294,  1303,  1305,
    1318,  1329,  1345,  1367,  1424,  1425,  1426,  1427,  1428,  1429,
    1430,  1431,  1432,  1433,  1434,  1435,  1436,  1437,  1438,  1439,
    1440,  1441,  1442,  1443,  1444,  1445,  1446,  1447,  1448,  1449,
    1450,  1451,  1452,  1454,  1455,  1456,  1457,  1458,  1584,  1585,
    1119,    58,    85,    88,   257,   980,   981,  1228,  1237,  1252,
    1258,  1260,  1352,  1353,  1174,  1175,  1709,   249,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   531,   532,   533,   534,
     535,   536,   537,   557,   558,   559,   560,   561,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     581,   582,   583,   653,  1094,  1095,  1238,  1338,  1472,  1473,
    1474,  1475,  1476,  1477,  1478,  1479,  1480,  1481,  1482,  1483,
    1484,  1485,  1486,  1487,  1488,  1489,  1490,  1491,  1492,  1494,
    1495,  1496,  1497,  1498,  1499,  1500,  1501,  1502,  1503,  1504,
    1505,  1506,  1507,  1508,  1509,  1510,  1511,  1512,  1513,  1514,
    1515,  1516,  1517,  1546,   591,   331,   353,   354,   586,   587,
     628,   629,   631,   632,   634,   635,   636,   641,   652,  1103,
    1104,  1542,  1543,  1545,  1562,  1570,  1571,  1572,  1575,  1576,
    1577,  1578,  1579,  1580,  1581,   769,   630,  1097,  1098,  1542,
    1543,  1545,  1562,  1570,  1571,  1572,  1574,  1575,  1576,  1577,
    1578,  1580,  1581,   529,   633,   654,   655,   656,   657,   658,
     659,   660,   661,   663,   664,   665,   666,   667,   668,   669,
    1115,  1116,  1238,  1352,  1353,  1472,  1473,  1474,  1475,  1476,
    1482,  1483,  1484,  1486,  1490,  1491,  1492,  1493,  1542,  1543,
    1544,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,
    1555,  1556,  1557,  1558,  1559,  1560,  1561,    65,   194,   271,
     651,  1112,  1113,  1470,  1471,  1542,  1543,  1562,  1563,  1564,
     646,   647,   648,   649,   650,  1109,  1110,  1542,  1543,  1545,
    1565,  1566,  1567,  1568,  1569,   642,  1106,  1107,  1542,  1543,
    1572,  1573,   637,  1100,  1101,  1542,  1543,  1545,  1562,  1570,
    1571,  1575,  1576,  1577,  1578,  1579,  1580,  1581,  1582,   769,
     289,   584,   609,   610,   611,   612,   901,   902,  1520,  1521,
    1522,  1523,  1524,  1525,   838,   617,   618,   620,   904,   905,
    1520,  1526,  1527,  1528,   622,   623,   624,   625,   944,   945,
    1531,  1532,  1533,  1534,   302,   645,   938,   939,  1611,  1612,
     938,   849,  1709,   174,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   704,   705,   708,   710,   711,   712,
     934,   935,  1189,  1190,  1191,  1226,  1227,  1238,  1242,  1243,
    1244,  1250,  1251,  1275,  1278,  1288,  1294,  1305,  1306,  1307,
    1308,  1309,  1310,  1311,  1312,  1313,  1315,  1317,  1318,  1319,
    1320,  1321,  1322,  1323,  1324,  1325,  1326,  1327,  1328,  1331,
    1333,  1337,  1343,  1348,  1351,  1352,  1353,  1355,  1356,  1357,
    1358,  1359,  1362,  1363,  1364,  1365,  1366,  1368,  1369,  1371,
    1374,  1375,  1376,  1377,  1378,  1379,  1380,  1381,  1518,  1519,
    1529,  1541,  1588,  1590,  1620,  1621,  1622,  1623,  1624,  1625,
    1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,
    1636,   769,   316,   773,   871,   880,  1709,   880,   864,   769,
     959,   969,   970,   744,  1643,   412,   413,  1177,  1178,  1179,
     286,  1182,  1183,  1184,  1709,   286,   549,    48,   121,   984,
    1709,   985,  1301,  1709,    48,   121,   999,  1709,    48,   121,
    1004,  1709,   134,   183,   201,   213,   214,   255,   445,   446,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   472,   473,
     474,   475,   771,   820,   951,  1043,  1709,   156,   157,   549,
    1709,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    52,   772,    73,    73,    73,    52,
     772,    52,    73,    73,    73,    73,   772,    52,  1709,   772,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      52,   772,    73,    73,    73,    73,    52,   772,  1709,    71,
    1141,    52,    73,    73,    73,    73,    73,    73,    73,   772,
      52,   769,   772,   772,    71,   833,    73,   746,   747,   772,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    52,
     772,  1709,  1709,    71,   958,    52,   769,   772,  1709,  1709,
      71,   967,    52,  1709,  1709,    71,   964,    52,   772,    73,
      73,   772,    52,   445,   772,    71,   973,    52,    73,    73,
      73,    73,    73,    52,   772,    52,   772,   772,    71,   836,
     771,   772,    73,    73,    73,    73,    73,    73,    52,   772,
      71,  1131,    52,   772,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
     772,    52,    71,   826,    73,   772,   772,    71,  1165,    52,
     771,   772,   772,    73,   847,   872,   773,   775,   868,   869,
     872,   875,    73,    73,    73,    73,    73,    73,    52,   772,
      73,   772,   951,  1042,   771,    52,   772,  1709,    71,   884,
      73,   772,   908,    71,  1162,    52,    71,  1026,   771,   769,
      52,    71,  1153,   772,    52,    71,  1023,   771,    71,    71,
    1709,    52,   820,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    52,   772,  1709,   398,   786,   786,    52,
     784,  1709,    52,   772,   784,   771,   771,   771,   771,   771,
     771,   872,   872,   771,   771,   771,   771,   771,   771,   771,
     771,   771,   771,   771,   771,   771,   771,   771,   771,   771,
     771,   771,   771,   771,   771,   771,   771,   771,   771,   771,
     872,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   450,  1049,   776,   873,   323,   324,   325,    73,    52,
     772,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    52,   772,    52,
     772,    52,   772,   772,  1709,  1709,    71,   883,    52,   772,
      52,   772,    73,  1709,    71,   888,   772,    73,    73,    73,
      73,   772,    52,    73,    71,  1171,    73,    73,    52,   772,
      73,    73,    73,    73,    73,   772,    52,   773,  1144,  1145,
    1709,    52,   772,    73,    73,    52,   772,    73,    73,    73,
      73,   772,    52,    73,    73,    73,    52,   772,    52,   772,
     441,   442,   443,   444,    71,  1054,    73,    73,    52,   772,
      73,    73,   772,    52,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,   772,    52,   772,
      52,    73,    73,   772,    52,   772,    52,    73,    52,   772,
      73,    52,   769,  1709,    52,   769,  1709,    73,    73,    73,
      73,    73,    73,    73,    52,   772,    73,    73,    73,    73,
      73,    73,    73,    73,    73,   772,    52,  1709,   398,   772,
     772,   772,    73,    73,    52,   772,   272,   287,   471,   594,
     680,   683,   806,   807,  1229,  1230,  1231,  1232,  1234,  1235,
      73,    73,    73,    52,   772,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,   772,    52,   772,    73,
      73,    73,    73,    52,   772,    71,  1175,    52,  1709,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    52,   772,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    52,   772,    52,
     772,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    52,   772,    73,
      73,    73,    52,   772,    73,    73,    73,    73,    52,   772,
      52,   772,    73,    52,   772,   519,   602,   604,   605,   891,
     892,    73,    73,    73,    73,    73,    73,    52,   772,   249,
     839,   840,    73,    52,   772,    73,    73,    73,    73,    52,
     772,    73,    73,    52,   772,   772,   249,   850,   851,   772,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,   772,    52,   870,   871,    52,   772,    73,   772,
     772,   769,    71,   970,   772,  1709,  1709,    71,  1178,   292,
     772,    71,  1183,    52,   771,   772,   989,   771,   771,   769,
     776,    52,   772,    73,   771,   771,   769,   776,   771,   771,
     769,   776,   771,   771,   771,   771,   820,   820,   771,   771,
     771,   771,   771,   771,   771,   771,   771,   771,   771,   771,
     771,   771,   771,   771,   771,   771,   771,   771,   771,   771,
     820,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   450,   769,   821,   771,   987,   776,   951,   445,   446,
     951,   952,   951,   142,   952,   142,  1042,   142,   142,   773,
    1697,  1699,  1700,   142,   142,   316,  1709,  1693,  1709,  1088,
     142,   142,   951,   142,  1091,   142,   316,  1700,   142,   951,
      69,   308,   309,   310,   311,   312,   313,   769,   781,  1147,
     781,   142,   142,   142,   951,   951,   951,   142,   951,   142,
     771,   917,   769,   951,   771,   142,   142,  1137,   769,   769,
     769,  1709,  1042,   434,   435,   436,   544,   545,   546,   548,
     771,  1299,   977,   977,  1709,   142,   769,   781,  1127,   769,
     781,   769,   781,   769,   820,   820,   820,   769,   142,   142,
     316,   951,  1709,   951,   951,   951,   142,  1042,  1697,  1700,
     771,  1299,  1697,  1700,   142,   771,   951,   951,   142,    60,
      95,    96,   344,   951,   951,   951,   951,   951,   951,   951,
     951,   951,   142,   142,  1042,  1042,  1042,   142,   134,   445,
     446,   952,   953,   954,   142,   142,   142,  1709,  1042,   142,
    1700,   773,  1703,  1704,  1704,   142,   550,   551,   552,  1042,
     142,   230,   231,   548,   951,   234,   235,   236,   238,   239,
     142,  1709,   245,   246,   247,   245,   246,   247,   771,   142,
     142,   951,   771,   134,   951,   142,   142,    50,    51,    95,
     771,   142,  1700,   142,   951,   142,  1007,   769,   781,    52,
     769,    10,   116,   144,   145,   146,   270,   404,   563,   820,
     823,   960,   975,   769,    52,    52,   769,   820,    52,    52,
     769,   820,   769,   142,   142,   769,  1156,   142,   769,   769,
     820,   316,   316,   316,   316,   316,   844,   769,  1134,   769,
     781,   776,   769,   142,   445,   446,   950,   769,  1709,  1042,
     977,   142,   977,   142,   977,   142,   977,   830,   769,   769,
     820,   769,   952,   951,   142,   142,   950,   142,   142,   142,
    1042,   142,   142,   142,   951,   951,   951,   142,   142,   769,
    1039,   769,   820,   769,   769,   769,  1709,   142,  1694,   769,
     769,   792,    71,   872,   769,   870,  1709,    71,   869,   875,
      73,   769,   951,   951,   771,   771,   142,   142,   863,   769,
     162,   216,  1046,   772,   771,   951,   920,   769,   769,   769,
     142,   769,   769,  1709,   769,   950,  1154,  1709,   769,   769,
    1150,   769,   820,   769,   769,    52,   820,  1709,   769,   951,
     142,   142,  1042,   951,   142,   142,   951,   142,   951,   142,
    1032,   769,   781,   398,   786,   786,   784,    73,   772,   784,
     872,   872,   872,   872,  1709,  1709,   872,   872,   872,   872,
     872,   872,   872,   872,   872,   872,   872,   872,   872,   872,
     872,   872,   872,   872,   872,   872,   872,   872,   872,   872,
     872,   950,  1709,   772,   872,   872,   872,   872,   872,   872,
     872,   872,   872,   872,   872,   769,  1709,   771,   142,   923,
     769,   951,   951,   142,   951,   142,   142,   142,   951,   951,
     951,   951,   951,   951,   142,   951,   771,   926,   769,   929,
     769,   932,   769,   769,    52,    52,    73,   769,   769,   675,
     745,   769,   286,   769,   142,   769,   769,   769,   356,   357,
     142,  1709,  1709,   769,   781,  1121,  1172,  1709,   769,  1172,
    1709,   942,   769,  1042,   771,  1042,   771,   142,   769,  1167,
     781,    71,  1145,    73,   914,   769,   951,  1700,   949,   769,
     781,   142,  1697,  1700,   142,  1700,   769,   781,  1123,   771,
     820,   398,  1074,   769,  1076,   769,   781,   820,   820,   820,
     820,   769,   142,   951,  1072,   769,   781,   142,   142,   769,
    1056,   142,   142,   142,   142,   142,   142,   142,   142,   142,
     142,   142,   142,   142,   769,  1059,   769,  1062,  1042,  1697,
    1700,   769,  1065,   769,   781,  1068,   796,   590,   787,   794,
    1709,  1709,   811,  1709,   820,  1709,  1709,   142,  1695,   950,
     810,   769,  1042,   434,   435,   436,   142,   142,   771,  1299,
     977,   977,  1709,   142,   769,   781,  1125,   398,   769,   769,
     769,  1709,   773,  1701,  1702,   800,   769,    73,    73,    73,
    1233,    73,    73,    52,   772,  1709,  1702,  1702,   803,   769,
     142,   142,   142,   142,   142,   142,   142,   142,   142,   142,
     142,   142,   142,   951,   142,   773,  1706,   951,   951,   771,
     771,   771,   142,   142,   771,   951,   142,   951,   951,   951,
     951,   951,   769,  1119,   769,  1042,   142,   981,   769,   769,
    1709,   769,  1709,   142,   606,   607,   142,   142,   142,   142,
    1042,   142,   771,   142,   249,   604,   605,   142,   142,   142,
     142,   142,   951,   951,   142,   142,   142,   142,   142,   142,
     951,   142,   142,   142,   142,   142,   142,   142,   142,   142,
     142,   142,   142,   142,   142,   142,   142,   142,   142,  1704,
    1095,   769,   790,   142,  1042,   142,  1042,  1042,  1704,   142,
     142,  1704,   952,   142,  1104,   769,   781,  1098,   769,   530,
     548,   951,   951,   951,   142,   951,   142,   142,   951,   951,
     142,   142,   142,   142,   951,   951,  1116,   769,   142,   142,
     142,  1113,   769,   142,   952,   952,   142,  1110,   769,  1107,
     769,   142,  1101,   769,   601,   603,   619,   769,   769,    71,
     892,   773,   773,  1708,   142,   951,  1706,   142,   142,   902,
     769,   841,    71,   840,  1697,  1700,   905,   769,   316,  1043,
    1044,   142,  1044,  1044,   945,   769,  1042,   142,   939,   769,
     769,   316,    71,   851,   769,   951,   689,   690,   691,   352,
     142,  1702,   951,   142,   142,   951,   142,  1042,   951,   769,
     934,    52,   774,   316,   773,   871,   769,   316,   769,   769,
     769,   769,   769,   769,   769,   142,   910,   769,   769,  1184,
     142,  1694,   769,   771,  1709,  1709,  1301,   769,   977,  1709,
    1709,   549,  1709,  1709,  1709,   157,  1709,   820,   820,   820,
     820,   820,   820,   820,   820,   820,   820,   820,   820,   820,
     820,   820,   820,   820,   820,   820,   820,   820,   820,   820,
     820,   820,   820,   772,   820,   820,   820,   820,   820,   820,
     820,   820,   820,   820,   820,   771,   137,   138,   139,  1001,
    1002,  1268,  1269,  1270,   771,   157,   549,   951,   951,    52,
     142,  1697,  1698,    52,   774,  1698,   770,   769,   769,   772,
     769,   769,   316,  1008,  1010,  1011,   781,   292,   772,  1299,
    1300,   769,   769,   769,   769,   769,   769,   832,   772,  1300,
     781,   134,   134,    52,   952,    52,   774,   952,  1011,  1011,
     316,  1008,  1012,  1013,   769,  1709,    52,   769,    52,   957,
    1709,   820,    52,  1709,   820,   769,    71,   963,    52,   769,
     156,   157,   549,  1709,   142,   142,   772,   835,    52,   769,
      71,  1130,   769,   825,    52,   770,   772,   772,  1164,   872,
     769,   769,   774,    73,   769,   872,   781,  1042,  1045,   867,
     769,   951,   772,   292,   909,    52,   771,   772,    52,   769,
      73,    71,  1152,   772,  1709,   769,   820,   769,   786,   316,
      52,    52,   772,   772,   772,   772,   772,   772,   772,   772,
     772,   772,   772,   772,   772,   772,   772,   772,   772,   772,
     772,   772,   772,   772,   772,    52,   772,   772,    52,   772,
      52,   772,   772,   772,   772,   872,   874,   772,   781,  1709,
    1709,   820,   350,   772,    73,    71,   882,   772,   884,   885,
      52,   772,   292,    71,   887,   769,    52,   769,  1709,   769,
     772,   781,   781,   774,   769,   820,   769,   769,   781,   769,
     769,   769,   769,   769,   769,   769,   872,    73,   769,   872,
     872,   770,  1300,   769,    52,   316,    52,   316,   774,  1709,
    1709,  1709,    73,  1709,   684,   685,   686,   861,   807,   769,
     954,  1705,   770,   781,   782,   782,   782,   782,   769,   772,
     781,   872,   769,   142,   142,   769,   769,   781,  1704,  1707,
      73,   769,   769,   769,   855,   871,   870,   878,   413,   412,
     770,    52,   142,   769,  1177,    52,   772,   772,  1182,   108,
     109,   110,   111,   112,   113,   114,   115,   322,   996,   997,
    1261,  1262,  1263,  1265,  1266,  1267,  1271,  1272,  1274,  1579,
      52,   772,   770,    52,   772,   776,    52,   772,   776,    52,
      52,   772,   772,   772,   772,   772,   772,   772,   772,   772,
     772,   772,   772,   772,   772,   772,   772,   772,   772,   772,
     772,   772,   772,    52,   772,    52,   772,   820,   822,    73,
      73,    73,    52,   772,   109,   111,   994,   995,  1261,  1262,
    1263,  1264,  1266,  1267,  1271,  1272,  1273,  1579,   771,   988,
    1698,   770,   774,  1698,  1709,   769,    52,    52,   772,   772,
     910,   776,    52,   772,    71,   769,   772,   772,   952,   774,
     952,   772,   772,    52,    52,   772,   820,   823,   975,   823,
     961,    71,    52,    52,   820,    52,   769,   769,    71,   820,
     771,   990,   776,    73,    71,   820,   769,    71,    71,   445,
     446,   773,  1159,   142,    52,    52,    71,   772,   872,   872,
     769,   772,    52,   772,   868,   772,   910,    71,  1159,   446,
     950,  1696,    73,  1709,   952,   769,    71,   769,   820,   769,
     872,   872,   316,   872,   872,   771,    52,   772,   781,   772,
      73,    73,   769,   820,   769,   142,   769,    71,   769,    71,
     884,   286,   769,   910,   769,    71,  1709,   769,   772,   772,
      73,   769,   772,   772,   795,   772,   134,   142,   772,   316,
     316,   774,   872,    52,   774,   954,   772,   772,   772,   772,
     769,   772,   772,    52,   769,   774,    52,   774,   820,   400,
     401,   402,   403,   852,   853,   678,   679,   681,   856,   857,
     858,   774,   868,  1709,  1709,   142,   142,   770,   410,   767,
    1180,    71,   820,    52,    52,    71,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    52,   772,  1709,   776,   977,
    1709,   776,   549,  1709,   776,   157,   820,   820,   820,   820,
      52,   772,  1706,   951,   952,  1002,   769,    73,    73,    52,
     772,  1001,   771,   142,    92,   316,   399,   952,   955,  1010,
     769,   156,   157,   549,  1709,  1299,   769,   832,   771,  1702,
    1012,    52,    52,    52,   769,   820,   820,   769,   820,   769,
     769,  1001,   771,   157,   549,   820,   769,   769,   769,   769,
     820,   769,  1709,  1709,   769,   783,    73,   769,   769,  1042,
      71,   769,   769,   769,   771,   770,   772,   772,   820,    73,
     769,   769,   772,   772,    52,   772,    52,    52,   872,   872,
     769,   820,   820,   769,   885,   772,   769,   885,   769,   772,
     885,   769,   769,  1170,   820,   787,   872,   787,   954,  1174,
     783,   893,   601,   895,  1704,   769,   872,   872,   872,   872,
     853,   872,   872,  1709,    71,   857,    71,   769,   769,   770,
     142,   771,   911,   952,   911,   769,   769,  1709,  1709,   769,
     952,  1704,   951,  1708,   952,  1704,   532,   538,   539,   540,
     541,   542,   543,   553,   562,   974,  1704,  1704,   997,   769,
     772,   772,   549,  1709,   772,   157,  1709,   772,   772,    52,
      52,   820,   952,   820,   995,   769,   772,   994,   410,   771,
     992,   776,    71,   316,  1008,  1009,   823,   961,   823,    52,
     769,   769,   772,   994,   771,   991,   769,    52,    52,    52,
     769,   872,   769,   410,   687,   688,   950,   950,    52,    52,
     769,   952,   142,  1700,   872,   872,   772,   769,   769,    71,
     769,    71,   769,    71,   410,   411,    71,   769,   769,   772,
     769,    71,   769,   445,   446,   616,   820,   896,   897,   898,
     142,   601,   769,   769,   769,   769,   769,   769,   769,   769,
     769,   142,   820,    52,   769,   771,   952,   769,   776,   776,
     776,   776,   776,   820,   820,   769,   772,   911,  1001,   771,
     157,   549,   769,    52,    52,   772,    52,    52,   820,   769,
     772,  1001,   771,   820,  1159,  1159,   769,   911,   911,   911,
     770,  1159,  1159,   772,   772,   772,   772,   769,   885,   769,
     885,   769,   911,   911,   769,   787,   769,   616,   616,   771,
     447,    73,   820,   898,    52,   142,   594,   680,   683,   859,
     860,   772,   771,   952,   767,   820,   410,   549,  1709,   549,
     157,  1709,   157,   772,   772,   769,   769,   772,   994,   771,
     993,  1008,   975,   823,   769,   769,   772,   994,   774,   769,
     769,   769,   769,   769,   950,   769,   769,    71,    71,   769,
     769,   769,   771,   771,  1709,   616,   894,   781,    52,   872,
    1709,   861,   860,   820,   911,   772,   911,   776,   776,   769,
     772,  1001,   771,    52,    52,   769,   772,   772,   769,   769,
    1709,  1709,    52,   771,   896,   769,   781,   769,   769,   769,
     772,   769,   769,   549,   157,   769,   772,   994,   961,   823,
     769,    52,    52,   142,  1709,   769,   769,   769,   772,    52,
     142,   142,   772,    52,   769,   820,   772,   772,   142,   772
  };

  const short
  parser::yyr1_[] =
  {
       0,   777,   778,   778,   779,   779,   779,   779,   779,   779,
     779,   779,   779,   779,   779,   779,   779,   779,   779,   779,
     779,   779,   779,   779,   779,   779,   779,   779,   779,   779,
     779,   779,   779,   779,   779,   779,   779,   779,   779,   779,
     779,   779,   779,   779,   779,   779,   779,   779,   779,   779,
     779,   779,   779,   779,   779,   779,   779,   779,   779,   779,
     779,   779,   779,   779,   779,   779,   779,   779,   779,   779,
     779,   779,   779,   779,   779,   779,   779,   779,   779,   779,
     779,   779,   779,   779,   779,   779,   779,   779,   779,   779,
     779,   779,   779,   779,   779,   779,   779,   779,   779,   779,
     779,   779,   779,   779,   779,   779,   779,   779,   779,   779,
     779,   779,   779,   779,   779,   779,   779,   779,   779,   779,
     779,   779,   779,   779,   779,   779,   779,   779,   779,   779,
     779,   779,   779,   780,   780,   781,   781,   781,   782,   782,
     783,   783,   783,   783,   783,   783,   784,   785,   785,   785,
     785,   786,   786,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   788,   790,   789,   792,   791,
     793,   793,   794,   793,   795,   793,   796,   793,   797,   798,
     799,   799,   800,   800,   800,   801,   802,   802,   803,   803,
     803,   805,   804,   806,   806,   807,   807,   807,   807,   807,
     807,   808,   809,   809,   810,   811,   810,   810,   810,   810,
     810,   810,   810,   812,   813,   814,   815,   816,   817,   818,
     818,   818,   818,   819,   820,   820,   820,   820,   820,   820,
     820,   820,   820,   820,   820,   820,   820,   820,   820,   820,
     820,   820,   820,   820,   820,   820,   820,   820,   820,   820,
     820,   820,   820,   820,   820,   820,   820,   820,   820,   820,
     820,   820,   821,   820,   820,   820,   820,   820,   820,   820,
     820,   820,   822,   822,   823,   823,   824,   824,   825,   825,
     826,   827,   828,   829,   829,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   831,   831,   831,
     832,   832,   833,   833,   833,   834,   834,   835,   835,   836,
     838,   837,   839,   839,   841,   840,   842,   843,   843,   844,
     844,   844,   844,   844,   846,   845,   847,   847,   849,   848,
     850,   850,   851,   852,   852,   853,   853,   853,   853,   855,
     854,   856,   856,   857,   857,   857,   858,   859,   859,   860,
     860,   860,   861,   861,   861,   862,   862,   863,   863,   863,
     863,   863,   863,   863,   863,   863,   863,   863,   863,   864,
     864,   866,   865,   867,   865,   868,   868,   868,   868,   869,
     869,   869,   869,   870,   870,   871,   871,   872,   872,   872,
     872,   872,   872,   872,   872,   872,   872,   872,   872,   872,
     872,   872,   872,   872,   872,   872,   872,   872,   872,   872,
     872,   872,   872,   872,   872,   872,   872,   872,   872,   872,
     872,   872,   872,   872,   872,   872,   872,   872,   872,   872,
     872,   872,   872,   872,   872,   872,   873,   872,   872,   872,
     872,   872,   872,   872,   872,   874,   874,   875,   876,   878,
     877,   879,   880,   880,   880,   880,   880,   880,   881,   881,
     881,   881,   881,   881,   881,   881,   881,   882,   882,   883,
     883,   883,   883,   883,   884,   884,   884,   885,   885,   886,
     886,   886,   887,   887,   888,   888,   890,   889,   891,   891,
     892,   892,   893,   894,   892,   892,   892,   895,   895,   896,
     896,   897,   897,   898,   898,   898,   898,   899,   900,   901,
     901,   902,   902,   902,   902,   902,   902,   903,   904,   904,
     905,   905,   905,   905,   906,   906,   907,   907,   908,   908,
     908,   909,   909,   910,   910,   910,   910,   910,   910,   911,
     911,   911,   911,   911,   911,   912,   912,   913,   913,   914,
     914,   914,   914,   914,   914,   914,   914,   914,   914,   915,
     915,   916,   916,   917,   917,   918,   918,   919,   919,   920,
     920,   920,   921,   921,   922,   922,   923,   923,   923,   924,
     924,   925,   925,   926,   926,   926,   926,   926,   926,   926,
     926,   926,   926,   926,   926,   926,   926,   926,   926,   926,
     926,   926,   926,   926,   926,   926,   926,   926,   926,   927,
     927,   928,   928,   929,   929,   930,   930,   931,   931,   932,
     932,   933,   933,   934,   934,   935,   935,   935,   935,   935,
     935,   935,   935,   935,   935,   935,   935,   935,   935,   935,
     935,   935,   935,   935,   935,   935,   935,   935,   935,   935,
     935,   935,   935,   935,   935,   935,   935,   935,   935,   935,
     935,   935,   935,   935,   935,   935,   935,   935,   935,   935,
     935,   935,   935,   935,   935,   935,   935,   935,   935,   935,
     935,   935,   935,   935,   935,   935,   935,   935,   935,   935,
     935,   935,   935,   935,   935,   935,   935,   935,   935,   935,
     935,   935,   935,   935,   935,   935,   935,   935,   935,   935,
     935,   935,   935,   935,   936,   937,   938,   938,   939,   939,
     940,   940,   941,   941,   942,   942,   943,   944,   944,   945,
     945,   945,   945,   946,   946,   946,   946,   947,   947,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   949,   949,   949,   949,   949,   949,
     950,   950,   950,   951,   951,   952,   952,   952,   953,   953,
     953,   954,   954,   955,   955,   956,   956,   957,   957,   958,
     958,   959,   959,   959,   959,   960,   960,   960,   960,   960,
     961,   961,   961,   961,   962,   962,   962,   963,   963,   964,
     964,   964,   965,   966,   966,   967,   967,   967,   968,   969,
     969,   970,   971,   972,   972,   973,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   975,   975,   975,   975,   975,
     975,   975,   975,   976,   977,   977,   978,   979,   980,   980,
     981,   981,   981,   981,   981,   981,   981,   982,   983,   984,
     984,   984,   985,   985,   987,   986,   988,   986,   989,   986,
     990,   986,   991,   986,   992,   986,   993,   986,   994,   994,
     995,   995,   995,   995,   995,   995,   995,   995,   995,   995,
     996,   996,   997,   997,   997,   997,   997,   997,   997,   997,
     997,   997,   998,   999,   999,   999,   999,   999,   999,  1000,
    1000,  1000,  1000,  1000,  1000,  1001,  1001,  1002,  1002,  1002,
    1003,  1004,  1004,  1004,  1004,  1004,  1004,  1005,  1005,  1005,
    1005,  1006,  1006,  1007,  1007,  1007,  1007,  1007,  1007,  1007,
    1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,
    1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,
    1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,
    1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,
    1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,
    1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,
    1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,
    1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,
    1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,
    1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,
    1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,
    1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,  1007,
    1007,  1007,  1007,  1007,  1008,  1008,  1009,  1009,  1010,  1010,
    1011,  1011,  1012,  1012,  1012,  1013,  1013,  1015,  1014,  1016,
    1016,  1016,  1018,  1017,  1019,  1019,  1019,  1020,  1021,  1022,
    1022,  1023,  1024,  1025,  1025,  1026,  1027,  1028,  1029,  1029,
    1029,  1029,  1030,  1031,  1031,  1032,  1032,  1032,  1032,  1032,
    1032,  1032,  1032,  1032,  1033,  1033,  1033,  1033,  1034,  1034,
    1035,  1035,  1036,  1037,  1038,  1038,  1039,  1039,  1040,  1040,
    1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,
    1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,
    1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,
    1040,  1040,  1040,  1041,  1041,  1042,  1042,  1043,  1043,  1044,
    1044,  1045,  1045,  1046,  1046,  1046,  1046,  1046,  1046,  1048,
    1049,  1047,  1050,  1050,  1051,  1051,  1051,  1051,  1052,  1053,
    1053,  1054,  1054,  1054,  1054,  1055,  1055,  1056,  1056,  1057,
    1057,  1058,  1058,  1059,  1059,  1060,  1060,  1060,  1060,  1060,
    1060,  1060,  1060,  1060,  1060,  1060,  1060,  1060,  1060,  1060,
    1060,  1060,  1060,  1060,  1060,  1060,  1060,  1060,  1060,  1060,
    1060,  1060,  1061,  1061,  1062,  1062,  1063,  1063,  1063,  1063,
    1063,  1063,  1063,  1063,  1064,  1064,  1065,  1065,  1066,  1066,
    1066,  1066,  1067,  1067,  1067,  1067,  1068,  1068,  1069,  1070,
    1070,  1070,  1070,  1071,  1071,  1072,  1072,  1072,  1073,  1073,
    1074,  1074,  1074,  1075,  1075,  1076,  1076,  1076,  1077,  1077,
    1078,  1078,  1079,  1079,  1080,  1081,  1081,  1081,  1081,  1082,
    1082,  1082,  1082,  1083,  1083,  1083,  1083,  1084,  1084,  1084,
    1084,  1085,  1085,  1086,  1086,  1086,  1086,  1086,  1086,  1086,
    1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,
    1088,  1088,  1089,  1089,  1090,  1090,  1090,  1090,  1091,  1091,
    1092,  1092,  1093,  1094,  1094,  1094,  1094,  1094,  1094,  1094,
    1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,
    1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,
    1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,
    1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,
    1094,  1095,  1095,  1096,  1096,  1097,  1097,  1097,  1097,  1097,
    1097,  1097,  1097,  1097,  1097,  1097,  1097,  1097,  1097,  1098,
    1098,  1099,  1099,  1100,  1100,  1100,  1100,  1100,  1100,  1100,
    1100,  1100,  1100,  1100,  1100,  1100,  1100,  1101,  1101,  1102,
    1102,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,  1103,
    1103,  1103,  1103,  1103,  1103,  1104,  1104,  1105,  1105,  1105,
    1105,  1106,  1106,  1106,  1106,  1107,  1107,  1108,  1108,  1109,
    1109,  1109,  1109,  1109,  1109,  1109,  1109,  1110,  1110,  1111,
    1111,  1112,  1112,  1112,  1112,  1112,  1112,  1112,  1113,  1113,
    1114,  1114,  1115,  1115,  1115,  1115,  1115,  1115,  1115,  1115,
    1115,  1115,  1115,  1115,  1115,  1115,  1115,  1115,  1115,  1115,
    1115,  1115,  1115,  1115,  1115,  1115,  1115,  1115,  1115,  1115,
    1115,  1115,  1115,  1115,  1115,  1115,  1115,  1116,  1116,  1117,
    1117,  1118,  1118,  1118,  1118,  1119,  1119,  1120,  1120,  1120,
    1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,
    1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,
    1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,
    1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,
    1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1120,  1121,
    1121,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,
    1122,  1122,  1122,  1122,  1122,  1122,  1122,  1123,  1123,  1124,
    1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,  1124,
    1124,  1125,  1125,  1126,  1126,  1126,  1126,  1126,  1126,  1126,
    1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,
    1126,  1126,  1126,  1127,  1127,  1128,  1128,  1128,  1128,  1128,
    1128,  1128,  1128,  1128,  1128,  1128,  1128,  1128,  1128,  1129,
    1129,  1129,  1130,  1130,  1131,  1131,  1132,  1132,  1132,  1132,
    1133,  1133,  1134,  1134,  1134,  1134,  1134,  1135,  1136,  1136,
    1137,  1137,  1137,  1137,  1137,  1138,  1138,  1139,  1140,  1140,
    1141,  1143,  1142,  1144,  1144,  1145,  1145,  1146,  1146,  1146,
    1146,  1147,  1147,  1148,  1148,  1148,  1148,  1148,  1148,  1148,
    1148,  1148,  1148,  1148,  1148,  1148,  1148,  1148,  1148,  1148,
    1148,  1148,  1149,  1149,  1149,  1149,  1150,  1150,  1151,  1151,
    1152,  1152,  1153,  1154,  1154,  1155,  1155,  1156,  1156,  1157,
    1157,  1157,  1157,  1157,  1158,  1159,  1159,  1159,  1160,  1161,
    1161,  1162,  1162,  1162,  1163,  1163,  1164,  1164,  1165,  1165,
    1165,  1166,  1166,  1167,  1167,  1168,  1168,  1168,  1168,  1168,
    1169,  1169,  1170,  1170,  1171,  1171,  1172,  1172,  1172,  1173,
    1173,  1174,  1174,  1175,  1175,  1176,  1176,  1177,  1177,  1178,
    1179,  1179,  1180,  1180,  1180,  1181,  1181,  1182,  1182,  1183,
    1184,  1184,  1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,
    1193,  1194,  1195,  1196,  1197,  1198,  1199,  1200,  1201,  1202,
    1203,  1204,  1205,  1206,  1207,  1208,  1209,  1209,  1210,  1211,
    1212,  1213,  1214,  1215,  1216,  1217,  1217,  1218,  1219,  1220,
    1221,  1222,  1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,
    1231,  1233,  1232,  1234,  1235,  1236,  1237,  1238,  1239,  1240,
    1241,  1242,  1243,  1244,  1244,  1245,  1246,  1247,  1248,  1248,
    1249,  1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,
    1258,  1259,  1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,
    1268,  1269,  1270,  1271,  1272,  1273,  1274,  1275,  1276,  1277,
    1278,  1278,  1279,  1279,  1280,  1281,  1282,  1283,  1283,  1284,
    1285,  1286,  1287,  1287,  1288,  1289,  1290,  1291,  1291,  1292,
    1293,  1294,  1294,  1295,  1295,  1296,  1296,  1297,  1298,  1299,
    1299,  1299,  1299,  1300,  1300,  1301,  1302,  1303,  1304,  1305,
    1306,  1307,  1308,  1309,  1310,  1310,  1311,  1312,  1313,  1314,
    1315,  1316,  1317,  1318,  1319,  1319,  1320,  1321,  1322,  1323,
    1324,  1325,  1326,  1327,  1328,  1329,  1330,  1331,  1332,  1333,
    1334,  1335,  1335,  1335,  1336,  1337,  1338,  1339,  1340,  1341,
    1342,  1343,  1344,  1345,  1346,  1347,  1348,  1349,  1349,  1350,
    1351,  1352,  1352,  1353,  1354,  1355,  1356,  1357,  1358,  1359,
    1360,  1361,  1362,  1363,  1364,  1365,  1366,  1367,  1368,  1369,
    1370,  1371,  1372,  1373,  1374,  1374,  1374,  1374,  1375,  1376,
    1377,  1378,  1378,  1378,  1379,  1380,  1381,  1382,  1383,  1384,
    1385,  1386,  1387,  1388,  1389,  1390,  1390,  1390,  1391,  1391,
    1391,  1392,  1393,  1394,  1395,  1396,  1397,  1398,  1399,  1400,
    1401,  1402,  1403,  1404,  1405,  1406,  1407,  1408,  1409,  1410,
    1411,  1412,  1413,  1414,  1415,  1416,  1416,  1416,  1417,  1418,
    1418,  1418,  1419,  1419,  1420,  1421,  1422,  1422,  1422,  1423,
    1423,  1423,  1424,  1425,  1426,  1427,  1428,  1429,  1430,  1431,
    1432,  1433,  1434,  1435,  1436,  1437,  1438,  1439,  1440,  1441,
    1442,  1443,  1444,  1445,  1446,  1447,  1448,  1449,  1450,  1451,
    1452,  1453,  1453,  1454,  1455,  1456,  1457,  1458,  1459,  1460,
    1461,  1462,  1463,  1464,  1465,  1466,  1467,  1467,  1467,  1467,
    1467,  1467,  1467,  1468,  1469,  1470,  1471,  1472,  1472,  1472,
    1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,  1481,  1481,
    1481,  1482,  1483,  1484,  1485,  1486,  1487,  1488,  1489,  1490,
    1491,  1492,  1493,  1493,  1494,  1495,  1496,  1497,  1498,  1499,
    1500,  1501,  1502,  1503,  1504,  1505,  1506,  1507,  1508,  1509,
    1510,  1511,  1512,  1513,  1514,  1515,  1516,  1517,  1518,  1519,
    1520,  1521,  1522,  1522,  1523,  1524,  1525,  1526,  1527,  1528,
    1528,  1529,  1530,  1531,  1532,  1533,  1533,  1534,  1534,  1535,
    1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,
    1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,
    1556,  1557,  1558,  1559,  1560,  1561,  1562,  1563,  1564,  1565,
    1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,
    1576,  1577,  1578,  1579,  1579,  1580,  1581,  1582,  1583,  1584,
    1585,  1586,  1587,  1588,  1588,  1588,  1588,  1589,  1590,  1591,
    1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,
    1602,  1603,  1603,  1604,  1605,  1606,  1607,  1608,  1609,  1610,
    1611,  1612,  1613,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1625,  1625,  1626,  1627,
    1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,
    1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,
    1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,
    1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,
    1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,
    1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,
    1688,  1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1695,
    1696,  1696,  1697,  1698,  1698,  1699,  1699,  1699,  1699,  1700,
    1700,  1701,  1701,  1701,  1701,  1702,  1702,  1703,  1703,  1703,
    1703,  1704,  1704,  1705,  1705,  1705,  1706,  1707,  1707,  1708,
    1709,  1709,  1709,  1709,  1709,  1709,  1709,  1709,  1709,  1709,
    1709,  1709,  1709,  1709,  1709,  1709,  1709,  1709,  1709,  1709,
    1709,  1709,  1709,  1709,  1709,  1709,  1709,  1709,  1709,  1709,
    1709,  1709,  1709
  };

  const signed char
  parser::yyr2_[] =
  {
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     4,     2,     3,     1,     1,     1,
       2,     3,     1,     3,     4,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     1,     3,     4,     2,     3,
       4,     2,     4,     5,     3,     3,     0,     9,     0,     9,
       3,     6,     0,     9,     0,    11,     0,     9,     3,     5,
       3,     1,     1,     1,     1,     5,     3,     1,     1,     1,
       1,     0,     6,     3,     1,     1,     1,     1,     1,     1,
       1,     5,     1,     3,     3,     0,     4,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     6,     1,
       1,     1,     1,     4,     3,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       6,     6,     0,     5,     8,     4,     8,     4,     4,     4,
       1,     1,     1,     3,     0,     1,     5,     8,     2,     1,
       4,     5,     5,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     5,     8,    10,
       2,     1,     4,     4,     4,     5,     8,     2,     1,     7,
       0,     6,     2,     1,     0,     5,     5,     3,     1,     3,
       3,     3,     3,     3,     0,     6,     2,     3,     0,     6,
       1,     2,     4,     1,     2,     3,     3,     3,     3,     0,
       9,     1,     2,     3,     3,     1,     4,     1,     2,     3,
       3,     3,     1,     1,     1,     2,     5,     1,     3,     3,
       3,     1,     1,     1,     1,     5,     1,     5,     3,     3,
       1,     0,     6,     0,     9,     2,     2,     1,     1,     4,
       2,     7,     5,     3,     1,     3,     1,     3,     1,     2,
       2,     2,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     7,     4,     4,     4,     2,     2,
       4,     4,     6,     8,     8,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     6,     6,     0,     5,     8,     4,
       8,     4,     4,     4,     4,     1,     3,     5,     5,     0,
       9,     5,     1,     1,     3,     3,     3,     5,     5,     8,
       7,     8,    10,    10,    10,    12,    12,     2,     1,     1,
       6,     5,     7,     7,     9,     9,     9,     2,     1,     5,
       8,     7,     2,     1,     9,     9,     0,     6,     2,     1,
       5,     3,     0,     0,    10,     2,     2,     6,     5,     1,
       1,     1,     2,     6,     7,     7,     8,     2,     5,     3,
       1,     1,     1,     1,     1,     1,     1,     5,     3,     1,
       1,     1,     1,     1,     5,     8,     1,     2,     1,     3,
       1,     2,     1,     3,     2,     5,     4,     3,     1,     5,
       4,     3,     3,     2,     1,     2,     5,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       5,     3,     1,     1,     1,     2,     5,     3,     1,     1,
       1,     1,     2,     5,     3,     1,     1,     1,     1,     2,
       5,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       5,     3,     1,     1,     1,     2,     5,     3,     1,     1,
       1,     2,     5,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     5,     5,     3,     1,     1,     1,
       2,     5,     3,     1,     1,     1,     5,     3,     1,     1,
       1,     1,     1,     2,     5,     3,     6,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     1,     1,     1,     2,     2,     1,     2,     2,
       1,     1,     1,     1,     1,     5,     8,     2,     1,     4,
       2,     2,     1,     4,     1,     3,     5,     9,     1,     5,
       3,     5,     7,     9,     5,     7,     8,     2,     1,     5,
       7,     4,     5,     2,     1,     7,     9,     6,     5,     1,
       2,     2,     5,     2,     1,     6,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     5,     5,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     5,     4,     3,
       6,     8,     3,     1,     0,     8,     0,    10,     0,     8,
       0,    11,     0,    13,     0,    13,     0,    15,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     5,     6,     8,     8,    10,     7,
       9,    10,    12,    12,    14,     3,     1,     1,     1,     1,
       4,     3,     5,     6,     8,     8,    10,     2,     5,     3,
       6,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     1,     3,     1,     3,
       1,     3,     1,     3,     5,     1,     3,     0,     4,     2,
       3,     1,     0,     4,     2,     3,     1,     5,     5,     2,
       1,     5,     5,     2,     1,     7,     3,     5,     4,     6,
       3,     5,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     5,     3,     6,     5,     6,
       5,     6,     5,     5,     2,     5,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     6,     1,     1,     1,     3,     1,
       1,     1,     3,     1,     4,     2,     5,     3,     6,     0,
       0,     5,     2,     5,     2,     5,     3,     6,     5,     2,
       1,     4,     4,     4,     4,     2,     5,     3,     1,     1,
       1,     2,     5,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     5,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     5,     3,     1,     1,     1,
       1,     1,     2,     5,     3,     6,     3,     1,     1,     2,
       5,     3,     6,     3,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     2,     5,
       2,     5,     2,     5,     2,     2,     5,     3,     6,     2,
       5,     3,     6,     2,     5,     3,     6,     2,     5,     3,
       6,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     3,     6,     1,     1,     1,     1,     3,     1,
       3,     6,     7,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     2,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     2,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     2,
       5,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     2,     5,     3,
       6,     1,     1,     1,     1,     3,     1,     2,     5,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     2,
       5,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       2,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     2,
       5,     2,     5,     2,     5,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     5,
       7,     8,     1,     2,     6,     4,     2,     5,     3,     6,
       1,     3,     1,     1,     1,     1,     1,     5,     1,     3,
       1,     1,     1,     1,     1,     3,     8,     5,     1,     2,
       9,     0,     6,     2,     1,     4,     6,     2,     5,     3,
       6,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     5,     7,     8,     3,     1,     1,     1,
       2,     1,     4,     5,     3,     2,     5,     3,     1,     1,
       1,     1,     1,     1,     2,     5,     1,     1,     5,     1,
       2,     6,     9,     9,     5,     8,     1,     2,     6,     9,
       9,     2,     5,     3,     1,     1,     1,     1,     1,     1,
       5,    10,     2,     1,     4,     4,     3,     2,     1,     5,
      10,     2,     1,     3,     4,     5,     8,     1,     2,     5,
       6,     6,     3,     6,     6,     5,     8,     1,     2,     6,
       6,     6,     3,     3,     1,     1,     3,     3,     3,     3,
       1,     1,     1,     1,     3,     5,     3,     3,     3,     3,
       3,     3,     3,     1,     3,     3,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     0,     4,     3,     3,     3,     3,     3,     3,     3,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     3,     3,
       3,     3,     5,     3,     5,     3,     5,     1,     1,     1,
       1,     1,     1,     1,     3,     5,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     1,     3,     5,     5,     3,
       1,     3,     3,     3,     3,     3,     1,     3,     3,     3,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     1,
       1,     3,     3,     3,     3,     3,     3,     1,     3,     3,
       1,     1,     1,     1,     3,     3,     3,     1,     3,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     1,     1,     3,     3,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     1,     3,
       3,     1,     1,     3,     5,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     5,     5,     5,     3,     3,     5,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     1,     5,     3,     3,     3,     3,
       3,     3,     3,     1,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     5,     3,     3,     3,
       3,     3,     1,     1,     3,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       3,     3,     3,     3,     3,     3,     5,     1,     1,     3,
       3,     1,     5,     3,     3,     3,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     3,
       1,     3,     3,     3,     1,     3,     1,     1,     1,     3,
       3,     3,     3,     1,     3,     1,     3,     3,     3,     1,
       3,     1,     3,     3,     3,     3,     3,     1,     1,     3,
       3,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       1,     1,     3,     5,     3,     5,     3,     3,     5,     1,
       3,     3,     1,     3,     3,     3,     1,     1,     1,     5,
       3,     3,     3,     1,     1,     3,     3,     3,     3,     1,
       1,     3,     3,     1,     3,     3,     3,     3,     3,     1,
       1,     1,     3,     3,     3,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     3,     3,     3,     3,     1,     3,     3,     1,     1,
       1,     1,     1,     3,     3,     1,     3,     3,     1,     3,
       1,     1,     3,     3,     1,     3,     3,     1,     1,     1,
       3,     3,     3,     1,     1,     1,     3,     3,     3,     3,
       3,     6,     1,     1,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     1,     2,     3,     3,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "AIM_SOLVER",
  "ANALYTIC_DERIVATION", "ANALYTIC_DERIVATION_MODE", "AR",
  "POSTERIOR_SAMPLING_METHOD", "BALANCED_GROWTH_TEST_TOL", "BAYESIAN_IRF",
  "BETA_PDF", "BLOCK", "USE_CALIBRATION", "SILENT_OPTIMIZER",
  "BVAR_DENSITY", "BVAR_FORECAST", "BVAR_IRF", "NODECOMPOSITION",
  "DR_DISPLAY_TOL", "HUGE_NUMBER", "FIG_NAME", "WRITE_XLS",
  "BVAR_PRIOR_DECAY", "BVAR_PRIOR_FLAT", "BVAR_PRIOR_LAMBDA",
  "INTERACTIVE", "SCREEN_SHOCKS", "STEADYSTATE", "BVAR_PRIOR_MU",
  "BVAR_PRIOR_OMEGA", "BVAR_PRIOR_TAU", "BVAR_PRIOR_TRAIN", "DETAIL_PLOT",
  "TYPE", "BVAR_REPLIC", "BYTECODE", "ALL_VALUES_REQUIRED",
  "PROPOSAL_DISTRIBUTION", "REALTIME", "VINTAGE", "CALIB_SMOOTHER",
  "CHANGE_TYPE", "CHECK", "CONDITIONAL_FORECAST",
  "CONDITIONAL_FORECAST_PATHS", "CONF_SIG", "CONSTANT",
  "CONTROLLED_VAREXO", "CORR", "CUTOFF", "CYCLE_REDUCTION",
  "LOGARITHMIC_REDUCTION", "COMMA", "CONSIDER_ALL_ENDOGENOUS",
  "CONSIDER_ALL_ENDOGENOUS_AND_AUXILIARY", "CONSIDER_ONLY_OBSERVED",
  "INITIAL_CONDITION_DECOMPOSITION", "DATAFILE", "FILE", "SERIES",
  "DOUBLING", "DR_CYCLE_REDUCTION_TOL", "DR_LOGARITHMIC_REDUCTION_TOL",
  "DR_LOGARITHMIC_REDUCTION_MAXITER", "DR_ALGO", "DROP", "DSAMPLE",
  "DYNASAVE", "DYNATYPE", "CALIBRATION", "DIFFERENTIATE_FORWARD_VARS",
  "END", "ENDVAL", "EQUAL", "ESTIMATION", "ESTIMATED_PARAMS",
  "ESTIMATED_PARAMS_BOUNDS", "ESTIMATED_PARAMS_INIT", "EXTENDED_PATH",
  "ENDOGENOUS_PRIOR", "EXPRESSION", "FILENAME", "DIRNAME",
  "FILTER_STEP_AHEAD", "FILTERED_VARS", "FIRST_OBS",
  "FIRST_SIMULATION_PERIOD", "LAST_SIMULATION_PERIOD", "LAST_OBS",
  "SET_TIME", "OSR_PARAMS_BOUNDS",
  "KEEP_KALMAN_ALGO_IF_SINGULARITY_IS_DETECTED", "FALSE", "FLOAT_NUMBER",
  "DATES", "DEFAULT", "FIXED_POINT", "FLIP", "OPT_ALGO",
  "COMPILATION_SETUP", "COMPILER", "ADD_FLAGS", "SUBSTITUTE_FLAGS",
  "ADD_LIBS", "SUBSTITUTE_LIBS", "FORECAST", "K_ORDER_SOLVER",
  "INSTRUMENTS", "SHIFT", "MEAN", "STDEV", "VARIANCE", "MODE", "INTERVAL",
  "SHAPE", "DOMAINN", "GAMMA_PDF", "GRAPH", "GRAPH_FORMAT",
  "CONDITIONAL_VARIANCE_DECOMPOSITION", "NOCHECK", "STD", "HISTVAL",
  "HISTVAL_FILE", "HOMOTOPY_SETUP", "HOMOTOPY_MODE", "HOMOTOPY_STEPS",
  "HOMOTOPY_FORCE_CONTINUE", "HP_FILTER", "HP_NGRID",
  "FILTERED_THEORETICAL_MOMENTS_GRID", "HYBRID", "ONE_SIDED_HP_FILTER",
  "IDENTIFICATION", "INF_CONSTANT", "INITVAL", "INITVAL_FILE", "BOUNDS",
  "JSCALE", "INIT", "INFILE", "INVARS", "INT_NUMBER",
  "CONDITIONAL_LIKELIHOOD", "INV_GAMMA_PDF", "INV_GAMMA1_PDF",
  "INV_GAMMA2_PDF", "IRF", "IRF_SHOCKS", "IRF_PLOT_THRESHOLD",
  "IRF_CALIBRATION", "FAST_KALMAN_FILTER", "KALMAN_ALGO", "KALMAN_TOL",
  "DIFFUSE_KALMAN_TOL", "SCHUR_VEC_TOL", "SUBSAMPLES", "OPTIONS", "TOLF",
  "TOLX", "PLOT_INIT_DATE", "PLOT_END_DATE", "LAPLACE", "LIK_INIT",
  "LINEAR", "LINEAR_DECOMPOSITION", "LOAD_IDENT_FILES", "LOAD_MH_FILE",
  "LOAD_RESULTS_AFTER_LOAD_MH", "LOAD_PARAMS_AND_STEADY_STATE",
  "LOGLINEAR", "LOGDATA", "LYAPUNOV", "LINEAR_APPROXIMATION",
  "LYAPUNOV_COMPLEX_THRESHOLD", "LYAPUNOV_FIXED_POINT_TOL",
  "LYAPUNOV_DOUBLING_TOL", "LOG_DEFLATOR", "LOG_TREND_VAR",
  "LOG_GROWTH_FACTOR", "MATCHED_MOMENTS", "MARKOWITZ", "MARGINAL_DENSITY",
  "MAX", "MAXIT", "MH_CONF_SIG", "MH_DROP", "MH_INIT_SCALE",
  "MH_INIT_SCALE_FACTOR", "MH_JSCALE", "MH_TUNE_JSCALE", "MH_TUNE_GUESS",
  "MH_POSTERIOR_MODE_ESTIMATION", "MH_NBLOCKS", "MH_REPLIC", "MH_RECOVER",
  "MH_INITIALIZE_FROM_PREVIOUS_MCMC",
  "MH_INITIALIZE_FROM_PREVIOUS_MCMC_DIRECTORY",
  "MH_INITIALIZE_FROM_PREVIOUS_MCMC_RECORD",
  "MH_INITIALIZE_FROM_PREVIOUS_MCMC_PRIOR",
  "POSTERIOR_MAX_SUBSAMPLE_DRAWS", "MIN", "MINIMAL_SOLVING_PERIODS",
  "MODE_CHECK", "MODE_CHECK_NEIGHBOURHOOD_SIZE",
  "MODE_CHECK_SYMMETRIC_PLOTS", "MODE_CHECK_NUMBER_OF_POINTS",
  "MODE_COMPUTE", "MODE_FILE", "MODEL", "MODEL_COMPARISON", "MODEL_INFO",
  "MSHOCKS", "ABS", "SIGN", "MODEL_DIAGNOSTICS", "MODIFIEDHARMONICMEAN",
  "MOMENTS_VARENDO", "CONTEMPORANEOUS_CORRELATION", "DIFFUSE_FILTER",
  "SUB_DRAWS", "TAPER_STEPS", "GEWEKE_INTERVAL", "RAFTERY_LEWIS_QRS",
  "RAFTERY_LEWIS_DIAGNOSTICS", "BROOKS_GELMAN_PLOTROWS",
  "MCMC_JUMPING_COVARIANCE", "MOMENT_CALIBRATION", "NUMBER_OF_PARTICLES",
  "RESAMPLING", "SYSTEMATIC", "GENERIC", "RESAMPLING_THRESHOLD",
  "RESAMPLING_METHOD", "KITAGAWA", "STRATIFIED", "SMOOTH", "CPF_WEIGHTS",
  "AMISANOTRISTANI", "MURRAYJONESPARSLOW", "WRITE_EQUATION_TAGS",
  "FILTER_INITIAL_STATE", "NONLINEAR_FILTER_INITIALIZATION",
  "FILTER_ALGORITHM", "PROPOSAL_APPROXIMATION", "CUBATURE", "UNSCENTED",
  "MONTECARLO", "DISTRIBUTION_APPROXIMATION", "NAME",
  "USE_PENALIZED_OBJECTIVE_FOR_HESSIAN", "INIT_STATE", "FAST_REALTIME",
  "RESCALE_PREDICTION_ERROR_COVARIANCE", "GENERATE_IRFS", "NAN_CONSTANT",
  "NO_STATIC", "NOBS", "NOCONSTANT", "NODISPLAY", "NOCORR", "NODIAGNOSTIC",
  "NOFUNCTIONS", "NO_HOMOTOPY", "NOGRAPH", "POSTERIOR_NOGRAPH",
  "POSTERIOR_GRAPH", "NOMOMENTS", "NOMODELSUMMARY", "NOPRINT",
  "NORMAL_PDF", "SAVE_DRAWS", "MODEL_NAME", "STDERR_MULTIPLES",
  "DIAGONAL_ONLY", "DETERMINISTIC_TRENDS", "OBSERVATION_TRENDS", "OPTIM",
  "OPTIM_WEIGHTS", "ORDER", "OSR", "OSR_PARAMS", "MAX_DIM_COVA_GROUP",
  "ADVANCED", "OUTFILE", "OUTVARS", "OVERWRITE", "DISCOUNT",
  "PARALLEL_LOCAL_FILES", "PARAMETERS", "PARAMETER_SET",
  "PARTIAL_INFORMATION", "PERIODS", "PERIOD", "PLANNER_OBJECTIVE",
  "PLOT_CONDITIONAL_FORECAST", "PLOT_PRIORS", "PREFILTER", "PRESAMPLE",
  "PERFECT_FORESIGHT_SETUP", "PERFECT_FORESIGHT_SOLVER",
  "NO_POSTERIOR_KERNEL_DENSITY", "FUNCTION",
  "PERFECT_FORESIGHT_WITH_EXPECTATION_ERRORS_SETUP",
  "PERFECT_FORESIGHT_WITH_EXPECTATION_ERRORS_SOLVER", "PRINT", "PRIOR_MC",
  "PRIOR_TRUNC", "PRIOR_MODE", "PRIOR_MEAN", "POSTERIOR_MODE",
  "POSTERIOR_MEAN", "POSTERIOR_MEDIAN", "MLE_MODE", "PRUNING",
  "PARTICLE_FILTER_OPTIONS", "QUOTED_STRING", "QZ_CRITERIUM",
  "QZ_ZERO_THRESHOLD", "DSGE_VAR", "DSGE_VARLAG", "DSGE_PRIOR_WEIGHT",
  "TRUNCATE", "PIPE_E", "PIPE_X", "PIPE_P", "RELATIVE_IRF", "REPLIC",
  "SIMUL_REPLIC", "RPLOT", "SAVE_PARAMS_AND_STEADY_STATE",
  "PARAMETER_UNCERTAINTY", "TARGETS", "SHOCKS", "HETEROSKEDASTIC_SHOCKS",
  "SHOCK_DECOMPOSITION", "SHOCK_GROUPS", "USE_SHOCK_GROUPS", "SIMUL",
  "SIMUL_ALGO", "SIMUL_SEED", "ENDOGENOUS_TERMINAL_PERIOD", "SMOOTHER",
  "SMOOTHER2HISTVAL", "SQUARE_ROOT_SOLVER", "STACK_SOLVE_ALGO",
  "STEADY_STATE_MODEL", "SOLVE_ALGO", "SOLVER_PERIODS", "ROBUST_LIN_SOLVE",
  "STDERR", "STEADY", "STOCH_SIMUL", "REGIMES", "REGIME",
  "REALTIME_SHOCK_DECOMPOSITION", "CONDITIONAL", "UNCONDITIONAL", "TEX",
  "RAMSEY_MODEL", "RAMSEY_POLICY", "RAMSEY_CONSTRAINTS",
  "PLANNER_DISCOUNT", "PLANNER_DISCOUNT_LATEX_NAME",
  "DISCRETIONARY_POLICY", "DISCRETIONARY_TOL",
  "EVALUATE_PLANNER_OBJECTIVE", "OCCBIN_SETUP", "OCCBIN_SOLVER",
  "OCCBIN_WRITE_REGIMES", "OCCBIN_GRAPH", "SIMUL_MAXIT",
  "LIKELIHOOD_MAXIT", "SMOOTHER_MAXIT", "SIMUL_PERIODS",
  "LIKELIHOOD_PERIODS", "SMOOTHER_PERIODS", "SIMUL_CURB_RETRENCH",
  "LIKELIHOOD_CURB_RETRENCH", "SMOOTHER_CURB_RETRENCH",
  "SIMUL_CHECK_AHEAD_PERIODS", "SIMUL_MAX_CHECK_AHEAD_PERIODS",
  "SIMUL_RESET_CHECK_AHEAD_PERIODS", "LIKELIHOOD_CHECK_AHEAD_PERIODS",
  "LIKELIHOOD_MAX_CHECK_AHEAD_PERIODS", "SMOOTHER_CHECK_AHEAD_PERIODS",
  "SMOOTHER_MAX_CHECK_AHEAD_PERIODS", "SIMUL_DEBUG", "SMOOTHER_DEBUG",
  "SIMUL_PERIODIC_SOLUTION", "LIKELIHOOD_PERIODIC_SOLUTION",
  "SMOOTHER_PERIODIC_SOLUTION", "LIKELIHOOD_INVERSION_FILTER",
  "SMOOTHER_INVERSION_FILTER", "FILTER_USE_RELEXATION",
  "LIKELIHOOD_PIECEWISE_KALMAN_FILTER", "SMOOTHER_PIECEWISE_KALMAN_FILTER",
  "LIKELIHOOD_MAX_KALMAN_ITERATIONS", "TEX_NAME", "TRUE", "BIND", "RELAX",
  "ERROR_BIND", "ERROR_RELAX", "UNIFORM_PDF", "UNIT_ROOT_VARS", "USE_DLL",
  "USEAUTOCORR", "GSA_SAMPLE_FILE",
  "USE_UNIVARIATE_FILTERS_IF_SINGULARITY_IS_DETECTED", "VALUES", "SCALES",
  "VAR", "VAREXO", "VAREXO_DET", "VARIABLE", "VAROBS", "VAREXOBS",
  "PREDETERMINED_VARIABLES", "VAR_EXPECTATION", "VAR_EXPECTATION_MODEL",
  "PLOT_SHOCK_DECOMPOSITION", "MODEL_LOCAL_VARIABLE",
  "WRITE_LATEX_DYNAMIC_MODEL", "WRITE_LATEX_STATIC_MODEL",
  "WRITE_LATEX_ORIGINAL_MODEL", "WRITE_LATEX_STEADY_STATE_MODEL",
  "XLS_SHEET", "XLS_RANGE", "LMMCP", "BANDPASS_FILTER", "COLORMAP",
  "VAR_MODEL", "PAC_MODEL", "QOQ", "YOY", "AOA", "PAC_EXPECTATION",
  "TREND_COMPONENT_MODEL", "EQUAL_EQUAL", "EXCLAMATION_EQUAL", "LESS",
  "GREATER", "LESS_EQUAL", "GREATER_EQUAL", "PLUS", "MINUS", "TIMES",
  "DIVIDE", "UNARY", "POWER", "EXP", "LOG", "LN", "LOG10", "SIN", "COS",
  "TAN", "ASIN", "ACOS", "ATAN", "SINH", "COSH", "TANH", "ASINH", "ACOSH",
  "ATANH", "ERF", "ERFC", "DIFF", "ADL", "AUXILIARY_MODEL_NAME", "SQRT",
  "CBRT", "NORMCDF", "NORMPDF", "STEADY_STATE", "EXPECTATION",
  "SENSITIVITY", "DYNARE_SENSITIVITY", "MORRIS", "STAB", "REDFORM",
  "PPRIOR", "PRIOR_RANGE", "PPOST", "ILPTAU", "MORRIS_NLIV", "MORRIS_NTRA",
  "NSAM", "LOAD_REDFORM", "LOAD_RMSE", "LOAD_STAB", "ALPHA2_STAB",
  "LOGTRANS_REDFORM", "THRESHOLD_REDFORM", "KSSTAT_REDFORM",
  "ALPHA2_REDFORM", "NAMENDO", "NAMLAGENDO", "NAMEXO", "RMSE", "LIK_ONLY",
  "VAR_RMSE", "PFILT_RMSE", "ISTART_RMSE", "ALPHA_RMSE", "ALPHA2_RMSE",
  "FREQ", "INITIAL_YEAR", "INITIAL_SUBPERIOD", "FINAL_YEAR",
  "FINAL_SUBPERIOD", "DATA", "VLIST", "VLISTLOG", "VLISTPER",
  "SPECTRAL_DENSITY", "INIT2SHOCKS", "RESTRICTION", "RESTRICTION_FNAME",
  "CROSS_RESTRICTIONS", "NLAGS", "CONTEMP_REDUCED_FORM",
  "REAL_PSEUDO_FORECAST", "DUMMY_OBS", "NSTATES", "INDXSCALESSTATES",
  "NO_BAYESIAN_PRIOR", "SPECIFICATION", "SIMS_ZHA", "ALPHA", "BETA",
  "ABAND", "NINV", "CMS", "NCMS", "CNUM", "GAMMA", "INV_GAMMA",
  "INV_GAMMA1", "INV_GAMMA2", "NORMAL", "UNIFORM", "EPS", "PDF", "FIG",
  "DR", "NONE", "PRIOR", "PRIOR_VARIANCE", "HESSIAN", "IDENTITY_MATRIX",
  "DIRICHLET", "DIAGONAL", "OPTIMAL", "MFS", "GSIG2_LMDM", "Q_DIAG",
  "FLAT_PRIOR", "NCSK", "NSTD", "WEIBULL", "WEIBULL_PDF", "INDXPARR",
  "INDXOVR", "INDXAP", "APBAND", "INDXIMF", "INDXFORE", "FOREBAND",
  "INDXGFOREHAT", "INDXGIMFHAT", "INDXESTIMA", "INDXGDLS", "EQ_MS",
  "FILTER_COVARIANCE", "UPDATED_COVARIANCE", "FILTER_DECOMPOSITION",
  "SMOOTHED_STATE_UNCERTAINTY", "SMOOTHER_REDUX", "EQ_CMS", "TLINDX",
  "TLNUMBER", "RESTRICTIONS", "POSTERIOR_SAMPLER_OPTIONS",
  "OUTPUT_FILE_TAG", "HORIZON", "SBVAR", "TREND_VAR", "DEFLATOR",
  "GROWTH_FACTOR", "MS_IRF", "MS_VARIANCE_DECOMPOSITION", "GROWTH",
  "MS_ESTIMATION", "MS_SIMULATION", "MS_COMPUTE_MDD",
  "MS_COMPUTE_PROBABILITIES", "MS_FORECAST", "SVAR_IDENTIFICATION",
  "EQUATION", "EXCLUSION", "LAG", "UPPER_CHOLESKY", "LOWER_CHOLESKY",
  "MONTHLY", "QUARTERLY", "MARKOV_SWITCHING", "CHAIN", "DURATION",
  "NUMBER_OF_REGIMES", "NUMBER_OF_LAGS", "EPILOGUE", "SVAR",
  "SVAR_GLOBAL_IDENTIFICATION_CHECK", "COEFF", "COEFFICIENTS", "VARIANCES",
  "CONSTANTS", "EQUATIONS", "EXTERNAL_FUNCTION", "EXT_FUNC_NAME",
  "EXT_FUNC_NARGS", "FIRST_DERIV_PROVIDED", "SECOND_DERIV_PROVIDED",
  "SELECTED_VARIABLES_ONLY", "COVA_COMPUTE", "SIMULATION_FILE_TAG",
  "FILE_TAG", "NO_ERROR_BANDS", "ERROR_BAND_PERCENTILES",
  "SHOCKS_PER_PARAMETER", "NO_CREATE_INIT", "SHOCK_DRAWS",
  "FREE_PARAMETERS", "MEDIAN", "DATA_OBS_NBR", "NEIGHBORHOOD_WIDTH",
  "PVALUE_KS", "PVALUE_CORR", "FILTERED_PROBABILITIES",
  "REAL_TIME_SMOOTHED", "PRIOR_FUNCTION", "POSTERIOR_FUNCTION",
  "SAMPLING_DRAWS", "PROPOSAL_TYPE", "PROPOSAL_UPPER_BOUND",
  "PROPOSAL_LOWER_BOUND", "PROPOSAL_DRAWS", "USE_MEAN_CENTER",
  "ADAPTIVE_MH_DRAWS", "THINNING_FACTOR",
  "COEFFICIENTS_PRIOR_HYPERPARAMETERS", "CONVERGENCE_STARTING_VALUE",
  "CONVERGENCE_ENDING_VALUE", "CONVERGENCE_INCREMENT_VALUE",
  "MAX_ITERATIONS_STARTING_VALUE", "MAX_ITERATIONS_INCREMENT_VALUE",
  "MAX_BLOCK_ITERATIONS", "MAX_REPEATED_OPTIMIZATION_RUNS",
  "FUNCTION_CONVERGENCE_CRITERION", "SAVE_REALTIME",
  "PARAMETER_CONVERGENCE_CRITERION", "NUMBER_OF_LARGE_PERTURBATIONS",
  "NUMBER_OF_SMALL_PERTURBATIONS",
  "NUMBER_OF_POSTERIOR_DRAWS_AFTER_PERTURBATION", "MAX_NUMBER_OF_STAGES",
  "RANDOM_FUNCTION_CONVERGENCE_CRITERION",
  "RANDOM_PARAMETER_CONVERGENCE_CRITERION",
  "NO_INIT_ESTIMATION_CHECK_FIRST_OBS", "HETEROSKEDASTIC_FILTER",
  "TIME_SHIFT", "STRUCTURAL", "CONSTANT_SIMULATION_LENGTH", "SURPRISE",
  "OCCBIN_CONSTRAINTS", "PAC_TARGET_INFO", "COMPONENT", "TARGET",
  "AUXNAME", "AUXNAME_TARGET_NONSTATIONARY", "PAC_TARGET_NONSTATIONARY",
  "KIND", "LL", "DL", "DD", "ADD", "MULTIPLY", "GMM", "SMM",
  "IRF_MATCHING", "METHOD_OF_MOMENTS", "MOM_METHOD", "SIMULATION_METHOD",
  "BARTLETT_KERNEL_LAG", "WEIGHTING_MATRIX",
  "WEIGHTING_MATRIX_SCALING_FACTOR", "ANALYTIC_STANDARD_ERRORS",
  "ANALYTIC_JACOBIAN", "PENALIZED_ESTIMATOR", "VERBOSE",
  "SIMULATION_MULTIPLE", "MOM_SEED", "SEED", "BOUNDED_SHOCK_SUPPORT",
  "ADDITIONAL_OPTIMIZER_STEPS", "MOM_SE_TOLX", "SE_TOLX", "MOM_BURNIN",
  "BURNIN", "IRF_MATCHING_FILE", "ADD_TINY_NUMBER_TO_CHOLESKY", "EQTAGS",
  "ANALYTICAL_GIRF", "IRF_IN_PERCENT", "EMAS_GIRF", "EMAS_DROP",
  "EMAS_TOLF", "EMAS_MAX_ITER", "NO_IDENTIFICATION_STRENGTH",
  "NO_IDENTIFICATION_REDUCEDFORM", "NO_IDENTIFICATION_MOMENTS",
  "NO_IDENTIFICATION_MINIMAL", "NO_IDENTIFICATION_SPECTRUM",
  "NORMALIZE_JACOBIANS", "GRID_NBR", "TOL_RANK", "TOL_DERIV", "TOL_SV",
  "CHECKS_VIA_SUBSETS", "MAX_DIM_SUBSETS_GROUPS", "MAX_NROWS",
  "SQUEEZE_SHOCK_DECOMPOSITION", "WITH_EPILOGUE", "MODEL_REMOVE",
  "MODEL_REPLACE", "MODEL_OPTIONS", "VAR_REMOVE",
  "ESTIMATED_PARAMS_REMOVE", "BLOCK_STATIC", "BLOCK_DYNAMIC", "INCIDENCE",
  "RESID", "NON_ZERO", "LEARNT_IN", "PLUS_EQUAL", "TIMES_EQUAL",
  "FSOLVE_OPTIONS", "ENDVAL_STEADY", "STEADY_SOLVE_ALGO", "STEADY_MAXIT",
  "STEADY_TOLF", "STEADY_TOLX", "STEADY_MARKOWITZ",
  "HOMOTOPY_MAX_COMPLETION_SHARE", "HOMOTOPY_MIN_STEP_SIZE",
  "HOMOTOPY_INITIAL_STEP_SIZE",
  "HOMOTOPY_STEP_SIZE_INCREASE_SUCCESS_COUNT",
  "HOMOTOPY_LINEARIZATION_FALLBACK",
  "HOMOTOPY_MARGINAL_LINEARIZATION_FALLBACK", "HOMOTOPY_EXCLUDE_VAREXO",
  "FROM_INITVAL_TO_ENDVAL", "STATIC_MFS", "RELATIVE_TO_INITVAL",
  "MATCHED_IRFS", "MATCHED_IRFS_WEIGHTS", "WEIGHTS", "SYMBOL_VEC", "';'",
  "':'", "'('", "')'", "'['", "']'", "'#'", "'.'", "$accept",
  "statement_list", "statement", "dsample", "symbol_list",
  "symbol_list_or_wildcard", "symbol_list_with_tex", "partition_elem",
  "partition_1", "partition", "symbol_list_with_tex_and_partition",
  "rplot", "trend_var", "$@1", "log_trend_var", "$@2", "var", "$@3", "$@4",
  "$@5", "var_remove", "var_model", "var_model_options_list",
  "var_model_options", "trend_component_model",
  "trend_component_model_options_list", "trend_component_model_options",
  "pac_model", "$@6", "pac_model_options_list", "pac_model_options",
  "var_expectation_model", "var_expectation_model_options_list",
  "var_expectation_model_option", "$@7", "varexo", "varexo_det",
  "predetermined_variables", "parameters", "model_local_variable",
  "change_type", "change_type_arg", "init_param", "expression", "$@8",
  "comma_expression", "expression_or_empty", "initval", "initval_list",
  "initval_elem", "histval_file", "initval_file", "h_options_list",
  "h_options", "endval", "endval_list", "endval_elem", "histval",
  "histval_list", "histval_elem", "epilogue", "$@9",
  "epilogue_equation_list", "epilogue_equation", "$@10",
  "compilation_setup", "compilation_setup_options_list",
  "compilation_setup_option", "matched_moments", "$@11",
  "matched_moments_list", "occbin_constraints", "$@12",
  "occbin_constraints_regimes_list", "occbin_constraints_regime",
  "occbin_constraints_regime_options_list",
  "occbin_constraints_regime_option", "pac_target_info", "$@13",
  "pac_target_info_statement_list", "pac_target_info_statement",
  "pac_target_info_component", "pac_target_info_component_list",
  "pac_target_info_component_elem", "pac_target_kind", "resid",
  "model_option", "model_options_list", "model", "$@14", "$@15",
  "equation_list", "equation", "tag_pair_list", "tag_pair", "hand_side",
  "$@16", "comma_hand_side", "pound_expression", "model_remove",
  "model_replace", "$@17", "model_options", "tag_pair_list_for_selection",
  "shocks", "shock_list", "shock_elem", "det_shock_elem", "det_shock_list",
  "heteroskedastic_shocks", "heteroskedastic_shock_list",
  "heteroskedastic_shock_elem", "svar_identification", "$@18",
  "svar_identification_list", "svar_identification_elem", "$@19", "$@20",
  "svar_equation_list", "restriction_expression",
  "restriction_expression_1", "restriction_elem_expression",
  "svar_global_identification_check", "markov_switching",
  "ms_options_list", "ms_options", "svar", "svar_options_list",
  "svar_options", "mshocks", "mshocks_options_list", "mshocks_option",
  "mshock_list", "period_list", "value_list", "steady",
  "steady_options_list", "steady_options", "check", "check_options_list",
  "check_options", "model_info", "model_info_options_list",
  "model_info_options", "perfect_foresight_setup",
  "perfect_foresight_setup_options_list",
  "perfect_foresight_setup_options", "perfect_foresight_solver",
  "perfect_foresight_solver_options_list",
  "perfect_foresight_solver_options",
  "perfect_foresight_with_expectation_errors_setup",
  "perfect_foresight_with_expectation_errors_setup_options_list",
  "perfect_foresight_with_expectation_errors_setup_options",
  "perfect_foresight_with_expectation_errors_solver",
  "perfect_foresight_with_expectation_errors_solver_options_list",
  "perfect_foresight_with_expectation_errors_solver_options",
  "method_of_moments", "method_of_moments_options_list",
  "method_of_moments_option", "prior_function", "posterior_function",
  "prior_posterior_function_options_list",
  "prior_posterior_function_options", "simul", "simul_options_list",
  "simul_options", "external_function", "external_function_options_list",
  "external_function_options", "stoch_simul", "stoch_simul_options_list",
  "stoch_simul_primary_options", "stoch_simul_options", "signed_integer",
  "non_negative_number", "signed_number", "signed_inf",
  "signed_number_w_inf", "boolean", "estimated_params", "estimated_list",
  "estimated_elem", "estimated_elem1", "estimated_elem2",
  "estimated_elem3", "estimated_params_init", "estimated_init_list",
  "estimated_init_elem", "estimated_params_bounds",
  "estimated_bounds_list", "estimated_bounds_elem",
  "estimated_params_remove", "estimated_remove_list",
  "estimated_remove_elem", "osr_params_bounds", "osr_bounds_list",
  "osr_bounds_elem", "prior_distribution", "prior_pdf", "date_str",
  "date_expr", "set_time", "data", "data_options_list", "data_options",
  "subsamples", "subsamples_eq", "subsamples_eq_opt",
  "subsamples_name_list", "prior", "$@21", "$@22", "$@23", "$@24", "$@25",
  "$@26", "$@27", "prior_options_list", "prior_options",
  "joint_prior_options_list", "joint_prior_options", "prior_eq",
  "prior_eq_opt", "options", "options_options_list", "options_options",
  "options_eq", "options_eq_opt", "estimation", "estimation_options_list",
  "estimation_options", "name_value_pair", "name_value_pair_list",
  "name_value_pair_with_boolean", "name_value_pair_with_boolean_list",
  "name_value_pair_with_suboptions",
  "name_value_pair_with_suboptions_list", "varobs", "$@28", "varobs_list",
  "varexobs", "$@29", "varexobs_list", "deterministic_trends",
  "observation_trends", "trend_list", "trend_element",
  "filter_initial_state", "filter_initial_state_list",
  "filter_initial_state_element", "unit_root_vars", "optim_weights",
  "optim_weights_list", "osr_params", "osr_options_list", "osr_options",
  "osr", "dynatype", "dynasave", "load_params_and_steady_state",
  "save_params_and_steady_state", "identification",
  "identification_options_list", "identification_option",
  "model_comparison", "filename", "namespace_qualified_symbol",
  "namespace_qualified_filename", "parallel_local_filename_list",
  "mc_filename_list", "planner_objective", "$@30", "$@31", "ramsey_model",
  "ramsey_policy", "ramsey_constraints", "ramsey_constraints_list",
  "ramsey_constraint", "evaluate_planner_objective",
  "evaluate_planner_objective_options_list",
  "evaluate_planner_objective_option", "occbin_setup",
  "occbin_setup_options_list", "occbin_setup_option", "occbin_solver",
  "occbin_solver_options_list", "occbin_solver_option",
  "occbin_write_regimes", "occbin_write_regimes_options_list",
  "occbin_write_regimes_option", "occbin_graph",
  "occbin_graph_options_list", "occbin_graph_option",
  "discretionary_policy", "discretionary_policy_options_list",
  "discretionary_policy_options", "ramsey_model_options_list",
  "ramsey_model_options", "ramsey_policy_options_list",
  "ramsey_policy_options", "write_latex_dynamic_model",
  "write_latex_static_model", "write_latex_original_model",
  "write_latex_steady_state_model", "shock_decomposition",
  "realtime_shock_decomposition", "plot_shock_decomposition",
  "initial_condition_decomposition", "squeeze_shock_decomposition",
  "bvar_prior_option", "bvar_common_option", "bvar_density_options_list",
  "bvar_density", "bvar_forecast_option", "bvar_forecast_options_list",
  "bvar_forecast", "bvar_irf", "sbvar_option", "sbvar_options_list",
  "sbvar", "ms_variance_decomposition_option",
  "ms_variance_decomposition_options_list", "ms_variance_decomposition",
  "ms_forecast_option", "ms_forecast_options_list", "ms_forecast",
  "ms_irf_option", "ms_irf_options_list", "ms_irf",
  "ms_compute_probabilities_option",
  "ms_compute_probabilities_options_list", "ms_compute_probabilities",
  "ms_compute_mdd_option", "ms_compute_mdd_options_list", "ms_compute_mdd",
  "ms_simulation_option", "ms_simulation_options_list", "ms_simulation",
  "ms_estimation_option", "ms_estimation_options_list", "ms_estimation",
  "sensitivity", "sensitivity_options_list", "sensitivity_option",
  "shock_decomposition_options_list", "shock_decomposition_option",
  "realtime_shock_decomposition_options_list",
  "realtime_shock_decomposition_option",
  "plot_shock_decomposition_options_list",
  "plot_shock_decomposition_option",
  "initial_condition_decomposition_options_list",
  "initial_condition_decomposition_option", "homotopy_setup",
  "homotopy_list", "homotopy_item", "forecast", "forecast_options",
  "forecast_option", "conditional_forecast",
  "conditional_forecast_options", "conditional_forecast_option",
  "plot_conditional_forecast", "conditional_forecast_paths",
  "conditional_forecast_paths_shock_list",
  "conditional_forecast_paths_shock_elem", "steady_state_model", "$@32",
  "steady_state_equation_list", "steady_state_equation", "calib_smoother",
  "calib_smoother_options_list", "calib_smoother_option", "generate_irfs",
  "generate_irfs_options_list", "generate_irfs_option",
  "generate_irfs_element_list", "generate_irfs_element",
  "generate_irfs_exog_element_list", "extended_path",
  "extended_path_options_list", "extended_path_option",
  "model_diagnostics", "calibration_range", "moment_calibration",
  "moment_calibration_list", "moment_calibration_item", "irf_calibration",
  "irf_calibration_list", "irf_calibration_item", "smoother2histval",
  "smoother2histval_options_list", "smoother2histval_option",
  "shock_groups", "shock_group_list", "shock_group_element",
  "shock_name_list", "init2shocks", "init2shocks_list",
  "init2shocks_element", "matched_irfs", "matched_irfs_list",
  "matched_irfs_elem", "matched_irfs_elem_var_varexo",
  "matched_irfs_elem_values_weights", "matched_irfs_weights",
  "matched_irfs_weights_list", "matched_irfs_weights_elem",
  "matched_irfs_weights_elem_var_varexo", "o_solve_algo",
  "o_stack_solve_algo", "o_robust_lin_solve",
  "o_endogenous_terminal_period", "o_order", "o_replic", "o_drop", "o_ar",
  "o_nocorr", "o_nofunctions", "o_nomoments", "o_nomodelsummary", "o_irf",
  "o_irf_shocks", "o_hp_filter", "o_hp_ngrid",
  "o_filtered_theoretical_moments_grid", "o_one_sided_hp_filter",
  "o_periods", "o_solver_periods", "o_extended_path_order", "o_hybrid",
  "o_steady_maxit", "o_simul_maxit", "o_bandpass_filter", "o_dp_maxit",
  "o_osr_maxit", "o_osr_tolf", "o_pf_tolf", "o_pf_tolx", "o_steady_tolf",
  "o_steady_tolx", "o_opt_algo", "o_markowitz", "o_pf_steady_solve_algo",
  "o_pf_steady_maxit", "o_pf_steady_tolf", "o_pf_steady_tolx",
  "o_pf_steady_markowitz", "o_minimal_solving_periods", "o_simul_replic",
  "o_qz_criterium", "o_qz_zero_threshold", "o_file", "o_pac_name",
  "o_pac_aux_model_name", "o_pac_discount", "o_pac_growth", "$@33",
  "o_pac_auxname", "o_pac_kind", "o_var_name", "o_series", "o_datafile",
  "o_filename", "o_var_eq_tags", "o_var_structural", "o_dirname",
  "o_huge_number", "o_nobs", "o_trend_component_model_name",
  "o_trend_component_model_targets", "o_trend_component_model_eq_tags",
  "o_conditional_variance_decomposition", "o_est_first_obs",
  "o_posterior_sampling_method", "o_first_obs", "o_data_first_obs",
  "o_first_simulation_period", "o_date_first_simulation_period",
  "o_last_simulation_period", "o_date_last_simulation_period",
  "o_last_obs", "o_data_last_obs",
  "o_keep_kalman_algo_if_singularity_is_detected", "o_data_nobs",
  "o_shift", "o_shape", "o_mode", "o_mean", "o_mean_vec", "o_truncate",
  "o_stdev", "o_jscale", "o_init", "o_bounds", "o_domain", "o_interval",
  "o_variance", "o_variance_mat", "o_prefilter", "o_presample",
  "o_lik_init", "o_nograph", "o_posterior_nograph", "o_psd_nograph",
  "o_shock_decomposition_nograph", "o_init_state", "o_forecast_type",
  "o_shock_decomposition_presample", "o_shock_decomposition_forecast",
  "o_save_realtime", "o_fast_realtime", "o_nodisplay", "o_icd_nodisplay",
  "o_psd_nodisplay", "o_psd_init2shocks", "o_icd_max_nrows",
  "o_psd_max_nrows", "o_graph_format", "o_icd_graph_format",
  "o_psd_graph_format", "o_shock_decomposition_with_epilogue",
  "o_icd_with_epilogue", "allowed_graph_formats",
  "list_allowed_graph_formats", "o_subsample_name", "o_bvar_conf_sig",
  "o_forecasts_conf_sig", "o_conditional_forecast_conf_sig",
  "o_mh_conf_sig", "o_mh_replic", "o_posterior_max_subsample_draws",
  "o_mh_drop", "o_mh_jscale", "o_mh_tune_jscale", "o_mh_tune_guess",
  "o_optim", "o_posterior_sampler_options", "o_proposal_distribution",
  "o_no_posterior_kernel_density", "o_mh_init_scale",
  "o_mh_init_scale_factor", "o_mode_file", "o_mode_compute",
  "o_mode_check", "o_mode_check_neighbourhood_size",
  "o_mode_check_number_of_points", "o_mode_check_symmetric_plots",
  "o_prior_trunc", "o_mh_posterior_mode_estimation", "o_mh_nblocks",
  "o_load_mh_file", "o_load_results_after_load_mh", "o_loglinear",
  "o_linear_approximation", "o_logdata", "o_conditional_likelihood",
  "o_nodiagnostic", "o_bayesian_irf", "o_dsge_var", "o_dsge_varlag",
  "o_tex", "o_forecast", "o_smoother", "o_moments_varendo",
  "o_contemporaneous_correlation", "o_filtered_vars", "o_relative_irf",
  "o_fast_kalman_filter", "o_kalman_algo", "o_kalman_tol",
  "o_diffuse_kalman_tol", "o_schur_vec_tol", "o_marginal_density",
  "o_print", "o_noprint", "o_xls_sheet", "o_xls_range",
  "o_filter_step_ahead", "o_taper_steps", "o_geweke_interval",
  "o_raftery_lewis_diagnostics", "o_raftery_lewis_qrs",
  "o_brooks_gelman_plotrows", "o_constant", "o_noconstant", "o_mh_recover",
  "o_mh_initialize_from_previous_mcmc",
  "o_mh_initialize_from_previous_mcmc_directory",
  "o_mh_initialize_from_previous_mcmc_record",
  "o_mh_initialize_from_previous_mcmc_prior", "o_diffuse_filter",
  "o_plot_priors", "o_aim_solver", "o_partial_information", "o_sub_draws",
  "o_planner_discount", "o_planner_discount_latex_name", "o_lyapunov",
  "o_lyapunov_complex_threshold", "o_lyapunov_fixed_point_tol",
  "o_lyapunov_doubling_tol", "o_dr", "o_dr_cycle_reduction_tol",
  "o_dr_logarithmic_reduction_tol", "o_dr_logarithmic_reduction_maxiter",
  "o_psd_detail_plot", "o_icd_detail_plot", "o_psd_interactive",
  "o_psd_screen_shocks", "o_psd_steadystate", "o_icd_steadystate",
  "o_icd_fig_name", "o_psd_fig_name", "o_psd_type", "o_icd_type",
  "o_icd_plot_init_date", "o_icd_plot_end_date", "o_psd_plot_init_date",
  "o_psd_plot_end_date", "o_icd_write_xls", "o_psd_write_xls",
  "o_psd_realtime", "o_psd_vintage", "o_psd_diff", "o_icd_diff",
  "o_psd_flip", "o_icd_flip", "o_bvar_prior_tau", "o_bvar_prior_decay",
  "o_bvar_prior_lambda", "o_bvar_prior_mu", "o_bvar_prior_omega",
  "o_bvar_prior_flat", "o_bvar_prior_train", "o_bvar_replic",
  "o_stderr_multiples", "o_diagonal_only", "o_number_of_particles",
  "o_particle_filter_options", "o_resampling", "o_resampling_threshold",
  "o_resampling_method", "o_cpf_weights", "o_filter_algorithm",
  "o_nonlinear_filter_initialization", "o_proposal_approximation",
  "o_distribution_approximation", "o_gsa_identification", "o_gsa_morris",
  "o_gsa_stab", "o_gsa_redform", "o_gsa_pprior", "o_gsa_prior_range",
  "o_gsa_ppost", "o_gsa_ilptau", "o_gsa_morris_nliv", "o_gsa_morris_ntra",
  "o_gsa_nsam", "o_gsa_load_redform", "o_gsa_load_rmse", "o_gsa_load_stab",
  "o_gsa_alpha2_stab", "o_gsa_logtrans_redform", "o_gsa_threshold_redform",
  "o_gsa_ksstat_redform", "o_gsa_alpha2_redform", "o_gsa_namendo",
  "o_gsa_namlagendo", "o_gsa_namexo", "o_gsa_rmse", "o_gsa_lik_only",
  "o_gsa_var_rmse", "o_gsa_pfilt_rmse", "o_gsa_istart_rmse",
  "o_gsa_alpha_rmse", "o_gsa_alpha2_rmse", "o_gsa_sample_file",
  "o_gsa_neighborhood_width", "o_gsa_pvalue_ks", "o_gsa_pvalue_corr",
  "o_load_ident_files", "o_useautocorr", "o_prior_mc", "o_advanced",
  "o_max_dim_cova_group", "o_homotopy_mode", "o_homotopy_steps",
  "o_homotopy_force_continue", "o_nocheck", "o_controlled_varexo",
  "o_parameter_set", "o_nodecomposition", "o_spectral_density",
  "o_ms_drop", "o_ms_mh_replic", "o_freq", "o_initial_year",
  "o_initial_subperiod", "o_final_year", "o_final_subperiod", "o_data",
  "o_vlist", "o_vlistlog", "o_vlistper", "o_restriction_fname", "o_nlags",
  "o_cross_restrictions", "o_contemp_reduced_form",
  "o_real_pseudo_forecast", "o_no_bayesian_prior", "o_dummy_obs",
  "o_nstates", "o_indxscalesstates", "o_alpha", "o_beta", "o_gsig2_lmdm",
  "o_specification", "o_q_diag", "o_flat_prior", "o_ncsk", "o_nstd",
  "o_ninv", "o_indxparr", "o_indxovr", "o_aband", "o_indxap", "o_apband",
  "o_indximf", "o_indxfore", "o_foreband", "o_indxgforhat",
  "o_indxgimfhat", "o_indxestima", "o_indxgdls", "o_eq_ms", "o_cms",
  "o_ncms", "o_eq_cms", "o_tlindx", "o_tlnumber", "o_cnum",
  "o_k_order_solver", "o_pruning", "o_chain", "o_restrictions",
  "o_duration", "o_number_of_regimes", "o_number_of_lags", "o_parameters",
  "o_coefficients", "o_variances", "o_equations", "o_silent_optimizer",
  "o_instruments", "o_ext_func_name", "o_ext_func_nargs",
  "o_first_deriv_provided", "o_second_deriv_provided",
  "o_filter_covariance", "o_updated_covariance", "o_filter_decomposition",
  "o_smoothed_state_uncertainty", "o_smoother_redux",
  "o_selected_variables_only", "o_cova_compute", "o_output_file_tag",
  "o_file_tag", "o_no_create_init", "o_simulation_file_tag",
  "o_coefficients_prior_hyperparameters", "o_convergence_starting_value",
  "o_convergence_ending_value", "o_convergence_increment_value",
  "o_max_iterations_starting_value", "o_max_iterations_increment_value",
  "o_max_block_iterations", "o_max_repeated_optimization_runs",
  "o_function_convergence_criterion", "o_parameter_convergence_criterion",
  "o_number_of_large_perturbations", "o_number_of_small_perturbations",
  "o_number_of_posterior_draws_after_perturbation",
  "o_max_number_of_stages", "o_random_function_convergence_criterion",
  "o_random_parameter_convergence_criterion", "o_thinning_factor",
  "o_adaptive_mh_draws", "o_save_draws", "o_proposal_draws",
  "o_use_mean_center", "o_proposal_type", "o_proposal_lower_bound",
  "o_proposal_upper_bound", "o_parameter_uncertainty", "o_horizon",
  "o_filtered_probabilities", "o_real_time_smoothed", "o_no_error_bands",
  "o_error_band_percentiles", "o_shock_draws", "o_shocks_per_parameter",
  "o_free_parameters", "o_median", "o_regimes", "o_regime",
  "o_data_obs_nbr", "o_discretionary_tol", "o_analytic_derivation",
  "o_analytic_derivation_mode", "o_endogenous_prior",
  "o_use_univariate_filters_if_singularity_is_detected",
  "o_mcmc_jumping_covariance", "o_rescale_prediction_error_covariance",
  "o_use_penalized_objective_for_hessian", "o_irf_plot_threshold",
  "o_dr_display_tol", "o_consider_all_endogenous",
  "o_consider_all_endogenous_and_auxiliary", "o_consider_only_observed",
  "o_no_homotopy", "o_endval_steady", "o_homotopy_max_completion_share",
  "o_homotopy_min_step_size", "o_homotopy_initial_step_size",
  "o_homotopy_step_size_increase_success_count",
  "o_homotopy_linearization_fallback",
  "o_homotopy_marginal_linearization_fallback",
  "o_homotopy_exclude_varexo", "o_infile", "o_invars", "o_period",
  "o_outfile", "o_outvars", "o_lmmcp", "o_function", "o_sampling_draws",
  "o_use_shock_groups", "o_colormap", "o_icd_colormap",
  "o_no_init_estimation_check_first_obs", "o_heteroskedastic_filter",
  "o_pfwee_constant_simulation_length", "o_fsolve_options",
  "o_bartlett_kernel_lag", "o_weighting_matrix",
  "o_weighting_matrix_scaling_factor", "o_analytic_standard_errors",
  "o_analytic_jacobian", "o_mom_method", "o_simulation_method",
  "o_penalized_estimator", "o_verbose", "o_simulation_multiple",
  "o_mom_burnin", "o_bounded_shock_support", "o_mom_seed",
  "o_additional_optimizer_steps", "o_mom_se_tolx", "o_irf_matching_file",
  "o_add_tiny_number_to_cholesky", "o_analytical_girf", "o_irf_in_percent",
  "o_emas_girf", "o_emas_drop", "o_emas_tolf", "o_emas_max_iter",
  "o_non_zero", "o_no_identification_strength",
  "o_no_identification_reducedform", "o_no_identification_moments",
  "o_no_identification_minimal", "o_no_identification_spectrum",
  "o_normalize_jacobians", "o_grid_nbr", "o_tol_rank", "o_tol_deriv",
  "o_tol_sv", "o_checks_via_subsets", "o_max_dim_subsets_groups",
  "o_block_static", "o_block_dynamic", "o_incidence",
  "o_evaluate_planner_objective_periods",
  "o_evaluate_planner_objective_drop", "o_occbin_simul_maxit",
  "o_occbin_simul_periods", "o_occbin_simul_curb_retrench",
  "o_occbin_simul_check_ahead_periods",
  "o_occbin_simul_max_check_ahead_periods",
  "o_occbin_simul_reset_check_ahead_periods", "o_occbin_simul_debug",
  "o_occbin_simul_periodic_solution",
  "o_occbin_likelihood_inversion_filter",
  "o_occbin_likelihood_piecewise_kalman_filter",
  "o_occbin_likelihood_maxit", "o_occbin_likelihood_periods",
  "o_occbin_likelihood_curb_retrench",
  "o_occbin_likelihood_check_ahead_periods",
  "o_occbin_likelihood_max_check_ahead_periods",
  "o_occbin_likelihood_periodic_solution",
  "o_occbin_likelihood_max_kalman_iterations",
  "o_occbin_smoother_inversion_filter",
  "o_occbin_smoother_piecewise_kalman_filter", "o_occbin_smoother_maxit",
  "o_occbin_smoother_periods", "o_occbin_smoother_curb_retrench",
  "o_occbin_smoother_check_ahead_periods",
  "o_occbin_smoother_max_check_ahead_periods", "o_occbin_smoother_debug",
  "o_occbin_smoother_periodic_solution", "o_occbin_filter_use_relaxation",
  "o_occbin_write_regimes_periods", "o_occbin_write_regimes_filename",
  "o_occbin_write_regimes_smoother", "o_occbin_write_regimes_simul",
  "o_occbin_graph_noconstant", "range", "integer_range",
  "integer_range_w_inf", "signed_integer_range", "vec_int_number",
  "vec_int_elem", "vec_int_1", "vec_int", "vec_str_1", "vec_str",
  "vec_value_1", "vec_value", "vec_value_w_inf_1", "vec_value_w_inf",
  "vec_of_vec_value_1", "vec_of_vec_value", "symbol", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  parser::yyrline_[] =
  {
       0,   264,   264,   265,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   399,   401,   405,   410,   415,   419,   420,
     424,   429,   434,   436,   441,   446,   450,   453,   455,   457,
     462,   469,   470,   473,   478,   483,   485,   490,   495,   497,
     502,   507,   509,   514,   519,   523,   525,   525,   529,   529,
     533,   535,   537,   537,   539,   539,   541,   541,   547,   549,
     552,   553,   556,   557,   558,   561,   564,   565,   568,   569,
     570,   573,   573,   575,   576,   579,   580,   581,   582,   583,
     584,   587,   591,   592,   596,   598,   598,   603,   605,   607,
     609,   611,   613,   617,   621,   625,   629,   633,   637,   641,
     643,   645,   647,   651,   653,   655,   657,   659,   661,   663,
     665,   667,   669,   671,   673,   675,   677,   679,   681,   683,
     685,   687,   689,   691,   693,   695,   697,   699,   701,   703,
     705,   707,   709,   711,   713,   715,   717,   719,   721,   723,
     725,   727,   729,   729,   731,   733,   735,   737,   739,   741,
     743,   745,   749,   751,   755,   757,   760,   762,   766,   767,
     770,   772,   775,   778,   779,   782,   783,   784,   785,   786,
     787,   788,   789,   790,   791,   792,   793,   796,   798,   800,
     804,   805,   808,   810,   812,   816,   818,   822,   823,   826,
     828,   828,   832,   833,   836,   836,   840,   842,   843,   846,
     848,   850,   852,   854,   858,   858,   862,   864,   871,   871,
     876,   878,   885,   903,   905,   914,   916,   918,   920,   925,
     924,   931,   932,   935,   937,   939,   942,   947,   948,   951,
     953,   955,   959,   961,   963,   967,   969,   976,   977,   978,
     979,   980,   981,   982,   983,   984,   985,   986,   987,   990,
     991,   994,   994,   996,   996,  1000,  1001,  1002,  1003,  1006,
    1008,  1010,  1012,  1016,  1023,  1027,  1029,  1033,  1035,  1037,
    1039,  1041,  1043,  1045,  1047,  1049,  1051,  1053,  1055,  1057,
    1059,  1061,  1063,  1065,  1067,  1069,  1071,  1073,  1075,  1077,
    1079,  1081,  1083,  1085,  1087,  1089,  1091,  1093,  1095,  1097,
    1099,  1101,  1103,  1105,  1107,  1109,  1111,  1113,  1115,  1117,
    1119,  1121,  1123,  1125,  1127,  1129,  1131,  1131,  1133,  1135,
    1137,  1139,  1141,  1143,  1145,  1149,  1151,  1155,  1158,  1162,
    1161,  1166,  1168,  1170,  1172,  1174,  1179,  1184,  1191,  1192,
    1193,  1194,  1195,  1196,  1197,  1198,  1199,  1202,  1203,  1206,
    1207,  1209,  1211,  1213,  1217,  1219,  1221,  1225,  1226,  1229,
    1231,  1233,  1237,  1238,  1241,  1243,  1247,  1247,  1251,  1252,
    1255,  1257,  1260,  1262,  1259,  1264,  1266,  1270,  1272,  1276,
    1277,  1280,  1281,  1284,  1286,  1288,  1290,  1294,  1298,  1302,
    1303,  1306,  1307,  1308,  1309,  1310,  1311,  1314,  1318,  1319,
    1322,  1323,  1324,  1325,  1328,  1330,  1344,  1346,  1355,  1357,
    1359,  1363,  1364,  1367,  1373,  1379,  1387,  1395,  1402,  1409,
    1414,  1419,  1421,  1428,  1435,  1443,  1445,  1449,  1450,  1453,
    1454,  1455,  1456,  1457,  1458,  1459,  1460,  1461,  1462,  1465,
    1467,  1471,  1472,  1475,  1476,  1479,  1481,  1485,  1486,  1489,
    1490,  1491,  1494,  1496,  1500,  1501,  1504,  1505,  1506,  1509,
    1511,  1515,  1516,  1519,  1520,  1521,  1522,  1523,  1524,  1525,
    1526,  1527,  1528,  1529,  1530,  1531,  1532,  1533,  1534,  1535,
    1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1547,
    1549,  1553,  1554,  1557,  1558,  1561,  1563,  1567,  1568,  1571,
    1572,  1575,  1577,  1581,  1582,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1676,  1680,  1684,  1685,  1688,  1689,
    1692,  1694,  1698,  1699,  1702,  1703,  1706,  1710,  1711,  1714,
    1715,  1716,  1717,  1720,  1722,  1724,  1726,  1730,  1731,  1734,
    1735,  1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,  1744,
    1745,  1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,  1754,
    1755,  1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,  1764,
    1765,  1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,  1774,
    1775,  1776,  1777,  1778,  1781,  1782,  1783,  1784,  1785,  1786,
    1789,  1791,  1796,  1799,  1800,  1803,  1805,  1810,  1813,  1815,
    1817,  1821,  1822,  1825,  1826,  1829,  1831,  1835,  1837,  1841,
    1842,  1844,  1849,  1854,  1860,  1867,  1871,  1876,  1883,  1887,
    1895,  1900,  1906,  1913,  1923,  1925,  1927,  1931,  1933,  1937,
    1943,  1950,  1958,  1961,  1963,  1967,  1974,  1982,  1991,  1994,
    1995,  1998,  2001,  2004,  2006,  2010,  2018,  2020,  2022,  2024,
    2026,  2028,  2030,  2032,  2034,  2038,  2040,  2042,  2044,  2046,
    2048,  2050,  2052,  2056,  2058,  2059,  2063,  2067,  2071,  2072,
    2075,  2076,  2077,  2078,  2079,  2080,  2081,  2084,  2088,  2092,
    2094,  2096,  2100,  2101,  2104,  2104,  2106,  2106,  2108,  2108,
    2110,  2110,  2112,  2112,  2114,  2114,  2116,  2116,  2120,  2121,
    2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,
    2136,  2137,  2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,
    2148,  2149,  2152,  2157,  2159,  2161,  2163,  2165,  2167,  2171,
    2173,  2175,  2177,  2179,  2181,  2185,  2186,  2189,  2190,  2191,
    2194,  2199,  2201,  2203,  2205,  2207,  2209,  2213,  2215,  2217,
    2219,  2223,  2224,  2227,  2228,  2229,  2230,  2231,  2232,  2233,
    2234,  2235,  2236,  2237,  2238,  2239,  2240,  2241,  2242,  2243,
    2244,  2245,  2246,  2247,  2248,  2249,  2250,  2251,  2252,  2253,
    2254,  2255,  2256,  2257,  2258,  2259,  2260,  2261,  2262,  2263,
    2264,  2265,  2266,  2267,  2268,  2269,  2270,  2271,  2272,  2273,
    2274,  2275,  2276,  2277,  2278,  2279,  2280,  2281,  2282,  2283,
    2284,  2285,  2286,  2287,  2288,  2289,  2290,  2291,  2292,  2293,
    2294,  2295,  2296,  2297,  2298,  2299,  2300,  2301,  2302,  2303,
    2304,  2305,  2306,  2307,  2308,  2309,  2310,  2311,  2312,  2313,
    2314,  2315,  2316,  2317,  2318,  2319,  2320,  2321,  2322,  2323,
    2324,  2325,  2326,  2327,  2328,  2329,  2330,  2331,  2332,  2333,
    2334,  2335,  2336,  2337,  2338,  2339,  2340,  2341,  2342,  2343,
    2344,  2345,  2346,  2347,  2348,  2349,  2350,  2351,  2352,  2353,
    2354,  2355,  2356,  2357,  2360,  2362,  2366,  2367,  2371,  2372,
    2376,  2377,  2382,  2383,  2394,  2398,  2399,  2403,  2403,  2405,
    2407,  2409,  2413,  2413,  2415,  2417,  2419,  2423,  2424,  2426,
    2427,  2430,  2432,  2436,  2437,  2440,  2444,  2446,  2448,  2450,
    2452,  2454,  2458,  2461,  2462,  2465,  2466,  2467,  2468,  2469,
    2470,  2471,  2472,  2473,  2476,  2478,  2480,  2482,  2486,  2488,
    2492,  2494,  2498,  2502,  2506,  2508,  2512,  2513,  2516,  2517,
    2518,  2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,
    2528,  2529,  2530,  2531,  2532,  2533,  2534,  2535,  2536,  2537,
    2538,  2539,  2540,  2541,  2542,  2543,  2544,  2545,  2546,  2547,
    2548,  2549,  2550,  2553,  2555,  2559,  2560,  2563,  2564,  2568,
    2569,  2572,  2574,  2578,  2580,  2582,  2584,  2586,  2588,  2592,
    2593,  2592,  2595,  2597,  2601,  2603,  2605,  2607,  2611,  2615,
    2616,  2619,  2621,  2623,  2625,  2629,  2631,  2635,  2636,  2639,
    2640,  2643,  2645,  2648,  2649,  2652,  2653,  2654,  2655,  2656,
    2657,  2658,  2659,  2660,  2661,  2662,  2663,  2664,  2665,  2666,
    2667,  2668,  2669,  2670,  2671,  2672,  2673,  2674,  2675,  2676,
    2677,  2678,  2681,  2683,  2687,  2688,  2691,  2692,  2693,  2694,
    2695,  2696,  2697,  2698,  2701,  2703,  2706,  2707,  2710,  2711,
    2712,  2713,  2716,  2718,  2720,  2722,  2726,  2727,  2730,  2732,
    2734,  2736,  2738,  2742,  2743,  2746,  2747,  2748,  2751,  2752,
    2755,  2756,  2757,  2760,  2761,  2764,  2765,  2766,  2769,  2771,
    2775,  2777,  2781,  2783,  2787,  2791,  2793,  2795,  2797,  2801,
    2803,  2805,  2807,  2811,  2813,  2815,  2817,  2821,  2823,  2825,
    2827,  2831,  2833,  2837,  2838,  2839,  2840,  2841,  2842,  2843,
    2846,  2847,  2848,  2849,  2850,  2851,  2852,  2853,  2854,  2855,
    2858,  2859,  2862,  2864,  2868,  2869,  2870,  2871,  2874,  2875,
    2878,  2880,  2884,  2887,  2888,  2889,  2890,  2891,  2892,  2893,
    2894,  2895,  2896,  2897,  2898,  2899,  2900,  2901,  2902,  2903,
    2904,  2905,  2906,  2907,  2908,  2909,  2910,  2911,  2912,  2913,
    2914,  2915,  2916,  2917,  2918,  2919,  2920,  2921,  2922,  2923,
    2924,  2925,  2926,  2927,  2928,  2929,  2930,  2931,  2932,  2933,
    2934,  2937,  2938,  2941,  2943,  2947,  2948,  2949,  2950,  2951,
    2952,  2953,  2954,  2955,  2956,  2957,  2958,  2959,  2960,  2963,
    2964,  2967,  2969,  2973,  2974,  2975,  2976,  2977,  2978,  2979,
    2980,  2981,  2982,  2983,  2984,  2985,  2986,  2989,  2990,  2993,
    2995,  2999,  3000,  3001,  3002,  3003,  3004,  3005,  3006,  3007,
    3008,  3009,  3010,  3011,  3012,  3015,  3016,  3019,  3021,  3023,
    3025,  3029,  3030,  3031,  3032,  3035,  3036,  3039,  3041,  3045,
    3046,  3047,  3048,  3049,  3050,  3051,  3052,  3055,  3056,  3059,
    3061,  3065,  3066,  3067,  3068,  3069,  3070,  3071,  3074,  3075,
    3078,  3080,  3084,  3085,  3086,  3087,  3088,  3089,  3090,  3091,
    3092,  3093,  3094,  3095,  3096,  3097,  3098,  3099,  3100,  3101,
    3102,  3103,  3104,  3105,  3106,  3107,  3108,  3109,  3110,  3111,
    3112,  3113,  3114,  3115,  3116,  3117,  3118,  3121,  3122,  3125,
    3127,  3131,  3133,  3135,  3140,  3147,  3148,  3151,  3152,  3153,
    3154,  3155,  3156,  3157,  3158,  3159,  3160,  3161,  3162,  3163,
    3164,  3165,  3166,  3167,  3168,  3169,  3170,  3171,  3172,  3173,
    3174,  3175,  3176,  3177,  3178,  3179,  3180,  3181,  3182,  3183,
    3184,  3185,  3186,  3187,  3188,  3189,  3190,  3191,  3192,  3193,
    3194,  3195,  3196,  3197,  3198,  3199,  3200,  3201,  3202,  3205,
    3206,  3209,  3210,  3211,  3212,  3213,  3214,  3215,  3216,  3217,
    3218,  3219,  3220,  3221,  3222,  3223,  3224,  3227,  3228,  3231,
    3232,  3233,  3234,  3235,  3236,  3237,  3238,  3239,  3240,  3241,
    3242,  3245,  3246,  3249,  3250,  3251,  3252,  3253,  3254,  3255,
    3256,  3257,  3258,  3259,  3260,  3261,  3262,  3263,  3264,  3265,
    3266,  3267,  3268,  3271,  3272,  3275,  3276,  3277,  3278,  3279,
    3280,  3281,  3282,  3283,  3284,  3285,  3286,  3287,  3288,  3291,
    3293,  3295,  3299,  3300,  3303,  3305,  3309,  3311,  3313,  3315,
    3319,  3320,  3323,  3324,  3325,  3326,  3327,  3330,  3334,  3335,
    3338,  3339,  3340,  3341,  3342,  3345,  3347,  3351,  3355,  3356,
    3359,  3365,  3365,  3369,  3370,  3373,  3375,  3379,  3381,  3383,
    3385,  3389,  3390,  3393,  3394,  3395,  3396,  3397,  3398,  3399,
    3400,  3401,  3402,  3403,  3404,  3405,  3406,  3407,  3408,  3409,
    3410,  3411,  3414,  3416,  3418,  3420,  3424,  3425,  3428,  3429,
    3432,  3433,  3436,  3440,  3442,  3446,  3448,  3452,  3453,  3456,
    3457,  3458,  3459,  3460,  3463,  3467,  3469,  3471,  3476,  3480,
    3481,  3484,  3486,  3488,  3492,  3494,  3498,  3499,  3502,  3504,
    3506,  3510,  3512,  3516,  3517,  3520,  3521,  3522,  3523,  3524,
    3527,  3529,  3533,  3534,  3537,  3538,  3541,  3542,  3543,  3546,
    3548,  3552,  3553,  3556,  3557,  3560,  3562,  3566,  3568,  3577,
    3593,  3599,  3607,  3612,  3614,  3618,  3620,  3624,  3626,  3638,
    3648,  3654,  3662,  3663,  3664,  3665,  3666,  3667,  3668,  3669,
    3670,  3671,  3672,  3673,  3674,  3675,  3676,  3677,  3681,  3682,
    3683,  3684,  3685,  3686,  3687,  3688,  3689,  3690,  3696,  3697,
    3698,  3699,  3700,  3701,  3702,  3703,  3704,  3706,  3709,  3710,
    3711,  3712,  3713,  3715,  3716,  3717,  3718,  3719,  3720,  3721,
    3722,  3723,  3723,  3724,  3725,  3726,  3727,  3728,  3729,  3730,
    3731,  3732,  3733,  3734,  3736,  3739,  3740,  3741,  3742,  3744,
    3747,  3749,  3752,  3754,  3755,  3756,  3757,  3758,  3759,  3760,
    3761,  3762,  3763,  3764,  3765,  3766,  3767,  3768,  3769,  3770,
    3771,  3772,  3773,  3774,  3775,  3776,  3777,  3778,  3779,  3780,
    3781,  3783,  3786,  3788,  3791,  3792,  3793,  3794,  3796,  3798,
    3799,  3800,  3801,  3803,  3806,  3807,  3808,  3809,  3810,  3812,
    3813,  3814,  3816,  3819,  3821,  3824,  3826,  3829,  3830,  3831,
    3833,  3835,  3837,  3840,  3841,  3844,  3847,  3848,  3849,  3850,
    3851,  3852,  3853,  3854,  3855,  3857,  3858,  3859,  3860,  3861,
    3862,  3865,  3866,  3867,  3868,  3869,  3870,  3871,  3872,  3873,
    3874,  3875,  3876,  3877,  3878,  3879,  3880,  3881,  3882,  3883,
    3884,  3885,  3887,  3889,  3892,  3893,  3894,  3895,  3896,  3897,
    3898,  3899,  3900,  3901,  3902,  3903,  3904,  3905,  3907,  3910,
    3911,  3912,  3913,  3915,  3916,  3917,  3918,  3919,  3920,  3921,
    3922,  3923,  3924,  3925,  3926,  3927,  3928,  3929,  3930,  3931,
    3932,  3933,  3934,  3935,  3936,  3937,  3938,  3939,  3940,  3941,
    3942,  3943,  3944,  3945,  3946,  3947,  3948,  3949,  3950,  3951,
    3952,  3953,  3954,  3955,  3956,  3957,  3959,  3961,  3964,  3966,
    3968,  3971,  3972,  3973,  3974,  3975,  3976,  3977,  3978,  3979,
    3980,  3981,  3982,  3983,  3984,  3985,  3986,  3987,  3988,  3989,
    3990,  3991,  3992,  3993,  3994,  3995,  3996,  3997,  3998,  3999,
    4000,  4001,  4002,  4003,  4004,  4005,  4006,  4007,  4008,  4009,
    4010,  4011,  4012,  4013,  4014,  4015,  4016,  4017,  4018,  4019,
    4020,  4021,  4022,  4023,  4024,  4025,  4026,  4027,  4028,  4029,
    4030,  4031,  4032,  4033,  4034,  4035,  4036,  4037,  4038,  4039,
    4040,  4041,  4043,  4046,  4047,  4048,  4049,  4050,  4051,  4052,
    4053,  4055,  4056,  4057,  4058,  4060,  4061,  4063,  4065,  4067,
    4069,  4071,  4073,  4076,  4077,  4078,  4079,  4080,  4082,  4084,
    4087,  4088,  4089,  4090,  4091,  4092,  4093,  4094,  4095,  4100,
    4105,  4111,  4112,  4113,  4114,  4115,  4116,  4117,  4118,  4119,
    4120,  4121,  4122,  4124,  4127,  4128,  4129,  4130,  4131,  4132,
    4133,  4134,  4135,  4136,  4137,  4138,  4139,  4140,  4141,  4142,
    4143,  4144,  4145,  4146,  4147,  4148,  4149,  4150,  4151,  4152,
    4153,  4154,  4157,  4159,  4162,  4163,  4164,  4165,  4166,  4167,
    4169,  4172,  4173,  4175,  4176,  4177,  4179,  4182,  4184,  4187,
    4190,  4193,  4196,  4199,  4202,  4205,  4208,  4209,  4210,  4211,
    4212,  4214,  4216,  4218,  4220,  4222,  4224,  4226,  4228,  4230,
    4232,  4234,  4236,  4238,  4240,  4242,  4244,  4245,  4246,  4247,
    4248,  4249,  4250,  4251,  4252,  4253,  4254,  4255,  4256,  4257,
    4258,  4259,  4260,  4261,  4262,  4263,  4264,  4265,  4266,  4267,
    4268,  4269,  4270,  4271,  4272,  4274,  4276,  4279,  4280,  4281,
    4282,  4283,  4284,  4285,  4286,  4287,  4288,  4289,  4290,  4291,
    4292,  4293,  4294,  4295,  4297,  4298,  4299,  4300,  4301,  4302,
    4303,  4304,  4305,  4306,  4308,  4309,  4310,  4311,  4312,  4313,
    4316,  4317,  4318,  4319,  4320,  4321,  4323,  4325,  4327,  4329,
    4330,  4331,  4332,  4333,  4334,  4335,  4336,  4337,  4338,  4340,
    4341,  4342,  4343,  4344,  4345,  4346,  4349,  4350,  4351,  4352,
    4353,  4354,  4355,  4356,  4357,  4358,  4359,  4360,  4361,  4362,
    4363,  4366,  4367,  4370,  4371,  4372,  4373,  4374,  4375,  4376,
    4377,  4380,  4381,  4382,  4383,  4384,  4385,  4386,  4387,  4388,
    4389,  4390,  4391,  4392,  4393,  4394,  4395,  4396,  4397,  4398,
    4401,  4403,  4405,  4406,  4407,  4410,  4412,  4415,  4418,  4420,
    4424,  4426,  4429,  4433,  4434,  4442,  4444,  4446,  4451,  4458,
    4459,  4462,  4464,  4466,  4471,  4478,  4479,  4482,  4484,  4486,
    4491,  4498,  4499,  4502,  4504,  4509,  4516,  4520,  4525,  4529,
    4533,  4534,  4535,  4536,  4537,  4538,  4539,  4540,  4541,  4542,
    4543,  4544,  4545,  4546,  4547,  4548,  4549,  4550,  4551,  4552,
    4553,  4554,  4555,  4556,  4557,  4558,  4559,  4560,  4561,  4562,
    4563,  4564,  4565
  };

  void
  parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  parser::symbol_kind_type
  parser::yytranslate_ (int t) YY_NOEXCEPT
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const short
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,   775,     2,     2,     2,     2,
     771,   772,     2,     2,     2,     2,   776,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   770,   769,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   773,     2,   774,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768
    };
    // Last valid token kind.
    const int code_max = 1023;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return static_cast <symbol_kind_type> (translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

#line 25 "../preprocessor/src/DynareBison.yy"
} // Dynare
#line 18181 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"

#line 4568 "../preprocessor/src/DynareBison.yy"


void
Dynare::parser::error(const Dynare::parser::location_type& l, const string& m)
{
  driver.error(l, m);
}
